SystemOrganization addCategory: #'SqueakNOS-VM'!
SystemOrganization addCategory: #'SqueakNOS-Kernel'!
SystemOrganization addCategory: #'SqueakNOS-Devices-Base'!
SystemOrganization addCategory: #'SqueakNOS-Devices-Network'!
SystemOrganization addCategory: #'SqueakNOS-Devices-USB'!
SystemOrganization addCategory: #'SqueakNOS-FileSupport'!
SystemOrganization addCategory: #'SqueakNOS-OFW-OLPC'!
SystemOrganization addCategory: #'SqueakNOS-Storage'!
SystemOrganization addCategory: #'SqueakNOS-External-Structures'!
SystemOrganization addCategory: #'SqueakNOS-Devices-Memory'!
SystemOrganization addCategory: #'SqueakNOS-Devices-Storage'!
SystemOrganization addCategory: #'SqueakNOS-Filesystems'!
SystemOrganization addCategory: #'SqueakNOS-Filesystems-FAT32'!
SystemOrganization addCategory: #'SqueakNOS-Memory-Manager'!
SystemOrganization addCategory: #'SqueakNOS-Devices-Processor'!
SystemOrganization addCategory: #'SqueakNOS-MemoryManager-Paging'!

ParagraphEditor subclass: #ParagraphEditorWithBindings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-FileSupport'!

!ParagraphEditorWithBindings methodsFor: 'as yet unclassified' stamp: 'r++ 7/23/2008 21:06'!
bindingOf: key
	model ifNil: [model := Dictionary new].
	(model includesKey: key) ifFalse: [model at: key put: nil].
	^ model associationAt: key! !

!ParagraphEditorWithBindings methodsFor: 'as yet unclassified' stamp: 'r++ 7/23/2008 21:08'!
evaluate: aString
	paragraph := aString asParagraph.
	self selectAll.
	^ self evaluateSelection! !

!Number methodsFor: '*Squeaknos' stamp: 'GuidoChari 1/4/2011 16:21'!
isPageAligned 
	^ (self bitAnd: 16rFFFFF000) = self! !

StandardFileStream subclass: #CheapHardDiskStream
	instanceVariableNames: 'fileSize offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Storage'!

!CheapHardDiskStream class methodsFor: 'as yet unclassified' stamp: 'Pocho 3/27/2010 17:41'!
on: anATADevice
	^self new device: anATADevice.! !

!CheapHardDiskStream methodsFor: 'accessing' stamp: 'gc 7/16/2010 15:41'!
device: device
	fileID := device.
	buffer1 := String new: 1.
	name := device printString.
	position := 0.
	offset := 0.
	fileSize := 199493210.
	rwmode := true.
	self enableReadBuffering! !

!CheapHardDiskStream methodsFor: 'accessing' stamp: 'Pocho 3/28/2010 03:45'!
fileSize
	"Answer the value of fileSize"

	^ fileSize! !

!CheapHardDiskStream methodsFor: 'accessing' stamp: 'Pocho 3/28/2010 03:45'!
fileSize: anObject
	"Set the value of fileSize"

	fileSize := anObject! !

!CheapHardDiskStream methodsFor: 'primitives' stamp: 'richie 8/31/2009 16:53'!
primAtEnd: id
	^(self primSize: id) = position! !

!CheapHardDiskStream methodsFor: 'primitives' stamp: 'richie 8/31/2009 16:15'!
primClose: id! !

!CheapHardDiskStream methodsFor: 'primitives' stamp: 'richie 8/31/2009 16:15'!
primCloseNoError: id! !

!CheapHardDiskStream methodsFor: 'primitives' stamp: 'Pocho 7/20/2010 16:17'!
primFlush: id
	id flush! !

!CheapHardDiskStream methodsFor: 'primitives' stamp: 'gc 7/16/2010 15:32'!
primGetPosition: id
	^offset! !

!CheapHardDiskStream methodsFor: 'primitives' stamp: 'JavierPimas 8/12/2010 18:15'!
primRead: aDriveNumber into: byteArray startingAt: startIndex count: count

	fileID
		readInto: byteArray
		startWritingAtByte: startIndex
		startReadingAtByte: offset + 1
		bytesCount: count.
	
	offset := offset + count.
	^count
! !

!CheapHardDiskStream methodsFor: 'primitives' stamp: 'gc 7/16/2010 15:31'!
primSetPosition: id to: anInteger
	anInteger > fileSize ifTrue: [self error: 'Out of bounds'].
	offset := anInteger! !

!CheapHardDiskStream methodsFor: 'primitives' stamp: 'gc 7/16/2010 15:31'!
primSize: id
	^offset! !

!CheapHardDiskStream methodsFor: 'primitives' stamp: 'richie 8/31/2009 16:55'!
primSizeNoError: id
	^self primSize: id! !

!CheapHardDiskStream methodsFor: 'primitives' stamp: 'richie 8/31/2009 16:14'!
primTruncate: id to: anInteger! !

!CheapHardDiskStream methodsFor: 'primitives' stamp: 'gc 7/16/2010 15:54'!
primWrite: aDriveNumber from: stringOrByteArray startingAt: startIndex count: count
	"remember that fileID isn't an ID but actually an ATA Device."
	| pos |
	pos := self primGetPosition: fileID.
	fileID replaceFromByte: offset + 1 bytesCount: count 
		  with: stringOrByteArray startingAtByte: startIndex.
	fileSize := fileSize max: pos + count.
	self primSetPosition: fileID to: pos + count.
	^count
! !

StandardFileStream subclass: #StreamOnStream
	instanceVariableNames: 'contentLength offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Filesystems'!

!StreamOnStream class methodsFor: 'as yet unclassified' stamp: 'Pocho 6/25/2010 00:35'!
on: aStream
	^self new on: aStream.! !

!StreamOnStream class methodsFor: 'as yet unclassified' stamp: 'Pocho 6/25/2010 16:02'!
on: aStream offset: anOffset
	^self new on: aStream offset: anOffset.! !

!StreamOnStream class methodsFor: 'as yet unclassified' stamp: 'Pocho 6/25/2010 16:02'!
on: aStream offset: anOffset size: aSize
	^self new on: aStream offset: anOffset size: aSize.! !

!StreamOnStream methodsFor: 'accessing' stamp: 'Pocho 6/25/2010 00:30'!
contentLength
	"Answer the value of contentLength"

	^ contentLength! !

!StreamOnStream methodsFor: 'accessing' stamp: 'Pocho 6/25/2010 00:31'!
contentLength: aLength
	"Set the value of contentLength"

	contentLength := aLength.! !

!StreamOnStream methodsFor: 'private' stamp: 'gc 6/26/2010 16:19'!
innerStreamPosition
	^fileID position! !

!StreamOnStream methodsFor: 'private' stamp: 'gc 6/26/2010 14:47'!
innerStreamPosition: aNumber
	^fileID position: aNumber.! !

!StreamOnStream methodsFor: 'accessing' stamp: 'Pocho 6/25/2010 15:53'!
on: aStream
	self on: aStream offset: 0 size: aStream size.! !

!StreamOnStream methodsFor: 'accessing' stamp: 'Pocho 6/25/2010 16:31'!
on: aStream offset: anOffset
	self on: aStream offset: anOffset size: aStream size - anOffset.! !

!StreamOnStream methodsFor: 'accessing' stamp: 'gc 6/26/2010 16:36'!
on: aStream offset: anOffset size: aSize
	fileID := aStream.
	buffer1 := String new: 1.
	name := aStream printString.
	position := 0.
	offset := anOffset.
	aStream position: anOffset.
	contentLength := aStream size min: aSize.
	rwmode := true.
	self binary! !

!StreamOnStream methodsFor: 'primitives' stamp: 'gc 7/6/2010 19:58'!
position
	^position! !

!StreamOnStream methodsFor: 'primitives' stamp: 'gc 7/6/2010 19:58'!
position: aNumber
	position := aNumber.
	fileID position: offset + aNumber
		! !

!StreamOnStream methodsFor: 'primitives' stamp: 'Pocho 6/25/2010 00:29'!
primAtEnd: id
	^(self primSize: id) = position! !

!StreamOnStream methodsFor: 'primitives' stamp: 'Pocho 6/25/2010 00:29'!
primClose: id! !

!StreamOnStream methodsFor: 'primitives' stamp: 'Pocho 6/25/2010 00:29'!
primCloseNoError: id! !

!StreamOnStream methodsFor: 'primitives' stamp: 'Pocho 7/20/2010 16:18'!
primFlush: id
	id flush.! !

!StreamOnStream methodsFor: 'primitives' stamp: 'Pocho 6/25/2010 00:29'!
primGetPosition: id
	^position! !

!StreamOnStream methodsFor: 'primitives' stamp: 'gc 6/26/2010 16:28'!
primRead: unusedNumber into: byteArray startingAt: startIndex count: count
	| read inner |
	inner := self setInnerStreamPosition.
	read := fileID next: count into: byteArray startingAt: startIndex.
	position := position + read size.
	self revertInnerStreamToPosition: inner.
	^read size
! !

!StreamOnStream methodsFor: 'primitives' stamp: 'gc 6/26/2010 14:40'!
primSetPosition: id to: anInteger
	position := anInteger.
! !

!StreamOnStream methodsFor: 'primitives' stamp: 'Pocho 6/25/2010 00:36'!
primSize: id
	^contentLength.! !

!StreamOnStream methodsFor: 'primitives' stamp: 'Pocho 6/25/2010 00:29'!
primSizeNoError: id
	^self primSize: id! !

!StreamOnStream methodsFor: 'primitives' stamp: 'Pocho 6/25/2010 00:29'!
primTruncate: id to: anInteger! !

!StreamOnStream methodsFor: 'primitives' stamp: 'gc 6/30/2010 14:31'!
primWrite: aDriveNumber from: stringOrByteArray startingAt: startIndex count: count
	"remember that fileID isn't an ID but actually a stream."
	| inner |
	inner := self setInnerStreamPosition.
	fileID next: count putAll: stringOrByteArray startingAt: startIndex.
	position := position + count.
	contentLength := contentLength max: position.
	self revertInnerStreamToPosition: inner.
	^count
! !

!StreamOnStream methodsFor: 'private' stamp: 'gc 6/26/2010 14:51'!
revertInnerStreamToPosition: aNumber
	self innerStreamPosition: aNumber
	! !

!StreamOnStream methodsFor: 'private' stamp: 'gc 6/26/2010 16:32'!
setInnerStreamPosition
	| pos |
	pos := self innerStreamPosition. 
	fileID position: offset + position.
	^pos! !

!SmalltalkImage class methodsFor: '*SqueakNOS' stamp: 'GuidoChari 1/5/2011 16:00'!
startUp: resuming 
	super startUp: resuming.
	Computer isSqueakNOS ifTrue: [
		resuming ifFalse: [ [self current preSnapshot; snapshot; postSnapshot] forkAt: Processor highestPriority]
	]
	! !

!SmalltalkImage methodsFor: '*SqueakNOS' stamp: 'GuidoChari 1/5/2011 15:02'!
headerSize
	^16 * Computer current bytesPerWord! !

!SmalltalkImage methodsFor: '*SqueakNOS' stamp: 'GuidoChari 1/5/2011 16:05'!
imagePagesCount
	| image pageSize startAddress rest firstSpace addendum |
	image := self size.
	pageSize := Computer current memoryManager pageSize. 
	startAddress := self objectMemoryStartAddress.
	addendum := 0.
	startAddress isPageAligned ifFalse: [
		rest := (image \\ pageSize).
		firstSpace := (startAddress bitOr: 16r00000FFF) - startAddress.
		(firstSpace > rest) ifFalse: [addendum := 1].
	].
	^(image / pageSize) ceiling + addendum! !

!SmalltalkImage methodsFor: '*SqueakNOS' stamp: 'JavierPimas 8/12/2010 18:16'!
isPharo
	Smalltalk at: #SystemVersion ifPresent: [:cl |
		^cl current version beginsWith: 'Pharo'.
	].
	^false.! !

!SmalltalkImage methodsFor: '*SqueakNOS' stamp: 'GuidoChari 8/3/2010 17:05'!
isSqueakNOS	
	^self platformName = 'SqueakNOS'! !

!SmalltalkImage methodsFor: '*SqueakNOS' stamp: 'GuidoChari 1/5/2011 15:53'!
objectMemoryStartAddress
	^self startAddress + self headerSize! !

!SmalltalkImage methodsFor: '*SqueakNOS' stamp: 'JavierPimas 9/14/2010 12:59'!
openSourceFilesForSqueakNos
	| filesystem directory source sources changes change |
	self imageName = LastImageName
		ifFalse: [LastImageName := self imageName.
				self isPharo ifTrue: [ Author fullName: '' ] ifFalse: [ Utilities setAuthorInitials: '' ] ].
	filesystem := Computer primaryFilesystem.
	sources := filesystem pureFAT32FilenameFor: self sourcesName.
	changes := filesystem pureFAT32FilenameFor: self changesName.
	directory := filesystem root.
	(directory fileExists: sources)
		ifTrue: [source := (directory readOnlyFileNamed: sources) readStream].
	(directory fileExists: changes)
		ifTrue: [change := (directory readOnlyFileNamed: changes) readWriteStream].
	SourceFiles := Array with: source with: change.
	SourceFileArray install! !

!SmalltalkImage methodsFor: '*SqueakNOS-Snapshot' stamp: 'GuidoChari 1/5/2011 15:46'!
postPagedSnapshot
	| manager start end computer |
	computer := Computer current.	
	start := self objectMemoryStartAddress.
	end := start + computer snapshotEndAddress.
	manager := computer memoryManager.
	^manager readWriteFrom: start to: end.! !

!SmalltalkImage methodsFor: '*SqueakNOS-Snapshot' stamp: 'GuidoChari 1/5/2011 15:46'!
postSnapshot
	"self postClonedSnapshot"
	self postPagedSnapshot
	! !

!SmalltalkImage methodsFor: '*SqueakNOS-Snapshot' stamp: 'GuidoChari 1/5/2011 15:45'!
prePagedSnapshot
	| pageFaultHandler start end manager computer | 
	computer := Computer current.
	start := self objectMemoryStartAddress.
	end := start + computer snapshotEndAddress.
	manager := computer memoryManager.
	CopyOnWriteSaveReadOnlyPageFaultHandler manager: manager.
	manager from: start to: end useHandler: pageFaultHandler. 
	"manager readOnlyFrom: start to: end."
	! !

!SmalltalkImage methodsFor: '*SqueakNOS-Snapshot' stamp: 'GuidoChari 1/5/2011 15:40'!
preSnapshot
	"self prepareForClonedSnapshot"
	self prePagedSnapshot
	! !

!SmalltalkImage methodsFor: '*SqueakNOS' stamp: 'GuidoChari 1/5/2011 15:10'!
size
	^Computer current snapshotEndAddress ! !

!SmalltalkImage methodsFor: '*SqueakNOS-Snapshot' stamp: 'GuidoChari 1/5/2011 16:14'!
snapshot
	| imageCopy memory aStream computer |
	computer := Computer current.
	aStream := computer imageFileStreamForWrite. 
	aStream binary.
	self writeHeaderOn: aStream fromMemory: computer snapshotStartAddress.
	self writeObjectMemory: aStream.
	aStream truncate: computer snapshotEndAddress + self headerSize; close
	
	 ! !

!SmalltalkImage methodsFor: '*SqueakNOS' stamp: 'gc 6/16/2010 18:51'!
squeaknosChangesName	
	"Answer the full path to the version-stable source code"
	^FAT32FileSystem pureFAT32FilenameFor: self changesName! !

!SmalltalkImage methodsFor: '*SqueakNOS' stamp: 'gc 6/16/2010 18:51'!
squeaknosSourcesName	
	"Answer the full path to the version-stable source code"
	^FAT32FileSystem pureFAT32FilenameFor: SmalltalkImage current sourcesName! !

!SmalltalkImage methodsFor: '*SqueakNOS' stamp: 'GuidoChari 1/5/2011 15:54'!
startAddress
	^Computer current imageStartAddress! !

!SmalltalkImage methodsFor: '*SqueakNOS-Snapshot' stamp: 'GuidoChari 1/5/2011 15:01'!
writeHeaderOn: aStream fromMemory: anAddress
	| contents |
	contents := Buffer at: anAddress size: self headerSize.
	aStream nextPutAll: contents contents! !

!SmalltalkImage methodsFor: '*SqueakNOS-Snapshot' stamp: 'GuidoChari 1/5/2011 16:14'!
writeObjectMemory: aStream
	| startAddress firstPageOffset pages lastAddress lastPageLimit computer |
	computer := Computer current.
	pages := self imagePagesCount.
	startAddress := self objectMemoryStartAddress.
	firstPageOffset := startAddress - (startAddress bitAnd: 16rFFFFF000).
	aStream nextPutAll: ((computer imageMemoryReadOnlyPageContents: 1) allButFirst: firstPageOffset).
	2 to: pages - 1 do: [:index | | memory |
		aStream nextPutAll: (computer imageMemoryReadOnlyPageContents: index)
	].
	lastAddress := startAddress + self size.
	lastPageLimit := lastAddress - (lastAddress bitAnd: 16rFFFFF000).
	aStream nextPutAll: ((computer imageMemoryReadOnlyPageContents: pages) first: lastPageLimit)! !

!SmalltalkImage methodsFor: '*SqueakNOS-Snapshot' stamp: 'GuidoChari 1/5/2011 16:03'!
writeObjectMemory: aStream fromClonedSnapshotOn: anAddress
	| contents computer |
	computer := Computer current.	
	contents := Buffer at: computer snapshotStartAddress size: computer snapshotEndAddress. 
	aStream nextPutAll: contents contents! !

SmartSyntaxInterpreterPlugin subclass: #SqueakNOSPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-VM'!

!SqueakNOSPlugin commentStamp: 'gera 5/9/2006 13:47' prior: 0!
This class implements the few needed primitives for running SqueakNOS.

primitiveInPortByte: portNumber					'primitiveInPortByte'
primitiveOutPort: portNumber byte: byte			'primitiveOutPortByte'
primitiveInPortWord: portNumber				'primitiveInPortWord'
primitiveOutPort: portNumber word: word		'primitiveOutPortWord'
primitiveInPortDword: portNumber				'primitiveInPortDword'
primitiveOutPort: portNumber dword: dword		'primitiveOutPortDword'

primitiveReadStringLength: length fromMemoryAt: address
												'primitiveReadStringLengthFromMemoryAt'
primitiveWriteString: aString toMemoryAt: address
												'primitiveWriteStringToMemoryAt'

primitiveRegisterSemaphoreIndex: aSemaphoreIndex forIRQ: irqNumber
												'primitiveRegisterSemaphoreIndexForIRQ'!

!SqueakNOSPlugin class methodsFor: 'as yet unclassified' stamp: 'gc 11/8/2010 18:51'!
declareCVarsIn: aCCodeGenerator

	aCCodeGenerator addHeaderFile: '"ints.h"'.
	aCCodeGenerator addHeaderFile: '"ofw.h"'.
	aCCodeGenerator addHeaderFile: '"console.h"'! !

!SqueakNOSPlugin methodsFor: 'lock memory addresses' stamp: 'gc 7/27/2010 16:10'!
primVMBiosInformationPosition
	| start |
	self primitive: 'primVMBiosInformationPosition'
		parameters: #().

	self cCode: 'extern Computer computer'.
	self var: 'start' type: 'usqInt'.
	
	self cCode: 'start = &computer'.

	^ start asSmallIntegerObj.
! !

!SqueakNOSPlugin methodsFor: 'debugging' stamp: 'GuidoChari 12/28/2010 16:35'!
primitiveDisableConsole
	| console |

	self primitive: 'primitiveDisableConsole'
		parameters: #().

	self var: #console type: 'extern Console'.
	self cCode: 'console.debugging_now = 0'.

! !

!SqueakNOSPlugin methodsFor: 'debugging' stamp: 'GuidoChari 12/28/2010 16:35'!
primitiveEnableConsole
	| console |

	self primitive: 'primitiveEnableConsole'
		parameters: #().

	self var: #console type: 'extern Console'.
	self cCode: 'console.debugging_now = 1'.

! !

!SqueakNOSPlugin methodsFor: 'debugging' stamp: 'Pocho 6/12/2010 00:10'!
primitiveInDebugString
	| dataOop dataPtr length console |

	self primitive: 'primitiveInDebugString'
		parameters: #().

	self var: #dataPtr type: 'unsigned char *'.
	self var: #console type: 'extern Console'.
	self var: #length type: 'unsigned long'.
	self cCode: 'length = strlen(console.text)'.
	dataOop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: length + 1.
	dataPtr := interpreterProxy firstIndexableField: dataOop.

	self cCode: 'strcpy(dataPtr, console.text)'. 

	^ dataOop
! !

!SqueakNOSPlugin methodsFor: 'port i/o' stamp: 'gera 5/9/2006 13:29'!
primitiveInPortByte: portNumber
	| answer |

	self primitive: 'primitiveInPortByte'
		parameters: #(SmallInteger).

	self var: #answer type: 'unsigned char'.

	self cCode: 'asm("in %1, %0" : "=a" (answer) : "d" ((unsigned short)portNumber))'. 
	^ answer asSmallIntegerObj
! !

!SqueakNOSPlugin methodsFor: 'port i/o' stamp: 'gera 11/14/2008 20:45'!
primitiveInPortByte: port stringLength: length
	| dataOop dataPtr |

	self primitive: 'primitiveInPortByteStringLength'
		parameters: #(SmallInteger SmallInteger).

	self var: #dataPtr type: 'unsigned char *'.
	dataOop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: length.
	dataPtr := interpreterProxy firstIndexableField: dataOop.

	self cCode: 'asm("rep insb"
		: 
		: "d" ((unsigned short)port),
		  "c" ((unsigned int) length),
		  "D" (dataPtr)
		)'. 

	^ dataOop
! !

!SqueakNOSPlugin methodsFor: 'port i/o' stamp: 'gera 6/30/2006 19:50'!
primitiveInPortDword: portNumber
	| answer |

	self primitive: 'primitiveInPortDword'
		parameters: #(SmallInteger).

	self var: #answer type: 'unsigned int'.

	self cCode: 'asm("in %1, %0" : "=a" (answer) : "d" ((unsigned short)portNumber))'. 
	^ interpreterProxy positive32BitIntegerFor: answer! !

!SqueakNOSPlugin methodsFor: 'port i/o' stamp: 'gera 11/14/2008 20:45'!
primitiveInPortDword: port stringLength: length
	| dataOop dataPtr |

	self primitive: 'primitiveInPortdWordStringLength'
		parameters: #(SmallInteger SmallInteger).

	self var: #dataPtr type: 'unsigned char *'.
	dataOop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: length.
	dataPtr := interpreterProxy firstIndexableField: dataOop.

	self cCode: 'asm("rep insl"
		: 
		: "d" ((unsigned short)port),
		  "c" ((unsigned int) (length >> 2)),
		  "D" (dataPtr)
		)'. 

	^ dataOop! !

!SqueakNOSPlugin methodsFor: 'port i/o' stamp: 'gera 5/9/2006 13:30'!
primitiveInPortWord: portNumber
	| answer |

	self primitive: 'primitiveInPortWord'
		parameters: #(SmallInteger).

	self var: #answer type: 'unsigned short'.

	self cCode: 'asm("in %1, %0" : "=a" (answer) : "d" ((unsigned short)portNumber))'. 
	^ answer asSmallIntegerObj
! !

!SqueakNOSPlugin methodsFor: 'port i/o' stamp: 'gera 11/14/2008 20:45'!
primitiveInPortWord: port stringLength: length
	| dataOop dataPtr |

	self primitive: 'primitiveInPortWordStringLength'
		parameters: #(SmallInteger SmallInteger).

	self var: #dataPtr type: 'unsigned char *'.
	dataOop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: length.
	dataPtr := interpreterProxy firstIndexableField: dataOop.

	self cCode: 'asm("rep insw"
		:
		: "d" ((unsigned short)port),
		  "c" ((unsigned int) (length >> 1)),
		  "D" (dataPtr)
		)'. 

	^ dataOop! !

!SqueakNOSPlugin methodsFor: 'lock memory addresses' stamp: 'Pocho 6/12/2010 00:20'!
primitiveMultibootInfoFromGrub
	| mbi |
	self primitive: 'primitiveMultibootInfoFromGrub'
		parameters: #().

	self cCode: 'extern Computer computer'.
	self var: 'mbi' type: 'usqInt'.
	
	self cCode: 'mbi = computer.mbi'.

	^ mbi asSmallIntegerObj.
! !

!SqueakNOSPlugin methodsFor: 'as yet unclassified' stamp: 'gera 9/21/2008 21:16'!
primitiveOFWCallout: anArray
	| answer length element |
	self primitive: 'primitiveOFWCallout' parameters: #(Array).

"	self var: #args declareC: 'unsigned long args[]={&milliseconds, 0, 1, &milliseconds}'.
	self var: #args declareC: 'unsigned long args[]={&""interpret"", 1, 0, &"".\"" Hello VPRI2\""""}'.
"
	length := interpreterProxy slotSizeOf: anArray cPtrAsOop.

	answer := 0.

	"convert everything to native format"
	0 to: length-1 do: [:i |
		element := anArray at: i.
		(interpreterProxy isIntegerObject: element)
			ifTrue: [anArray at: i put: (interpreterProxy integerValueOf: element)]
			ifFalse: [anArray at: i put: (interpreterProxy firstIndexableField: element)]
	].

	self cCode: 'asm("call *OFW_callout" : "=a" (answer) : "a" ((unsigned int)anArray))'. 
	"milliseconds := args at: 3."

	"convert everything to integers. oops will be lost, but that's fine. The client should mantain a reference"
	0 to: length-1 do: [:i |
		element := anArray at: i.
		anArray at: i put: (interpreterProxy positive32BitIntegerFor: element)
	].

	answer = 0
		ifTrue: [^ self]
		ifFalse: [interpreterProxy primitiveFail].
! !

!SqueakNOSPlugin methodsFor: 'port i/o' stamp: 'gera 5/9/2006 13:30'!
primitiveOutPort: portNumber byte: byte

	self primitive: 'primitiveOutPortByte'
		parameters: #(SmallInteger SmallInteger).

	self cCode: 'asm("out %0, %1" :: "a" ((unsigned char)byte), "d" ((unsigned short)portNumber))'
! !

!SqueakNOSPlugin methodsFor: 'port i/o' stamp: 'gera 11/14/2008 20:46'!
primitiveOutPort: port byteString: aString
	| length |

	self primitive: 'primitiveOutPortByteString'
		parameters: #(SmallInteger String).

	self var: #length type: 'unsigned int'.
	length := interpreterProxy slotSizeOf: aString cPtrAsOop.

	self cCode: 'asm("rep outsb"
		: 
		: "d" ((unsigned short)port),
		  "c" ((unsigned int) length),
		  "S" (aString)
		)'. 
! !

!SqueakNOSPlugin methodsFor: 'port i/o' stamp: 'gera 6/24/2006 21:01'!
primitiveOutPort: portNumber dword: dwordOop
	| dword |
	self primitive: 'primitiveOutPortDword'
		parameters: #(SmallInteger Oop).

	dword := interpreterProxy positive32BitValueOf: dwordOop.
	interpreterProxy failed ifTrue: [^nil].
	self cCode: 'asm("out %0, %1" :: "a" (dword), "d" ((unsigned short)portNumber))'
! !

!SqueakNOSPlugin methodsFor: 'port i/o' stamp: 'gera 11/14/2008 20:46'!
primitiveOutPort: port dwordString: aString
	| length |

	self primitive: 'primitiveOutPortDwordString'
		parameters: #(SmallInteger String).

	self var: #length type: 'unsigned int'.
	length := (interpreterProxy slotSizeOf: aString cPtrAsOop) >> 2.

	self cCode: 'asm("rep outsl"
		: 
		: "d" ((unsigned short)port),
		  "c" ((unsigned int) length),
		  "S" (aString)
		)'. 
! !

!SqueakNOSPlugin methodsFor: 'port i/o' stamp: 'gera 5/9/2006 13:30'!
primitiveOutPort: portNumber word: word

	self primitive: 'primitiveOutPortWord'
		parameters: #(SmallInteger SmallInteger).

	self cCode: 'asm("out %0, %1" :: "a" ((unsigned short)word), "d" ((unsigned short)portNumber))'
! !

!SqueakNOSPlugin methodsFor: 'port i/o' stamp: 'gera 11/14/2008 20:46'!
primitiveOutPort: port wordString: aString
	| length |

	self primitive: 'primitiveOutPortWordString'
		parameters: #(SmallInteger String).

	self var: #length type: 'unsigned int'.
	length := (interpreterProxy slotSizeOf: aString cPtrAsOop) >> 1.

	self cCode: 'asm("rep outsw"
		: 
		: "d" ((unsigned short)port),
		  "c" ((unsigned int) length),
		  "S" (aString)
		)'. 
! !

!SqueakNOSPlugin methodsFor: 'debugging' stamp: 'Pocho 6/14/2010 16:16'!
primitivePullDebugString
	| dataOop dataPtr length console |

	self primitive: 'primitivePullDebugString'
		parameters: #().

	self var: #dataPtr type: 'unsigned char *'.
	self var: #console type: 'extern Console'.
	self var: #length type: 'unsigned long'.
	self cCode: 'length = strlen(console.text)'.
	dataOop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: length + 1.
	dataPtr := interpreterProxy firstIndexableField: dataOop.

	self cCode: 'strcpy(dataPtr, console.text)'. 
	self cCode: 'console_clear(&console)'.

	^ dataOop
! !

!SqueakNOSPlugin methodsFor: 'processor registers' stamp: 'JavierPimas 12/18/2010 14:27'!
primitivePutIn32bitRegisterCr0
	"Store an unsigned integer into the CR0 register"
	"primitivePutIn32bitRegisterCr0: aStatusWord <Integer>"

	| aStatusWord | 
	self export: true.
	self var: aStatusWord type: 'long'.
	aStatusWord := interpreterProxy positive32BitValueOf: (interpreterProxy stackValue: 0).
	interpreterProxy failed ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadArgument].
	interpreterProxy pop: 1.
	self cCode: 'asm("movl %0, %%cr0" : "=g" (aStatusWord) )'
	
! !

!SqueakNOSPlugin methodsFor: 'processor registers' stamp: 'JavierPimas 12/18/2010 14:28'!
primitivePutIn32bitRegisterCr3
	"Store an unsigned integer into the CR3 register"
	"primitivePutIn32bitRegisterCr3: aStatusWord <Integer>"

	| aStatusWord | 
	self export: true.
	self var: aStatusWord type: 'long'.
	aStatusWord := interpreterProxy positive32BitValueOf: (interpreterProxy stackValue: 0).
	interpreterProxy failed ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadArgument].
	interpreterProxy pop: 1.
	self cCode: 'asm("movl %0, %%cr3" : "=g" (aStatusWord) )'! !

!SqueakNOSPlugin methodsFor: 'processor registers' stamp: 'JavierPimas 12/18/2010 14:25'!
primitiveRead32bitRegisterCr0
	| answer |
	self primitive: 'primitiveRead32bitRegisterCr0' parameters: #().
	self var: #answer type: 'unsigned long'.
	self cCode: 'asm("movl %%cr0, %0" : "=a" (answer) )'. 
	^interpreterProxy positive32BitIntegerFor: answer

! !

!SqueakNOSPlugin methodsFor: 'processor registers' stamp: 'JavierPimas 12/18/2010 14:26'!
primitiveRead32bitRegisterCr3
	| answer |
	self primitive: 'primitiveRead32bitRegisterCr3' parameters: #().
	self var: #answer type: 'unsigned long'.
	self cCode: 'asm("movl %%cr3, %0" : "=a" (answer) )'. 
	^interpreterProxy positive32BitIntegerFor: answer
! !

!SqueakNOSPlugin methodsFor: 'string i/o' stamp: 'gera 5/9/2006 15:13'!
primitiveReadStringLength: length fromMemoryAt: address
	| dataOop dataPtr |

	self primitive: 'primitiveReadStringLengthFromMemoryAt'
		parameters: #(SmallInteger SmallInteger).

	self var: #dataPtr type: 'unsigned char *'.
	dataOop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: length.
	dataPtr := interpreterProxy firstIndexableField: dataOop.
	self cCode: 'memcpy(dataPtr, (void*)address, length)'.
	^ dataOop! !

!SqueakNOSPlugin methodsFor: 'semaphore' stamp: 'gera 5/8/2006 02:55'!
primitiveRegisterSemaphoreIndex: aSemaphoreIndex forIRQ: irqNumber
	| IRQSemaphores |

	self primitive: 'primitiveRegisterSemaphoreIndexForIRQ'
		parameters: #(SmallInteger SmallInteger).

	self var: #IRQSemaphores type: 'extern t_IRQSemaphores'.

	irqNumber < (IRQSemaphores sizeof/(IRQSemaphores at: 0) sizeof)
			ifTrue: [IRQSemaphores at: irqNumber put: aSemaphoreIndex]
			ifFalse: [interpreterProxy primitiveFail].

	^ interpreterProxy trueObject! !

!SqueakNOSPlugin methodsFor: 'lock memory addresses' stamp: 'Pocho 6/1/2010 01:56'!
primitiveVMEndPosition
	| end |
	self primitive: 'primitiveVMEndPosition'
		parameters: #().

	self cCode: 'extern usqInt __end'.
	self var: 'end' type: 'usqInt'.
	
	self cCode: 'end = &__end'.

	^ end asSmallIntegerObj.
! !

!SqueakNOSPlugin methodsFor: 'string i/o' stamp: 'gera 5/9/2006 13:30'!
primitiveWriteString: aString toMemoryAt: address
	| length |
	self primitive: 'primitiveWriteStringToMemoryAt'
		parameters: #(String SmallInteger).

	length := interpreterProxy slotSizeOf: aString cPtrAsOop.
	self cCode: 'memcpy((void*)address, aString, length)'.
! !

MultiByteFileStream subclass: #MultiByteFilesystemFileStream
	instanceVariableNames: 'offset resize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Filesystems'!

!MultiByteFilesystemFileStream class methodsFor: 'instance creation' stamp: 'gc 5/13/2010 12:01'!
for: aFile
	^self new for: aFile.
	! !

!MultiByteFilesystemFileStream methodsFor: 'private' stamp: 'gc 7/16/2010 20:27'!
close
	^self primClose: fileID.! !

!MultiByteFilesystemFileStream methodsFor: 'accessing' stamp: ''!
filesystem
	^ fileID filesystem! !

!MultiByteFilesystemFileStream methodsFor: 'private' stamp: 'gc 7/16/2010 20:30'!
for: aFile
	fileID := aFile.
	name := aFile name.
	self register.
	offset := 0.
	rwmode := true.
	resize := false.
	buffer1 := String new: 1.
	self enableReadBuffering.
	converter := UTF8TextConverter new.
	self detectLineEndConvention.
	! !

!MultiByteFilesystemFileStream methodsFor: 'initialize-release' stamp: 'gc 7/16/2010 19:40'!
initialize
	super initialize.
	offset := 0.
	resize := false! !

!MultiByteFilesystemFileStream methodsFor: 'open/close' stamp: 'gc 6/29/2010 18:03'!
open: fileName forWrite: writeMode
	"Do nothing"! !

!MultiByteFilesystemFileStream methodsFor: 'private' stamp: 'Pocho 7/13/2010 11:20'!
primAtEnd: id
	^offset >= fileID size
! !

!MultiByteFilesystemFileStream methodsFor: 'private' stamp: 'Pocho 7/20/2010 16:32'!
primClose: id
	resize ifFalse: [^true].
	id filesystem cleanExtraSpace: id; flush.
	^true! !

!MultiByteFilesystemFileStream methodsFor: 'private' stamp: 'Pocho 7/20/2010 16:20'!
primFlush: id
	id filesystem flush! !

!MultiByteFilesystemFileStream methodsFor: 'private' stamp: 'gc 6/24/2010 14:59'!
primGetPosition: id
	^offset! !

!MultiByteFilesystemFileStream methodsFor: 'private' stamp: 'gc 7/5/2010 18:06'!
primRead: id into: byteArray startingAt: startIndex count: count
	"Read up to count bytes of data from this file into the given string or byte array starting at the given index. Answer the number of bytes actually read."
	| contents endIndex |
	contents := id filesystem
				contentsFor: id
				startingAt: offset
				count: (count min: (self size - offset)).
	endIndex := startIndex + (count min: contents size) - 1.			
	byteArray replaceFrom: startIndex to: endIndex with: contents.		
	self primSetPosition: id to: (self primGetPosition: id) + contents size.				
	^contents size! !

!MultiByteFilesystemFileStream methodsFor: 'private' stamp: 'gc 6/24/2010 14:57'!
primSetPosition: id to: anInteger
	anInteger > id size ifTrue: [self error: 'Out of bounds'].
	offset := anInteger! !

!MultiByteFilesystemFileStream methodsFor: 'private' stamp: 'gc 5/13/2010 12:37'!
primSize: id
	"Answer the size of this file."
	^fileID size! !

!MultiByteFilesystemFileStream methodsFor: 'private' stamp: 'JavierPimas 11/4/2010 12:32'!
primTruncate: id to: aSize
	"Truncate this file to the given position."
	fileID filesystem updateSizeOf: fileID with: aSize! !

!MultiByteFilesystemFileStream methodsFor: 'private' stamp: 'gc 6/30/2010 18:35'!
primWrite: id from: stringOrByteArray startingAt: startIndex count: count
	"Write count bytes onto this file from the given string or byte array starting at the given index. Answer the number of bytes written."
	| bytesWritten pos |
	pos := self primGetPosition: id.
	bytesWritten := id filesystem
		writeOn: id
		startingAt: pos
		contents: stringOrByteArray
		startingAt: 1
		count: count.
	self updateSizeAfterWriteUpTo: pos + bytesWritten.	
	self primSetPosition: id to: pos + bytesWritten.
	^bytesWritten	
		
	! !

!MultiByteFilesystemFileStream methodsFor: 'open/close' stamp: 'GuidoChari 8/3/2010 17:22'!
readOnlyCopy	
	^self copy readOnly.! !

!MultiByteFilesystemFileStream methodsFor: 'private' stamp: 'gc 6/26/2010 18:38'!
updateSizeAfterWriteUpTo: aNumber
	aNumber > fileID size ifTrue: [fileID filesystem updateSizeOf: fileID with: aNumber].! !

!MultiByteFilesystemFileStream methodsFor: 'readability' stamp: 'gc 7/16/2010 19:40'!
writeOnly
	super readWrite.
	resize := true.! !

MultiByteFileStream subclass: #RemoteMultiByteFileStream
	instanceVariableNames: 'channel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-FileSupport'!

!RemoteMultiByteFileStream methodsFor: 'remote file compatibility' stamp: 'gera 5/26/2006 09:52'!
atEnd
	^ self channel remotePerform: #atEnd! !

!RemoteMultiByteFileStream methodsFor: 'remote file compatibility' stamp: 'gera 5/25/2006 13:46'!
basicNext
	^ self channel remotePerform: #basicNext! !

!RemoteMultiByteFileStream methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 14:04'!
channel
	channel
		ifNil: [channel := RemoteObjectChannel for: self using: 'MultiByteFileStream new'].
	^ channel! !

!RemoteMultiByteFileStream methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 12:24'!
channel: aStream
	channel := aStream! !

!RemoteMultiByteFileStream methodsFor: 'remote file compatibility' stamp: 'gera 5/26/2006 09:53'!
close
	^ self channel remotePerform: #close! !

!RemoteMultiByteFileStream methodsFor: 'remote file compatibility' stamp: 'gera 5/26/2006 08:33'!
closed
	^ self channel remotePerform: #closed! !

!RemoteMultiByteFileStream methodsFor: 'remote file compatibility' stamp: 'gera 5/26/2006 08:33'!
ensureOpen
	^ self channel remotePerform: #ensureOpen! !

!RemoteMultiByteFileStream methodsFor: 'remote file compatibility' stamp: 'gera 5/26/2006 09:53'!
finalize
	^ self channel remotePerform: #finalize! !

!RemoteMultiByteFileStream methodsFor: 'remote file compatibility' stamp: 'gera 5/26/2006 09:54'!
flush
	^ self channel remotePerform: #flush! !

!RemoteMultiByteFileStream methodsFor: 'as yet unclassified' stamp: 'gera 5/26/2006 10:05'!
next: anInteger
	^ self channel remotePerform: #next: with: anInteger! !

!RemoteMultiByteFileStream methodsFor: 'remote file compatibility' stamp: 'gera 5/26/2006 09:58'!
next: anInteger putAll: aString startingAt: startIndex
	^ self nextPutAll: (aString copyFrom: startIndex to: startIndex + anInteger)! !

!RemoteMultiByteFileStream methodsFor: 'as yet unclassified' stamp: 'gera 5/26/2006 20:01'!
nextChunk
	^ self channel remotePerform: #nextChunk! !

!RemoteMultiByteFileStream methodsFor: 'as yet unclassified' stamp: 'gera 5/27/2006 12:08'!
nextChunkText
	^ self channel remotePerform: #nextChunkText! !

!RemoteMultiByteFileStream methodsFor: 'remote file compatibility' stamp: 'gera 5/27/2006 12:15'!
nextPut: char
	^ self channel remotePerform: #nextPut: with: char! !

!RemoteMultiByteFileStream methodsFor: 'remote file compatibility' stamp: 'gera 5/26/2006 09:56'!
nextPutAll: aString
	^ self channel remotePerform: #nextPutAll: with: aString! !

!RemoteMultiByteFileStream methodsFor: 'remote file compatibility' stamp: 'gera 5/27/2006 12:10'!
open: fileName forWrite: writableFlag
	name := fileName.
	rwmode := writableFlag.
	^ self channel remotePerform: #open:forWrite: with: fileName with: writableFlag
! !

!RemoteMultiByteFileStream methodsFor: 'as yet unclassified' stamp: 'gera 5/28/2006 14:46'!
peek
	^ self channel remotePerform: #peek! !

!RemoteMultiByteFileStream methodsFor: 'remote file compatibility' stamp: 'gera 5/26/2006 08:26'!
position
	^ self channel remotePerform: #position! !

!RemoteMultiByteFileStream methodsFor: 'remote file compatibility' stamp: 'gera 5/26/2006 10:48'!
position: pos
	^ self channel remotePerform: #position: with: pos! !

!RemoteMultiByteFileStream methodsFor: 'primitives' stamp: 'gera 5/26/2006 08:34'!
primAtEnd: id
	self shouldNotImplement! !

!RemoteMultiByteFileStream methodsFor: 'primitives' stamp: 'gera 5/26/2006 08:34'!
primClose: id
	self shouldNotImplement! !

!RemoteMultiByteFileStream methodsFor: 'primitives' stamp: 'gera 5/26/2006 08:34'!
primCloseNoError: id
	self shouldNotImplement! !

!RemoteMultiByteFileStream methodsFor: 'primitives' stamp: 'gera 5/26/2006 08:34'!
primFlush: id
	self shouldNotImplement! !

!RemoteMultiByteFileStream methodsFor: 'primitives' stamp: 'gera 5/26/2006 08:26'!
primGetPosition: id
	^ self shouldNotImplement! !

!RemoteMultiByteFileStream methodsFor: 'primitives' stamp: 'gera 5/26/2006 08:26'!
primOpen: fileName writable: writableFlag
	self shouldNotImplement! !

!RemoteMultiByteFileStream methodsFor: 'primitives' stamp: 'gera 5/26/2006 08:26'!
primRead: id into: byteArray startingAt: startIndex count: count
	"The main problem with this primitive is that it replaces the contents of the string,
	and that is not reflected in the answer. We'll need to hack something if needed"
	self shouldNotImplement.! !

!RemoteMultiByteFileStream methodsFor: 'primitives' stamp: 'gera 5/26/2006 08:27'!
primSetPosition: id to: anInteger
	self shouldNotImplement! !

!RemoteMultiByteFileStream methodsFor: 'primitives' stamp: 'gera 5/26/2006 08:32'!
primSize: id
	self shouldNotImplement! !

!RemoteMultiByteFileStream methodsFor: 'primitives' stamp: 'gera 5/26/2006 08:34'!
primSizeNoError: id
	self shouldNotImplement! !

!RemoteMultiByteFileStream methodsFor: 'primitives' stamp: 'gera 5/26/2006 09:51'!
primTruncate: id to: anInteger
	self shouldNotImplement! !

!RemoteMultiByteFileStream methodsFor: 'primitives' stamp: 'gera 5/26/2006 09:51'!
primWrite: id from: stringOrByteArray startingAt: startIndex count: count

	self shouldNotImplement! !

!RemoteMultiByteFileStream methodsFor: 'remote file compatibility' stamp: 'gera 5/26/2006 09:54'!
reopen
	^ self channel remotePerform: #reopen! !

!RemoteMultiByteFileStream methodsFor: 'remote file compatibility' stamp: 'gera 5/26/2006 08:32'!
size
	^ self channel remotePerform: #size! !

!RemoteMultiByteFileStream methodsFor: 'as yet unclassified' stamp: 'gera 5/28/2006 14:01'!
skipSeparators
	^ self channel remotePerform: #skipSeparators! !

!RemoteMultiByteFileStream methodsFor: 'remote file compatibility' stamp: 'gera 5/26/2006 09:55'!
truncate: pos
	^ self channel remotePerform: #truncate: with: pos! !

!RemoteMultiByteFileStream methodsFor: 'as yet unclassified' stamp: 'gera 5/27/2006 11:05'!
upTo: aCharacter
	^ self channel remotePerform: #upTo: with: aCharacter! !

Interval subclass: #Segment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Storage'!

!Segment methodsFor: 'as yet unclassified' stamp: 'Pocho 7/20/2010 09:15'!
intersects: anotherSegment
	start > anotherSegment stop ifTrue: [^false].
	stop < anotherSegment start ifTrue: [^false].
	^true.! !

ReadWriteStream subclass: #DeviceStream
	instanceVariableNames: 'device'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-FileSupport'!

!DeviceStream commentStamp: '<historical>' prior: 0!
a DeviceStream is a ReadWriteStream on top of a Device

a Device must understand
#next, #nextPut: , #reopen, #isOpen, #flush, #close, #dataAvailable!

!DeviceStream class methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 21:59'!
on: aDevice
	^ self basicNew device: aDevice! !

!DeviceStream methodsFor: 'fileIn/Out' stamp: 'r++ 3/31/2001 19:22'!
atEnd
	^ device isOpen not! !

!DeviceStream methodsFor: 'accessing' stamp: 'r++ 3/31/2001 19:26'!
close
	device close! !

!DeviceStream methodsFor: 'testing' stamp: 'r++ 3/31/2001 19:36'!
dataAvailable
	^ device dataAvailable! !

!DeviceStream methodsFor: 'accessing' stamp: 'r++ 3/31/2001 19:24'!
device: aDevice
	device _ aDevice! !

!DeviceStream methodsFor: 'accessing' stamp: 'r++ 3/31/2001 19:26'!
flush
	device flush! !

!DeviceStream methodsFor: 'fileIn/Out' stamp: 'r++ 3/31/2001 19:22'!
next
	^ device next! !

!DeviceStream methodsFor: 'fileIn/Out' stamp: 'gera 5/25/2006 22:39'!
next: anInteger
	^ device next: anInteger! !

!DeviceStream methodsFor: 'fileIn/Out' stamp: 'r++ 3/31/2001 19:22'!
nextPut: anObject
	^ device nextPut: anObject! !

!DeviceStream methodsFor: 'accessing' stamp: 'r++ 3/31/2001 19:25'!
reopen
	^ device reopen! !

FileDirectory subclass: #RemoteFileDirectory
	instanceVariableNames: 'channel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-FileSupport'!

!RemoteFileDirectory class methodsFor: 'as yet unclassified' stamp: 'gera 5/27/2006 13:04'!
isActiveDirectoryClass
	^ Computer isSqueakNOS! !

!RemoteFileDirectory class methodsFor: 'as yet unclassified' stamp: 'gera 5/26/2006 11:33'!
pathNameDelimiter
	^ $/! !

!RemoteFileDirectory methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 14:04'!
channel
	channel
		ifNil: [channel := RemoteObjectChannel for: self using: 'FileDirectory on: ' , pathName pathName storeString].
	^ channel! !

!RemoteFileDirectory methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 12:24'!
channel: aStream
	channel := aStream! !

!RemoteFileDirectory methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 11:58'!
primCreateDirectory: fullPath
	^ self channel remotePerform: #primCreateDirectory: with: fullPath! !

!RemoteFileDirectory methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 11:59'!
primDeleteDirectory: fullPath
	^ self channel remotePerform: #primDeleteDirectory: with: fullPath! !

!RemoteFileDirectory methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 12:02'!
primDeleteFileNamed: aFileName
	^ self channel remotePerform: #primDeleteFileNamed: with: aFileName! !

!RemoteFileDirectory methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 12:03'!
primLookupEntryIn: fullPath index: index
	^ self channel remotePerform: #primLookupEntryIn:index: with: fullPath with: index! !

!RemoteFileDirectory methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 11:57'!
primRename: oldFileFullName to: newFileFullName 
	^ self channel remotePerform: #primRename:to: with: oldFileFullName with: newFileFullName.
! !

ExternalStructure subclass: #DisplayInformation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-External-Structures'!

!DisplayInformation class methodsFor: 'accessing' stamp: 'gc 6/15/2010 19:13'!
fields
	^#(
		(width 'ulong')
		(height 'ulong')
		(depth 'ulong')
		(address 'ulong')
		(bytesPerScanLine 'ulong')
	    )! !

!DisplayInformation methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
address
	"This method was automatically generated"
	^handle unsignedLongAt: 13! !

!DisplayInformation methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
address: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 13 put: anObject! !

!DisplayInformation methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
bytesPerScanLine
	"This method was automatically generated"
	^handle unsignedLongAt: 17! !

!DisplayInformation methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
bytesPerScanLine: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 17 put: anObject! !

!DisplayInformation methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
depth
	"This method was automatically generated"
	^handle unsignedLongAt: 9! !

!DisplayInformation methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
depth: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 9 put: anObject! !

!DisplayInformation methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
height
	"This method was automatically generated"
	^handle unsignedLongAt: 5! !

!DisplayInformation methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
height: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 5 put: anObject! !

!DisplayInformation methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
width
	"This method was automatically generated"
	^handle unsignedLongAt: 1! !

!DisplayInformation methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
width: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 1 put: anObject! !

ExternalStructure subclass: #ElfSectionHeaderTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-External-Structures'!

!ElfSectionHeaderTable class methodsFor: 'accessing' stamp: 'gc 6/16/2010 17:53'!
fields
	^#(
		(number 'ulong')
		(size 'ulong')
		(address 'ulong')
		(shndx 'ulong')
	   )! !

!ElfSectionHeaderTable methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
address
	"This method was automatically generated"
	^handle unsignedLongAt: 9! !

!ElfSectionHeaderTable methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
address: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 9 put: anObject! !

!ElfSectionHeaderTable methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
number
	"This method was automatically generated"
	^handle unsignedLongAt: 1! !

!ElfSectionHeaderTable methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
number: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 1 put: anObject! !

!ElfSectionHeaderTable methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
shndx
	"This method was automatically generated"
	^handle unsignedLongAt: 13! !

!ElfSectionHeaderTable methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
shndx: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 13 put: anObject! !

!ElfSectionHeaderTable methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
size
	"This method was automatically generated"
	^handle unsignedLongAt: 5! !

!ElfSectionHeaderTable methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
size: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 5 put: anObject! !

!ExternalStructure class methodsFor: '*SqueakNOS' stamp: 'gera 7/4/2006 10:35'!
externalNewAligned: byteAlign
	"Create an instance of the receiver on the external heap"
	^self fromHandle: (ExternalAddress allocate: self byteSize aligned: byteAlign)! !

!ExternalStructure methodsFor: '*SqueakNOS' stamp: 'gera 7/6/2006 16:57'!
address
	^ handle asInteger! !

ExternalStructure subclass: #IDEHardDiskDeviceInformation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Storage'!

!IDEHardDiskDeviceInformation class methodsFor: 'as yet unclassified' stamp: 'richie 8/31/2009 11:20'!
fields
	"self defineFields"
	^#(
		(configuration		'short')		" 0 "
		(cylindersDefault	'short')
		(specific			'short')
		(headsDefault		'short')
		(nil					'long')		" 4-5 "
		(sectorsDefault		'short')		" 6 "
		(nil					'long')		" 7-8 "
		(nil					'short')		" 9 "
		(serial				'string' 20)	" 10-19 "
		(nil					'long')		" 20-21 "
		(nil					'short')
		(version			'string' 8)	" 23-26 "
		(model				'string' 40)	" 27-46 "
		(sectorsMultipleMax	'short')		" 47 "
		(nil					'short')
		(capabilities			'long')
		(nil					'long')
		(validity			'short')		" 53 "
		(cylindersCurrent	'short')
		(headsCurrent		'short')
		(sectorsCurrent		'short')
		(totalSectorsCurrent	'long')
		(sectorsMultiple		'short')
		(sectors				'long')		" 60-61 "
		(nil					'short')
		(multiwordDMAtransfer		'short')
		(pioMode			'short')
		(minMultiwordDMAtime	'short')

	)! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
capabilities
	"This method was automatically generated"
	^handle signedLongAt: 99! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
capabilities: anObject
	"This method was automatically generated"
	handle signedLongAt: 99 put: anObject! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
configuration
	"This method was automatically generated"
	^handle signedShortAt: 1! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
configuration: anObject
	"This method was automatically generated"
	handle signedShortAt: 1 put: anObject! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
cylindersCurrent
	"This method was automatically generated"
	^handle signedShortAt: 109! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
cylindersCurrent: anObject
	"This method was automatically generated"
	handle signedShortAt: 109 put: anObject! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
cylindersDefault
	"This method was automatically generated"
	^handle signedShortAt: 3! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
cylindersDefault: anObject
	"This method was automatically generated"
	handle signedShortAt: 3 put: anObject! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
headsCurrent
	"This method was automatically generated"
	^handle signedShortAt: 111! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
headsCurrent: anObject
	"This method was automatically generated"
	handle signedShortAt: 111 put: anObject! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
headsDefault
	"This method was automatically generated"
	^handle signedShortAt: 7! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
headsDefault: anObject
	"This method was automatically generated"
	handle signedShortAt: 7 put: anObject! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
minMultiwordDMAtime
	"This method was automatically generated"
	^handle signedShortAt: 131! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
minMultiwordDMAtime: anObject
	"This method was automatically generated"
	handle signedShortAt: 131 put: anObject! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:46'!
model
	^self stringAt: 55 length: 40! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
multiwordDMAtransfer
	"This method was automatically generated"
	^handle signedShortAt: 127! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
multiwordDMAtransfer: anObject
	"This method was automatically generated"
	handle signedShortAt: 127 put: anObject! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
pioMode
	"This method was automatically generated"
	^handle signedShortAt: 129! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
pioMode: anObject
	"This method was automatically generated"
	handle signedShortAt: 129 put: anObject! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
sectors
	"This method was automatically generated"
	^handle signedLongAt: 121! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
sectors: anObject
	"This method was automatically generated"
	handle signedLongAt: 121 put: anObject! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
sectorsCurrent
	"This method was automatically generated"
	^handle signedShortAt: 113! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
sectorsCurrent: anObject
	"This method was automatically generated"
	handle signedShortAt: 113 put: anObject! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
sectorsDefault
	"This method was automatically generated"
	^handle signedShortAt: 13! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
sectorsDefault: anObject
	"This method was automatically generated"
	handle signedShortAt: 13 put: anObject! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
sectorsMultiple
	"This method was automatically generated"
	^handle signedShortAt: 119! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
sectorsMultiple: anObject
	"This method was automatically generated"
	handle signedShortAt: 119 put: anObject! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
sectorsMultipleMax
	"This method was automatically generated"
	^handle signedShortAt: 95! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
sectorsMultipleMax: anObject
	"This method was automatically generated"
	handle signedShortAt: 95 put: anObject! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:46'!
serial
	^self stringAt: 21 length: 10! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
specific
	"This method was automatically generated"
	^handle signedShortAt: 5! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
specific: anObject
	"This method was automatically generated"
	handle signedShortAt: 5 put: anObject! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:46'!
stringAt: byteOffset length: length
	"Return a structure of the given length starting at the indicated byte offset."
	| value |
	value := String new: length.
	1 to: length do:[:i|
		value
			at: i + (i odd ifTrue: [1] ifFalse: [-1])
			put: (handle unsignedCharAt: byteOffset+i-1)].
	^value! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
totalSectorsCurrent
	"This method was automatically generated"
	^handle signedLongAt: 115! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
totalSectorsCurrent: anObject
	"This method was automatically generated"
	handle signedLongAt: 115 put: anObject! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
validity
	"This method was automatically generated"
	^handle signedShortAt: 107! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:19'!
validity: anObject
	"This method was automatically generated"
	handle signedShortAt: 107 put: anObject! !

!IDEHardDiskDeviceInformation methodsFor: 'accessing' stamp: 'richie 8/31/2009 11:42'!
version
	^self stringAt: 47 length: 8
! !

ExternalStructure subclass: #KernelModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-External-Structures'!

!KernelModule class methodsFor: 'accessing' stamp: 'gc 6/16/2010 18:25'!
fields
	^#(
		(start 'ulong')
		(end 'ulong')
		(string 'ulong')
		(reserved 'ulong')
	   )! !

!KernelModule methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
end
	"This method was automatically generated"
	^handle unsignedLongAt: 5! !

!KernelModule methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
end: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 5 put: anObject! !

!KernelModule methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
reserved
	"This method was automatically generated"
	^handle unsignedLongAt: 13! !

!KernelModule methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
reserved: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 13 put: anObject! !

!KernelModule methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
start
	"This method was automatically generated"
	^handle unsignedLongAt: 1! !

!KernelModule methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
start: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 1 put: anObject! !

!KernelModule methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
string
	"This method was automatically generated"
	^handle unsignedLongAt: 9! !

!KernelModule methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
string: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 9 put: anObject! !

ExternalStructure subclass: #LanceNICInitializationBlock16
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Network'!

!LanceNICInitializationBlock16 commentStamp: 'gera 7/6/2006 10:07' prior: 0!
16 bits version of the initialization block.
see http://www.amd.com/files/connectivitysolutions/networking/archivednetworking/19436.pdf
page 156!

!LanceNICInitializationBlock16 class methodsFor: 'as yet unclassified' stamp: 'gera 7/8/2006 11:55'!
fields
	"self defineFields"
	^#(
		(mode 'ushort')
		(mac0 'ushort')
		(mac1 'ushort')
		(mac2 'ushort')
		(ladrf0 'ulong')
		(ladrf1 'ulong')
		(rdra0 'ushort')
		(rdra1 'byte')
		(rlen 'byte')
		(tdra0 'ushort')
		(tdra1 'byte')
		(tlen 'byte')
	)! !

!LanceNICInitializationBlock16 methodsFor: 'testing' stamp: 'gera 7/6/2006 10:08'!
is16
	^ true! !

!LanceNICInitializationBlock16 methodsFor: 'testing' stamp: 'gera 7/6/2006 10:08'!
is32
	^ false! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
ladrf0
	"This method was automatically generated"
	^handle unsignedLongAt: 9! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
ladrf0: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 9 put: anObject! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
ladrf1
	"This method was automatically generated"
	^handle unsignedLongAt: 13! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
ladrf1: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 13 put: anObject! !

!LanceNICInitializationBlock16 methodsFor: 'accessing - noauto' stamp: 'gera 7/8/2006 11:48'!
logicalAddressFilter
	^ self ladrf1 << 32 + self ladrf0! !

!LanceNICInitializationBlock16 methodsFor: 'accessing - noauto' stamp: 'gera 7/8/2006 11:48'!
logicalAddressFilter: a64BitsInteger
	self ladrf0: (a64BitsInteger bitAnd: 16rFFFFFFFF).
	self ladrf1: (a64BitsInteger >> 32 bitAnd: 16rFFFFFFFF).

! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
mac0
	"This method was automatically generated"
	^handle unsignedShortAt: 3! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
mac0: anObject
	"This method was automatically generated"
	handle unsignedShortAt: 3 put: anObject! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
mac1
	"This method was automatically generated"
	^handle unsignedShortAt: 5! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
mac1: anObject
	"This method was automatically generated"
	handle unsignedShortAt: 5 put: anObject! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
mac2
	"This method was automatically generated"
	^handle unsignedShortAt: 7! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
mac2: anObject
	"This method was automatically generated"
	handle unsignedShortAt: 7 put: anObject! !

!LanceNICInitializationBlock16 methodsFor: 'accessing - noauto' stamp: 'gera 7/16/2006 17:46'!
macAddress
	| addr |
	addr := self mac2 << 16 + self mac1 << 16 + self mac0.
	^ EthernetAddress fromInteger: addr! !

!LanceNICInitializationBlock16 methodsFor: 'accessing - noauto' stamp: 'gera 7/16/2006 17:47'!
macAddress: anEthernetAddress
	| a6BytesInteger |
	a6BytesInteger := anEthernetAddress asInteger.
	self mac0: (a6BytesInteger bitAnd: 16rFFFF).
	self mac1: (a6BytesInteger >> 16 bitAnd: 16rFFFF).
	self mac2: (a6BytesInteger >> 32 bitAnd: 16rFFFF).
! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
mode
	"This method was automatically generated"
	^handle unsignedShortAt: 1! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
mode: anObject
	"This method was automatically generated"
	handle unsignedShortAt: 1 put: anObject! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
rdra0
	"This method was automatically generated"
	^handle unsignedShortAt: 17! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
rdra0: anObject
	"This method was automatically generated"
	handle unsignedShortAt: 17 put: anObject! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
rdra1
	"This method was automatically generated"
	^handle unsignedByteAt: 19! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
rdra1: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 19 put: anObject! !

!LanceNICInitializationBlock16 methodsFor: 'accessing - noauto' stamp: 'gera 7/9/2006 18:53'!
receiveRing
	^ LanceNICReceiveRingDescriptor16 fromHandle: (ExternalAddress new fromInteger: (self receiveRingAddress))! !

!LanceNICInitializationBlock16 methodsFor: 'accessing - noauto' stamp: 'gera 7/6/2006 16:59'!
receiveRing: aLanceNICReceiveRing
	^ self receiveRingAddress: aLanceNICReceiveRing address! !

!LanceNICInitializationBlock16 methodsFor: 'accessing - noauto' stamp: 'gera 7/8/2006 11:52'!
receiveRingAddress
	^ self rdra1  << 16 + self rdra0! !

!LanceNICInitializationBlock16 methodsFor: 'accessing - noauto' stamp: 'gera 7/8/2006 11:52'!
receiveRingAddress: address
	((address bitXor: self address) bitAnd: 16rFF000000) isZero
		ifFalse: [^ self error: 'In 16 bits mode the address for the receive buffer must share the higher byte with that of the initialization block'].
	self rdra0: (address bitAnd: 16rFFFF).
	^ self rdra1: (address >> 16 bitAnd: 16rFF)! !

!LanceNICInitializationBlock16 methodsFor: 'accessing - noauto' stamp: 'gera 7/8/2006 11:53'!
receiveRingLen
	^ self rlen >> 5! !

!LanceNICInitializationBlock16 methodsFor: 'accessing - noauto' stamp: 'gera 7/8/2006 11:53'!
receiveRingLen: ringLen
	^ self rlen: ringLen << 5! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
rlen
	"This method was automatically generated"
	^handle unsignedByteAt: 20! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
rlen: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 20 put: anObject! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
tdra0
	"This method was automatically generated"
	^handle unsignedShortAt: 21! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
tdra0: anObject
	"This method was automatically generated"
	handle unsignedShortAt: 21 put: anObject! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
tdra1
	"This method was automatically generated"
	^handle unsignedByteAt: 23! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
tdra1: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 23 put: anObject! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
tlen
	"This method was automatically generated"
	^handle unsignedByteAt: 24! !

!LanceNICInitializationBlock16 methodsFor: 'accessing' stamp: 'gera 7/8/2006 11:56'!
tlen: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 24 put: anObject! !

!LanceNICInitializationBlock16 methodsFor: 'accessing - noauto' stamp: 'gera 7/9/2006 18:53'!
transmitRing
	^ LanceNICTransmitRingDescriptor16 fromHandle: (ExternalAddress new fromInteger: (self transmitRingAddress))! !

!LanceNICInitializationBlock16 methodsFor: 'accessing - noauto' stamp: 'gera 7/15/2006 01:12'!
transmitRing: aLanceNICTransmitRing
	^ self transmitRingAddress: aLanceNICTransmitRing address! !

!LanceNICInitializationBlock16 methodsFor: 'accessing - noauto' stamp: 'gera 7/8/2006 13:59'!
transmitRingAddress
	^ self tdra1 << 16 + self tdra0 + (self address bitAnd: 16rFF000000)! !

!LanceNICInitializationBlock16 methodsFor: 'accessing - noauto' stamp: 'gera 7/8/2006 14:02'!
transmitRingAddress: address
	((address bitXor: self address) bitAnd: 16rFF000000) isZero
		ifFalse: [^ self error: 'In 16 bits mode all addresses must share the higher byte'].
	self tdra0: (address bitAnd: 16rFFFF).
	^ self tdra1: (address >> 16 bitAnd: 16rFF)! !

!LanceNICInitializationBlock16 methodsFor: 'accessing - noauto' stamp: 'gera 7/8/2006 11:54'!
transmitRingLen
	^ self tlen >> 5! !

!LanceNICInitializationBlock16 methodsFor: 'accessing - noauto' stamp: 'gera 7/8/2006 11:54'!
transmitRingLen: ringLen
	^ self tlen: ringLen << 5! !

ExternalStructure subclass: #LanceNICRingDescriptor16
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Network'!

LanceNICRingDescriptor16 subclass: #LanceNICReceiveRingDescriptor16
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Network'!

!LanceNICReceiveRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:24'!
bufferError
	"Buffer error is set any time the PCnet-PCI II controller does not
	own the next buffer while data chaining a received frame. This
	can occur in either of two ways:
		1. The OWN bit of the next buffer is ZERO.
		2. FIFO overflow occurred before the PCnet-PCI II controller
		was able to read the OWNbit of the next descriptor.
	If a Buffer Error occurs, an Overflow Error may also occur
	internally in the FIFO, but will not be reported in the descriptor status
	entry unless both BUFF and OFLO errors occur at the same
	time. BUFF is set by the PCnet-PCI II controller and cleared
	by the host."
	^ self flagsBit: 2! !

!LanceNICReceiveRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:23'!
bufferErrorClear
	^ self flagsBitClear: 2! !

!LanceNICReceiveRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:24'!
crcError
	"CRC indicates that the receiver has detected a CRC (FCS) error
	on the incoming frame. CRC is valid only when ENP is set and
	OFLO is not. CRC is set by the PCnet-PCI II controller and
	cleared by the host."
	^ self flagsBit: 3! !

!LanceNICReceiveRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:23'!
crcErrorClear
	^ self flagsBitClear: 3! !

!LanceNICReceiveRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:24'!
frameError
	"Framing error indicates that the incoming frame contains a
	non-integer multiple of eight bits and there was an FCS error. If
	there was no FCS error on the in coming frame, then FRAM will
	not be set even if there was a non-integer multiple of eight bits
	in the frame. FRAM is not valid in internal loopback mode. FRAM is
	valid only when ENP is set and OFLO is not. FRAM is set by the
	PCnet-PCI II controller and cleared by the host."

	^ self flagsBit: 5! !

!LanceNICReceiveRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:23'!
frameErrorClear
	^ self flagsBitClear: 5! !

!LanceNICReceiveRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/27/2006 19:13'!
messageSize
	"Message Byte Count is the length in bytes of the received
	message, expressed as an unsigned binary integer. MCNT is
	valid only when ERR is clear and ENP is set. MCNT is written by
	the PCnet-PCI II controller and cleared by the host."
	^ self mcnttdr - 4! !

!LanceNICReceiveRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/27/2006 19:13'!
messageSize: size
	"Message Byte Count is the length in bytes of the received
	message, expressed as an unsigned binary integer. MCNT is
	valid only when ERR is clear and ENP is set. MCNT is written by
	the PCnet-PCI II controller and cleared by the host."
	^ self mcnttdr: size ! !

!LanceNICReceiveRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:24'!
overflowError
	"Overflow error indicates that the receiver has lost all or part of the
	incoming frame, due to an inability to move data from the receive
	FIFO into a memory buffer before the internal FIFO overflowed.
	OFLO is valid only when ENP is not set. OFLO is set by the PC-
	net-PCI II controller and cleared by the host."
	^ self flagsBit: 4! !

!LanceNICReceiveRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:23'!
overflowErrorClear
	^ self flagsBitClear: 4! !

!LanceNICRingDescriptor16 class methodsFor: 'as yet unclassified' stamp: 'gera 7/13/2006 23:00'!
fields
	"self defineFields"
	^#(
		(badr0 'ushort')
		(badr1 'byte')
		(flags 'byte')
		(bcnt 'ushort')
		(mcnttdr 'ushort')
	)! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/14/2006 11:24'!
anyError
	"ERR is the OR of FRAM, OFLO, CRC, BUFF or BPE. ERR is set
	by the PCnet-PCI II controller and cleared by the host."

	^ self flagsBit: 6! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/14/2006 11:23'!
anyErrorClear
	^ self flagsBitClear: 6! !

!LanceNICRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/13/2006 23:01'!
badr0
	"This method was automatically generated"
	^handle unsignedShortAt: 1! !

!LanceNICRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/13/2006 23:01'!
badr0: anObject
	"This method was automatically generated"
	handle unsignedShortAt: 1 put: anObject! !

!LanceNICRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/13/2006 23:01'!
badr1
	"This method was automatically generated"
	^handle unsignedByteAt: 3! !

!LanceNICRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/13/2006 23:01'!
badr1: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 3 put: anObject! !

!LanceNICRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/13/2006 23:01'!
bcnt
	"This method was automatically generated"
	^handle unsignedShortAt: 5! !

!LanceNICRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/13/2006 23:01'!
bcnt: anObject
	"This method was automatically generated"
	handle unsignedShortAt: 5 put: anObject! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/14/2006 11:23'!
beOwnedByCard
	^ self flagsBitSet: 7! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/14/2006 11:23'!
beOwnedByHost
	^ self flagsBitClear: 7! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/13/2006 23:01'!
buffer
	^ ExternalAddress new fromInteger: (self bufferAddress)! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/13/2006 23:02'!
buffer: anExternalAddress
	^ self bufferAddress: anExternalAddress asInteger 
! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/13/2006 23:08'!
bufferAddress
	^ self badr1 << 16 + self badr0 + (self address bitAnd: 16rFF000000)! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/13/2006 23:08'!
bufferAddress: address
	((address bitXor: self address) bitAnd: 16rFF000000) isZero
		ifFalse: [^ self error: 'In 16 bits mode all addresses must share the higher byte'].
	self badr0: (address bitAnd: 16rFFFF).
	^ self badr1: (address >> 16 bitAnd: 16rFF)! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/13/2006 23:02'!
bufferSize
	"BCNT Buffer Byte Count is the length of the buffer pointed to
	by this de scriptor, expressed as the two's complement of the
	length of the buffer. This field is written by the host and
	unchanged by the PCnet-PCI II controller."
	^ 16r10000 - self bcnt! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/13/2006 23:02'!
bufferSize: size
	^ self bcnt: (size negated bitAnd: 16rFFFF)! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/15/2006 01:21'!
endOfPacketClear
	^ self flagsBitClear: 0! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/15/2006 01:21'!
endOfPacketSet
	^ self flagsBitSet: 0! !

!LanceNICRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/13/2006 23:01'!
flags
	"This method was automatically generated"
	^handle unsignedByteAt: 4! !

!LanceNICRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/13/2006 23:01'!
flags: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 4 put: anObject! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/14/2006 11:22'!
flagsBit: index
	^ self flags anyMask: 1 << index! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/14/2006 11:23'!
flagsBitClear: index
	^ self flags: (self flags bitAnd: (1 << index) bitInvert)! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/14/2006 11:22'!
flagsBitSet: index
	^ self flags: (self flags bitOr: 1 << index)! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/14/2006 11:24'!
isEndOfPacket
	"End of Packet (ENP) indicates that this is the last buffer used by the
	PCnet-PCI II controller for this frame. It is used for data chaining
	buffers. If both STP and ENP are set, the frame fits into one buffer
	and there is no data chaining. ENP is set by the PCnet-PCI II controller
	and cleared by the host."
	^ self flagsBit: 0! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/14/2006 11:24'!
isOwnedByCard
	^ self flagsBit: 7! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/13/2006 23:04'!
isOwnedByHost
	^ self isOwnedByCard not! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/14/2006 11:24'!
isStartOfPacket
	"Start of Packet (STP) indicates that this is the first buffer used by the
	PCnet-PCI II controller for this frame. If STP and ENP are both
	set to ONE, the frame fits into a single buffer. Otherwise, the
	frame is spread over more than one buffer. When LAPPEN
	(CSR3, bit 5) is cleared to ZERO, STP is set by the PCnet-PCI II
	controller and cleared by the host. When LAPPEN is set to
	ONE, STP must be set by the host."
	^ self flagsBit: 1! !

!LanceNICRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/13/2006 23:01'!
mcnttdr
	"This method was automatically generated"
	^handle unsignedShortAt: 7! !

!LanceNICRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/13/2006 23:01'!
mcnttdr: anObject
	"This method was automatically generated"
	handle unsignedShortAt: 7 put: anObject! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/14/2006 11:22'!
mcnttdrBit: index
	^ self mcnttdr anyMask: 1 << index! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/14/2006 11:22'!
mcnttdrBitClear: index
	^ self mcnttdr: (self mcnttdr bitAnd: (1 << index) bitInvert)! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/14/2006 11:22'!
mcnttdrBitSet: index
	^ self mcnttdr: (self mcnttdr bitOr: 1 << index)! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/13/2006 23:11'!
message
	^ self buffer stringAt: 1 size: self messageSize! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/15/2006 00:41'!
message: aString
	^ self buffer stringAt: 1 put: aString! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/14/2006 00:42'!
reset
	self
		flags: 0;
		mcnttdr: 0.! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/15/2006 01:21'!
startOfPacketClear
	^ self flagsBitClear: 1! !

!LanceNICRingDescriptor16 methodsFor: 'accessing - no auto' stamp: 'gera 7/15/2006 01:27'!
startOfPacketSet
	^ self flagsBitSet: 1! !

LanceNICRingDescriptor16 subclass: #LanceNICTransmitRingDescriptor16
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Network'!

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:29'!
bufferError
	"bit 15 - BUFF
	Buffer error is set by the PCnet-PCI II controller during transmission
	when the PCnet-PCI II controller does not find the ENP flag in the
	current descriptor and does not own the next descriptor.
	This can occur in either of two ways:
        1.    The OWN bit of the next descriptor is ZERO.
        2.    FIFO underflow occurred before the PCnet-PCI II
              controller obtained the STATUS byte (TMD1[31:24]) of
              the next descriptor. BUFF is set by the PCnet-PCI II
			controller and cleared by the host.                     

	If a Buffer Error occurs, an Underflow Error will also occur.
	BUFF is not valid when LCOL or RTRY error is set during transmit
	data chaining. BUFF is set by the PCnet-PCI II controller and
	cleared by the host."
	^ self mcnttdrBit: 15! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:30'!
bufferErrorClear
	^ self mcnttdrBitClear: 15! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:23'!
disableCRCGeneration
	"clearing this bit will not automatically disable CRC generation.
	read comment on #enableCRCGeneration"
	^ self flagsBitClear: 5

! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:23'!
disableTransmitInterrupt
	"bit 4 - LTINT
	When LTINTEN is set to ONE this bit functions as LTINT on
	host write operations and on PCnet-PCI II controller read operations.

	LTINT is used to suppress interrupts after successful transmission
	on selected frames. When LTINT is cleared to ZERO and
	ENP (End of Packet) is set to ONE, the PCnet-PCI II controller will not
	set TINT (CSR0, bit 9) after a successful transmission. TINT will
	only be set when the last descriptor of a frame has both LTINT and
	ENP set to ONE. When LTINT is cleared to ZERO, it will only
	cause the suppression of interrupts for successful transmission.
	TINT will always be set if the transmission has an error. The
	LTINTEN overrides the function of TOKINTD (CSR5, bit 15)."
	^ self flagsBitClear: 4! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:24'!
enableCRCGeneration
	"bit 5 - ADD_FCS
	ADD_FCS dynamically controls the generation of FCS on a frame
	by frame basis. It is valid only if the STP (Start of Packet) bit is set.
	When ADD_FCS is set, the state of DXMTFCS is ignored and trans-
	mitter FCS generation is activated. When ADD_FCS is cleared to
	ZERO, FCS generation is controlled by DXMTFCS. When
	APAD_XMT (CSR4, bit 11) is set to ONE, the setting of ADD_FCS
	has no effect. ADD_FCS is set by the host, and is not changed by
	the PCnet-PCI II controller. This is a reserved bit in the C-LANCE
	(Am79C90). This function differs from the corresponding ILACC
	function."
	^ self flagsBitSet: 5

! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:24'!
enableTransmitInterrupt
	"bit 4 - LTINT
	When LTINTEN is set to ONE this bit functions as LTINT on
	host write operations and on PCnet-PCI II controller read operations.

	LTINT is used to suppress interrupts after successful transmission
	on selected frames. When LTINT is cleared to ZERO and
	ENP (End of Packet) is set to ONE, the PCnet-PCI II controller will not
	set TINT (CSR0, bit 9) after a successful transmission. TINT will
	only be set when the last descriptor of a frame has both LTINT and
	ENP set to ONE. When LTINT is cleared to ZERO, it will only
	cause the suppression of interrupts for successful transmission.
	TINT will always be set if the transmission has an error. The
	LTINTEN overrides the function of TOKINTD (CSR5, bit 15)."
	^ self flagsBitSet: 4! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 18:58'!
excessiveDeferralError
	"Excessive Deferral. Indicates that the transmitter has experienced
	Excessive Deferral on this transmit frame, where Excessive
	Deferral is defined in ISO 8802-3 (IEEE/ANSI 802.3). Excessive
	Deferral will also set the interrupt bit EXDINT (CSR5, bit 7)."
	^ self mcnttdrBit: 13! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/15/2006 00:31'!
excessiveDeferralErrorClear
	^ self mcnttdrBitClear: 13! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 18:59'!
lateCollisionError
	"Late Collision indicates that a collision has occurred after the first
	slot time of the channel has elapsed. The PCnet-PCI II con-
	troller does not retry on late collisions. LCOL is set by the
	PCnet-PCI II controller and cleared by the host."
	^ self mcnttdrBit: 12! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:32'!
lateCollisionErrorClear
	^ self mcnttdrBitClear: 12! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/15/2006 00:20'!
lossOfCarrierError
	"bit 11 - LCAR
	Loss of Carrier is set when the carrier is lost during a PCnet-PCI II
	controller-initiated transmission when in AUI mode and the device
	is operating in half-duplex mode. The PCnet-PCI II controller does
	not retry upon loss of carrier. It will continue to transmit the whole
	frame until done. LCAR will not be set when the device is operating
	in full-duplex mode and the AUI port is active. LCAR is not
	valid in Internal Loopback Mode.
	LCAR is set by the PCnet-PCI II controller and cleared by the host.
	In 10BASE-T mode, LCAR will be set when the T-MAU was in Link
	Fail state during the transmission."
	^ self mcnttdrBit: 11! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:33'!
lossOfCarrierErrorClear
	^ self mcnttdrBitClear: 11! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/15/2006 01:24'!
message: aString
	super message: aString.
	self
		bufferSize: aString size;
		startOfPacketSet;
		endOfPacketSet;
		beOwnedByCard.! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/15/2006 01:15'!
messageSize
	^ self bufferSize! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/15/2006 00:21'!
neededDefer
	"bit 2 - DEF
	Deferred indicates that the PCnet-PCI II controller had to defer
	while trying to transmit a frame. This condition occurs if the channel
	is busy when the PCnet-PCI II controller is ready to transmit.
	DEF is set by the PCnet-PCI II controller and cleared by the host."
	^ self flagsBit: 2! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/15/2006 00:32'!
neededDeferClear
	^ self flagsBitClear: 2! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:24'!
neededMultipleRetries
	"bit 4 - MORE/LTINT
	MORE indicates that more than one retry was needed to transmit
	a frame. The value of MORE is written by the PCnet-PCI II controller.
	This bit has meaning only if the ENP bit is set."
	^ self flagsBit: 4! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/15/2006 00:32'!
neededMultipleRetriesClear
	^ self flagsBitClear: 4! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:24'!
neededOneRetry
	"bit 3 - ONE
	ONE indicates that exactly one retry was needed to transmit a
	frame. ONE flag is not valid when LCOL is set. The value of the
	ONE bit is written by the PCnet-PCI II controller. This bit has
	meaning only if the ENP bit is set."
	^ self flagsBit: 3! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/15/2006 00:32'!
neededOneRetryClear
	^ self flagsBitClear: 3! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/15/2006 00:22'!
retryError
	" bit 10 - RTRY
	Retry error indicates that the transmitter has failed after 16
	attempts to successfully transmit a message, due to repeated
	collisions on the medium. If DRTY is set to ONE in the MODE
	register, RTRY will set after 1 failed transmission attempt.
	RTRY is set by the PCnet-PCI II controller and cleared by the host."
	^ self mcnttdrBit: 10! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:33'!
retryErrorClear
	^ self mcnttdrBitClear: 10! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:18'!
timeDomainReflectometer
	"nice method name eh!! not my imagination thought :-)
	TDR Time Domain Reflectometer reflects the state of an internal
	PCnet-PCI II controller counter that counts at a 10 MHz rate from the
	start of a transmission to the occurrence of a collision or loss of
	carrier. This value is useful in determining the approximate distance
	to a cable fault. The TDR value is written by the PCnet-PCI II
	controller and is valid only if RTRY is set.
	Note that 10 MHz gives very low resolution and in general has not
	been found to be particularly useful. This feature is here primarily
	to maintain full compatibility with the C-LANCE device (Am79C90)."
	^ self mcnttdr bitAnd: 16r3FF! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/15/2006 00:27'!
underflowError
	" bit 14 - UFLO
	Underflow error indicates that the transmitter has truncated a
	message because it could not read data from memory fast enough.
	UFLO indicates that the FIFO has emptied before the end of the
	frame was reached. When DXSUFLO (CSR3, bit 6) is cleared to
	ZERO, the transmitter is turned off when an UFLO error
	occurs (CSR0, TXON = 0). When DXSUFLO is set to ONE
	the PCnet-PCI II controller grace fully recovers from an UFLO
	error. It scans the transmit descriptor ring until it finds the
	start of a new frame and starts a new transmission.
	UFLO is set by the PCnet-PCI II controller and cleared by the
	host."
	^ self mcnttdrBit: 14! !

!LanceNICTransmitRingDescriptor16 methodsFor: 'accessing' stamp: 'gera 7/14/2006 11:30'!
underflowErrorClear
	^ self mcnttdrBitClear: 14! !

ExternalStructure subclass: #MultiBootInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-External-Structures'!

!MultiBootInfo class methodsFor: 'accessing' stamp: 'gc 6/16/2010 17:47'!
fields
	^#(
		(flags 'ulong')
		(memLower 'ulong')
		(memUpper 'ulong')
		(bootDevice 'ulong')
		(cmdLine 'ulong')
		(modsCount 'ulong')
		(modsAddress 'ulong')
		(aoutSymbol 'SymbolTable')
		(elfSection 'ElfSectionHeaderTable')
		(mmapLength 'ulong')
		(mmapAddress 'ulong')
		(drivesLength 'ulong')
		(drivesAddress 'ulong')
		(configTable 'ulong')
		(bootLoaderName 'ulong')
		(apmTable 'ulong')
		(vbeControlInfo 'ulong')
		(vbeModeInfo 'ulong')
		(vbeMode 'ulong')
		(vbeInterfaceSegment 'ulong')
		(vbeInterfaceOffset 'ulong')
		(vbeInterfaceName 'ulong')
	    )
	
! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
aoutSymbol
	"This method was automatically generated"
	^SymbolTable fromHandle: (handle structAt: 29 length: 16)! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
aoutSymbol: anObject
	"This method was automatically generated"
	handle structAt: 29 put: anObject getHandle length: 16.! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
apmTable
	"This method was automatically generated"
	^handle unsignedLongAt: 85! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
apmTable: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 85 put: anObject! !

!MultiBootInfo methodsFor: 'testing' stamp: 'gc 6/17/2010 17:29'!
areMemoryAddressesValid
	"Addresses are valid if first bit of the flags is set"
	^(self flags bitAnd: 16r00000001) = 16r00000001! !

!MultiBootInfo methodsFor: 'testing' stamp: 'gc 6/17/2010 17:29'!
areModulesValid
	"Modules are valid if third bit of the flags is set"
	^(self flags bitAnd: 16r00000004) = 16r00000004! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
bootDevice
	"This method was automatically generated"
	^handle unsignedLongAt: 13! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
bootDevice: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 13 put: anObject! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
bootLoaderName
	"This method was automatically generated"
	^handle unsignedLongAt: 81! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
bootLoaderName: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 81 put: anObject! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
cmdLine
	"This method was automatically generated"
	^handle unsignedLongAt: 17! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
cmdLine: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 17 put: anObject! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
configTable
	"This method was automatically generated"
	^handle unsignedLongAt: 77! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
configTable: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 77 put: anObject! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
drivesAddress
	"This method was automatically generated"
	^handle unsignedLongAt: 73! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
drivesAddress: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 73 put: anObject! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
drivesLength
	"This method was automatically generated"
	^handle unsignedLongAt: 69! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
drivesLength: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 69 put: anObject! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
elfSection
	"This method was automatically generated"
	^ElfSectionHeaderTable fromHandle: (handle structAt: 45 length: 16)! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
elfSection: anObject
	"This method was automatically generated"
	handle structAt: 45 put: anObject getHandle length: 16.! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
flags
	"This method was automatically generated"
	^handle unsignedLongAt: 1! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
flags: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 1 put: anObject! !

!MultiBootInfo methodsFor: 'testing' stamp: 'gc 6/17/2010 17:29'!
isMemoryMapValid
	"Modules are valid if six bit of the flags is set"
	^(self flags bitAnd: 16r00000020) = 16r00000020! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
memLower
	"This method was automatically generated"
	^handle unsignedLongAt: 5! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
memLower: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 5 put: anObject! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
memUpper
	"This method was automatically generated"
	^handle unsignedLongAt: 9! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
memUpper: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 9 put: anObject! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
mmapAddress
	"This method was automatically generated"
	^handle unsignedLongAt: 65! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
mmapAddress: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 65 put: anObject! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
mmapLength
	"This method was automatically generated"
	^handle unsignedLongAt: 61! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
mmapLength: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 61 put: anObject! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
modsAddress
	"This method was automatically generated"
	^handle unsignedLongAt: 25! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
modsAddress: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 25 put: anObject! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
modsCount
	"This method was automatically generated"
	^handle unsignedLongAt: 21! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
modsCount: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 21 put: anObject! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
vbeControlInfo
	"This method was automatically generated"
	^handle unsignedLongAt: 89! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
vbeControlInfo: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 89 put: anObject! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
vbeInterfaceName
	"This method was automatically generated"
	^handle unsignedLongAt: 109! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
vbeInterfaceName: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 109 put: anObject! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
vbeInterfaceOffset
	"This method was automatically generated"
	^handle unsignedLongAt: 105! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
vbeInterfaceOffset: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 105 put: anObject! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
vbeInterfaceSegment
	"This method was automatically generated"
	^handle unsignedLongAt: 101! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
vbeInterfaceSegment: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 101 put: anObject! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
vbeMode
	"This method was automatically generated"
	^handle unsignedLongAt: 97! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
vbeMode: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 97 put: anObject! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
vbeModeInfo
	"This method was automatically generated"
	^handle unsignedLongAt: 93! !

!MultiBootInfo methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
vbeModeInfo: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 93 put: anObject! !

ExternalStructure subclass: #MultiBootMemoryMap
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-External-Structures'!

!MultiBootMemoryMap class methodsFor: 'instance creation' stamp: 'gc 6/17/2010 16:33'!
fromHandle: handle size: anInteger
	^(self fromHandle: handle) size: anInteger! !

!MultiBootMemoryMap methodsFor: 'collection' stamp: 'gc 6/17/2010 16:28'!
do: aBlock
	| memoryAddress entry |
	memoryAddress := self address.
		[memoryAddress - self address > self size] 
	whileFalse:
		[entry := MultiBootMemoryMapEntry fromHandle: (ExternalAddress fromInteger: memoryAddress).
		aBlock value: entry.
		memoryAddress := memoryAddress + entry size]! !

!MultiBootMemoryMap methodsFor: 'accessing' stamp: 'gc 6/17/2010 16:34'!
size
	^size! !

!MultiBootMemoryMap methodsFor: 'accessing' stamp: 'gc 6/17/2010 16:34'!
size: anInteger
	size := anInteger! !

ExternalStructure subclass: #MultiBootMemoryMapEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-External-Structures'!

!MultiBootMemoryMapEntry class methodsFor: 'accessing' stamp: 'gc 6/17/2010 15:26'!
fields
	^#(
		(size 'ulong')
		(baseAddress 'double')
		(length 'double')
		(type 'ulong')
	   )! !

!MultiBootMemoryMapEntry methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
baseAddress
	"This method was automatically generated"
	^handle doubleAt: 5! !

!MultiBootMemoryMapEntry methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
baseAddress: anObject
	"This method was automatically generated"
	handle doubleAt: 5 put: anObject! !

!MultiBootMemoryMapEntry methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
length
	"This method was automatically generated"
	^handle doubleAt: 13! !

!MultiBootMemoryMapEntry methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
length: anObject
	"This method was automatically generated"
	handle doubleAt: 13 put: anObject! !

!MultiBootMemoryMapEntry methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
size
	"This method was automatically generated"
	^handle unsignedLongAt: 1! !

!MultiBootMemoryMapEntry methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
size: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 1 put: anObject! !

!MultiBootMemoryMapEntry methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
type
	"This method was automatically generated"
	^handle unsignedLongAt: 21! !

!MultiBootMemoryMapEntry methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
type: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 21 put: anObject! !

ExternalStructure subclass: #ReadonlyPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-External-Structures'!

!ReadonlyPage class methodsFor: 'accessing' stamp: 'GuidoChari 11/8/2010 15:16'!
fields
	"self defineFields"
	^#(
		(virtual 'ulong')
		(physical 'ulong')
		(contents 'string' 4096)
	   )! !

!ReadonlyPage methodsFor: 'accessing' stamp: 'GuidoChari 12/28/2010 17:32'!
contents
	"This method was automatically generated"
	^(Buffer at: self address + 8 size: 4096) contents
	! !

!ReadonlyPage methodsFor: 'accessing' stamp: 'GuidoChari 11/8/2010 15:16'!
physical
	"This method was automatically generated"
	^handle unsignedLongAt: 5! !

!ReadonlyPage methodsFor: 'accessing' stamp: 'GuidoChari 11/8/2010 15:16'!
physical: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 5 put: anObject! !

!ReadonlyPage methodsFor: 'accessing' stamp: 'GuidoChari 11/8/2010 15:16'!
virtual
	"This method was automatically generated"
	^handle unsignedLongAt: 1! !

!ReadonlyPage methodsFor: 'accessing' stamp: 'GuidoChari 11/8/2010 15:16'!
virtual: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 1 put: anObject! !

ExternalStructure subclass: #SnapshotInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-External-Structures'!

!SnapshotInfo class methodsFor: 'accessing' stamp: 'GuidoChari 11/8/2010 15:21'!
fields
	"self defineFields"
	^#(
		(saved 'ulong')
		(toSave 'ulong')
		(pages 'ReadonlyPage*')
	   )! !

!SnapshotInfo methodsFor: 'accessing' stamp: 'GuidoChari 1/4/2011 18:38'!
pageFor: anAddress
	"This method was automatically generated"
	| pages start pageDescriptorAddress virtualAddress |
	pages := OrderedCollection new: self toSave.
	start :=  handle pointerAt: 9.
	0 to: self saved - 1 do: [:index | 
		pageDescriptorAddress := start + (index * ReadonlyPage byteSize).
		virtualAddress := pageDescriptorAddress unsignedLongAt: 1.
		(anAddress between: virtualAddress and: virtualAddress + 4095) ifTrue: 
			[^ReadonlyPage fromHandle: pageDescriptorAddress]
	].
	^nil! !

!SnapshotInfo methodsFor: 'accessing' stamp: 'GuidoChari 11/8/2010 15:30'!
pages
	"This method was automatically generated"
	| pages start |
	pages := OrderedCollection new: self toSave.
	start :=  handle pointerAt: 9.
	0 to: self toSave - 1 do: [:index | pages add: (ReadonlyPage fromHandle: start + (index * ReadonlyPage byteSize))].
	^pages! !

!SnapshotInfo methodsFor: 'accessing' stamp: 'JavierPimas 12/20/2010 16:51'!
pages: anObject
	"This method was automatically generated (and then modified by hand)"
	handle pointerAt: 9 put: anObject.! !

!SnapshotInfo methodsFor: 'initialize-release' stamp: 'GuidoChari 1/3/2011 16:21'!
resetPages
	| address |
	address := ExternalAddress allocate: self toSave * ReadonlyPage byteSize.
	self pages: address ! !

!SnapshotInfo methodsFor: 'accessing' stamp: 'GuidoChari 11/8/2010 15:21'!
saved
	"This method was automatically generated"
	^handle unsignedLongAt: 1! !

!SnapshotInfo methodsFor: 'accessing' stamp: 'GuidoChari 11/8/2010 15:21'!
saved: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 1 put: anObject! !

!SnapshotInfo methodsFor: 'accessing' stamp: 'GuidoChari 11/8/2010 15:21'!
toSave
	"This method was automatically generated"
	^handle unsignedLongAt: 5! !

!SnapshotInfo methodsFor: 'accessing' stamp: 'GuidoChari 11/8/2010 15:21'!
toSave: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 5 put: anObject! !

ExternalStructure subclass: #SymbolTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-External-Structures'!

!SymbolTable class methodsFor: 'accessing' stamp: 'gc 6/16/2010 17:49'!
fields
	^#(
		(tabSize 'ulong')
		(strSize 'ulong')
		(address 'ulong')
		(reserved 'ulong')
	   )
	
! !

!SymbolTable methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
address
	"This method was automatically generated"
	^handle unsignedLongAt: 9! !

!SymbolTable methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
address: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 9 put: anObject! !

!SymbolTable methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
reserved
	"This method was automatically generated"
	^handle unsignedLongAt: 13! !

!SymbolTable methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
reserved: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 13 put: anObject! !

!SymbolTable methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
strSize
	"This method was automatically generated"
	^handle unsignedLongAt: 5! !

!SymbolTable methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
strSize: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 5 put: anObject! !

!SymbolTable methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
tabSize
	"This method was automatically generated"
	^handle unsignedLongAt: 1! !

!SymbolTable methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
tabSize: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 1 put: anObject! !

ExternalStructure subclass: #USBQueueHead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-USB'!

!USBQueueHead class methodsFor: 'as yet unclassified' stamp: 'gera 8/24/2008 09:59'!
externalNew
	"must be aligned to 16"
	^self externalNewAligned: 16! !

!USBQueueHead class methodsFor: 'as yet unclassified' stamp: 'gera 8/23/2008 20:10'!
fields
	"self defineFields"
	^#(
		(queueHeadLinkPointerQT 'ulong')
		(queueElementLinkPointerRQT 'ulong')
	)! !

!USBQueueHead methodsFor: 'accessing' stamp: 'gera 9/8/2008 20:11'!
beEmpty
	^ self queueElementLinkPointerRQT: 1! !

!USBQueueHead methodsFor: 'private' stamp: 'gera 9/8/2008 09:05'!
beTerminator
	self queueHeadLinkPointerQT: 1! !

!USBQueueHead methodsFor: 'accessing' stamp: 'gera 9/7/2008 16:29'!
first
	self isEmpty ifTrue: [^ nil].
	self firstIsQueueHead
		ifTrue: [^ USBQueueHead fromHandle: self firstAddress]
		ifFalse: [^ USBTransferDescriptor fromHandle: self firstAddress]! !

!USBQueueHead methodsFor: 'accessing' stamp: 'gera 9/7/2008 16:32'!
first: usbQHorTD
	| address |
	address := usbQHorTD address asInteger.
	(address anyMask: 2r1111) ifTrue: [self error: 'QH element must be aligned to 16'].
	usbQHorTD isQueueHead ifTrue: [address := address bitOr: 2r10].	" turn on Q bit. "
	self queueElementLinkPointerRQT: address.	" clear Terminator "! !

!USBQueueHead methodsFor: 'private' stamp: 'gera 9/7/2008 16:30'!
firstAddress
	^ ExternalAddress new fromInteger: (self queueElementLinkPointerRQT bitClear: 2r1111) ! !

!USBQueueHead methodsFor: 'private' stamp: 'gera 9/7/2008 17:36'!
firstIsQueueHead
	^ self queueElementLinkPointerRQT anyMask: 2r10! !

!USBQueueHead methodsFor: 'private' stamp: 'gera 9/7/2008 16:23'!
firstIsTransferDescriptor
	^ self firstIsQueueHead not! !

!USBQueueHead methodsFor: 'accessing' stamp: 'gera 9/7/2008 16:24'!
isEmpty
	^ self queueElementLinkPointerRQT anyMask: 1! !

!USBQueueHead methodsFor: 'accessing' stamp: 'gera 8/24/2008 09:56'!
isQueueHead
	^ true! !

!USBQueueHead methodsFor: 'private' stamp: 'gera 9/8/2008 09:05'!
isTerminator
	self queueHeadLinkPointerQT anyMask: 1! !

!USBQueueHead methodsFor: 'accessing' stamp: 'gera 8/24/2008 09:57'!
isTransferDescriptor
	^ false! !

!USBQueueHead methodsFor: 'accessing' stamp: 'gera 9/14/2008 14:23'!
next: usbQHorTD
	| address |
	address := usbQHorTD address asInteger.
	(address anyMask: 2r1111) ifTrue: [self error: 'QH element must be aligned to 16'].
	usbQHorTD isQueueHead ifTrue: [address := address bitOr: 2r10].	" turn on Q bit. "
	self queueHeadLinkPointerQT: address.	" clear Terminator "! !

!USBQueueHead methodsFor: 'accessing - automatic' stamp: 'gera 8/23/2008 20:11'!
queueElementLinkPointerRQT
	"This method was automatically generated"
	^handle unsignedLongAt: 5! !

!USBQueueHead methodsFor: 'accessing - automatic' stamp: 'gera 8/23/2008 20:11'!
queueElementLinkPointerRQT: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 5 put: anObject! !

!USBQueueHead methodsFor: 'accessing - automatic' stamp: 'gera 8/23/2008 20:11'!
queueHeadLinkPointerQT
	"This method was automatically generated"
	^handle unsignedLongAt: 1! !

!USBQueueHead methodsFor: 'accessing - automatic' stamp: 'gera 8/23/2008 20:11'!
queueHeadLinkPointerQT: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 1 put: anObject! !

ExternalStructure subclass: #USBTransferDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-USB'!

!USBTransferDescriptor class methodsFor: 'as yet unclassified' stamp: 'gera 8/24/2008 09:59'!
externalNew
	"must be aligned to 16"
	^self externalNewAligned: 16! !

!USBTransferDescriptor class methodsFor: 'as yet unclassified' stamp: 'gera 8/24/2008 10:20'!
fields
	"self defineFields"
	^#(
		(linkPointerVQT 'ulong')
		(statusActLen 'ulong')
		(maxLenAddr 'ulong')
		(bufferPointer 'ulong')
	)! !

!USBTransferDescriptor methodsFor: 'accessing - status etc.' stamp: 'gera 8/24/2008 10:36'!
activate
	self statusActLen: (self statusActLen bitOr: 1 << 23)! !

!USBTransferDescriptor methodsFor: 'accessing - status etc.' stamp: 'gera 8/24/2008 11:02'!
actualLength
	^ (self statusActLen bitAnd: 16r3FF) + 1! !

!USBTransferDescriptor methodsFor: 'accessing - status etc.' stamp: 'gera 8/24/2008 11:02'!
actualLength: anInteger
	^ self statusActLen: (self statusActLen bitAnd: 16rFFFFFC00) + (anInteger - 1)! !

!USBTransferDescriptor methodsFor: 'accessing - max len etc.' stamp: 'gera 9/4/2008 19:23'!
beData0
	self maxLenAddr: (self maxLenAddr bitClear: 1 << 19)! !

!USBTransferDescriptor methodsFor: 'accessing - max len etc.' stamp: 'gera 9/4/2008 19:23'!
beData1
	self maxLenAddr: (self maxLenAddr bitOr: 1 << 19)! !

!USBTransferDescriptor methodsFor: 'accessing - status etc.' stamp: 'gera 9/7/2008 18:06'!
beFullSpeedDevice
	self statusActLen: (self statusActLen bitClear: 1 << 26)! !

!USBTransferDescriptor methodsFor: 'accessing - max len etc.' stamp: 'gera 9/7/2008 16:51'!
beInput
	self packetIdentification: 16r69! !

!USBTransferDescriptor methodsFor: 'accessing - status etc.' stamp: 'gera 8/24/2008 10:24'!
beIsochronous
	self statusActLen: (self statusActLen bitOr: 1 << 25)! !

!USBTransferDescriptor methodsFor: 'accessing - status etc.' stamp: 'gera 8/24/2008 10:29'!
beLowSpeedDevice
	self statusActLen: (self statusActLen bitOr: 1 << 26)! !

!USBTransferDescriptor methodsFor: 'accessing - status etc.' stamp: 'gera 9/7/2008 18:06'!
beNonIsochronous
	self statusActLen: (self statusActLen bitClear: 1 << 25)! !

!USBTransferDescriptor methodsFor: 'accessing - max len etc.' stamp: 'gera 9/7/2008 16:51'!
beOutput
	self packetIdentification: 16rE1! !

!USBTransferDescriptor methodsFor: 'accessing - max len etc.' stamp: 'gera 9/7/2008 16:46'!
beSetup
	self packetIdentification: 16r2D! !

!USBTransferDescriptor methodsFor: 'accessing - link pointer' stamp: 'gera 8/24/2008 10:15'!
beTerminator
	self linkPointerVQT: (self linkPointerVQT bitOr: 1)! !

!USBTransferDescriptor methodsFor: 'accessing - automatic' stamp: 'gera 8/23/2008 20:12'!
bufferPointer
	"This method was automatically generated"
	^handle unsignedLongAt: 13! !

!USBTransferDescriptor methodsFor: 'accessing - automatic' stamp: 'gera 8/23/2008 20:12'!
bufferPointer: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 13 put: anObject! !

!USBTransferDescriptor methodsFor: 'accessing - link pointer' stamp: 'gera 8/24/2008 10:14'!
clearLinkPointer
	self linkPointerVQT: 1! !

!USBTransferDescriptor methodsFor: 'accessing - max len etc.' stamp: 'gera 8/24/2008 10:48'!
deviceAddress
	^ self maxLenAddr >> 8 bitAnd: 16r7F! !

!USBTransferDescriptor methodsFor: 'accessing - max len etc.' stamp: 'gera 8/24/2008 10:48'!
deviceAddress: anInteger
	self maxLenAddr: anInteger << 8 + (self maxLenAddr bitAnd: 16rFFFF80FF)! !

!USBTransferDescriptor methodsFor: 'accessing - status etc.' stamp: 'gera 8/24/2008 10:29'!
disableInterruptOnComplete
	self statusActLen: (self statusActLen bitAnd: (1 << 24) bitInvert)! !

!USBTransferDescriptor methodsFor: 'accessing - status etc.' stamp: 'gera 9/7/2008 18:06'!
disableShortPacketDetect
	self statusActLen: (self statusActLen bitClear: 1 << 29)! !

!USBTransferDescriptor methodsFor: 'accessing - status etc.' stamp: 'gera 8/24/2008 10:28'!
enableInterruptOnComplete
	self statusActLen: (self statusActLen bitOr: 1 << 24)! !

!USBTransferDescriptor methodsFor: 'accessing - status etc.' stamp: 'gera 8/24/2008 10:34'!
enableShortPacketDetect
	self statusActLen: (self statusActLen bitOr: 1 << 29)! !

!USBTransferDescriptor methodsFor: 'accessing - max len etc.' stamp: 'gera 8/24/2008 10:45'!
endpoint
	^ self maxLenAddr >> 15 bitAnd: 16rF! !

!USBTransferDescriptor methodsFor: 'accessing - max len etc.' stamp: 'gera 8/24/2008 10:47'!
endpoint: anInteger
	self maxLenAddr: anInteger << 15 + (self maxLenAddr bitAnd: 16rFFC07FFF)! !

!USBTransferDescriptor methodsFor: 'accessing - status etc.' stamp: 'gera 8/24/2008 10:31'!
errorCount
	^ self statusActLen >> 27 bitAnd: 3! !

!USBTransferDescriptor methodsFor: 'accessing - status etc.' stamp: 'gera 8/24/2008 10:33'!
errorCount: anInteger
	^ self statusActLen: (self statusActLen bitAnd: (3 << 27) bitInvert) + (anInteger << 27)
! !

!USBTransferDescriptor methodsFor: 'initialization' stamp: 'gera 8/24/2008 10:41'!
initialize
	super initialize.
	self
		clearLinkPointer;
		statusActLen: 0;
		maxLenAddr: 0.! !

!USBTransferDescriptor methodsFor: 'accessing - status etc.' stamp: 'gera 8/24/2008 10:36'!
isActive
	^ self statusActLen anyMask: 1 << 23! !

!USBTransferDescriptor methodsFor: 'accessing - link pointer' stamp: 'gera 8/24/2008 10:13'!
isBreadthFirst
	^ self isDepthFirst not! !

!USBTransferDescriptor methodsFor: 'accessing - max len etc.' stamp: 'gera 9/4/2008 19:29'!
isData0
	^ self isData1 not! !

!USBTransferDescriptor methodsFor: 'accessing - max len etc.' stamp: 'gera 9/4/2008 19:29'!
isData1
	^ self maxLenAddr anyMask: 1 << 19! !

!USBTransferDescriptor methodsFor: 'accessing - link pointer' stamp: 'gera 9/7/2008 17:07'!
isDepthFirst
	^ self linkPointerVQT anyMask: 2r100! !

!USBTransferDescriptor methodsFor: 'accessing - link pointer' stamp: 'gera 8/24/2008 09:57'!
isQueueHead
	^ false! !

!USBTransferDescriptor methodsFor: 'accessing - link pointer' stamp: 'gera 8/24/2008 10:03'!
isTerminator
	^ self linkPointerVQT anyMask: 1! !

!USBTransferDescriptor methodsFor: 'accessing - link pointer' stamp: 'gera 8/24/2008 09:57'!
isTransferDescriptor
	^ true! !

!USBTransferDescriptor methodsFor: 'accessing - automatic' stamp: 'gera 8/23/2008 20:12'!
linkPointerVQT
	"This method was automatically generated"
	^handle unsignedLongAt: 1! !

!USBTransferDescriptor methodsFor: 'accessing - automatic' stamp: 'gera 8/23/2008 20:12'!
linkPointerVQT: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 1 put: anObject! !

!USBTransferDescriptor methodsFor: 'accessing - automatic' stamp: 'gera 8/23/2008 20:12'!
maxLenAddr
	"This method was automatically generated"
	^handle unsignedLongAt: 9! !

!USBTransferDescriptor methodsFor: 'accessing - automatic' stamp: 'gera 8/23/2008 20:12'!
maxLenAddr: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 9 put: anObject! !

!USBTransferDescriptor methodsFor: 'accessing - max len etc.' stamp: 'gera 8/24/2008 10:44'!
maxLength
	^ self maxLenAddr >> 21 bitAnd: 16r7FF! !

!USBTransferDescriptor methodsFor: 'accessing - max len etc.' stamp: 'gera 9/14/2008 15:12'!
maxLength: anInteger
	anInteger > 1280 ifTrue: [self error: 'Maximum allowed length for USB transfers is 1280'].
	self maxLenAddr: (self maxLenAddr bitAnd: 16r1FFFFF) + (anInteger - 1 << 21)! !

!USBTransferDescriptor methodsFor: 'accessing - link pointer' stamp: 'gera 9/8/2008 09:08'!
next
	self isTerminator ifTrue: [^ nil].
	self nextIsQueueHead
		ifTrue: [^ USBQueueHead fromHandle: self nextAddress]
		ifFalse: [^ USBTransferDescriptor fromHandle: self nextAddress]
	! !

!USBTransferDescriptor methodsFor: 'accessing - link pointer' stamp: 'gera 9/7/2008 17:10'!
next: usbQHorTD
	| address |
	address := usbQHorTD address asInteger.
	(address anyMask: 2r1111) ifTrue: [self error: 'Elements must be aligned to 16'].
	usbQHorTD isQueueHead ifTrue: [address := address bitOr: 2r10].	" turn on Q bit. "
	self isDepthFirst ifTrue: [address := address bitOr: 2r100].			" maintain Vf "
	self linkPointerVQT: address.	" clear Terminator "
! !

!USBTransferDescriptor methodsFor: 'accessing - link pointer' stamp: 'gera 9/14/2008 14:35'!
nextAddress
	^ ExternalAddress new fromInteger: (self linkPointerVQT bitClear: 2r1111).! !

!USBTransferDescriptor methodsFor: 'accessing - link pointer' stamp: 'gera 9/8/2008 09:09'!
nextBeQueueHead
	self linkPointerVQT: (self linkPointerVQT bitOr: 2r10)! !

!USBTransferDescriptor methodsFor: 'accessing - link pointer' stamp: 'gera 9/8/2008 09:09'!
nextBeTransferDescriptor
	self linkPointerVQT: (self linkPointerVQT bitClear: 2r10)! !

!USBTransferDescriptor methodsFor: 'accessing - link pointer' stamp: 'gera 9/8/2008 09:08'!
nextIsQueueHead
	^ self linkPointerVQT anyMask: 2r10! !

!USBTransferDescriptor methodsFor: 'accessing - link pointer' stamp: 'gera 9/8/2008 09:09'!
nextIsTransferDescriptor
	^ self nextIsQueueHead not! !

!USBTransferDescriptor methodsFor: 'accessing - max len etc.' stamp: 'gera 8/24/2008 10:49'!
packetIdentification
	^ self maxLenAddr bitAnd: 16rFF! !

!USBTransferDescriptor methodsFor: 'accessing - max len etc.' stamp: 'gera 9/14/2008 14:35'!
packetIdentification: anInteger
	self maxLenAddr: anInteger + (self maxLenAddr bitClear: 16rFF)! !

!USBTransferDescriptor methodsFor: 'accessing - automatic' stamp: 'gera 8/24/2008 10:20'!
statusActLen
	"This method was automatically generated"
	^handle unsignedLongAt: 5! !

!USBTransferDescriptor methodsFor: 'accessing - automatic' stamp: 'gera 8/24/2008 10:20'!
statusActLen: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 5 put: anObject! !

ExternalStructure subclass: #VMBridge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-External-Structures'!

!VMBridge class methodsFor: 'accessing' stamp: 'GuidoChari 11/8/2010 15:33'!
fields
	^#(
		(video 'DisplayInformation')
		(multiboot 'MultiBootInfo*')
		(image 'void*')
	   	(snapshotStartAddress 'ulong') 
	      (snapshotEndAddress 'ulong')
		(pageFaultHandlerEntry 'void*')
		(snapshotInfo 'SnapshotInfo')    
	)! !

!VMBridge class methodsFor: 'system startup' stamp: 'gc 7/13/2010 15:10'!
install
	Computer current ifNotNil: [:computer | computer initializeBridge]! !

!VMBridge methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
image
	"This method was automatically generated"
	^ExternalData fromHandle: (handle pointerAt: 25) type: ExternalType void asPointerType! !

!VMBridge methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
image: anObject
	"This method was automatically generated"
	handle pointerAt: 25 put: anObject getHandle.! !

!VMBridge methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
multiboot
	"This method was automatically generated"
	^MultiBootInfo fromHandle: (handle pointerAt: 21)! !

!VMBridge methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
multiboot: anObject
	"This method was automatically generated"
	handle pointerAt: 21 put: anObject getHandle.! !

!VMBridge methodsFor: 'accessing' stamp: 'GuidoChari 8/27/2010 16:51'!
pageFaultHandlerEntry
	^handle unsignedLongAt: 37! !

!VMBridge methodsFor: 'accessing' stamp: 'GuidoChari 8/27/2010 16:50'!
pageFaultHandlerEntry: aCallBackAddress
	"This method was automatically generated"
	handle unsignedLongAt: 37 put: aCallBackAddress! !

!VMBridge methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
snapshotEndAddress
	"This method was automatically generated"
	^handle unsignedLongAt: 33! !

!VMBridge methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
snapshotEndAddress: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 33 put: anObject! !

!VMBridge methodsFor: 'accessing' stamp: 'GuidoChari 12/27/2010 15:55'!
snapshotInfo
	"This method was automatically generated and modified by hand"
	^SnapshotInfo fromHandle: handle + 40! !

!VMBridge methodsFor: 'accessing' stamp: 'GuidoChari 11/8/2010 15:33'!
snapshotInfo: anObject
	"This method was automatically generated"
	handle structAt: 41 put: anObject getHandle length: 12.! !

!VMBridge methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
snapshotStartAddress
	"This method was automatically generated"
	^handle unsignedLongAt: 29! !

!VMBridge methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
snapshotStartAddress: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 29 put: anObject! !

!VMBridge methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
video
	"This method was automatically generated"
	^DisplayInformation fromHandle: (handle structAt: 1 length: 20)! !

!VMBridge methodsFor: 'accessing' stamp: 'gc 6/29/2010 18:51'!
video: anObject
	"This method was automatically generated"
	handle structAt: 1 put: anObject getHandle length: 20.! !

Workspace subclass: #RemoteWorkspace
	instanceVariableNames: 'remote'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-FileSupport'!

!RemoteWorkspace methodsFor: 'as yet unclassified' stamp: 'r++ 7/23/2008 23:23'!
evaluate: aStream
	^ remote remotePerform: #evaluate: with: aStream upToEnd.! !

!RemoteWorkspace methodsFor: 'as yet unclassified' stamp: 'r++ 7/23/2008 21:33'!
initialize
	super initialize.
	remote := RemoteObjectChannel for: self using: 'ParagraphEditorWithBindings new'! !

!RemoteWorkspace methodsFor: 'as yet unclassified' stamp: 'r++ 7/23/2008 21:30'!
isRemote
	^ true! !

TestCase subclass: #BlockArithmeticTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Storage'!

!BlockArithmeticTest methodsFor: 'as yet unclassified' stamp: 'JavierPimas 1/3/2011 17:00'!
testFirstPositionInSameBlock

	| helper |
	helper := BlockArithmetic new size: 512.

	self assert: (helper firstPositionInSameBlockOf: 1) = 1.
	self assert: (helper firstPositionInSameBlockOf: 2) = 1.
	self assert: (helper firstPositionInSameBlockOf: 300) = 1.
	self assert: (helper firstPositionInSameBlockOf: 511) = 1.
	self assert: (helper firstPositionInSameBlockOf: 512) = 1.
	self assert: (helper firstPositionInSameBlockOf: 513) = 513.
	self assert: (helper firstPositionInSameBlockOf: 514) = 513.
	self assert: (helper firstPositionInSameBlockOf: 1024) = 513.
	self assert: (helper firstPositionInSameBlockOf: 1025) = 1025.! !

!BlockArithmeticTest methodsFor: 'as yet unclassified' stamp: 'JavierPimas 1/3/2011 17:01'!
testLastPositionInSameBlock

	| helper |
	helper := BlockArithmetic new size: 512.

	self assert: (helper lastPositionInSameBlockOf: 1) = 512.
	self assert: (helper lastPositionInSameBlockOf: 2) = 512.
	self assert: (helper lastPositionInSameBlockOf: 300) = 512.
	self assert: (helper lastPositionInSameBlockOf: 511) = 512.
	self assert: (helper lastPositionInSameBlockOf: 512) = 512.
	self assert: (helper lastPositionInSameBlockOf: 513) = 1024.
	self assert: (helper lastPositionInSameBlockOf: 514) = 1024.
	self assert: (helper lastPositionInSameBlockOf: 1024) = 1024.
	self assert: (helper lastPositionInSameBlockOf: 1025) = 1536.! !

TestCase subclass: #BlockCacheTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Storage'!

!BlockCacheTest methodsFor: 'as yet unclassified' stamp: 'JavierPimas 1/4/2011 15:33'!
testBigWrite
	| device cache array original |
	device := Computer blankBlockDeviceForTest.
	cache := BlockCache on: device.
	
	device at: 1 writeArray: (ByteArray new: 300000).
	array := ByteArray new: 200000.
	1 to: 200000 do: [ :i | array at: i put: i \\ 256 ].
	original :=  (device from: 2 to: 300000) asByteArray.

	original replaceFrom:         15                                              to: 200009 with: array startingAt: 5.
	cache   replaceFromByte: (15 + cache blockSize) bytesCount: 199995 with: array startingAtByte: 5.
	
	self assert: original = (cache from: 2 to: 300000).
	! !

!BlockCacheTest methodsFor: 'as yet unclassified' stamp: 'Pocho 7/20/2010 09:35'!
testRead
	| device cache |
	device := ATAController primary master.
	cache := BlockCache on: device.
	
	
	self assert: (device from: 10 to: 11) asByteArray = (cache from: 10 to: 11).	
	self assert: (device from: 1 to: 1) asByteArray = (cache from: 1 to: 1).
	self assert: (device from: 100 to: 110) asByteArray = (cache from: 100 to: 110).! !

!BlockCacheTest methodsFor: 'as yet unclassified' stamp: 'Pocho 7/20/2010 03:28'!
testWrite
	| device cache array original |
	device := ATAController primary master.
	cache := BlockCache on: device.
	
	array := ByteArray withAll: (0 to: 255).
	
	original :=  (device at: 1) asByteArray.
	original replaceFrom: 15 to: 32 with: array startingAt: 5.
	cache replaceFromByte: 15 bytesCount: 18 with: array startingAtByte: 5.
	
	self assert: original = (cache from: 1 to: 1).! !

TestCase subclass: #BlockDevicesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Storage'!

!BlockDevicesTest methodsFor: 'as yet unclassified' stamp: 'Pocho 6/29/2010 19:24'!
fill: aByteArray
	1 to: 512 do: [ :i | aByteArray at: i put: i \\ 256 ].! !

!BlockDevicesTest methodsFor: 'as yet unclassified' stamp: 'gc 6/30/2010 15:01'!
testCreation
	self shouldnt: [ATAController primary master] raise: Error.
	self shouldnt: [ATAController secondary slave] raise: Error.
! !

!BlockDevicesTest methodsFor: 'objects' stamp: 'Pocho 3/27/2010 13:33'!
testDevice
	"Should warn that this will read and WRITE secondary slave hard disk"
	^ ATAController secondary slave.! !

!BlockDevicesTest methodsFor: 'as yet unclassified' stamp: 'JavierPimas 1/4/2011 14:33'!
testImageSaving
	| image collection raw tester cache bytes strm1 strm2 sizeToTest |
	image := StandardFileStream fileNamed: SmalltalkImage current imageName.
	sizeToTest := 1000000.
	bytes := (image next: sizeToTest) asByteArray.
	collection := OrderedCollection new: sizeToTest.
	strm1 := ReadWriteStream on: collection.
	strm2 := ReadWriteStream on: collection copy.
	cache := BlockDeviceOnStream on: strm1 blockSize: 512.
	cache enableCache.
	raw := BlockDeviceOnStream on: strm2 blockSize: 512.
	tester := DualTestBlockDevice deviceA: cache deviceB: raw.
	tester at: 1 writeArray: bytes; flush.
	self assert: (tester fromByte: 1 bytesCount: bytes size) asByteArray = bytes.
	image close
	! !

!BlockDevicesTest methodsFor: 'as yet unclassified' stamp: 'gc 6/30/2010 15:01'!
testRead
	| ba value |
	ba := ByteArray new: 4.
	value := -1.
	self shouldnt: [ba longAt: 1 put: value bigEndian: true] raise: Error.
	self assert: (ba longAt: 1 bigEndian: true) = value.
	self shouldnt: [ba longAt: 1 put: value bigEndian: false] raise: Error.
	self assert: (ba longAt: 1 bigEndian: false) = value.! !

!BlockDevicesTest methodsFor: 'as yet unclassified' stamp: 'Pocho 7/13/2010 14:55'!
testWriteChangesSector
	| device newBytes originalBytes |
	"(self confirm: 'This test is going to permanently write into secondary master partition, are you sure you want to continue?')
		ifFalse: [^self]."
	device           := ATAController secondary master.
	originalBytes := device at: 100.
	newBytes      := ByteArray new: 512.
	
	self fill: newBytes.

	[
		device at: 100 writeArray: newBytes.
		self assert: (device at: 100) = newBytes asString
	] ensure: [ "Try to restore the original contents"
		device at: 100 writeArray: originalBytes
	]! !

!BlockDevicesTest methodsFor: 'as yet unclassified' stamp: 'Pocho 7/13/2010 12:39'!
testWriteManySectors
	| device newBytes originalBytes |
	"(self confirm: 'This test is going to permanently write into secondary master partition, are you sure you want to continue?')
		ifFalse: [^self]."
	"
	device           := ATAController secondary master.
	originalBytes := device at: 100.
	newBytes      := ByteArray new: 512.
	
	self fill: newBytes.

	[
		device replaceFromByte: 1030 bytesCount: 1500 with: newBytes startingAtByte: 20.

		self assert: (device at: 100) = newBytes asString
	] ensure: [ ""Try to restore the original contents""
		device at: 100 writeArray: originalBytes
	]"! !

!BlockDevicesTest methodsFor: 'as yet unclassified' stamp: 'Pocho 7/13/2010 12:39'!
testWriteSector
	| device newBytes originalBytes |
	"(self confirm: 'This test is going to permanently write into secondary master partition, are you sure you want to continue?')
		ifFalse: [^self]."
	device           := ATAController secondary master.
	originalBytes := device at: 100.
	newBytes      := ByteArray new: 512.
	
	self fill: newBytes.

	[
		device at: 100 writeArray: newBytes.
		self assert: (device at: 100) = newBytes asString
	] ensure: [ "Try to restore the original contents"
		device at: 100 writeArray: originalBytes
	]! !

TestCase subclass: #FAT32FileSystemTest
	instanceVariableNames: 'device'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Filesystems-FAT32'!

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'Pocho 7/5/2010 19:14'!
createTempFile: tempFileName from: existingFileName do: aTriArgsBlock
	| filesystem root original clone |
	filesystem := self newInstance.
	root := filesystem root.

	original := root files detect: [:file | file name asLowercase = existingFileName].
	(root files noneSatisfy: [:file | file name asLowercase = tempFileName]) ifFalse: [self error: 'Temporary file already exists.'].
	
	[
		clone := root newFileNamed: tempFileName.
		clone readWriteStream nextPutAll: original readStream contents withBlanksTrimmed.
		aTriArgsBlock value: original value: clone value: filesystem.
	] ensure: [
		root removeFileNamed: tempFileName.
		(root files noneSatisfy: [:file | file name asLowercase = tempFileName]) ifFalse: [ self error: 'Couldn''t delete temporary file' ].
	]! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'gc 7/14/2010 17:39'!
exampleFAT32FileNamed: aFileName
	|  filesystem root |
	filesystem := self newInstance.
	root := filesystem root.
	
	^(root fileNamed: (filesystem pureFAT32FilenameFor: aFileName)) readStream .! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'gc 7/14/2010 17:39'!
fat32ChangesStream
	|  filesystem root |
	filesystem := self newInstance.
	root := filesystem root.
	
	^(root readOnlyFileNamed: (filesystem pureFAT32FilenameFor: 'SqueakNOS.changes')) readStream .! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'JavierPimas 1/4/2011 14:33'!
newInstance
	| stream |
	stream := Computer isSqueakNOS 
		ifTrue: [ CheapHardDiskStream on: ATAController primary master ] 
		ifFalse: [CheapHardDiskStream on: (BlockDeviceOnStream on: (StandardFileStream fileNamed: './testdata/ExampleFAT32.raw') blockSize: 512)].
	stream readWrite.
	^FAT32FileSystem of: stream partition: 1.! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'Pocho 7/5/2010 16:46'!
standardChangesStream
	| fd |
	"look for the changes file on the test directory"
	fd := FileDirectory default / 'testdata/mount/'.
	^fd readOnlyFileNamed: 'SqueakNOS.changes'.
	! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'gc 6/28/2010 17:58'!
testBootRecord
	| br |
	br := self newInstance bootRecord.
	self assert: br bytesPerSector = 512;
		assert: br sectorsPerCluster = 1;
		assert: br reservedSectors = 16r20;
		assert: br numberOfCopiesOfFAT = 2;
		assert: br mediaDescriptor = 16rF8;
		assert: br sectorsPerTrack = 16r20;
		assert: br numberOfHeads = 4;
		assert: br numberOfHiddenSectors = 16r20;
		assert: br numberOfSectorsInPartition = 16r0107E0;
		assert: br sectorsPerFAT = 16r020C;
		assert: br flags = 0;
		assert: br versionOfFAT32Drive = 0;
		assert: br clusterNumberOfStartOfRootDir = 2;
		assert: br sectorNumberOfFSInformationSector = 1;
		assert: br logicalDriveNumberOfPartition = 16r80;
		assert: br extendedSignature = 16r29;assert: br volumeNameOfPartition = 'NO NAME    ';
		assert: br fatName = 'FAT32   ';
		"assert: br executableCode = ;"
		assert: br bootRecordSignature = 16rAA55.
		! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'Pocho 7/5/2010 17:40'!
testCompareToStandardFileStream
	| fat32TestStream standardTestStream |
	
	fat32TestStream := self fat32ChangesStream.
	standardTestStream := self standardChangesStream.
	
	self assert: fat32TestStream size = standardTestStream size.
	self assert: ((fat32TestStream next: 1000) = (standardTestStream next: 1000)).
	
	fat32TestStream position: 10000.
	standardTestStream position: 10000.
	
	self assert: ((fat32TestStream basicUpTo: $!!) = (standardTestStream basicUpTo: $!!)).
	
	fat32TestStream position: fat32TestStream size - 500.
	standardTestStream position: standardTestStream size - 500.
	
	self assert: ((fat32TestStream upToEnd) = standardTestStream upToEnd).
	! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'gc 6/28/2010 17:57'!
testCreation
	self shouldnt: [self newInstance] raise: Error.
	"self shouldnt:[ATAController secondary slave] raise: Error."! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'GC 5/4/2010 18:14'!
testDeepDirectory
	| filesystem directory |
	filesystem := self newInstance.
	directory := filesystem directoryNamed: '/dira'.
	self assert: directory directories size = 0;
		 assert: (directory fileExists: 'file.txt')
		! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'gc 6/28/2010 17:57'!
testEmptyFile
	| filesystem root files empty |
	filesystem := self newInstance.
	root := filesystem root.
	files := root files.
	empty := files detect: [:file | file name asLowercase = 'empty.txt'] ifNone: [self assert: false].
	self assert: empty readStream contents isEmpty.! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'Pocho 7/5/2010 20:40'!
testLargeFileAppend

	self createTempFile: 'morecopy.st' from: 'moreth~2' do:
	[ :original :clone :filesystem | | stream |
	
		stream := clone readWriteStream.
		stream setToEnd.
		stream nextPutAll: 'Goodbye cruel world!!'.
		self assert: clone readStream contents withBlanksTrimmed = (original readStream contents withBlanksTrimmed, 'Goodbye cruel world!!').
	].
	
	! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'Pocho 7/5/2010 20:39'!
testLargeFileCopy
	
	self createTempFile: 'morecopy.st' from: 'moreth~2' do:
	[ :original :clone :filesystem | | stream |	
		self assert: original readStream contents withBlanksTrimmed = clone readStream contents withBlanksTrimmed.
	].
	
! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'Pocho 7/5/2010 18:38'!
testLargeFileRead
	"I open a file bigger than one cluster and check it's content to match what is written by the testing filesystem generator script" 

	| bytesPerCluster large contents |
	bytesPerCluster := self newInstance bytesPerCluster.
	
	large := self exampleFAT32FileNamed: 'moreth~2'.
	contents := large readStream contents asString withBlanksTrimmed.
	
	self assert: contents size > bytesPerCluster;
		assert: (contents first: 13) = '1234567890abc';
		assert: (contents last: 13) = '1234567890abc'.! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'Pocho 7/13/2010 15:31'!
testLargeFileWrite
"	| filesystem root name small stream large files contents |
	filesystem := self newInstance.
	root := filesystem root.
	files := root files.
	large := files detect: [:file | file name asLowercase = 'moreth~2'] ifNone: [self assert: false].
	contents := large readStream contents withBlanksTrimmed.
	name := 'large.st'.
	self assert: ( root files noneSatisfy: [:file | file name asLowercase = name] ).
	small := root newFileNamed: name.
	[
		stream := small readWriteStream.
		stream nextPutAll: contents.
		contents := (root fileNamed: name) readStream contents.
		self assert: contents size > filesystem bytesPerCluster;
		assert: (contents first: 13) = '1234567890abc';
		assert: (contents last: 13) = '1234567890abc'.
	] ensure:[
		root removeFileNamed: name.
		self assert: ( root files noneSatisfy: [:file | file name asLowercase = name] )
	]"! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'Pocho 7/13/2010 15:31'!
testMethodSources
"	| image sources |
	image := SmalltalkImage current.
	[image openSourceFilesForSqueakNos.
	sources := SmalltalkImage methodDictionary at: #argumentAt:.
	self
		assert: (sources getSource string includesSubString: 'argumentAt: i')]
		ensure: [image openSourceFiles]"! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'gc 6/24/2010 13:02'!
testNewAndRemoveFile
	| filesystem root test name |
	filesystem := self newInstance.
	root := filesystem root.
	name := 'test.st'.
	self assert: ( root files noneSatisfy: [:file | file name asLowercase = name] ).
	root newFileNamed: name.
	[
		test := root files detect: [:file | file name asLowercase = name] ifNone: [self assert: false].
		self assert: test readStream contents isEmpty
	] ensure:[
		root removeFileNamed: name.
		self assert: ( root files noneSatisfy: [:file | file name asLowercase = name] )
	]! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'GC 4/21/2010 16:26'!
testRoot
	| filesystem root |
	filesystem := self newInstance.
	root := filesystem root.
	self assert: root directories size = 2.! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'gc 6/28/2010 17:57'!
testSmallFileRead
	| filesystem root ascii |
	filesystem := self newInstance.
	root := filesystem root.
	ascii := root fileNamed: 'ascii'.
	self assert: ascii readStream contents asString withBlanksTrimmed asLowercase = 'zaraza'.! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'gc 6/28/2010 17:56'!
testSmallFileWrite
	| filesystem root name small stream |
	filesystem := self newInstance.
	root := filesystem root.
	name := 'small.st'.
	self assert: ( root files noneSatisfy: [:file | file name asLowercase = name] ).
	small := root newFileNamed: name.
	[
		stream := small readWriteStream.
		stream nextPutAll: 'zaraza test small'.
		self assert: (root fileNamed: name) readStream contents = 'zaraza test small'
	] ensure:[
		root removeFileNamed: name.
		self assert: ( root files noneSatisfy: [:file | file name asLowercase = name] )
	]! !

!FAT32FileSystemTest methodsFor: 'as yet unclassified' stamp: 'Pocho 7/13/2010 16:21'!
testWriteAtEndOfChanges
	| filesystem root stream changes files contents readOnlyStream |
	filesystem := self newInstance.
	root := filesystem root.
	files := root files.
	changes := files detect: [:file | file name asLowercase = 'squeak~1.cha'].

	stream := changes readWriteStream.
	stream position: stream size.
	stream nextPutAll: 'Test content'.

	readOnlyStream := changes readStream.
	readOnlyStream position: readOnlyStream size - 12.
	contents := readOnlyStream next: 12.


		self assert: contents = 'Test content'.
	" ensure: [
		root removeFileNamed: name.
		self assert: ( root files noneSatisfy: [:file | file name asLowercase = name] )
	]"! !

TestCase subclass: #PagingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Memory-Manager'!

!PagingTest methodsFor: 'as yet unclassified' stamp: 'GuidoChari 10/25/2010 16:07'!
testCopyOnWriteHandling
	| memory manager directory pte pageTable pageTableAfterFault pteAfterFault |
	memory := Memory new size: 1048576. "1mb"
	manager := Paging forMemory: memory.
	manager identityMapping.
	manager from: 0 to: 8192 useHandler: #copyOnWrite.
	directory := manager directory.
	pageTable := manager pageTableFor: 5000.
	pte := manager pageTableEntryFor: 5000.
	pte readOnly.
	manager resolvePageFaultOn: 5000.
	pageTableAfterFault := manager pageTableFor: 5000.
	pteAfterFault := manager pageTableEntryFor: 5000.	
	self deny: pageTable externalAddress = pageTableAfterFault externalAddress;
		 assert: (pageTable contentsFrom: 1 to: 4) = (pageTableAfterFault contentsFrom: 1 to: 4);
		assert: (pageTable contentsFrom: 9 to: 4096) = (pageTableAfterFault contentsFrom: 9 to: 4096);
		assert: pteAfterFault isPresentAndAllowed! !

!PagingTest methodsFor: 'as yet unclassified' stamp: 'GuidoChari 10/19/2010 18:20'!
testDirectoryCloning
	| memory manager alienAddresses clone newAddresses |
	[
	memory := Memory new size: 10485760. "10mb" 
	manager := Paging forMemory: memory.
	manager identityMapping.
	alienAddresses := manager directory entries collect: [:entry | entry pointedAddress].
	alienAddresses add: manager directory externalAddress. 
	clone := manager directory deepCopy.
	manager directory: clone.
	newAddresses := manager directory entries collect: [:entry | entry pointedAddress].
	self deny: (alienAddresses includes: manager directory externalAddress);
		 assert: (newAddresses noneSatisfy: [:address | alienAddresses includes: address]).
	16r0 to: 16rA00000 - 1 by: 1000 do: [:index | self assert: (manager translate: index) = index; assert: (manager isPresentAndAllowed: index)].
	] ensure: ["clone free"] 
	! !

!PagingTest methodsFor: 'as yet unclassified' stamp: 'GuidoChari 8/19/2010 16:06'!
testIdentityTranslation
	| memory manager |
	memory := Memory new size: 104857600. "100mb"
	manager := Paging forMemory: memory.
	manager identityMapping.
	16r0 to: 16r6400000 - 1 by: 413 do: [:index | self assert: (manager translate: index) = index; assert: (manager isPresentAndAllowed: index)].! !

!PagingTest methodsFor: 'as yet unclassified' stamp: 'GuidoChari 10/19/2010 18:24'!
testPageIndexesPageAligned
	| memory manager addresses |
	memory := Memory new size: 200000000. "100mb"
	manager := Paging forMemory: memory.
	addresses := manager directory entries collect: [:entry | entry pointedAddress].
	self assert: manager directory externalAddress \\ 4096 = 0;
	assert: (addresses allSatisfy: [:address | address \\ 4096 = 0])! !

TestCase subclass: #StreamOnStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Filesystems'!

!StreamOnStreamTest methodsFor: 'as yet unclassified' stamp: 'JavierPimas 1/4/2011 14:03'!
testInnerStreamOnStream
	| changes size str1 str2 |
	changes := StandardFileStream fileNamed: 'testdata/test.changes'.
	size := changes size.	
	str1 := StreamOnStream on: changes copy offset: changes size - 100 size: 100.
	str1 setToEnd; nextPutAll: 'test'.
	str2 := StreamOnStream on: str1 offset: str1 size - 10 size: 10.
	str2 setToEnd; nextPutAll: 'test'.
	str2 := StreamOnStream on: str1 offset: str1 size - 10 size: 10.
	str2 position: 2; nextPutAll: 'aaaaaaaa'.
	changes flush; close; open: changes name forWrite: true.
	self assert: changes size = (size + 8 ).
	self assert: (changes contents asString last: 8) = 'aaaaaaaa'.
	! !

!StreamOnStreamTest methodsFor: 'as yet unclassified' stamp: 'JavierPimas 1/4/2011 14:03'!
testInnerStreamOnStream2
	| changes size str1 str2 data contents |
	changes := StandardFileStream fileNamed: 'testdata/test.changes'.
	size := changes size.
	changes position: size - 10.
	data := (changes next: 10) asString.
	str1 := StreamOnStream
				on: changes copy
				offset: changes size - 100
				size: 100.
	str2 := StreamOnStream
				on: changes copy
				offset: changes size - 100
				size: 100.
	[str1 position: 90;
		 nextPutAll: 'testtestst'.
	str2 position: 0; nextPutAll: 'test'. 
	"self assert: (str2 next: 10) = 'testtestst'."
	changes flush; close; open: changes name forWrite: true.
	self assert: changes size = size.
	contents := changes contents asString.
	self assert: (contents last: 10) asString = 'testtestst'; assert: ((contents last: 100)first: 4) = 'test']
		ensure: [changes position: size - 10;
				 nextPutAll: data]! !

!StreamOnStreamTest methodsFor: 'as yet unclassified' stamp: 'JavierPimas 1/4/2011 14:03'!
testRead
	| source |
	source := ReadStream on: 'this is a long string to read'.
	self assert: (StreamOnStream on: source offset: 5) contents asString = 'is a long string to read'.
	self assert: (StreamOnStream on: source offset: 5 size: 9) contents asString = 'is a long'.! !

TestCase subclass: #WriteListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Storage'!

!WriteListTest methodsFor: 'as yet unclassified' stamp: 'Pocho 7/18/2010 22:49'!
testAddingBlocks

	| list |
	list := WriteList new.
	
	list reserve: 5 at: 10.
	list reserve: 10 at: 50.
	list reserve: 15 at: 18.
	list reserve: 3 at: 15.
	
	self assert: list blocks = (OrderedCollection with: { 10. 18+ 15 } with: { 50. 60 }).! !

!WriteListTest methodsFor: 'as yet unclassified' stamp: 'Pocho 7/20/2010 14:28'!
testAddingContiguousBlocks

	| list |
	list := WriteList new.
	
	list reserve: 1 at: 28322905.
	list reserve: 1 at: 28322906.
	list reserve: 64 at: 28322907.
	
	self assert: list blocks = (OrderedCollection with: { 28322905. 28322907 + 64 }).! !

!Alien class methodsFor: '*SqueakNOS' stamp: 'GuidoChari 8/13/2010 15:43'!
Cvalloc: byteSize "<Integer> ^<Integer>"
	<primitive: 'primValloc' error: errorCode module: 'IA32ABI'>
	^self primitiveFailed! !

!Alien class methodsFor: '*SqueakNOS' stamp: 'GuidoChari 8/13/2010 15:25'!
newCPageAligned: byteSize
	"Answer a new instance of the given byte size whose data resides on the external C heap.
	 As with instances residing on the Smalltalk heap the data is zero-filled."
	^(self basicNew: self sizeofLong + byteSize)
		sizeFieldPut: byteSize negated;
		addressFieldPut: (self Cvalloc: byteSize);
		initialize! !

Alien variableByteSubclass: #PageDirectoryRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-MemoryManager-Paging'!

!PageDirectoryRecord methodsFor: 'initialize-release' stamp: 'GuidoChari 8/5/2010 19:16'!
initializeSameAddresses
	| i |
	i := 1.
	self records do: [:record | record address: i]! !

Alien variableByteSubclass: #PageFaultParameters
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-MemoryManager-Paging'!

!PageFaultParameters class methodsFor: 'accessing' stamp: 'GuidoChari 8/28/2010 16:08'!
dataSize 
	^4! !

!PageFaultParameters methodsFor: 'accessing' stamp: 'GuidoChari 9/1/2010 15:42'!
virtualFaultAddress
	^self unsignedLongAt: 1! !

Object subclass: #ATABenchmarker
	instanceVariableNames: 'results controller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Storage'!

!ATABenchmarker methodsFor: 'services' stamp: 'JavierPimas 11/2/2010 00:04'!
at: aTitle benchmark: aBlock
	| startTime |
	startTime := Time millisecondsToRun: aBlock.
	results at: aTitle put: startTime.
	
! !

!ATABenchmarker methodsFor: 'services' stamp: 'JavierPimas 11/7/2010 23:37'!
at: aTitle benchmark: aBlock size: aSize
	| runTime bytesPerSecond stream |
	runTime := Time millisecondsToRun: aBlock.
	bytesPerSecond := aSize / runTime * 1000.
	stream := WriteStream on: ''.
	stream nextPutAll: runTime asString; nextPutAll: ' ms. Throughput: '.
	(bytesPerSecond / (1024*1024)) asFloat absPrintOn: stream base: 10 digitCount: 5.
	stream nextPutAll: ' MB/s'.
	results at: aTitle put: stream contents.
	
! !

!ATABenchmarker methodsFor: 'as yet unclassified' stamp: 'JavierPimas 11/1/2010 21:15'!
controller: aController
	controller := aController.! !

!ATABenchmarker methodsFor: 'as yet unclassified' stamp: 'JavierPimas 11/1/2010 21:40'!
initialize
	results := Dictionary new.
	controller := ATAController secondary.! !

!ATABenchmarker methodsFor: 'services' stamp: 'JavierPimas 11/7/2010 22:42'!
issueRead102400BlocksOf512Bytes
	self at: 'Read 102400 blocks of 512 Bytes' benchmark: [ | offset | offset := 0.
		102400 timesRepeat: [
			controller issueReadFrom: offset count: 1 device: 0 timeout: 5000.
			offset := offset + 1.
		]
	] size: 102400 * 512.
	
! !

!ATABenchmarker methodsFor: 'services' stamp: 'JavierPimas 11/7/2010 22:42'!
issueRead1024BlocksOf50KB
	self at: 'Read 1024 blocks of 50 KB' benchmark: [ | offset | offset := 0.
		1024 timesRepeat: [
			controller issueReadFrom: offset count: 100 device: 0 timeout: 5000.
			offset := offset + 100.
		]
	] size: 102400 * 512
	
! !

!ATABenchmarker methodsFor: 'services' stamp: 'JavierPimas 11/8/2010 02:01'!
issueRead1BlockOf50MB
	self at: 'Read 1 block of 50 MB' benchmark: [
		controller at: 1 count: 102400 of: 0.
	]  size: 102400 * 512
	
! !

!ATABenchmarker methodsFor: 'services' stamp: 'JavierPimas 11/7/2010 22:42'!
issueWrite102400BlocksOf512Bytes
	| array |
	array := ByteArray new: 512.
	self at: 'Write 102400 blocks of 512 Bytes' benchmark: [ | offset | offset := 0.
		102400 timesRepeat: [
			controller issueWrite: array at: offset device: 0 timeout: 5000.
			offset := offset + 1.
		]
	]  size: 102400 * 512
	
! !

!ATABenchmarker methodsFor: 'services' stamp: 'JavierPimas 11/7/2010 22:42'!
issueWrite1024BlocksOf50KB
	| array |
	array := ByteArray new: 50*1024.
	self at: 'Write 1024 blocks of 50 KB' benchmark: [ | offset | offset := 0.
		1024 timesRepeat: [
			controller issueWrite: array at: offset device: 0 timeout: 5000.
			offset := offset + 100.
		]
	]  size: 102400 * 512
	
! !

!ATABenchmarker methodsFor: 'services' stamp: 'JavierPimas 11/8/2010 02:02'!
issueWrite1BlockOf50MB
	| array |
	array := ByteArray new: 50*1024*1024.
	self at: 'Write 1 block of 50 MB' benchmark: [
		controller at: 1 of: 0 putAll: array.
	]  size: 102400 * 512
	
! !

!ATABenchmarker methodsFor: 'as yet unclassified' stamp: 'JavierPimas 11/2/2010 00:34'!
run
	self issueWrite1BlockOf50MB.
	self issueRead1BlockOf50MB.
	self issueWrite1024BlocksOf50KB.
	self issueRead1024BlocksOf50KB.! !

Object subclass: #BlockArithmetic
	instanceVariableNames: 'blockSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Storage'!

!BlockArithmetic methodsFor: 'accessing' stamp: 'Pocho 7/20/2010 10:26'!
alignedFrom: first to: last do: aBlock
	| nextEnd remaining |
	
	nextEnd := last min: (self lastPositionInSameBlockOf: first).
	aBlock value: first value: nextEnd.
	remaining := last - nextEnd.
	[remaining > 0] whileTrue: [ | nextStart |
		nextStart := nextEnd + 1.
		nextEnd := nextEnd + (remaining min: blockSize).
		aBlock value: nextStart value: nextEnd.
		remaining := remaining - blockSize.
	].
	! !

!BlockArithmetic methodsFor: 'accessing' stamp: 'Pocho 7/17/2010 15:57'!
alignedStart: first end: last with: aBlock
	aBlock value: (self firstPositionInSameBlockOf: first) value: (self lastPositionInSameBlockOf: last).! !

!BlockArithmetic methodsFor: 'accessing' stamp: 'Pocho 7/19/2010 05:00'!
blockNumberOf: anInteger
	^anInteger - 1 // self blockSize + 1.! !

!BlockArithmetic methodsFor: 'accessing' stamp: 'Pocho 7/16/2010 19:34'!
blockSize
	"Answer the value of blockSize"

	^ blockSize! !

!BlockArithmetic methodsFor: 'accessing' stamp: 'Pocho 7/16/2010 19:34'!
blockSize: anObject
	"Set the value of blockSize"

	blockSize := anObject! !

!BlockArithmetic methodsFor: 'accessing' stamp: 'Pocho 7/16/2010 19:55'!
firstPositionInSameBlockOf: position
	^position - (position - 1 \\ blockSize)! !

!BlockArithmetic methodsFor: 'accessing' stamp: 'Pocho 7/17/2010 16:03'!
from: first to: last do: aBlock
	first to: last by: blockSize do: [ :next | aBlock value: next ].! !

!BlockArithmetic methodsFor: 'accessing' stamp: 'JavierPimas 1/3/2011 17:07'!
lastPositionInSameBlockOf: position
	^(self firstPositionInSameBlockOf: position) + blockSize - 1.! !

!BlockArithmetic methodsFor: 'accessing' stamp: 'Pocho 7/16/2010 19:54'!
positionInBlockOf: position
	^ position - 1 \\ blockSize + 1.! !

!BlockArithmetic methodsFor: 'accessing' stamp: 'Pocho 7/17/2010 15:55'!
size
	"Answer the value of blockSize"

	^ blockSize! !

!BlockArithmetic methodsFor: 'accessing' stamp: 'Pocho 7/17/2010 15:55'!
size: anObject
	"Set the value of blockSize"

	blockSize := anObject! !

BlockArithmetic subclass: #BlockArithmetic0
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Storage'!

!BlockArithmetic0 class methodsFor: 'as yet unclassified' stamp: 'JavierPimas 11/1/2010 11:11'!
size: aSize
	^self new size: aSize! !

!BlockArithmetic0 class methodsFor: 'as yet unclassified' stamp: 'JavierPimas 11/1/2010 11:11'!
size: aSize index: index
	^self new size: aSize index: index! !

!BlockArithmetic0 methodsFor: 'accessing' stamp: 'JavierPimas 11/1/2010 11:14'!
blockNumberOf: anInteger
	^anInteger // self blockSize.! !

!BlockArithmetic0 methodsFor: 'accessing' stamp: 'JavierPimas 11/1/2010 11:13'!
firstPositionInSameBlockOf: position
	^position - (position \\ blockSize)! !

!BlockArithmetic0 methodsFor: 'accessing' stamp: 'JavierPimas 11/1/2010 11:16'!
offsetInBlockOf: position
	^position \\ blockSize! !

Object subclass: #BlockCache
	instanceVariableNames: 'device chunks writeList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Storage'!

!BlockCache class methodsFor: 'as yet unclassified' stamp: 'Pocho 7/16/2010 19:47'!
on: aBlockDevice
	^self new on: aBlockDevice.! !

!BlockCache methodsFor: 'as yet unclassified' stamp: 'JavierPimas 1/4/2011 15:26'!
blockSize
	^device blockSize! !

!BlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/17/2010 15:26'!
chunkSize
	^256! !

!BlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/20/2010 02:58'!
chunksFrom: firstBlockOfFirstChunk to: firstBlockOfLastChunk
	
	^(firstBlockOfFirstChunk to: firstBlockOfLastChunk by: self chunkSize) collect: [ :firstBlockOfChunk |
		chunks at: firstBlockOfChunk ifAbsent: [ | aByteArray |
			aByteArray := device from: firstBlockOfChunk to: firstBlockOfChunk + self chunkSize - 1.
			chunks at: firstBlockOfChunk put: aByteArray.
			self updateChunk: aByteArray withWritesAt: firstBlockOfChunk.
			aByteArray
		]
	  ]
	
	! !

!BlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/20/2010 10:05'!
clear
	"Discards all changes"
	chunks := Dictionary new.
	writeList := WriteList new.! !

!BlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/20/2010 13:07'!
concatenationFrom: first to: last of: aCollectionOfChunks
	| result offsetInResult chunkFirst helper i |
	helper := BlockArithmetic new blockSize: self chunkSize.
	i := 1.
	result := ByteArray new: last - first + 1 * self blockSize.
	offsetInResult := 1.
	chunkFirst := first - 1 * self blockSize + 1.

	helper alignedFrom: first to: last do: [ :nextStart :nextEnd | | count |

		count := nextEnd - nextStart + 1 * self blockSize.
		result replaceFrom: offsetInResult to: offsetInResult + count - 1 with: (aCollectionOfChunks at: i) startingAt: chunkFirst.
		chunkFirst := 1.
		i := i + 1.
		offsetInResult := offsetInResult + count.
	].

	^result
! !

!BlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/22/2010 22:59'!
flushWrites
	| helper buffer |
	self halt.
	helper := BlockArithmetic new size: self blockSize.
	writeList do: [ :byteStart :byteEnd :segments |
	
		helper alignedStart: byteStart end: byteEnd with: [ :alignedByteStart :alignedByteEnd  |
			buffer := ByteArray new: alignedByteEnd - alignedByteStart + 1.
			self readHalfWrittenSectorsInto: buffer start: byteStart end: byteEnd.
		
			segments do: [ :aSegment | 
				buffer replaceFrom: (aSegment at: 1) - alignedByteStart + 1
					    to: (aSegment at: 1) - alignedByteStart + (aSegment at: 2) size
					    with: (aSegment at: 2) startingAt: 1
			].

			device at: (helper blockNumberOf: alignedByteStart) writeArray: buffer.
		
		]
	].

	writeList clear.
	
	! !

!BlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/19/2010 03:56'!
from: firstBlock to: lastBlock
	| helper | 
	helper := BlockArithmetic new size: self chunkSize.
	
	helper alignedStart: firstBlock end: lastBlock with: [ :firstBlockOfFirstChunk :lastBlockOfLastChunk | | firstBlockOfLastChunk |
		firstBlockOfLastChunk := lastBlockOfLastChunk - self chunkSize + 1.
		^self concatenationFrom: firstBlock - firstBlockOfFirstChunk + 1
				to: lastBlock - firstBlockOfFirstChunk + 1
				of: (self chunksFrom: firstBlockOfFirstChunk to: firstBlockOfLastChunk).
	].
	
	! !

!BlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/17/2010 16:06'!
invalidateFrom: destOffset bytesCount: bytesCount
	| helper |
	helper := BlockArithmetic new size: self chunkSize * self blockSize.
	helper from: (helper blockNumberOf: destOffset) to: (helper blockNumberOf: destOffset + bytesCount - 1) do: [ :chunkStart |
		chunks removeKey: chunkStart ifAbsent: [].
	].! !

!BlockCache methodsFor: 'as yet unclassified' stamp: 'JavierPimas 1/4/2011 15:27'!
on: aBlockDevice
	device := aBlockDevice.
	chunks := Dictionary new.
	writeList := WriteList new.! !

!BlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/19/2010 19:26'!
readHalfWrittenSectorsInto: buffer start: byteStart end: byteEnd

	| firstBlock lastBlock blocksCount firstSectorRead helper |

	helper := BlockArithmetic new blockSize: self blockSize.
	firstSectorRead := false.
	firstBlock := helper blockNumberOf: byteStart.
	lastBlock := helper blockNumberOf: byteEnd.
	blocksCount := lastBlock - firstBlock + 1.

	"If it starts at block boundaries, we don't need to read the block. We'll probably overwrite it entirely"
	(helper positionInBlockOf: byteStart ) ~= 1 ifTrue: [
		firstSectorRead := true.
		buffer replaceFrom: 1 to: self blockSize with: (device at: firstBlock) startingAt: 1.
	].

	"If it ends at block boundaries, we don't need to read the last block. We'll probably overwrite it entirely"
	(helper positionInBlockOf: byteEnd) ~= self blockSize ifTrue: [
		(blocksCount = 1 & firstSectorRead) ifFalse: [
			buffer replaceFrom: 1	to: self blockSize with: (device at: lastBlock) startingAt: 1.
		].
	].
! !

!BlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/20/2010 16:31'!
replaceFromByte: destOffset bytesCount: bytesCount with: source startingAtByte: sourceOffset
	"Transcript show: 'Writing from: ', destOffset, ' count: ', bytesCount, '
	'."
	writeList at: destOffset wrote: (source copyFrom: sourceOffset to: sourceOffset + bytesCount - 1).
	
	self updateChunksFrom: destOffset bytesCount: bytesCount with: source startingAtByte: sourceOffset.
		! !

!BlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/20/2010 01:07'!
updateChunk: aChunk withWritesAt: firstBlockOfChunk
	writeList writeFrom: firstBlockOfChunk - 1 * self blockSize + 1
			  to: firstBlockOfChunk + self chunkSize - 1 * self blockSize
			  into: aChunk.
	
	! !

!BlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/20/2010 02:28'!
updateChunksFrom: destOffset bytesCount: bytesCount with: source startingAtByte: sourceOffset
	| helper sourceStart |
	helper := BlockArithmetic new size: self chunkSize * self blockSize.
	sourceStart := sourceOffset.
	
	helper alignedFrom: destOffset to: destOffset + bytesCount - 1 do: [ :nextStart :nextEnd |
		chunks at: (helper firstPositionInSameBlockOf: nextStart) - 1 // self blockSize + 1 ifPresent: [ :aByteArray |
			aByteArray replaceFrom: (helper positionInBlockOf: nextStart) to: (helper positionInBlockOf: nextEnd) with: source startingAt: sourceStart.
			sourceStart := sourceStart + self blockSize.
		].
	].! !

Object subclass: #BlockDevice
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Storage'!

!BlockDevice commentStamp: 'Pocho 4/2/2010 04:49' prior: 0!
A BlockDevice is an <<abstract class>> that represents a device that is accessed by block index. Maybe it should subclass ArrayedCollection and not Object. It implements a veeeeery primitive caching mechanism.

ATADevice is an example of a block device.!

BlockDevice subclass: #ATADevice
	instanceVariableNames: 'controller deviceNumber cachedSector cachedSectorNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Storage'!

ATADevice class
	instanceVariableNames: 'loadedDevices'!

!ATADevice commentStamp: 'Pocho 3/27/2010 14:31' prior: 0!
An ATADevice is our high level representation of an ATA Hard Disk, which is a BlockDevice with blocks (sectors) of 512 bytes. It uses an ATA Controller to control the device at the lowest level. The deviceNumber is a low-level number used by the controller, where 0 means master and 1 means slave.!

ATADevice class
	instanceVariableNames: 'loadedDevices'!

!ATADevice class methodsFor: 'as yet unclassified' stamp: 'Pocho 7/19/2010 00:09'!
controlledBy: aController device: aDeviceNumber
	loadedDevices ifNil: [ loadedDevices := Dictionary new ].
	(loadedDevices at: aController 
		ifAbsentPut: [ Dictionary new ])
		at: aDeviceNumber
			ifAbsentPut: [self new controller: aController; deviceNumber: aDeviceNumber].
	^(loadedDevices at: aController) at: aDeviceNumber.! !

!ATADevice methodsFor: 'services' stamp: 'JavierPimas 11/8/2010 01:40'!
at: aBlockNumber 
	"Retrieve sector number aBlockNumber from device"
	^ controller at: aBlockNumber "Decrement 1 because block num comes 1-based and LBA indexes are 0-based"
				 count: 1 of: deviceNumber.
	! !

!ATADevice methodsFor: 'services' stamp: 'JavierPimas 11/8/2010 01:14'!
at: firstBlockNumber count: numberOfBlocks
	"Retrieve numberOfBlocks sector number aBlockNumber from device.
	 NumberOfBlocks should be no more than 256"
	
	^controller at: firstBlockNumber count: numberOfBlocks device: deviceNumber.
	
	! !

!ATADevice methodsFor: 'services' stamp: 'JavierPimas 11/8/2010 01:45'!
at: firstBlockNumber writeArray: aByteArray
	"Write aByteArray to disk starting at firstBlockNumber. aByteArray size should be multiple of the sector size"
	controller at: firstBlockNumber of: deviceNumber putAll: aByteArray.! !

!ATADevice methodsFor: 'accessing' stamp: 'Pocho 3/27/2010 14:41'!
blockSize
	"Answer the size of a single block"

	^ 512! !

!ATADevice methodsFor: 'accessing' stamp: 'Pocho 3/27/2010 13:41'!
controller
	"Answer the value of controller"

	^ controller! !

!ATADevice methodsFor: 'accessing' stamp: 'Pocho 3/27/2010 13:43'!
controller: aController
	"Set the value of controller"

	controller := aController! !

!ATADevice methodsFor: 'accessing' stamp: 'Pocho 3/27/2010 13:41'!
deviceNumber
	"Answer the value of deviceNumber"

	^ deviceNumber! !

!ATADevice methodsFor: 'accessing' stamp: 'Pocho 3/27/2010 13:43'!
deviceNumber: aDeviceNumber
	"Set the value of deviceNumber"

	deviceNumber := aDeviceNumber! !

!ATADevice methodsFor: 'services' stamp: 'JavierPimas 11/8/2010 01:09'!
from: firstBlockNumber to: lastBlockNumber
	^controller from: firstBlockNumber to: lastBlockNumber device: deviceNumber.
		! !

!ATADevice methodsFor: 'services' stamp: 'Pocho 6/29/2010 11:40'!
information
	"I retrieve information about this device"
	| info |
	info := controller
		selectDrive: deviceNumber;
		cmdIdentifyDevice;
		readAllAvailable.
	^IDEHardDiskDeviceInformation fromHandle: info asByteArray! !

!ATADevice methodsFor: 'services' stamp: 'Pocho 6/29/2010 12:20'!
reset
	"Reset the device. Useful after errors"
	^ controller resetDevice: deviceNumber.
	! !

!BlockDevice methodsFor: 'real access' stamp: 'Pocho 3/27/2010 14:10'!
at: aBlockNumber
	^ self subclassResponsibility.
	! !

!BlockDevice methodsFor: 'real access' stamp: 'Pocho 3/27/2010 14:10'!
at: aBlockNumber write: aBlock
	^ self subclassResponsibility.
	! !

!BlockDevice methodsFor: 'real access' stamp: 'Pocho 3/27/2010 14:10'!
at: aBlockNumber writeArray: aByteArray
	^ self subclassResponsibility.
	! !

!BlockDevice methodsFor: 'as yet unclassified' stamp: 'Pocho 4/2/2010 01:17'!
blockNumberFromByteOffset: anInteger

	^anInteger - 1 // self blockSize + 1.! !

!BlockDevice methodsFor: 'accessing' stamp: 'Pocho 3/27/2010 14:24'!
blockSize
	"Answer the size of a single block"
	^ self subclassResponsibility.! !

!BlockDevice methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 16:37'!
disableCache
	cache flushWrites.
	cache := NullBlockCache on: self.! !

!BlockDevice methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 16:37'!
enableCache
	cache flushWrites.
	cache := BlockCache on: self.! !

!BlockDevice methodsFor: 'as yet unclassified' stamp: 'Pocho 7/20/2010 16:17'!
flush
	
	cache flushWrites.! !

!BlockDevice methodsFor: 'real access' stamp: 'Pocho 4/2/2010 01:04'!
from: firstBlockNumber to: lastBlockNumber
	"returns a bytearray containing all blocks from firstBlockNumber to lastBlockNumber included. Block number is a 1-based index."
	^ self subclassResponsibility.
	! !

!BlockDevice methodsFor: 'as yet unclassified' stamp: 'Pocho 3/27/2010 17:49'!
fromByte: sourceOffset bytesCount: bytesCount
	
	| data firstBlock lastBlock firstBlockBytesOffset |
	firstBlock := self blockNumberFromByteOffset: sourceOffset.
	lastBlock := self blockNumberFromByteOffset: sourceOffset + bytesCount - 1.
	
	data := self from: firstBlock to: lastBlock.
		
	firstBlockBytesOffset := sourceOffset - 1 \\ 512 + 1.
	^ data copyFrom: firstBlockBytesOffset to: firstBlockBytesOffset + bytesCount - 1.
! !

!BlockDevice methodsFor: 'as yet unclassified' stamp: 'Pocho 3/27/2010 18:01'!
fromByte: firstByte toByte: lastByte
	
	| data firstBlock lastBlock firstBlockBytesOffset |
	firstBlock := self blockNumberFromByteOffset: firstByte.
	lastBlock := self blockNumberFromByteOffset: lastByte.
	
	data := self from: firstBlock to: lastBlock.
		
	firstBlockBytesOffset := self positionInBlockOf: firstByte.
	^ data copyFrom: firstBlockBytesOffset to: firstBlockBytesOffset + lastByte - firstByte.
! !

!BlockDevice methodsFor: 'as yet unclassified' stamp: 'GuidoChari 11/1/2010 14:47'!
initialize
	cache := ReadBlockCache on: self
	! !

!BlockDevice methodsFor: 'as yet unclassified' stamp: 'Pocho 7/16/2010 20:01'!
oldreplaceFromByte: destOffset bytesCount: bytesCount with: source startingAtByte: sourceOffset
	"Write count bytes from source starting at startIndex bytes. We handle half sector
	 overwriting."
	| data firstBlock lastBlock blocksCount firstBlockBytesOffset lastBlockBytesCount blockData firstSectorRead |
	
	firstBlock := self blockNumberFromByteOffset: destOffset.
	lastBlock := self blockNumberFromByteOffset: destOffset + bytesCount - 1.
	blocksCount := lastBlock - firstBlock + 1.
	
	firstSectorRead := false.
	
	data := ByteArray new: blocksCount * self blockSize.
	
	cache := Array new: 3.
	
	"If it starts at block boundaries, we don't need to read the block. We'll probably overwrite it entirely"
	firstBlockBytesOffset := self positionInBlockOf: destOffset.
	firstBlockBytesOffset ~= 1 ifTrue: [
		firstSectorRead := true.
		blockData := self at: firstBlock.
		data replaceFrom: 1	to: self blockSize with: blockData startingAt: 1.
	].
	
	"If it ends at block boundaries, we don't need to read the last block. We'll probably overwrite it entirely"
	lastBlockBytesCount := self positionInBlockOf: destOffset + bytesCount - 1.
	lastBlockBytesCount ~= self blockSize ifTrue: [
		(blocksCount = 1 & firstSectorRead) ifFalse: [
			blockData := self at: lastBlock.
			data replaceFrom: 1	to: self blockSize with: blockData startingAt: 1.
		].
	].

	data
		replaceFrom: firstBlockBytesOffset to: (firstBlockBytesOffset + bytesCount - 1)
		with: source startingAt: sourceOffset.
	
	self at: firstBlock writeArray: data.
	! !

!BlockDevice methodsFor: 'as yet unclassified' stamp: 'Pocho 3/27/2010 17:57'!
positionInBlockOf: aByteOffset
	^ aByteOffset - 1 \\ self blockSize + 1.! !

!BlockDevice methodsFor: 'as yet unclassified' stamp: 'Pocho 7/16/2010 17:31'!
readInto: byteArray startWritingAtByte: destOffset startReadingAtByte: sourceOffset bytesCount: bytesCount
	
	| firstBlock lastBlock firstBlockBytesOffset |
	firstBlock := self blockNumberFromByteOffset: sourceOffset.
	lastBlock := self blockNumberFromByteOffset: sourceOffset + bytesCount - 1.
	
	firstBlockBytesOffset := self positionInBlockOf: sourceOffset.
	byteArray replaceFrom: destOffset to: destOffset + bytesCount - 1 with: (cache from: firstBlock to: lastBlock) startingAt: firstBlockBytesOffset.
	^bytesCount.
	
	
! !

!BlockDevice methodsFor: 'as yet unclassified' stamp: 'Pocho 7/16/2010 20:02'!
replaceFromByte: destOffset bytesCount: bytesCount with: source startingAtByte: sourceOffset
	"Write count bytes from source starting at startIndex bytes. We handle half sector
	 overwriting."
	cache replaceFromByte: destOffset bytesCount: bytesCount with: source startingAtByte: sourceOffset.! !

BlockDevice subclass: #BlockDeviceOnStream
	instanceVariableNames: 'stream blockSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Storage'!

!BlockDeviceOnStream commentStamp: 'Pocho 7/21/2010 16:07' prior: 0!
I provide objects that allow to see files as block devices. It's similar to loop devices in linux.!

!BlockDeviceOnStream class methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 16:54'!
on: aStream blockSize: aBlockSize
	^(self basicNew on: aStream blockSize: aBlockSize) initialize.! !

!BlockDeviceOnStream methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 16:20'!
at: aBlockNumber 
	"Retrieve sector number aBlockNumber from device"

	stream position: (aBlockNumber - 1 * self blockSize).
	^stream next: self blockSize.! !

!BlockDeviceOnStream methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 16:19'!
at: aBlockNumber count: blocksCount
	"Retrieve sector number aBlockNumber from device"

	stream position: (aBlockNumber - 1 * self blockSize).
	^stream next: self blockSize * blocksCount.! !

!BlockDeviceOnStream methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 16:23'!
at: firstBlockNumber writeArray: aByteArray
	"Write aByteArray to disk starting at firstBlockNumber. aByteArray size should be multiple of the sector size"

	stream position: (firstBlockNumber - 1 * self blockSize).
	stream nextPutAll: aByteArray.! !

!BlockDeviceOnStream methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 16:46'!
blockSize
	^blockSize.! !

!BlockDeviceOnStream methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 16:23'!
from: firstBlockNumber to: lastBlockNumber
	"Retrieve sectorst from firstBlockNumber to lastBlockNumber"

	^self at: firstBlockNumber count: lastBlockNumber - firstBlockNumber + 1.! !

!BlockDeviceOnStream methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 16:46'!
on: aStream blockSize: aBlockSize
	stream := aStream.
	stream binary.
	blockSize := aBlockSize.! !

BlockDevice subclass: #DualTestBlockDevice
	instanceVariableNames: 'deviceA deviceB'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Storage'!

!DualTestBlockDevice class methodsFor: 'as yet unclassified' stamp: 'Pocho 7/22/2010 16:06'!
deviceA: aDeviceA deviceB: aDeviceB
	^(self basicNew deviceA: aDeviceA deviceB: aDeviceB) initialize.! !

!DualTestBlockDevice methodsFor: 'as yet unclassified' stamp: 'Pocho 7/22/2010 16:01'!
at: aBlockNumber 
	"Retrieve sector number aBlockNumber from device"
	| result | 
	result := deviceA at: aBlockNumber.
	(deviceB at: aBlockNumber) = result ifFalse: [ self error: 'Read failed' ].
	^result.! !

!DualTestBlockDevice methodsFor: 'as yet unclassified' stamp: 'Pocho 7/22/2010 16:02'!
at: aBlockNumber count: blocksCount
	"Retrieve sector number aBlockNumber from device"
	| result | 
	result := deviceA at: aBlockNumber count: blocksCount.
	(deviceB at: aBlockNumber count: blocksCount) = result ifFalse: [ self error: 'Read failed' ].
	^result.! !

!DualTestBlockDevice methodsFor: 'as yet unclassified' stamp: 'Pocho 7/22/2010 16:20'!
at: firstBlockNumber writeArray: aByteArray
	"Write aByteArray to disk starting at firstBlockNumber. aByteArray size should be multiple of the sector size"
	
	deviceA at: firstBlockNumber writeArray: aByteArray.
	(deviceB at: firstBlockNumber writeArray: aByteArray).
	
	self at: firstBlockNumber count: aByteArray size / self blockSize.
	! !

!DualTestBlockDevice methodsFor: 'as yet unclassified' stamp: 'Pocho 7/22/2010 16:05'!
blockSize
	^deviceA blockSize.! !

!DualTestBlockDevice methodsFor: 'as yet unclassified' stamp: 'Pocho 7/22/2010 16:05'!
deviceA: aDeviceA deviceB: aDeviceB
	deviceA := aDeviceA.
	deviceB := aDeviceB.! !

!DualTestBlockDevice methodsFor: 'as yet unclassified' stamp: 'Pocho 7/22/2010 15:59'!
from: firstBlockNumber to: lastBlockNumber
	"Retrieve sectorst from firstBlockNumber to lastBlockNumber"

	^self at: firstBlockNumber count: lastBlockNumber - firstBlockNumber + 1.! !

Object subclass: #Buffer
	instanceVariableNames: 'pointer size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-External-Structures'!

!Buffer class methodsFor: 'as yet unclassified' stamp: 'JavierPimas 11/1/2010 21:00'!
at: anAddress size: aNumberOfBytes
	^self new at: anAddress size: aNumberOfBytes! !

!Buffer class methodsFor: 'as yet unclassified' stamp: 'JavierPimas 11/1/2010 21:01'!
size: aNumberOfBytes
	^self new size: aNumberOfBytes; allocateSpace! !

!Buffer methodsFor: 'as yet unclassified' stamp: 'JavierPimas 11/1/2010 16:15'!
address
	^pointer address.
! !

!Buffer methodsFor: 'as yet unclassified' stamp: 'JavierPimas 11/1/2010 21:03'!
allocateSpace
	pointer := Alien newC: size.! !

!Buffer methodsFor: 'as yet unclassified' stamp: 'JavierPimas 11/1/2010 16:14'!
at: anAddress size: aNumberOfBytes
	pointer := Alien forPointer: anAddress.
	size := aNumberOfBytes.! !

!Buffer methodsFor: 'as yet unclassified' stamp: 'JavierPimas 11/1/2010 16:50'!
basicSize
	^size.
! !

!Buffer methodsFor: 'as yet unclassified' stamp: 'JavierPimas 11/4/2010 01:46'!
contents
	| result | 
	result := ByteArray new: size.
	pointer copyInto: result from: 1 to: size in: pointer startingAt: 1.
	^result.
! !

!Buffer methodsFor: 'as yet unclassified' stamp: 'JavierPimas 11/1/2010 21:54'!
contents: aByteArray
	pointer replaceFrom: 1 to: aByteArray size with: aByteArray startingAt: 1.
! !

!Buffer methodsFor: 'as yet unclassified' stamp: 'JavierPimas 11/1/2010 16:15'!
size
	^size.
! !

!Buffer methodsFor: 'as yet unclassified' stamp: 'JavierPimas 11/1/2010 21:02'!
size: aSize
	^size := aSize.
! !

Object subclass: #Computer
	instanceVariableNames: 'devices info processor memoryManager'
	classVariableNames: 'Current PageFaultHandler'
	poolDictionaries: ''
	category: 'SqueakNOS-Kernel'!

!Computer class methodsFor: 'filesystem' stamp: 'JavierPimas 1/4/2011 14:30'!
blankBlockDeviceForTest
	^self isSqueakNOS
				ifTrue: [ self blankDiskOnRealDiskForTest ]
				ifFalse: [self blankDiskOnFileForTest ].! !

!Computer class methodsFor: 'filesystem' stamp: 'JavierPimas 1/4/2011 15:27'!
blankDiskOnFileForTest
	^BlockDeviceOnStream on: (StandardFileStream fileNamed: './testdata/blank') blockSize: 512.! !

!Computer class methodsFor: 'filesystem' stamp: 'JavierPimas 1/4/2011 14:29'!
blankDiskOnRealDiskForTest
	^ATAController secondary slave.! !

!Computer class methodsFor: 'accessing' stamp: 'gera 5/20/2006 01:25'!
current
	^ Current! !

!Computer class methodsFor: 'filesystem' stamp: 'JavierPimas 9/14/2010 13:01'!
diskFS
	| diskStream |
	diskStream := CheapHardDiskStream on: ATAController primary master.
	^FAT32FileSystem of: diskStream partition: 1 readOnly: false! !

!Computer class methodsFor: 'filesystem' stamp: 'JavierPimas 9/14/2010 13:01'!
fileFS
	| diskStream |
	diskStream := StandardFileStream fileNamed: './testdata/ExampleFAT32.raw'.
	^FAT32FileSystem of: diskStream partition: 1! !

!Computer class methodsFor: 'class initialization' stamp: 'Pocho 7/29/2010 16:28'!
initialize
	"self initialize"
	Smalltalk addToStartUpList: ExternalObject after: Delay.
	Smalltalk addToStartUpList: self after: ExternalObject.
	Smalltalk addToShutDownList: self.
	"Smalltalk addToStartUpList: FileDirectory after: self."
	Smalltalk removeFromStartUpList: FileDirectory.
! !

!Computer class methodsFor: 'testing' stamp: 'gera 5/23/2006 00:20'!
isSqueakNOS
	^ SmalltalkImage current platformName = 'SqueakNOS'
! !

!Computer class methodsFor: 'filesystem' stamp: 'JavierPimas 9/14/2010 13:00'!
primaryFilesystem
	^self isSqueakNOS
				ifTrue: [self diskFS]
				ifFalse: [self fileFS].
! !

!Computer class methodsFor: 'class initialization' stamp: 'Pocho 7/29/2010 12:48'!
setSnapshotEndAddress
	| block |
	block := Computer current memory biggestEmptyBlock.
	Computer current snapshotEndAddress: block end.
! !

!Computer class methodsFor: 'class initialization' stamp: 'JavierPimas 11/16/2010 00:43'!
shutDown: quitting 
	self isSqueakNOS ifTrue: [ | current pageFaultHandler |  
		current := self current.
		self setSnapshotEndAddress.
		current memoryManager ifNotNil: [ :manager | 
			pageFaultHandler := CopyOnWriteSaveReadOnlyPageFaultHandler manager: manager readOnlyOn: current pages.
			manager from: current imageStartAddress to: current imageEndAddress useHandler: pageFaultHandler
		].
		current resetSnapshotInfo
	]
! !

!Computer class methodsFor: 'class initialization' stamp: 'GuidoChari 1/5/2011 15:39'!
startUp: resuming 
	self isSqueakNOS
		ifTrue: [
				Transcript cr; show: 'This is SqueakNOS!!!!!! :-)'; cr.
				resuming ifTrue: [ self startUpPCComputer ]
		] ifFalse: [
			Transcript cr; show: 'This is not SqueakNOS!! :-('; cr.
			FileDirectory startUp.
		]! !

!Computer class methodsFor: 'class initialization' stamp: 'gc 6/30/2010 16:15'!
startUpPCComputer
	Current := self new.
	
! !

!Computer class methodsFor: 'class initialization' stamp: 'Pocho 7/29/2010 12:43'!
tweakSqueakForSqueakNOS.
	Smalltalk removeFromStartUpList: SecurityManager; removeFromStartUpList: FileDirectory.
	Smalltalk removeFromShutDownList: FileDirectory.
	Preferences disable: #logDebuggerStackToFile! !

!Computer methodsFor: 'accessing' stamp: 'gera 7/20/2006 18:49'!
add: aHardwareDevice named: aSymbol
	Transcript cr; show: aHardwareDevice printString, ' installed as ', aSymbol.
	^ devices at: aSymbol put: aHardwareDevice! !

!Computer methodsFor: 'snapshotting' stamp: 'GuidoChari 1/4/2011 14:43'!
bytesPerWord
	^4! !

!Computer methodsFor: 'accessing' stamp: 'gera 5/20/2006 01:41'!
doesNotUnderstand: aMessage
	| selector |
	"it would be nice to compile the accessor the first time it's used"
	selector := aMessage selector.
	(aMessage arguments size = 1 and: [selector last = $:])
		ifTrue: [
			^ self add: aMessage arguments first
				named: selector allButLast asSymbol].

	^ devices at: aMessage selector ifAbsent: [
		super doesNotUnderstand: aMessage]
! !

!Computer methodsFor: 'memory' stamp: 'GuidoChari 10/28/2010 16:04'!
enablePaging
	memoryManager := Paging forMemory: self memory.
	self pageFaultHandler: memoryManager pageFaultHandler.
	processor enablePagingWithDirectory: memoryManager directory externalAddress! !

!Computer methodsFor: 'accessing' stamp: 'gera 5/20/2006 01:38'!
has: aSymbol
	^ devices includesKey: aSymbol! !

!Computer methodsFor: 'image' stamp: 'GuidoChari 10/28/2010 15:49'!
imageEndAddress
	^(KernelModule fromHandle: (ExternalAddress new fromInteger: info multiboot modsAddress)) end! !

!Computer methodsFor: 'snapshotting' stamp: 'JavierPimas 12/16/2010 17:17'!
imageFileStreamForWrite
	| filesystem image contents directory name bytearray |
	filesystem := self primaryFilesystem.
	directory := filesystem root.
	name := SmalltalkImage current imageName.
	image := (directory fileExists: name) ifTrue: [directory fileNamed: name] ifFalse: [directory newFileNamed: name]. 
	^image writeStream.
	! !

!Computer methodsFor: 'image' stamp: 'GuidoChari 1/5/2011 15:52'!
imageMemoryReadOnlyPageContents: aNumber
	| size address limit contents |
	size := self memoryManager pageSize.
	address := Smalltalk objectMemoryStartAddress + (aNumber - 1 * size) bitAnd: 16rFFFFF000.
	^(self kernelPageAt: address) ifNotNilDo: [:page | page contents] ifNil: [
			contents := (self readStringLength: 4096 fromMemory: address) asByteArray. 
			contents := (self kernelPageAt: address) ifNil: [contents].
			contents
	]! !

!Computer methodsFor: 'image' stamp: 'GuidoChari 10/28/2010 15:49'!
imageStartAddress
	^(KernelModule fromHandle: (ExternalAddress new fromInteger: info multiboot modsAddress)) start! !

!Computer methodsFor: 'initialize-release' stamp: 'GuidoChari 12/16/2010 18:14'!
initialize
	self currentWorld flash; fullRepaintNeeded.
	pages := Dictionary new.
	processor := X86Processor new.
	devices := Dictionary new.
	self class tweakSqueakForSqueakNOS.
	PIC8259 installOn: self.
	PCIBusEntry allValid do: [:bus | Transcript show: bus; cr; cr].
	"OldPCKeyboard installOn: Current. "
	PS2Keyboard installOn: self.
	self defaultNetworkInterface: nil.
	self initializeBridge.
	Memory installOn: self.
	self enablePaging.
	UART16550 installOn: self.
	CMOS installOn: self.
"	RemoteObjectChannel installOn: self.
	LancePCIDevice installOn: self.
	Realtek8139PCIDevice installOn: self.
	self defaultNetworkInterface ifNotNil: [
		self networkingStack: (EthernetInterface on: self defaultNetworkInterface)].
	USBUHCIController installOn: self.
	SDDevice installOn: self."
	Display forceToScreen.
	(self confirm: 'Do you want to load sources from disk?') ifTrue: [SmalltalkImage current openSourceFilesForSqueakNos]! !

!Computer methodsFor: 'initialize-release' stamp: 'gc 7/21/2010 16:25'!
initializeBridge
	info := VMBridge fromHandle: (ExternalAddress new fromInteger: self primVMBiosInformationPosition)
	! !

!Computer methodsFor: 'primitives' stamp: 'gera 5/17/2006 11:16'!
isSqueakNOS
	^ self class isSqueakNOS! !

!Computer methodsFor: 'image' stamp: 'GuidoChari 1/4/2011 18:33'!
kernelPageAt: anAddress
	^info snapshotInfo pageFor: anAddress! !

!Computer methodsFor: 'accessing' stamp: 'gc 6/16/2010 15:18'!
memory
	^devices at: #memory! !

!Computer methodsFor: 'accessing' stamp: 'gc 6/16/2010 15:18'!
memory: aMemory
	devices at: #memory put: aMemory! !

!Computer methodsFor: 'accessing' stamp: 'gc 7/21/2010 16:05'!
memoryManager
	^memoryManager! !

!Computer methodsFor: 'accessing' stamp: 'gc 7/21/2010 16:05'!
memoryManager: aMemoryManager
	memoryManager := aMemoryManager! !

!Computer methodsFor: 'memory' stamp: 'GuidoChari 8/30/2010 16:12'!
pageFaultHandler: aBlock
	| callback |
	callback := Callback block: aBlock argsClass: PageFaultParameters.
	PageFaultHandler := callback.
	info pageFaultHandlerEntry: PageFaultHandler thunk address.! !

!Computer methodsFor: 'accessing' stamp: 'GuidoChari 10/26/2010 17:45'!
pages 
	^pages! !

!Computer methodsFor: 'primitives' stamp: 'GuidoChari 12/28/2010 16:51'!
primDisableConsole
	<primitive: 'primitiveDisableConsole' module:'SqueakNOSPlugin'> 
	^ self primitiveFailed! !

!Computer methodsFor: 'primitives' stamp: 'GuidoChari 12/28/2010 16:51'!
primEnableConsole
	<primitive: 'primitiveEnableConsole' module:'SqueakNOSPlugin'> 
	^ self primitiveFailed! !

!Computer methodsFor: 'primitives' stamp: 'Pocho 5/31/2010 18:28'!
primEndOfVM
	<primitive: 'primitiveVMEndPosition' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!Computer methodsFor: 'primitives' stamp: ''!
primInPortByte: portNumber 
	<primitive: 'primitiveInPortByte' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!Computer methodsFor: 'primitives' stamp: 'Pocho 6/1/2010 01:49'!
primMultibootInfoFromGrub
	<primitive: 'primitiveMultibootInfoFromGrub' module:'SqueakNOSPlugin'> 
	^ self primitiveFailed! !

!Computer methodsFor: 'primitives' stamp: 'gera 9/19/2008 08:38'!
primOFWCallout: anArray 
	<primitive: 'primitiveOFWCallout' module:'SqueakNOSPlugin'> 
	^ self primitiveFailed! !

!Computer methodsFor: 'primitives' stamp: ''!
primOutPort: portNumber byte: byte 
	<primitive: 'primitiveOutPortByte' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!Computer methodsFor: 'primitives' stamp: 'Pocho 6/14/2010 16:11'!
primPullDebugString
	<primitive: 'primitivePullDebugString' module:'SqueakNOSPlugin'> 
	^ self primitiveFailed! !

!Computer methodsFor: 'primitives' stamp: ''!
primRegisterSemaphoreIndex: t1 forIRQ: t2 
	<primitive: 'primitiveRegisterSemaphoreIndexForIRQ' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!Computer methodsFor: 'primitives' stamp: 'gc 6/15/2010 19:22'!
primVMBiosInformationPosition
	<primitive: 'primVMBiosInformationPosition' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!Computer methodsFor: 'filesystem' stamp: 'GuidoChari 9/14/2010 12:04'!
primaryFilesystem
	| sources |
	sources := SourceFiles at: 2 ifAbsent: [nil].
	^sources ifNotNil: [:source | source filesystem]! !

!Computer methodsFor: 'primitives' stamp: ''!
readStringLength: len fromMemory: address 
	<primitive: 'primitiveReadStringLengthFromMemoryAt' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!Computer methodsFor: 'primitives' stamp: ''!
registerSemaphore: aSemaphore forIRQ: irqNumber 
	| semaIndex |
	semaIndex := Smalltalk registerExternalObject: aSemaphore.
	^ self primRegisterSemaphoreIndex: semaIndex forIRQ: irqNumber! !

!Computer methodsFor: 'initialize-release' stamp: 'gera 8/28/2008 18:16'!
reset
	self keyboard controllerCommand: 16rF0.
	self keyboard controllerCommand: 16rD1; dataPort: 0.! !

!Computer methodsFor: 'initialize-release' stamp: 'GuidoChari 1/3/2011 18:24'!
resetSnapshotInfo
	info snapshotInfo saved: 0; toSave: 1000; resetPages
	! !

!Computer methodsFor: 'initialize-release' stamp: 'GuidoChari 8/6/2010 17:31'!
setInitialMemoryState
	| image multiboot map |
	multiboot := info multiboot.
	multiboot areModulesValid ifTrue: [image := KernelModule fromHandle: (ExternalAddress new fromInteger: multiboot modsAddress)].
	multiboot areMemoryAddressesValid ifTrue: [self memory size: info multiboot memUpper + 1024 * 1024].
	"multiboot isMemoryMapValid ifTrue: [
		map := MultiBootMemoryMap fromHandle: (ExternalAddress new fromInteger: multiboot mmapAddress) size: multiboot mmapLength.
		map do: [:entry | | base | entry type = 1 ifFalse: [base := entry baseAddress. self memory alreadyReserved: (base to: base + entry length) for: 'Reserved']]
	]".
	self memory 
		alreadyReserved: (0 to: 1048575) for: 'First mega of low memory for bios, drivers, etc.';
		alreadyReserved: (1048576 to: self primEndOfVM) for: 'Virtual Machine code and data structures';
		alreadyReserved: (image start to: image end) for: 'Object memory (image)'.
	
		
	! !

!Computer methodsFor: 'snapshotting' stamp: 'GuidoChari 1/5/2011 16:15'!
snapshotEndAddress
	^info snapshotEndAddress - Smalltalk headerSize.! !

!Computer methodsFor: 'snapshotting' stamp: 'gc 6/19/2010 17:01'!
snapshotEndAddress: anInteger
	info snapshotEndAddress: anInteger! !

!Computer methodsFor: 'snapshotting' stamp: 'gc 7/14/2010 18:50'!
snapshotStartAddress
	^info snapshotStartAddress! !

!Computer methodsFor: 'snapshotting' stamp: 'gc 6/19/2010 17:01'!
snapshotStartAddress: anInteger
	info snapshotStartAddress: anInteger! !

Object subclass: #ExternalIOPort
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Kernel'!

!ExternalIOPort commentStamp: 'gera 7/22/2006 13:51' prior: 0!
This is 1 based to match ExternalAddress accessors, this adds a double stupid overhead on every accessors. Read comment for HardwareDevice class!

!ExternalIOPort class methodsFor: 'as yet unclassified' stamp: 'gera 7/21/2006 17:04'!
address: anInteger
	^ self new address: anInteger! !

!ExternalIOPort methodsFor: 'accessing' stamp: 'gera 7/23/2006 02:26'!
address: anInteger
	address := anInteger - 1! !

!ExternalIOPort methodsFor: 'accessing' stamp: 'gera 7/23/2006 02:26'!
asInteger
	^ address + 1! !

!ExternalIOPort methodsFor: 'primitives' stamp: 'gera 7/21/2006 16:41'!
primInPortByte: portNumber 
	<primitive: 'primitiveInPortByte' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!ExternalIOPort methodsFor: 'primitives' stamp: 'gera 11/14/2008 20:23'!
primInPortByte: portNumber stringLength: length
	<primitive: 'primitiveInPortByteStringLength' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!ExternalIOPort methodsFor: 'primitives' stamp: 'gera 7/21/2006 16:43'!
primInPortDword: portNumber 
	<primitive: 'primitiveInPortDword' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!ExternalIOPort methodsFor: 'primitives' stamp: 'gera 11/14/2008 20:09'!
primInPortDword: portNumber stringLength: length
	<primitive: 'primitiveInPortDwordStringLength' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!ExternalIOPort methodsFor: 'primitives' stamp: 'gera 7/21/2006 16:43'!
primInPortWord: portNumber 
	<primitive: 'primitiveInPortWord' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!ExternalIOPort methodsFor: 'primitives' stamp: 'gera 11/14/2008 20:07'!
primInPortWord: portNumber stringLength: length
	<primitive: 'primitiveInPortWordStringLength' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!ExternalIOPort methodsFor: 'primitives' stamp: 'gera 7/21/2006 16:43'!
primOutPort: portNumber byte: byte 
	<primitive: 'primitiveOutPortByte' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!ExternalIOPort methodsFor: 'primitives' stamp: 'gera 11/14/2008 20:09'!
primOutPort: portNumber byteString: aString 
	<primitive: 'primitiveOutPortByteString' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!ExternalIOPort methodsFor: 'primitives' stamp: 'gera 7/21/2006 16:43'!
primOutPort: portNumber dword: dword 
	<primitive: 'primitiveOutPortDword' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!ExternalIOPort methodsFor: 'primitives' stamp: 'gera 11/14/2008 20:10'!
primOutPort: portNumber dwordString: aString 
	<primitive: 'primitiveOutPortDwordString' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!ExternalIOPort methodsFor: 'primitives' stamp: 'gera 7/21/2006 16:43'!
primOutPort: portNumber word: word 
	<primitive: 'primitiveOutPortWord' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!ExternalIOPort methodsFor: 'primitives' stamp: 'gera 11/14/2008 20:10'!
primOutPort: portNumber wordString: aString 
	<primitive: 'primitiveOutPortWordString' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^ self primitiveFailed! !

!ExternalIOPort methodsFor: 'I/O' stamp: 'gera 7/23/2006 02:26'!
unsignedByteAt: index
	^ self primInPortByte: address + index

! !

!ExternalIOPort methodsFor: 'I/O' stamp: 'gera 7/23/2006 02:26'!
unsignedByteAt: index put: value
	^ self primOutPort: address + index byte: value

! !

!ExternalIOPort methodsFor: 'I/O' stamp: 'gera 11/14/2008 21:01'!
unsignedByteStringAt: index put: string
	^ self primOutPort: address + index byteString: string

! !

!ExternalIOPort methodsFor: 'I/O' stamp: 'gera 11/14/2008 20:12'!
unsignedByteStringAt: index size: size
	^ self primInPortByte: address + index stringLength: size

! !

!ExternalIOPort methodsFor: 'I/O' stamp: 'gera 7/23/2006 02:26'!
unsignedLongAt: index
	^ self primInPortDword: address + index
! !

!ExternalIOPort methodsFor: 'I/O' stamp: 'gera 7/23/2006 02:27'!
unsignedLongAt: index put: value
	^ self primOutPort: address + index dword: value

! !

!ExternalIOPort methodsFor: 'I/O' stamp: 'gera 11/14/2008 21:01'!
unsignedLongStringAt: index put: string
	^ self primOutPort: address + index dwordString: string

! !

!ExternalIOPort methodsFor: 'I/O' stamp: 'gera 11/14/2008 20:13'!
unsignedLongStringAt: index size: size
	^ self primInPortDword: address + index stringLength: size

! !

!ExternalIOPort methodsFor: 'I/O' stamp: 'gera 7/23/2006 02:27'!
unsignedShortAt: index
	^ self primInPortWord: address + index
! !

!ExternalIOPort methodsFor: 'I/O' stamp: 'gera 7/23/2006 02:27'!
unsignedShortAt: index put: value
	^ self primOutPort: address + index word: value

! !

!ExternalIOPort methodsFor: 'I/O' stamp: 'gera 11/14/2008 21:01'!
unsignedShortStringAt: index put: string
	^ self primOutPort: address + index wordString: string

! !

!ExternalIOPort methodsFor: 'I/O' stamp: 'gera 11/14/2008 20:13'!
unsignedShortStringAt: index size: size
	^ self primInPortWord: address + index stringLength: size

! !

!ExternalIOPort methodsFor: 'I/O' stamp: 'gera 11/14/2008 20:12'!
unsignedWordStringAt: index size: size
	^ self primInPortWord: address + index stringLength: size

! !

Object subclass: #FAT32BootRecord
	instanceVariableNames: 'bytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Filesystems-FAT32'!

!FAT32BootRecord commentStamp: 'Pocho 4/6/2010 22:36' prior: 0!
A FAT32BootRecord contains the description of a fat32 partition.!

!FAT32BootRecord class methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 22:40'!
bytes: aByteArray
	^self new bytes: aByteArray.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:35'!
bootRecordSignature
	^bytes unsignedShortAt: 16r1FF.! !

!FAT32BootRecord methodsFor: 'accessing' stamp: 'Pocho 4/6/2010 23:13'!
bytes
	"Answer the value of bytes"

	^ bytes! !

!FAT32BootRecord methodsFor: 'accessing' stamp: 'Pocho 4/6/2010 23:13'!
bytes: anObject
	"Set the value of bytes"

	bytes := anObject! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:01'!
bytesPerSector
	^bytes unsignedShortAt: 16r0C.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:24'!
clusterNumberOfStartOfRootDir
	^bytes unsignedLongAt: 16r2D.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:09'!
extendedSignature
	^bytes unsignedByteAt: 16r43.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:30'!
fatName
	^(bytes copyFrom: 16r53 to: 16r5A) asString.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:05'!
flags
	^bytes unsignedShortAt: 16r29.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:09'!
logicalDriveNumberOfPartition
	^bytes unsignedByteAt: 16r41.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:22'!
mediaDescriptor
	^bytes unsignedByteAt: 16r16.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:08'!
numberOfCopiesOfFAT
	^bytes unsignedByteAt: 16r11.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:04'!
numberOfHeads
	^bytes unsignedShortAt: 16r1B.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:11'!
numberOfHiddenSectors
	^bytes unsignedLongAt: 16r1D.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:11'!
numberOfSectorsInPartition
	^bytes unsignedLongAt: 16r21.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 23:05'!
printOn: out

	out nextPutAll: 'Boot sector named ', self volumeNameOfPartition; cr.
	out nextPutAll: 'Bytes per sector: ', self bytesPerSector; cr.
	out nextPutAll: 'Sectors per cluster: ', self sectorsPerCluster; cr.
	out nextPutAll: 'Cluster number of start of root dir: ', self clusterNumberOfStartOfRootDir; cr.
	out nextPutAll: 'Sectors per FAT: ', self sectorsPerFAT; cr.
	out nextPutAll: 'Sectors per track: ', self sectorsPerTrack; cr.
	out nextPutAll: 'Number of sectors in partition: ', self numberOfSectorsInPartition; cr.
	out nextPutAll: 'Number of copies of FAT: ', self numberOfCopiesOfFAT; cr.
	out nextPutAll: 'Reserved sectors: ', self reservedSectors.
	! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:02'!
reservedSectors
	^bytes unsignedShortAt: 16r0F.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:06'!
sectorNumberOfFSInformationSector
	^bytes unsignedShortAt: 16r31.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:07'!
sectorsPerCluster
	^bytes unsignedByteAt: 16rE.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'GC 4/16/2010 17:39'!
sectorsPerFAT
	^bytes unsignedLongAt: 16r25.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:22'!
sectorsPerTrack
	^bytes unsignedShortAt: 16r19.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:12'!
serialNumberOfPartition
	^bytes unsignedLongAt: 16r44.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:05'!
versionOfFAT32Drive
	^bytes unsignedShortAt: 16r2B.! !

!FAT32BootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:30'!
volumeNameOfPartition
	^(bytes copyFrom: 16r48 to: 16r52) asString.! !

Object subclass: #FAT32Cluster
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Filesystems-FAT32'!

!FAT32Cluster class methodsFor: 'instance creation' stamp: 'gc 6/25/2010 17:56'!
contents: aStream
	^self new contents: aStream.! !

!FAT32Cluster methodsFor: 'private' stamp: 'gc 6/23/2010 18:49'!
add: aFAT32ClusterRecord at: anIndex
	contents position: self recordSize * (anIndex - 1).
	contents nextPutAll: aFAT32ClusterRecord contents asByteArray! !

!FAT32Cluster methodsFor: 'private' stamp: 'gc 6/23/2010 15:46'!
addEndOfDirectoryRecord
	| index record |
	index := self firstFreeRecordIndex.
	record := FAT32ClusterRecord endOfDirectory.
	self add: record at: index.
	! !

!FAT32Cluster methodsFor: 'services' stamp: 'gc 6/26/2010 19:49'!
addFirstClusterToFileNamed: aString cluster: aNumber
	| index record |
	index := self indexOfRecordNamed: aString.
	record := self recordAt: index.
	record firstCluster: aNumber! !

!FAT32Cluster methodsFor: 'private' stamp: 'gc 6/25/2010 11:01'!
addRecordNamed: aString firstCluster: aNumber
	| index record addEndOfDirectoryRecord |
	index := self firstFreeRecordIndex.
	addEndOfDirectoryRecord := (index = self firstIndex or: [(self recordAt: index) isEndOfDirectory and: [(index = self lastIndex) not]]).
	record := FAT32ClusterRecord named: aString firstCluster: aNumber.
	self add: record at: index.
	addEndOfDirectoryRecord ifTrue: [self addEndOfDirectoryRecord].
	^record
	! !

!FAT32Cluster methodsFor: 'services' stamp: 'gc 6/25/2010 18:22'!
allRecords
	| records index |
	index := self firstIndex.
	records := OrderedCollection new.
	[index > self lastIndex] whileFalse: [
			records add: (self recordAt: index).
			index := index + 1.
	].
	^records! !

!FAT32Cluster methodsFor: 'services' stamp: 'GC 4/26/2010 14:20'!
bytes: aNumber
	contents position: 0. 
	^contents next: aNumber! !

!FAT32Cluster methodsFor: 'services' stamp: 'gc 5/11/2010 15:03'!
bytes: aNumber startingAt: anotherNumber
	contents position: anotherNumber. 
	^contents next: aNumber! !

!FAT32Cluster methodsFor: 'accesing' stamp: 'gc 6/23/2010 19:05'!
contents
	^contents contents! !

!FAT32Cluster methodsFor: 'accesing' stamp: 'GC 4/16/2010 18:05'!
contents: aStream
	contents := aStream! !

!FAT32Cluster methodsFor: 'services' stamp: 'gc 5/19/2010 18:14'!
directoryRecords
	^self records select: [:record | (record isUnused not and: [record isVFat not]) and: [record isDirectory]]! !

!FAT32Cluster methodsFor: 'services' stamp: 'gc 5/19/2010 18:13'!
fileRecords
	^self records select: [:record | (record isUnused not and: [record isVFat not]) and: [record isFile]]! !

!FAT32Cluster methodsFor: 'services' stamp: 'gc 6/23/2010 14:28'!
firstFreeRecordIndex
	self allRecords withIndexDo: [:record :index | (record isUnused or: [record isEndOfDirectory]) ifTrue: [^index]].
	self error: 'aaaa'! !

!FAT32Cluster methodsFor: 'private' stamp: 'gc 6/20/2010 18:06'!
firstIndex
	^1! !

!FAT32Cluster methodsFor: 'testing' stamp: 'gc 6/20/2010 17:52'!
hasFreeRecords
	| records |
	records := self allRecords.
	^(records anySatisfy: [:record | record isUnused]) or: [records anySatisfy: [:record | record isEndOfDirectory]].! !

!FAT32Cluster methodsFor: 'testing' stamp: 'gc 6/28/2010 14:48'!
hasRecord: id
	^self allRecords anySatisfy: [:record | (record firstCluster = id)].
	! !

!FAT32Cluster methodsFor: 'testing' stamp: 'gc 6/26/2010 19:10'!
hasRecordNamed: aString
	^self allRecords anySatisfy: [:record | (record name asLowercase = aString asLowercase)].
	! !

!FAT32Cluster methodsFor: 'private' stamp: 'gc 6/28/2010 11:34'!
identifierOfRecordNamed: aString
	self records withIndexDo: [:record :index | (record name asLowercase = aString asLowercase) ifTrue: [^record firstCluster]].
	self error: 'Not found'! !

!FAT32Cluster methodsFor: 'private' stamp: 'gc 6/28/2010 11:35'!
indexOfRecord: id
	self records withIndexDo: [:record :index | (record firstCluster = id) ifTrue: [^index]].
	self error: 'Not found'! !

!FAT32Cluster methodsFor: 'private' stamp: 'gc 6/28/2010 11:34'!
indexOfRecordNamed: aString
	self records withIndexDo: [:record :index | (record name asLowercase = aString asLowercase) ifTrue: [^index]].
	self error: 'Not found'! !

!FAT32Cluster methodsFor: 'initialize-release' stamp: 'gc 6/28/2010 17:51'!
initializeUnused
	self allRecords do: [:record | record free]! !

!FAT32Cluster methodsFor: 'private' stamp: 'GuidoChari 8/3/2010 17:17'!
lastIndex
	^self size // self recordSize! !

!FAT32Cluster methodsFor: 'services' stamp: 'gc 6/28/2010 11:15'!
record: id
	| index |
	index := self indexOfRecord: id.
	^self recordAt: index! !

!FAT32Cluster methodsFor: 'services' stamp: 'JavierPimas 1/4/2011 14:03'!
recordAt: index
	| size strm |
	size := self recordSize.
	strm := StreamOnStream on: contents copy offset: index - 1 * size size: size.
	^FAT32ClusterRecord contents: strm.! !

!FAT32Cluster methodsFor: 'services' stamp: 'gc 6/28/2010 11:07'!
recordNamed: aString
	| index |
	index := self indexOfRecordNamed: aString.
	^self recordAt: index! !

!FAT32Cluster methodsFor: 'private' stamp: 'GC 4/17/2010 16:21'!
recordSize
	^32! !

!FAT32Cluster methodsFor: 'services' stamp: 'gc 6/20/2010 18:20'!
records
	^self allRecords reject: [:record | record isUnused or: [record isEndOfDirectory]]! !

!FAT32Cluster methodsFor: 'services' stamp: 'gc 6/28/2010 11:14'!
removeRecord: id
	| record |
	record := self record: id.
	record free
	! !

!FAT32Cluster methodsFor: 'services' stamp: 'gc 6/28/2010 11:40'!
removeRecordNamed: aString
	| record |
	record := self recordNamed: aString.
	record free
	! !

!FAT32Cluster methodsFor: 'accesing' stamp: 'GC 4/26/2010 14:31'!
size
	^contents size! !

!FAT32Cluster methodsFor: 'services' stamp: 'gc 6/26/2010 18:43'!
updateSizeOfFileNamed: aString with: aNumber
	| index record |
	index := self indexOfRecordNamed: aString.
	record := self recordAt: index.
	record size: aNumber! !

!FAT32Cluster methodsFor: 'services' stamp: 'gc 6/25/2010 14:27'!
writeFrom: aNumber with: stringOrByteArray startingAt: anotherNumber count: count
	contents position: aNumber.
	contents nextPutAll: (stringOrByteArray copyFrom: anotherNumber to: anotherNumber + count - 1) asByteArray.
	^count! !

Object subclass: #FAT32ClusterRecord
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Filesystems-FAT32'!

!FAT32ClusterRecord class methodsFor: 'instance creation' stamp: 'gc 5/20/2010 16:11'!
contents: aStream
	^self new contents: aStream! !

!FAT32ClusterRecord class methodsFor: 'instance creation' stamp: 'gc 6/23/2010 15:47'!
endOfDirectory
	^self contents: (self streamForEndOfDirectory)
	! !

!FAT32ClusterRecord class methodsFor: 'instance creation' stamp: 'gc 6/25/2010 11:28'!
named: aString firstCluster: aNumber
	^(self raw) name: aString; firstCluster: aNumber.
	! !

!FAT32ClusterRecord class methodsFor: 'instance creation' stamp: 'gc 6/25/2010 11:27'!
raw
	^self contents: (self streamForNewRecord)
	! !

!FAT32ClusterRecord class methodsFor: 'instance creation' stamp: 'gc 6/23/2010 14:35'!
size
	^32! !

!FAT32ClusterRecord class methodsFor: 'instance creation' stamp: 'gc 6/23/2010 17:56'!
streamForEndOfDirectory
	| contents |
	contents := ByteArray new: self size withAll: 0.
	^ReadWriteStream with: contents! !

!FAT32ClusterRecord class methodsFor: 'instance creation' stamp: 'gc 6/25/2010 11:04'!
streamForNewRecord
	| contents |
	contents := ByteArray new: self size withAll: 0.
	^ReadWriteStream with: contents.
	! !

!FAT32ClusterRecord methodsFor: 'accessing' stamp: 'gc 6/26/2010 18:44'!
attrib
	contents position: 16r0B.
	^contents next	! !

!FAT32ClusterRecord methodsFor: 'accessing' stamp: 'gc 6/23/2010 15:53'!
contents
	^contents contents! !

!FAT32ClusterRecord methodsFor: 'accessing' stamp: 'GC 4/17/2010 16:24'!
contents: aStream
	contents := aStream.! !

!FAT32ClusterRecord methodsFor: 'accessing' stamp: 'gc 6/25/2010 12:11'!
firstCluster
	| bytes |
	bytes := ByteArray new: 4.
	contents position: 16r14.
	bytes replaceFrom: 3 to: 4 with: (contents next: 2) startingAt: 1.
	contents position: 16r1A.
	bytes replaceFrom: 1 to: 2 with: (contents next: 2) startingAt: 1.
	^bytes unsignedLongAt: 1! !

!FAT32ClusterRecord methodsFor: 'accessing' stamp: 'gc 6/25/2010 12:11'!
firstCluster: aNumber
	| bytes |
	bytes := ByteArray new: 4.
	bytes unsignedLongAt: 1 put: aNumber.
	contents position: 16r14.
	contents nextPutAll: (bytes copyFrom: 3 to: 4).
	contents position: 16r1A.
	contents nextPutAll: (bytes copyFrom: 1 to: 2).
	! !

!FAT32ClusterRecord methodsFor: 'accessing' stamp: 'gc 6/28/2010 11:00'!
free
	contents position: 0.
	^contents nextPut: self unusedByte! !

!FAT32ClusterRecord methodsFor: 'testing' stamp: 'GC 4/21/2010 15:57'!
isDirectory
	^(self attrib bitAnd: 16) = 16
	! !

!FAT32ClusterRecord methodsFor: 'testing' stamp: 'gc 5/20/2010 16:45'!
isEndOfDirectory
	contents position: 0.
	^contents next isZero
	! !

!FAT32ClusterRecord methodsFor: 'testing' stamp: 'GC 4/22/2010 14:28'!
isFile
	^(self attrib bitAnd: 16) = 0! !

!FAT32ClusterRecord methodsFor: 'testing' stamp: 'GC 5/4/2010 15:43'!
isInternal
	^self isDirectory and: [self name = '.' or: [self name = '..']]
	! !

!FAT32ClusterRecord methodsFor: 'testing' stamp: 'gc 6/20/2010 18:17'!
isUnused
	contents position: 0.
	^contents next = 16rE5
	! !

!FAT32ClusterRecord methodsFor: 'testing' stamp: 'GC 4/21/2010 15:57'!
isVFat
	^(self attrib bitAnd: 15) = 15
	! !

!FAT32ClusterRecord methodsFor: 'accessing' stamp: 'gc 6/24/2010 10:24'!
name
	| name extension |
	contents position: 0.
	name := (contents next: 8) asString withBlanksTrimmed.
	extension := (contents next: 3) asString withBlanksTrimmed.
	extension notEmpty ifTrue: [extension := '.' , extension].
	^name , extension! !

!FAT32ClusterRecord methodsFor: 'accessing' stamp: 'gc 6/25/2010 14:05'!
name: aString
	aString size = 11 ifFalse: [self error: 'The string is not in a suitable format'].
	contents position: 0.
	contents nextPutAll: aString asByteArray
	
! !

!FAT32ClusterRecord methodsFor: 'printing' stamp: 'gc 6/17/2010 14:47'!
printOn: aStream
	^aStream nextPutAll: self name! !

!FAT32ClusterRecord methodsFor: 'accessing' stamp: 'gc 6/25/2010 15:06'!
size
	| bytes |
	contents position: 16r1C.
	bytes := contents next: 4.
	^bytes unsignedLongAt: 1! !

!FAT32ClusterRecord methodsFor: 'accessing' stamp: 'gc 6/26/2010 18:44'!
size: aNumber
	| bytes |
	bytes := ByteArray new: 4.
	bytes unsignedLongAt: 1 put: aNumber.
	contents position: 16r1C.
	^contents nextPutAll: bytes! !

!FAT32ClusterRecord methodsFor: 'constants' stamp: 'gc 6/28/2010 10:59'!
unusedByte
	^16rE5! !

Object subclass: #FAT32FileAllocationTable
	instanceVariableNames: 'chains contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Filesystems-FAT32'!

!FAT32FileAllocationTable class methodsFor: 'instance creation' stamp: 'gc 5/17/2010 18:43'!
contents: aStream
	^self new contents: aStream.! !

!FAT32FileAllocationTable methodsFor: 'services' stamp: 'gc 6/30/2010 14:50'!
addCluster: aNumber to: anotherNumber
	| chain last |
	anotherNumber > 0 ifTrue: [
		chain := self chainFor: anotherNumber.
		last := chain last.
		chain add: aNumber.
		self point: last to: aNumber].
	self	 point: aNumber to: (self finishClustersChainValue unsignedLongAt: 1).
	! !

!FAT32FileAllocationTable methodsFor: 'services' stamp: 'GuidoChari 12/29/2010 15:37'!
addClusterTo: aNumber
	| last index chain |
	last := aNumber > 0 ifTrue: 
		[(self clustersChainFor: aNumber) last]
	 ifFalse:
		 [0].
	index := self firstFreeClusterSince: last.
	"Transcript show: 'Adding cluster: ', index printString, 'to: ', aNumber printString, Character cr."
	self addCluster: index to: aNumber.
	^index! !

!FAT32FileAllocationTable methodsFor: 'accessing' stamp: 'gc 6/25/2010 15:17'!
cache: aNumber with: anOrderedCollection
	chains at: aNumber put: anOrderedCollection! !

!FAT32FileAllocationTable methodsFor: 'services' stamp: 'JavierPimas 1/3/2011 17:28'!
cachedChain: aNumber preferredSize: aPreferredSize
	^(self hasCached: aNumber)
		ifTrue:  [ ^self chainFor: aNumber ]
		ifFalse: [ | chain | 
				 chain := self internalClusterChainFor: aNumber preferredSize: aPreferredSize.
				 self cache: aNumber with: chain.
				 ^chain ]
! !

!FAT32FileAllocationTable methodsFor: 'private' stamp: 'gc 6/25/2010 15:11'!
chainFor: aNumber
	^chains at: aNumber! !

!FAT32FileAllocationTable methodsFor: 'services' stamp: 'JavierPimas 1/3/2011 17:36'!
clustersChainFor: aNumber
	^self clustersChainFor: aNumber preferredSize: 0! !

!FAT32FileAllocationTable methodsFor: 'services' stamp: 'JavierPimas 1/3/2011 17:36'!
clustersChainFor: aNumber preferredSize: aPreferredSize
	^(self cachedChain: aNumber preferredSize: aPreferredSize) copy.
! !

!FAT32FileAllocationTable methodsFor: 'services' stamp: 'JavierPimas 1/3/2011 17:44'!
clustersChainNoCopyFor: aClusterNumber preferredSize: aSize
	^(self cachedChain: aClusterNumber preferredSize: aSize).	
! !

!FAT32FileAllocationTable methodsFor: 'accessing' stamp: 'gc 5/17/2010 18:47'!
contents: aStream	
	contents := aStream! !

!FAT32FileAllocationTable methodsFor: 'accessing' stamp: 'gc 6/25/2010 15:23'!
countOfClusters
	^contents size // self recordSize! !

!FAT32FileAllocationTable methodsFor: 'accessing' stamp: 'gc 6/23/2010 18:43'!
finishClustersChainValue
	| bytes |
	bytes := (ByteArray new: 4).
	bytes unsignedLongAt: 1 put: 16r0FFFFFFF.	
	^bytes! !

!FAT32FileAllocationTable methodsFor: 'services' stamp: 'gc 6/25/2010 15:24'!
firstFreeClusterSince: aNumber
	| index next |
	index := aNumber.
	next := self nextClusterFor: index.
	[next isZero or: [index = (aNumber - 1)]] whileFalse: [
		index := index + 1 \\ (self countOfClusters - 1).
		next := self nextClusterFor: index.	
	].
	next isZero ifFalse: [self error: 'No more free space on filesystem'].
	^index! !

!FAT32FileAllocationTable methodsFor: 'testing' stamp: 'gc 6/25/2010 15:13'!
hasCached: aNumber
	^chains includesKey: aNumber! !

!FAT32FileAllocationTable methodsFor: 'initialize-release' stamp: 'gc 5/17/2010 18:46'!
initialize
	chains := Dictionary new.! !

!FAT32FileAllocationTable methodsFor: 'services' stamp: 'JavierPimas 1/3/2011 16:18'!
internalClusterChainFor: aClusterNumber preferredSize: aPreferredSize
	| chain nextCluster | 
	nextCluster := aClusterNumber.
	chain := OrderedCollection new: aPreferredSize.
	[(nextCluster bitAnd: 16r0FFFFFFF) = 16r0FFFFFFF] whileFalse: [
		chain add: nextCluster.	
		self setPositionTo: nextCluster.
		nextCluster := self nextRecord unsignedLongAt: 1
	].
	^chain! !

!FAT32FileAllocationTable methodsFor: 'accessing' stamp: 'gc 6/25/2010 15:25'!
nextClusterFor: index
	self setPositionTo: index.
	^self nextRecord unsignedLongAt: 1.! !

!FAT32FileAllocationTable methodsFor: 'private' stamp: 'gc 6/25/2010 15:15'!
nextRecord
	^contents next: self recordSize! !

!FAT32FileAllocationTable methodsFor: 'services' stamp: 'gc 6/25/2010 18:34'!
point: aFatClusterNumber to: anotherFatClusterNumber
	"Alter the FAT so that it's cluster number aFatClusterNumber points to anotherFatClusterNumber"
	| bytes |
	self setPositionTo: aFatClusterNumber.
	bytes := (ByteArray new: 4).
	bytes unsignedLongAt: 1 put: anotherFatClusterNumber.
	contents nextPutAll: bytes.! !

!FAT32FileAllocationTable methodsFor: 'accessing' stamp: 'gc 5/17/2010 19:12'!
recordSize
	^4! !

!FAT32FileAllocationTable methodsFor: 'accessing' stamp: 'GuidoChari 12/29/2010 15:38'!
removeChainOf: id
	| chain |
	chain := self clustersChainFor: id.
	chain do: [:index | self point: index to: 0]! !

!FAT32FileAllocationTable methodsFor: 'services' stamp: 'gc 6/25/2010 15:30'!
setPositionTo: aNumber
	contents position: aNumber * self recordSize. 
	! !

!FAT32FileAllocationTable methodsFor: 'services' stamp: 'GuidoChari 12/29/2010 15:38'!
shrinkClusterChainOf: aNumber to: length
	| chain size toRemove last |
	chain := self clustersChainFor: aNumber.
	size := chain size.
	size > length ifFalse: [^self].
	toRemove := length - size.
	last := chain at: length.
	self	 point: last to: (self finishClustersChainValue unsignedLongAt: 1). 
	chain := chain last: toRemove.
	chain do: [:number | self point: number to: 0].
	
! !

Object subclass: #FAT32FileSystem
	instanceVariableNames: 'stream offsetToPartition bootRecord fat flushProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Filesystems-FAT32'!

!FAT32FileSystem commentStamp: 'Pocho 4/6/2010 22:20' prior: 0!
A FAT32FileSystem is the one who interacts with a FAT32 partition. It has a stream pointing to a disk
and the offset to the start point of one of its' partitions.

Instance Variables
	offsetToPartition: offset to partition
	stream:		a stream pointing to a disk.
!

!FAT32FileSystem class methodsFor: 'constants' stamp: 'gc 5/18/2010 17:02'!
basenameMaxSize
	^8! !

!FAT32FileSystem class methodsFor: 'constants' stamp: 'gc 5/18/2010 17:01'!
basenameTruncationIndex
	^6! !

!FAT32FileSystem class methodsFor: 'constants' stamp: 'gc 5/18/2010 17:03'!
extensionMaxSize
	^3! !

!FAT32FileSystem class methodsFor: 'services' stamp: 'Pocho 7/9/2010 16:37'!
join: path to: finalName
	^((path = '') ifFalse: [path, FileDirectory slash] ifTrue: ['']), finalName.! !

!FAT32FileSystem class methodsFor: 'instance creation' stamp: 'gc 5/17/2010 19:17'!
of: aDiskStream partition: aNumber
	"We asume sector size of 512 to make things easier for now."
	aDiskStream binary. "With this we make #next: return ByteArrays and no ByteStrings"
	^(self new stream: aDiskStream; offsetToPartition: 
		((MasterBootRecord of: aDiskStream) offsetToPartition: 1 sectorSize: 512)) initializeFAT.! !

!FAT32FileSystem class methodsFor: 'instance creation' stamp: 'Pocho 6/29/2010 12:31'!
of: aDiskStream partition: aNumber readOnly: beReadOnly
	"We asume sector size of 512 to make things easier for now."
	aDiskStream binary. "With this we make #next: return ByteArrays and no ByteStrings"
	
	beReadOnly ifTrue: [aDiskStream readOnly] ifFalse: [aDiskStream readWrite].
	
	^(self new stream: aDiskStream; offsetToPartition: 
		((MasterBootRecord of: aDiskStream) offsetToPartition: 1 sectorSize: 512)) initializeFAT.! !

!FAT32FileSystem methodsFor: 'private' stamp: 'gc 7/27/2010 16:36'!
addClusterTo: aFilesystemContent
	| index id |
	id := aFilesystemContent identifier.
	index := fat addClusterTo: id.
	aFilesystemContent isDirectory ifTrue: [(self clusterNumber: index) initializeUnused].	
	^index! !

!FAT32FileSystem methodsFor: 'private' stamp: 'JavierPimas 8/12/2010 18:13'!
addClustersTo: aFilesystemContent count: aNumber
	| clusters |
	Transcript show: aNumber printString, Character cr asString.
	clusters := OrderedCollection new.
	aNumber timesRepeat: [clusters add: (self addClusterTo: aFilesystemContent)].
	^clusters! !

!FAT32FileSystem methodsFor: 'private' stamp: 'gc 7/27/2010 16:33'!
addFirstClusterTo: aFilesystemContent
	| index cluster |
	index := self addClusterTo: aFilesystemContent.
	aFilesystemContent identifier: index.
	cluster := self clusterForFileNamed: aFilesystemContent name onDirectory: aFilesystemContent directory.
	cluster addFirstClusterToFileNamed: aFilesystemContent name cluster: index
	! !

!FAT32FileSystem methodsFor: 'private' stamp: 'GuidoChari 12/29/2010 16:05'!
adjacentClustersListFrom: clusters do: aBlock
	| clusterStartNumber numberOfClusters |
	clusters size = 0 ifTrue: [^self].
	clusterStartNumber := clusters first.
	numberOfClusters := 1.
	2 to: clusters size do: [ :i | | cluster |
		cluster := clusters at: i.	
		(clusterStartNumber + numberOfClusters = cluster) 
			ifTrue: [ numberOfClusters := numberOfClusters + 1]
			ifFalse: [ aBlock value: clusterStartNumber value: numberOfClusters. 
					numberOfClusters := 1. 
					clusterStartNumber := cluster]
	].
	aBlock value: clusterStartNumber value: numberOfClusters.
	! !

!FAT32FileSystem methodsFor: 'accessing' stamp: 'gc 6/24/2010 11:25'!
as83Format: aString
	| index name extension |
	index := aString findFirst: [:char | char = $.].
	name := index > 7 ifTrue: [aString first: 8] ifFalse: [(aString first: index - 1) , ((String new: 8 - index + 1) atAllPut: $ ) ].
	extension := aString size - index > 3 ifTrue: [aString copyFrom: index + 1 to: index + 3] ifFalse: [(aString copyFrom: index + 1 to: aString size) , ((String new: 3 - (aString size - index)) atAllPut: $ ) ].
	^name , extension. ! !

!FAT32FileSystem methodsFor: 'accessing' stamp: 'gc 5/13/2010 11:08'!
bootRecord
	bootRecord isNil ifTrue: [
		stream position: offsetToPartition.
		bootRecord := FAT32BootRecord bytes: (stream next: 512)].
	^bootRecord! !

!FAT32FileSystem methodsFor: 'accessing' stamp: 'GC 4/27/2010 17:02'!
bytesPerCluster
	^self sectorsPerCluster * self bytesPerSector! !

!FAT32FileSystem methodsFor: 'accessing' stamp: 'gc 6/25/2010 17:48'!
bytesPerFAT
	^self sectorsPerFAT * self bytesPerSector! !

!FAT32FileSystem methodsFor: 'accessing' stamp: 'GC 4/17/2010 15:40'!
bytesPerSector
	^self bootRecord bytesPerSector! !

!FAT32FileSystem methodsFor: 'services' stamp: 'gc 7/16/2010 20:04'!
cleanExtraSpace: id
	| clusters |
	clusters := self clustersNeededFor: id size.
	fat shrinkClusterChainOf: id identifier to: clusters! !

!FAT32FileSystem methodsFor: 'private' stamp: 'gc 6/25/2010 17:49'!
clusterBeginLBA
	^self fatBeginLBA + (self numberOfCopiesOfFAT * self bytesPerFAT)! !

!FAT32FileSystem methodsFor: 'private' stamp: 'gc 6/28/2010 17:24'!
clusterForFile: aFile onDirectory: aDirectory
	| chain |
	chain := self clustersChainFor: aDirectory.
	chain do: [:number | | cluster | cluster := self clusterNumber: number. (cluster hasRecord: aFile identifier) ifTrue: [^cluster]].
	self error:'cluster not found!!'! !

!FAT32FileSystem methodsFor: 'private' stamp: 'gc 6/28/2010 17:25'!
clusterForFileNamed: aString onDirectory: aDirectory
	| chain |
	chain := self clustersChainFor: aDirectory.
	chain do: [:number | | cluster | cluster := self clusterNumber: number. (cluster hasRecordNamed: aString) ifTrue: [^cluster]].
	self error:'cluster not found!!'! !

!FAT32FileSystem methodsFor: 'private' stamp: 'GC 4/16/2010 17:32'!
clusterIndexCorrection:aNumber
	^aNumber - 2! !

!FAT32FileSystem methodsFor: 'private' stamp: 'gc 6/25/2010 17:58'!
clusterNumber: aNumber
	self setPositionToCluster: aNumber.
	^self nextCluster.! !

!FAT32FileSystem methodsFor: 'private' stamp: 'gc 5/20/2010 16:27'!
clusterNumberWithFreeRecordsFor: aDirectory
	| chain |
	chain := self clustersChainFor: aDirectory.
	^chain detect: [:number | (self clusterNumber: number) hasFreeRecords] ifNone: [self addClusterTo: aDirectory]! !

!FAT32FileSystem methodsFor: 'private' stamp: 'gc 6/24/2010 11:59'!
clusterWithFileNamed: aString for: aDirectory
	| chain |
	chain := self clustersChainFor: aDirectory.
	^chain detect: [:number | (self clusterNumber: number) hasRecordNamed: aString]! !

!FAT32FileSystem methodsFor: 'private' stamp: 'JavierPimas 1/3/2011 17:36'!
clustersChainFor: aFileSystemContent
	| clusters count |
	count := aFileSystemContent isFile ifTrue: [
		(aFileSystemContent size / self bytesPerCluster) ceiling.
	] ifFalse: [0].
	^fat clustersChainFor: aFileSystemContent identifier preferredSize: count.
! !

!FAT32FileSystem methodsFor: 'private' stamp: 'JavierPimas 1/3/2011 18:11'!
clustersChainNoCopyFor: aFileSystemContent
	| clusters count |
	count := aFileSystemContent isFile ifTrue: [
		(aFileSystemContent size / self bytesPerCluster) ceiling.
	] ifFalse: [0].
	^fat clustersChainNoCopyFor: aFileSystemContent identifier preferredSize: count.
! !

!FAT32FileSystem methodsFor: 'private' stamp: 'Pocho 7/22/2010 14:42'!
clustersCount
	^(bootRecord numberOfSectorsInPartition - (self numberOfCopiesOfFAT * self bytesPerFAT / self bytesPerSector + self reservedSectors)) / self sectorsPerCluster.! !

!FAT32FileSystem methodsFor: 'private' stamp: 'gc 7/17/2010 18:56'!
clustersNeededFor: aNumber
	^(aNumber / self bytesPerCluster) ceiling! !

!FAT32FileSystem methodsFor: 'services' stamp: 'Pocho 7/5/2010 17:43'!
contentsFor: aFile startingAt: aNumber count: anotherNumber
	| clusterOffset clusters size needed bytesPerCluster |
	
	bytesPerCluster := self bytesPerCluster.
	aFile identifier > 0 ifFalse: [^ByteArray new].
	size := anotherNumber min: aFile size.
	clusterOffset := aNumber \\ bytesPerCluster.
	needed := (size + clusterOffset / bytesPerCluster) ceiling.
	clusters := self clustersChainFor: aFile.
	clusters removeFirst: aNumber // bytesPerCluster.
	clusters size >= needed ifTrue: [clusters removeLast: clusters size - needed].
	^self readFromClusters: clusters startingAt: clusterOffset count: size.
! !

!FAT32FileSystem methodsFor: 'services' stamp: 'gc 6/26/2010 18:47'!
directoriesFor: aDirectory
	| cluster directories clusters |
	directories := OrderedCollection new.
	clusters := self clustersChainFor: aDirectory.
	clusters do: [ :aNumber |
		cluster := self clusterNumber: aNumber.
		directories addAll: (cluster directoryRecords select: [:record | record isInternal not] thenCollect: [:record | Directory named: record name identifier: record firstCluster filesystem: self directory: aDirectory])
	].
	^directories! !

!FAT32FileSystem methodsFor: 'services' stamp: 'GC 5/4/2010 15:34'!
directoryNamed: aString
	| components current |
	components := aString findTokens: $/.
	components isEmpty ifTrue: [^nil].
	current := self root.
	components do: [ :name |
		current := current directories detect: [:directory | directory name asLowercase = name] ifNone: [^nil].
	].
	^current! !

!FAT32FileSystem methodsFor: 'private' stamp: 'GC 4/19/2010 15:47'!
fatBeginLBA
	^self offsetToPartition + (self reservedSectors * self bytesPerSector)
	
! !

!FAT32FileSystem methodsFor: 'private' stamp: 'gc 6/24/2010 13:09'!
fatFinishClustersChainValue
	^fat finishClustersChainValue! !

!FAT32FileSystem methodsFor: 'accessing' stamp: 'gc 5/17/2010 19:12'!
fatRecordSize
	^fat recordSize! !

!FAT32FileSystem methodsFor: 'services' stamp: 'gc 6/26/2010 18:36'!
filesFor: aDirectory
	| cluster files clusters |
	files := OrderedCollection new.
	clusters := self clustersChainFor: aDirectory.
	clusters do: [ :aNumber |
		cluster := self clusterNumber: aNumber.
		files addAll:	(cluster fileRecords collect: [:record | File named: record name identifier: record firstCluster filesystem: self directory: aDirectory size: record size])
	].
	^files! !

!FAT32FileSystem methodsFor: 'flushing' stamp: 'Pocho 7/20/2010 16:21'!
flush
	stream flush.	
		! !

!FAT32FileSystem methodsFor: 'flushing' stamp: 'JavierPimas 1/4/2011 14:03'!
flushFATChanges
	"flush to disk each fat index marked as dirty."
	| diskFAT |
	"fatToFlush ifEmpty: [ ^self ]."
	diskFAT := FAT32FileAllocationTable on: 
		(StreamOnStream 
			on: stream copy
			offset: self fatBeginLBA 
			size: self bytesPerFAT).
	fatToFlush do: [ :aClusterNumber | diskFAT point: aClusterNumber to: (fat nextClusterFor: aClusterNumber)].
		
		! !

!FAT32FileSystem methodsFor: 'flushing' stamp: 'Pocho 6/24/2010 19:26'!
flushProcess
	^
	[ 
		(Delay forSeconds: 10) wait. 
		self flushFatChanges.
		self flushClusterChanges.
	] fork.
		
		! !

!FAT32FileSystem methodsFor: 'initialize-release' stamp: 'gc 7/27/2010 16:32'!
initialize
	super initialize! !

!FAT32FileSystem methodsFor: 'initialize-release' stamp: 'JavierPimas 1/4/2011 14:03'!
initializeFAT
	| strm |
	strm := StreamOnStream on: stream copy offset: self fatBeginLBA size: self clustersCount * 4.
	fat := FAT32FileAllocationTable contents: strm! !

!FAT32FileSystem methodsFor: 'formatting' stamp: 'gc 7/17/2010 18:13'!
nameFormat: aString
	^self pureFAT32FilenameFor: aString! !

!FAT32FileSystem methodsFor: 'services' stamp: 'gc 7/27/2010 16:31'!
newFileNamed: aString on: aDirectory
	| cluster record number name |
	name := aString size > 11 ifTrue: [self pureFAT32FilenameFor: aString] 
							     ifFalse: [aString].
	number := self clusterNumberWithFreeRecordsFor: aDirectory.
	cluster := self clusterNumber: number.
	record := cluster addRecordNamed: (self as83Format: name) firstCluster: 0.
	^File named: record name identifier: record firstCluster filesystem: self directory: aDirectory size: record size! !

!FAT32FileSystem methodsFor: 'private' stamp: 'JavierPimas 1/4/2011 14:03'!
nextCluster
	| strm |
	strm := StreamOnStream on: stream copy offset: stream position size: self bytesPerCluster.
	^FAT32Cluster contents: strm.! !

!FAT32FileSystem methodsFor: 'accessing' stamp: 'GC 4/17/2010 15:34'!
numberOfCopiesOfFAT
	^self bootRecord numberOfCopiesOfFAT! !

!FAT32FileSystem methodsFor: 'accessing' stamp: 'Pocho 4/6/2010 22:13'!
offsetToPartition
	"Answer the value of offsetToPartition"

	^ offsetToPartition! !

!FAT32FileSystem methodsFor: 'accessing' stamp: 'Pocho 4/6/2010 22:13'!
offsetToPartition: anOffset
	"Set the value of offsetToPartition"

	offsetToPartition := anOffset! !

!FAT32FileSystem methodsFor: 'accessing' stamp: 'Pocho 7/21/2010 23:05'!
printOn: out
	"Answer the value of stream"

	out nextPutAll: 'FAT32FileSystem'; cr;
		nextPutAll: 'Offset to Partition: ', offsetToPartition; cr;
		nextPutAll: 'Begin of FAT: ', self fatBeginLBA; cr;
		nextPutAll: 'Begin of data clusters: ', self clusterBeginLBA; cr; cr;
		nextPutAll: bootRecord printString; cr; cr;
		nextPutAll: self root printString.
	 ! !

!FAT32FileSystem methodsFor: 'accessing' stamp: 'Pocho 7/21/2010 22:35'!
printStringOf: aDirectory
	| cluster clusters out |

	out := ReadWriteStream on: ''.
	clusters := self clustersChainFor: aDirectory.
	clusters do: [ :aNumber |
		cluster := self clusterNumber: aNumber.
		cluster fileRecords do: [ :record |
			out nextPutAll: 'File: ', record name;
				nextPutAll: ', first cluster: ', record firstCluster;
				nextPutAll: ', size: ', record size; nextPut: Character cr ].
	].
	 
	^out contents.! !

!FAT32FileSystem methodsFor: 'formatting' stamp: 'gc 7/14/2010 18:01'!
pureFAT32FilenameFor: aFileName
	FileDirectory splitName: aFileName to: [ :path :name | | basename extension finalName|
		basename := FileDirectory baseNameFor: name. 
		extension := FileDirectory extensionFor: name.
		basename size > self class basenameMaxSize ifTrue: [
			basename := (basename first: self class basenameTruncationIndex) , '~1'
		].
		extension := extension copyFrom: 1 to: (extension size min: self class extensionMaxSize).
		finalName := (extension size > 0) ifTrue: [ basename , '.' , extension ] ifFalse: [ basename ].
		^self class join: path to: finalName
	]! !

!FAT32FileSystem methodsFor: 'private' stamp: 'gc 6/25/2010 18:15'!
readFromClusters: clusters startingAt: aNumber count: count
	| index contentsIndex cluster bytes contents qty |
	contents := ByteArray new: count.
	index := aNumber.
	contentsIndex := 1.	
	clusters do: [ :clusterNumber |
			cluster := self clusterNumber: clusterNumber.
			qty := (cluster size min: self bytesPerCluster - index) min: count - contentsIndex + 1. 
			bytes := cluster bytes: qty startingAt: index.
			contents replaceFrom: contentsIndex to: contentsIndex + bytes size - 1 with: bytes.
			index := 0.
			contentsIndex := contentsIndex + bytes size].
	^contents
	
	! !

!FAT32FileSystem methodsFor: 'services' stamp: 'gc 7/27/2010 16:32'!
removeFileNamed: aString on: aDirectory
	| cluster number id name |
	name := self pureFAT32FilenameFor: aString.
	number := self clusterWithFileNamed: name  for: aDirectory.
	cluster := self clusterNumber: number.
	id := cluster identifierOfRecordNamed: name .
	cluster removeRecordNamed: name .
	id > 0 ifTrue: [fat removeChainOf: id]
	! !

!FAT32FileSystem methodsFor: 'accessing' stamp: 'GC 4/17/2010 15:31'!
reservedSectors
	^self bootRecord reservedSectors! !

!FAT32FileSystem methodsFor: 'accessing' stamp: 'GC 4/15/2010 17:55'!
root
	^Directory identifier:self bootRecord clusterNumberOfStartOfRootDir filesystem:self ! !

!FAT32FileSystem methodsFor: 'accessing' stamp: 'GC 4/17/2010 15:38'!
sectorsPerCluster
	^self bootRecord sectorsPerCluster! !

!FAT32FileSystem methodsFor: 'accessing' stamp: 'GC 4/17/2010 15:36'!
sectorsPerFAT
	^self bootRecord sectorsPerFAT! !

!FAT32FileSystem methodsFor: 'private' stamp: 'gc 6/25/2010 17:46'!
setPositionToCluster: aNumber
	| index offset |
	index := self clusterIndexCorrection: aNumber.
	offset := index * self bytesPerCluster.
	stream position: self clusterBeginLBA + offset.
	! !

!FAT32FileSystem methodsFor: 'private' stamp: 'gc 6/25/2010 17:49'!
setPositionToClusterRecordInFAT: aNumber
	stream position: self fatBeginLBA + (aNumber * self fatRecordSize).
	! !

!FAT32FileSystem methodsFor: 'private' stamp: 'Pocho 7/22/2010 22:41'!
startOfClusterSectors
	^(self offsetToPartition + (self numberOfCopiesOfFAT * self bytesPerFAT) / self bytesPerSector) + self reservedSectors.! !

!FAT32FileSystem methodsFor: 'accessing' stamp: 'Pocho 4/6/2010 22:21'!
stream
	"Answer the value of stream"

	^ stream! !

!FAT32FileSystem methodsFor: 'accessing' stamp: 'gc 5/17/2010 19:18'!
stream: aDiskStream
	stream := aDiskStream! !

!FAT32FileSystem methodsFor: 'services' stamp: 'GuidoChari 12/28/2010 20:06'!
truncateClusterChainOf: aFile newSize: aNumber
	| clusterSize  clusters needed |
	clusterSize := self bytesPerCluster.
	clusters := self clustersChainFor: aFile.
	needed := (aNumber / clusterSize) ceiling.
	
	needed <= clusters size ifTrue: [clusters removeLast: clusters size - needed]
! !

!FAT32FileSystem methodsFor: 'services' stamp: 'GuidoChari 12/28/2010 20:03'!
updateSizeOf: aFile with: aNumber
 	| cluster |
	self truncateClusterChainOf: aFile newSize: aNumber.
	cluster := self clusterForFile: aFile onDirectory: aFile directory.
	cluster updateSizeOfFileNamed: aFile name with: aNumber.
	aFile size: aNumber! !

!FAT32FileSystem methodsFor: 'private' stamp: 'JavierPimas 1/3/2011 18:18'!
writeClusters: clusters startingAt: aNumber with: stringOrByteArray startingAt: anotherNumber count: count
	| written adjacentClustersList start toWrite |
	written := 0.
	start := aNumber - 1.
	"count < 1000"
	"clusters first = 51761 ifTrue: [self halt]."
	self adjacentClustersListFrom: clusters do: [ :clusterStartNumber :numberOfClusters | |cluster|
		"(51761 between: clusterStartNumber and: clusterStartNumber + numberOfClusters) ifTrue: [self halt]."
		cluster := self clusterNumber: clusterStartNumber.
		toWrite := cluster size * numberOfClusters - start min: count - written.
		self setPositionToCluster: clusterStartNumber.
		stream skip: start.
		stream next: toWrite putAll: stringOrByteArray startingAt: anotherNumber + written.
		start := 0.
		written := written + toWrite.
	].
	^written! !

!FAT32FileSystem methodsFor: 'services' stamp: 'JavierPimas 1/4/2011 17:33'!
writeOn: aFile startingAt: aFileOffset contents: stringOrByteArray startingAt: anotherNumber count: aByteCount
	"notice: aFileOffset  is zero indexed, anotherNumber is not"
	| helper firstIndex lastIndex clusters |

	helper := BlockArithmetic new size: self bytesPerCluster.
	firstIndex := helper blockNumberOf: aFileOffset + 1.
	lastIndex := helper blockNumberOf: aFileOffset + aByteCount.
	
	aFile identifier = 0 ifTrue: [self addFirstClusterTo: aFile].
	
	clusters := self clustersChainNoCopyFor: aFile.
	lastIndex > clusters size ifTrue: [ self addClustersTo: aFile count: lastIndex - clusters size].
	
	^self writeClusters: (clusters copyFrom: firstIndex to: lastIndex)
		   startingAt: (helper positionInBlockOf: aFileOffset + 1)
	  	   with: stringOrByteArray startingAt: anotherNumber count: aByteCount.	! !

Object subclass: #FilesystemContent
	instanceVariableNames: 'name identifier filesystem directory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Filesystems'!

FilesystemContent subclass: #Directory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Filesystems'!

!Directory methodsFor: 'quering' stamp: 'gc 5/17/2010 16:25'!
directories
	^self filesystem directoriesFor: self! !

!Directory methodsFor: 'quering' stamp: 'gc 7/17/2010 18:08'!
fileExists: aString
	^self files anySatisfy: [:file | file name asLowercase = (filesystem nameFormat: aString) asLowercase]! !

!Directory methodsFor: 'services' stamp: 'gc 7/17/2010 18:10'!
fileNamed: aString
	^self files detect: [:file | file name asLowercase = (filesystem nameFormat: aString) asLowercase] ! !

!Directory methodsFor: 'quering' stamp: 'gc 5/17/2010 16:18'!
files
	^self filesystem filesFor: self! !

!Directory methodsFor: 'testing' stamp: 'gc 6/28/2010 17:53'!
isDirectory
	^true! !

!Directory methodsFor: 'quering' stamp: 'gc 5/19/2010 16:52'!
newFileNamed: aString
	^self filesystem newFileNamed: aString on: self.! !

!Directory methodsFor: 'quering' stamp: 'Pocho 7/21/2010 22:31'!
printString
	^self filesystem printStringOf: self.! !

!Directory methodsFor: 'services' stamp: 'GC 5/4/2010 18:26'!
readOnlyFileNamed: aString
	^self fileNamed: aString! !

!Directory methodsFor: 'quering' stamp: 'gc 6/24/2010 11:51'!
removeFileNamed: aString
	^self filesystem removeFileNamed: aString on: self.! !

FilesystemContent subclass: #File
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Filesystems'!

!File class methodsFor: 'instance creation' stamp: 'gc 6/26/2010 18:33'!
named: aString identifier: aNumber filesystem: aFilesystem directory: aDirectory size: anotherNumber
	^(self named: aString identifier: aNumber filesystem: aFilesystem directory: aDirectory) size: anotherNumber! !

!File class methodsFor: 'instance creation' stamp: 'GC 4/23/2010 19:26'!
named: aString identifier: aNumber filesystem: aFilesystem size: anotherNumber
	^(self named: aString identifier: aNumber filesystem: aFilesystem) size: anotherNumber! !

!File methodsFor: 'testing' stamp: 'gc 5/17/2010 16:24'!
isFile
	^true! !

!File methodsFor: 'printing' stamp: 'GC 4/22/2010 14:50'!
printOn: aStream
	aStream nextPutAll: self name! !

!File methodsFor: 'services' stamp: 'gc 6/24/2010 13:05'!
readStream
	| stream |
	stream := MultiByteFilesystemFileStream for: self.
	stream readOnly.
	^stream! !

!File methodsFor: 'services' stamp: 'gc 6/24/2010 16:34'!
readWriteStream
	| stream |
	stream := MultiByteFilesystemFileStream for: self.
	^stream! !

!File methodsFor: 'accesing' stamp: 'GC 4/23/2010 19:20'!
size
	^size! !

!File methodsFor: 'accesing' stamp: 'GC 4/23/2010 19:24'!
size: aNumber
	size := aNumber.! !

!File methodsFor: 'services' stamp: 'gc 7/16/2010 19:35'!
writeStream
	| stream |
	stream := MultiByteFilesystemFileStream for: self.
	stream writeOnly.
	^stream! !

!FilesystemContent class methodsFor: 'instance creation' stamp: 'gc 6/26/2010 18:33'!
identifier: anId filesystem:aFilesystem
	^self named: ''
	      identifier: anId 
		filesystem: aFilesystem.! !

!FilesystemContent class methodsFor: 'instance creation' stamp: 'GC 4/22/2010 14:47'!
named: aString identifier: anId filesystem: aFilesystem 
	^self new name: aString;
			   identifier: anId; 
			   filesystem: aFilesystem.! !

!FilesystemContent class methodsFor: 'instance creation' stamp: 'gc 6/26/2010 18:30'!
named: aString identifier: anId filesystem: aFilesystem directory: aDirectory 
	^self new name: aString;
		identifier: anId; 
		filesystem: aFilesystem;
		directory: aDirectory.! !

!FilesystemContent methodsFor: 'accesing' stamp: 'gc 6/26/2010 19:02'!
directory
	^directory! !

!FilesystemContent methodsFor: 'accesing' stamp: 'gc 6/26/2010 18:48'!
directory: aDirectory
	directory := aDirectory! !

!FilesystemContent methodsFor: 'accesing' stamp: 'GC 4/22/2010 15:18'!
filesystem
	^filesystem! !

!FilesystemContent methodsFor: 'accesing' stamp: 'GC 4/22/2010 15:18'!
filesystem: aFilesystem
	filesystem := aFilesystem! !

!FilesystemContent methodsFor: 'accesing' stamp: 'GC 4/22/2010 15:18'!
identifier
	^identifier! !

!FilesystemContent methodsFor: 'accesing' stamp: 'GC 4/22/2010 15:18'!
identifier: aClusterNumber
	identifier := aClusterNumber! !

!FilesystemContent methodsFor: 'testing' stamp: 'gc 6/28/2010 17:53'!
isDirectory
	^false! !

!FilesystemContent methodsFor: 'testing' stamp: 'gc 6/28/2010 17:53'!
isFile
	^false! !

!FilesystemContent methodsFor: 'accesing' stamp: 'GC 4/22/2010 15:18'!
name
	^name! !

!FilesystemContent methodsFor: 'accesing' stamp: 'GC 4/22/2010 15:18'!
name: aString
	name := aString! !

Object subclass: #HardwareDevice
	instanceVariableNames: 'resource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Kernel'!

!HardwareDevice commentStamp: 'gera 7/22/2006 13:51' prior: 0!
I'm a HadwareDevice. My subclasses implement support for different devices, for example, Keyboard, Mouse, Network cards, PCI support, etc.

My baseResource dictates whether I use ExternalMemory or ExternalOPort to talk to the hardware.

All accessors #(byteAt: shortAt: longAt: byteAt:put: shortAt:put: longAt:put:) are zero based. This is different from Smalltalk convention, and it was not an easy decision, but we finally opted for 0 based accessors to match all existing documentation for devices, so it's a lot easy to follow from code to documentation and back.

To do this zero based accessing we are playing silly and processor consuming tricks right now, we'll probably improve this in the future. The trick is: ExternalAddress (as implemented by stock Squeak) is 1 based, so we have to add one to the index before accessing the resources, howerver, in the native implementation, 1 has to be substracted back from the index to access the right memory address. To match this behaviour we had to make ExternalIOPort also be 1 based, so, before calling the primitives for ExternalIOPort we substract 1 to the index, and before calling the public accessors we have to add 1 to it... in short, if we could make ExternalAddress be zero based (or if we reimplement it in our own class) we could remove all this +/- 1 overhead. However, right now, we only want to make it work, and take note for the future.
!

HardwareDevice subclass: #CMOS
	instanceVariableNames: 'computer alarmBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Base'!

!CMOS commentStamp: 'gera 6/9/2006 01:49' prior: 0!
Information on CMOS:

DS14285/DS14287 Real-Time Clock with NV RAM Control Control (PDF datasheet)
http://www.maxim-ic.com/getds.cfm?qv_pk=2717

Ralph's Brown CMOS and ports description (From his Interrupt List)
http://oopweb.com/Assembly/Documents/InterList/VolumeFrames.html

BiosCentral. CMOS memory map, no more information than the map
http://www.bioscentral.com/misc/cmosmap.htm

CMOS RAM Bank 0. Some more information on different RTC IRQs handling
http://ps-2.kev009.com:8080/ohlandl/config/cmos_bank_0.html
!

!CMOS class methodsFor: 'as yet unclassified' stamp: 'gera 7/20/2006 18:49'!
installOn: aComputer 
	^ aComputer
		cmos: ((self onPort: 112)
				computer: aComputer)! !

!CMOS methodsFor: 'alarm' stamp: ''!
alarm
	^ Time
		hour: self alarmHour
		minute: self alarmMinute
		second: self alarmSecond! !

!CMOS methodsFor: 'alarm' stamp: ''!
alarm: aTime 
	self alarmHour: aTime hour;
		 alarmMinute: aTime minute;
		 alarmSecond: aTime second! !

!CMOS methodsFor: 'accessing' stamp: 'gera 6/1/2006 19:12'!
alarmBlock
	^ alarmBlock! !

!CMOS methodsFor: 'accessing' stamp: 'gera 6/1/2006 19:12'!
alarmBlock: aBlock
	alarmBlock := aBlock! !

!CMOS methodsFor: 'alarm' stamp: ''!
alarmHour
	^ self valueAt: 5! !

!CMOS methodsFor: 'alarm' stamp: ''!
alarmHour: aNumber 
	^ self valueAt: 5 put: aNumber! !

!CMOS methodsFor: 'alarm' stamp: ''!
alarmMinute
	^ self valueAt: 3! !

!CMOS methodsFor: 'alarm' stamp: ''!
alarmMinute: aNumber 
	^ self valueAt: 3 put: aNumber! !

!CMOS methodsFor: 'alarm' stamp: ''!
alarmSecond
	^ self valueAt: 1! !

!CMOS methodsFor: 'alarm' stamp: ''!
alarmSecond: aNumber 
	^ self valueAt: 1 put: aNumber! !

!CMOS methodsFor: 'accessing' stamp: ''!
at: index 
	self byteAt: 0 put: index.
	^ self byteAt: 1! !

!CMOS methodsFor: 'accessing' stamp: ''!
at: index put: value 
	self byteAt: 0 put: index.
	^ self byteAt: 1 put: value! !

!CMOS methodsFor: 'accessing' stamp: ''!
bcdAt: index 
	| value |
	value := self at: index.
	^ value // 16 * 10 + (value \\ 16)! !

!CMOS methodsFor: 'accessing' stamp: 'gera 1/1/1901 00:07'!
bcdAt: index put: value 
	^ self at: index put: value // 10 * 16 + (value \\ 10)! !

!CMOS methodsFor: 'date' stamp: 'gera 6/1/2006 21:08'!
century
	^ self valueAt: 16r32! !

!CMOS methodsFor: 'date' stamp: 'gera 6/1/2006 21:08'!
century: aNumber
	^ self valueAt: 16r32 put: aNumber! !

!CMOS methodsFor: 'accessing' stamp: 'gera 6/1/2006 19:13'!
computer
	^ computer! !

!CMOS methodsFor: 'accessing' stamp: ''!
computer: aComputer 
	computer := aComputer! !

!CMOS methodsFor: 'date' stamp: ''!
date
	^ Date
		newDay: self day
		month: self month
		year: self year! !

!CMOS methodsFor: 'date' stamp: ''!
date: aDate 
	self day: aDate day;
		 month: aDate month;
		 year: aDate year! !

!CMOS methodsFor: 'date' stamp: ''!
day
	^ self valueAt: 7! !

!CMOS methodsFor: 'date' stamp: ''!
day: aNumber 
	^ self valueAt: 7 put: aNumber! !

!CMOS methodsFor: 'date' stamp: ''!
dayOfWeek
	^ self at: 6! !

!CMOS methodsFor: 'date' stamp: ''!
dayOfWeek: aNumber 
	^ self at: 6 put: aNumber! !

!CMOS methodsFor: 'status' stamp: 'gera 6/5/2006 11:23'!
disableAlarm
	self statusB: (self statusB bitAnd: 16rDF)! !

!CMOS methodsFor: 'status' stamp: 'gera 6/1/2006 19:11'!
enableAlarm
	self statusB: (self statusB bitOr: 16r20)! !

!CMOS methodsFor: 'alarm' stamp: 'gera 7/22/2006 14:07'!
handleIRQ
	| flags |
	flags := self statusC.
	(flags anyMask: 16r20) ifTrue: [
		"registerC must be read to clear the interrupt bits,
		 otherwise, the interrupt is generated again"
		self alarmBlock value.
	].
	self uninstallAlarm.! !

!CMOS methodsFor: 'time' stamp: ''!
hour
	^ self valueAt: 4! !

!CMOS methodsFor: 'time' stamp: ''!
hour: aNumber 
	^ self valueAt: 4 put: aNumber! !

!CMOS methodsFor: 'alarm' stamp: 'gera 6/7/2006 09:38'!
installAlarm
	self computer interruptController addHandler: self forIRQ: 8.
	self enableAlarm.! !

!CMOS methodsFor: 'status' stamp: ''!
isBCD
	^ (self statusB anyMask: 4) not! !

!CMOS methodsFor: 'time' stamp: ''!
minute
	^ self valueAt: 2! !

!CMOS methodsFor: 'time' stamp: ''!
minute: aNumber 
	^ self valueAt: 2 put: aNumber! !

!CMOS methodsFor: 'date' stamp: ''!
month
	^ self valueAt: 8! !

!CMOS methodsFor: 'date' stamp: ''!
month: aNumber 
	^ self valueAt: 8 put: aNumber! !

!CMOS methodsFor: 'alarm' stamp: 'gera 6/7/2006 09:38'!
onAlarmDo: aBlock
	self alarmBlock: aBlock.
! !

!CMOS methodsFor: 'time' stamp: ''!
second
	^ (self valueAt: 0)
		bitAnd: 127! !

!CMOS methodsFor: 'time' stamp: ''!
second: aNumber 
	^ self valueAt: 0 put: aNumber! !

!CMOS methodsFor: 'status' stamp: 'gera 6/5/2006 19:40'!
statusA
	^ self at: 10! !

!CMOS methodsFor: 'status' stamp: 'gera 6/5/2006 19:40'!
statusA: value 
	^ self at: 10 put: value! !

!CMOS methodsFor: 'status' stamp: ''!
statusB
	^ self at: 11! !

!CMOS methodsFor: 'status' stamp: ''!
statusB: value 
	^ self at: 11 put: value! !

!CMOS methodsFor: 'status' stamp: 'gera 6/5/2006 09:42'!
statusC
	^ self at: 16rC! !

!CMOS methodsFor: 'time' stamp: ''!
time
	^ Time
		hour: self hour
		minute: self minute
		second: self second! !

!CMOS methodsFor: 'time' stamp: ''!
time: aTime 
	self hour: aTime hour;
		 minute: aTime minute;
		 second: aTime second! !

!CMOS methodsFor: 'alarm' stamp: 'gera 6/7/2006 09:39'!
uninstallAlarm
	self computer interruptController removeHandler: self forIRQ: 8.
	self disableAlarm.! !

!CMOS methodsFor: 'accessing' stamp: ''!
valueAt: index 
	^ self isBCD
		ifTrue: [self bcdAt: index]
		ifFalse: [self at: index]! !

!CMOS methodsFor: 'accessing' stamp: ''!
valueAt: index put: value 
	^ self isBCD
		ifTrue: [self bcdAt: index put: value]
		ifFalse: [self at: index put: value]! !

!CMOS methodsFor: 'date' stamp: 'gera 6/1/2006 21:14'!
year
	| year |
	year := self valueAt: 9.
	^ self century * 100 + year! !

!CMOS methodsFor: 'date' stamp: 'gera 6/1/2006 21:15'!
year: aNumber 
	self valueAt: 9 put: aNumber \\ 100.
	self century: aNumber // 100.! !

!HardwareDevice class methodsFor: 'instance creation' stamp: 'gera 7/22/2006 13:54'!
atMemoryAddress: anInteger 
	^ self basicNew resource: (ExternalAddress new fromInteger: anInteger);
		 initialize! !

!HardwareDevice class methodsFor: 'instance creation' stamp: 'gera 5/21/2006 19:50'!
installOn: aComputer
	" detect if hardware is present, if so, instantiate, initialize and install on aComputer"! !

!HardwareDevice class methodsFor: 'instance creation' stamp: 'gera 7/21/2006 17:02'!
new

	^ super new initialize! !

!HardwareDevice class methodsFor: 'instance creation' stamp: 'gera 7/21/2006 17:03'!
onPort: portNumber 
	^ self basicNew resource: (ExternalIOPort address: portNumber);
		 initialize! !

!HardwareDevice methodsFor: 'I/O' stamp: 'gera 7/22/2006 13:42'!
byteAt: index
	^ resource unsignedByteAt: index + 1! !

!HardwareDevice methodsFor: 'I/O' stamp: 'gera 7/22/2006 13:42'!
byteAt: index put: value
	^ resource unsignedByteAt: index + 1put: value! !

!HardwareDevice methodsFor: 'I/O' stamp: 'gera 11/14/2008 21:02'!
byteStringAt: index put: aString
	^ resource unsignedByteStringAt: index + 1 put: aString! !

!HardwareDevice methodsFor: 'I/O' stamp: 'gera 11/14/2008 20:59'!
byteStringAt: index size: anInteger
	^ resource unsignedByteStringAt: index + 1 size: anInteger! !

!HardwareDevice methodsFor: 'irq handling' stamp: 'LC 8/23/2008 16:10'!
handleIRQ
	self report: 'IRQ'! !

!HardwareDevice methodsFor: 'irq handling' stamp: 'gera 7/22/2006 13:58'!
handleIRQfor: anIRQDispatcher
	^ self handleIRQ! !

!HardwareDevice methodsFor: 'irq handling' stamp: 'gera 6/10/2006 00:02'!
handleIRQfor: anIRQDispatcher on: aComputer
	^ self handleIRQfor: anIRQDispatcher! !

!HardwareDevice methodsFor: 'initialization' stamp: 'gera 5/17/2006 11:39'!
initialize! !

!HardwareDevice methodsFor: 'I/O' stamp: 'gera 7/22/2006 13:42'!
longAt: index
	^ resource unsignedLongAt: index + 1! !

!HardwareDevice methodsFor: 'I/O' stamp: 'gera 7/22/2006 13:42'!
longAt: index put: value
	^ resource unsignedLongAt: index + 1 put: value! !

!HardwareDevice methodsFor: 'I/O' stamp: 'gera 11/14/2008 21:01'!
longStringAt: index put: aString
	^ resource unsignedLongStringAt: index + 1 put: aString! !

!HardwareDevice methodsFor: 'I/O' stamp: 'gera 11/14/2008 20:59'!
longStringAt: index size: anInteger
	^ resource unsignedLongStringAt: index + 1 size: anInteger! !

!HardwareDevice methodsFor: 'reporting' stamp: 'r++ 7/26/2008 12:22'!
report: msg
	Transcript
		cr;
		show: self;
		nextPutAll: ': ', msg asString;
		flush.! !

!HardwareDevice methodsFor: 'initialization' stamp: 'gera 7/21/2006 17:02'!
resource: anExternalIOPortOrZeroBasedAddress
	resource := anExternalIOPortOrZeroBasedAddress! !

!HardwareDevice methodsFor: 'I/O' stamp: 'gera 7/22/2006 13:42'!
shortAt: index
	^ resource unsignedShortAt: index + 1! !

!HardwareDevice methodsFor: 'I/O' stamp: 'gera 7/22/2006 13:42'!
shortAt: index put: value
	^ resource unsignedShortAt: index + 1 put: value! !

!HardwareDevice methodsFor: 'I/O' stamp: 'gera 11/14/2008 21:02'!
shortStringAt: index put: aString
	^ resource unsignedShortStringAt: index + 1 put: aString! !

!HardwareDevice methodsFor: 'I/O' stamp: 'gera 11/14/2008 20:59'!
shortStringAt: index size: anInteger
	^ resource unsignedShortStringAt: index + 1 size: anInteger! !

HardwareDevice subclass: #Memory
	instanceVariableNames: 'size blocks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Memory'!

!Memory class methodsFor: 'instance creation' stamp: 'gc 7/21/2010 16:26'!
installOn: aComputer
	| memory |
	memory := aComputer memory: (self atMemoryAddress: 0).
	aComputer setInitialMemoryState.
	^memory! !

!Memory methodsFor: 'accessing' stamp: 'gc 6/16/2010 19:10'!
alreadyReserved: anInterval for: aString
	blocks add: (MemoryBlock from: anInterval first to: anInterval last description: aString)! !

!Memory methodsFor: 'accessing' stamp: 'gc 6/19/2010 17:06'!
biggestEmptyBlock
	"Answers the biggest free block of memory"
	^self emptyBlocks detectMax: [ :block | block interval last - block interval first ].! !

!Memory methodsFor: 'accessing' stamp: 'gc 6/19/2010 16:55'!
emptyBlocks
	"Calculate all the free memory blocks. The algorithm assumes that used blocks are ordered and not overlapping."
	| emptyBlocks nextBlockStart |
	emptyBlocks := OrderedCollection new.
	nextBlockStart := 0.
	blocks do: [:block |
		block start > nextBlockStart 
			ifTrue: [
				emptyBlocks add: (MemoryBlock from: nextBlockStart to: block start - 1 description: 'Empty')
			].
		nextBlockStart := block end + 1.
	].
	nextBlockStart < size ifTrue: [emptyBlocks add: (MemoryBlock from: nextBlockStart to: size - 1 description: 'Empty') ].
	 ^emptyBlocks.
	! !

!Memory methodsFor: 'initialization' stamp: 'gc 6/16/2010 19:14'!
initialize
	super initialize.
	blocks := OrderedCollection new.! !

!Memory methodsFor: 'accessing' stamp: 'gc 6/17/2010 14:51'!
size
	 ^size! !

!Memory methodsFor: 'accessing' stamp: 'JavierPimas 8/11/2010 16:05'!
size: anInteger
	"memory size in bytes"
	 size := anInteger! !

HardwareDevice subclass: #OldPCKeyboard
	instanceVariableNames: 'pressedKeys replyExpected lastScanCode status buttonsState mousePoint mouseCount prevScanCode underCursorForm event'
	classVariableNames: 'ShiftedTranslationTable TranslationTable'
	poolDictionaries: 'EventSensorConstants'
	category: 'SqueakNOS-Devices-Base'!

!OldPCKeyboard class methodsFor: 'system startup' stamp: 'gera 5/17/2006 11:39'!
cCharsToArray: aString
	| strm table |
	strm _ ReadStream on: aString.
	strm reset.
	table _ OrderedCollection new: 128.
	[strm atEnd]
		whileFalse: [strm peek = $\
				ifTrue: 
					[strm next.
					strm peek isDigit
						ifTrue: [table add: (Character value: ('8r' , (strm next: 3)) asNumber)]
						ifFalse: [table add: (self unescapeCharacter: strm next)]]
				ifFalse: [table add: strm next]].
	^ table asArray! !

!OldPCKeyboard class methodsFor: 'system startup' stamp: 'gera 5/17/2006 11:39'!
initialize
	self initializeTranslationTables! !

!OldPCKeyboard class methodsFor: 'system startup' stamp: 'gera 5/17/2006 11:39'!
initializeTranslationTables
	TranslationTable _ self cCharsToArray: 
		'\000\0331234567890-=\010\t' ,
		'qwertyuiop[]\r\000as' ,
		'dfghjkl;''`\000\\zxcv' ,
		'bnm,./\000*\000 \000\201\202\203\204\205' ,
		'\206\207\210\211\212\000\000789-456+1' ,
		'230\177\000\000\213\214\000\000\000\000\000\000\000\000\000\000' ,
		'\r\000/'.
	ShiftedTranslationTable _ self cCharsToArray: 
		'\000\033!!@#$%^&*()_+\010\t' ,
		'QWERTYUIOP{}\r\000AS' ,
		'DFGHJKL:"~\000|ZXCV' ,
		'BNM<>?\000*\000 \000\201\202\203\204\205' ,
		'\206\207\210\211\212\000\000789-456+1' ,
		'230\177\000\000\213\214\000\000\000\000\000\000\000\000\000\000' ,
		'\r\000/'.
! !

!OldPCKeyboard class methodsFor: 'system startup' stamp: 'gera 9/1/2006 02:11'!
installOn: aComputer
	| keyboard |
	keyboard := self onPort: 16r60.
	aComputer interruptController addHandler: keyboard forIRQ: 1.
	aComputer keyboard: keyboard.
	aComputer interruptController addHandler: keyboard forIRQ: 12.
	HandMorph allInstances do: [:each |
		each hasUserInformation ifFalse: [
			each userInitials: ' ' andPicture: each userPicture]].
	Sensor eventTicklerProcess terminate.
	^ aComputer mouse: keyboard.
! !

!OldPCKeyboard class methodsFor: 'system startup' stamp: 'gera 5/17/2006 11:39'!
unescapeCharacter: char 
	char = $t ifTrue: [^ Character tab].
	char = $r ifTrue: [^ Character cr].
	char = $n ifTrue: [^ Character lf].
	^ char! !

!OldPCKeyboard methodsFor: 'testing' stamp: 'gera 5/17/2006 11:39'!
ackReceived
	^ lastScanCode = 16rFA! !

!OldPCKeyboard methodsFor: 'ports' stamp: 'gera 5/20/2006 15:46'!
acknowledge
	| read |
	read := self acknowledgePort.
	self acknowledgePort: (read bitOr: 16r80).
	self acknowledgePort: read! !

!OldPCKeyboard methodsFor: 'ports' stamp: 'gera 5/20/2006 15:46'!
acknowledgePort
	^ self byteAt: 1! !

!OldPCKeyboard methodsFor: 'ports' stamp: 'gera 5/20/2006 15:46'!
acknowledgePort: aByte
	^ self byteAt: 1 put: aByte! !

!OldPCKeyboard methodsFor: 'mouse access' stamp: 'gera 5/17/2006 11:39'!
anyButtonPressed
	"Answer whether a mouse button is being pressed."

	^self buttons > 0! !

!OldPCKeyboard methodsFor: 'accessing' stamp: 'gera 5/17/2006 11:39'!
anyModifierKeyPressed
	^ self commandKeyPressed | self controlKeyPressed | self macOptionKeyPressed! !

!OldPCKeyboard methodsFor: 'mouse commands' stamp: 'gera 5/17/2006 11:39'!
auxEnable
	self controllerCommand: 16rA8! !

!OldPCKeyboard methodsFor: 'mouse commands' stamp: 'gera 5/17/2006 11:39'!
auxEnableDevice
	self auxWriteAndWaitAck: 16rF4.! !

!OldPCKeyboard methodsFor: 'testing' stamp: 'gera 5/17/2006 11:39'!
auxOutputBufferFull
	^ status anyMask: 16r20! !

!OldPCKeyboard methodsFor: 'mouse commands' stamp: 'r++ 7/20/2008 15:27'!
auxSelfTest
	self controllerCommand: 16rA9.
	^ self waitData = 0! !

!OldPCKeyboard methodsFor: 'mouse commands' stamp: 'gera 5/17/2006 11:39'!
auxWrite: aByte
	self controllerCommand: 16rD4 data: aByte! !

!OldPCKeyboard methodsFor: 'mouse commands' stamp: 'gera 5/17/2006 11:39'!
auxWriteAndWaitAck: aByte
	self auxWrite: aByte.
	^self waitData = 16rFA! !

!OldPCKeyboard methodsFor: 'mouse commands' stamp: 'gera 5/17/2006 11:39'!
auxWriteToOutBuffer: aByte
	self controllerCommand: 16rD3 data: aByte! !

!OldPCKeyboard methodsFor: 'mouse access' stamp: 'gera 5/17/2006 11:39'!
blueButtonPressed
	"Answer whether only the blue mouse button is being pressed. This is the third mouse button or cmd+click on the Mac."

	^self buttons = 1! !

!OldPCKeyboard methodsFor: 'mouse access' stamp: 'gera 9/1/2006 01:20'!
buttons

	^ buttonsState bitAnd: 7! !

!OldPCKeyboard methodsFor: 'ports' stamp: 'r++ 7/26/2008 10:59'!
byteAt: index
	| r |
	r := super byteAt: index.
"	self report: ' at: ', index printString, ' -> ', r hex.
"	^ r! !

!OldPCKeyboard methodsFor: 'ports' stamp: 'r++ 7/26/2008 10:59'!
byteAt: index put: value
"	self report: ' at: ', index printString, ' <- ', value hex.
"	^ super byteAt: index put: value! !

!OldPCKeyboard methodsFor: 'testing' stamp: 'gera 5/17/2006 11:39'!
checkError
	^ self parityError | self timeout! !

!OldPCKeyboard methodsFor: 'irq handling' stamp: 'GuidoChari 12/16/2010 17:32'!
checkUserInterrupt: key
	| answer |
	answer := self commandKeyPressed and: [key = $.].
	answer ifTrue: [Sensor signalUserInterrupt].
	^answer! !

!OldPCKeyboard methodsFor: 'controller commands' stamp: 'gera 5/17/2006 11:39'!
clearInput
	100 timesRepeat: [self readData ifNil: [^ self]]! !

!OldPCKeyboard methodsFor: 'accessing' stamp: 'gera 5/17/2006 11:39'!
commandKeyPressed
	^ buttonsState anyMask: 16r40! !

!OldPCKeyboard methodsFor: 'accessing' stamp: 'gera 5/17/2006 11:39'!
controlKeyPressed
	^ buttonsState anyMask: 16r10! !

!OldPCKeyboard methodsFor: 'ports' stamp: 'gera 5/21/2006 18:46'!
controllerCommand: aByte
	^ self byteAt: 4 put: aByte! !

!OldPCKeyboard methodsFor: 'controller commands' stamp: 'gera 5/20/2006 15:48'!
controllerCommand: cmd data: aByte
	self controllerCommand: cmd.
	self safeDelay.
	self dataPort: aByte! !

!OldPCKeyboard methodsFor: 'controller commands' stamp: 'gera 5/17/2006 11:39'!
controllerSelfTest
	self controllerCommand: 16rAA.
	^ self waitData = 16r55 ! !

!OldPCKeyboard methodsFor: 'ports' stamp: 'gera 5/21/2006 18:46'!
controllerStatus
	^ self byteAt: 4! !

!OldPCKeyboard methodsFor: 'mouse access' stamp: 'gera 9/1/2006 01:19'!
cursorPoint: aPoint
	self hideCursor.
	self mousePoint: aPoint.
	self showCursor.
! !

!OldPCKeyboard methodsFor: 'ports' stamp: 'gera 5/20/2006 15:48'!
dataPort
	^ self byteAt: 0! !

!OldPCKeyboard methodsFor: 'ports' stamp: 'gera 5/20/2006 15:48'!
dataPort: aByte
	^ self byteAt: 0 put: aByte! !

!OldPCKeyboard methodsFor: 'keyboard commands' stamp: 'gera 5/17/2006 11:39'!
disableScanning
	^ self keyboardCommand: 16rF5! !

!OldPCKeyboard methodsFor: 'controller commands' stamp: 'gera 5/17/2006 11:39'!
enableKeyboard
	self controllerCommand: 16rAE
	! !

!OldPCKeyboard methodsFor: 'keyboard commands' stamp: 'gera 5/17/2006 11:39'!
enableScanning
	^ self keyboardCommand: 16rF4.
! !

!OldPCKeyboard methodsFor: 'translation' stamp: 'gera 5/17/2006 11:39'!
extendedTranslation: scanCode
	scanCode = 75 ifTrue: [^Character value: 28].
	scanCode = 77 ifTrue: [^Character value: 29].
	scanCode = 72 ifTrue: [^Character value: 30].
	scanCode = 80 ifTrue: [^Character value: 31].
	scanCode = 71 ifTrue: [^Character value: 1].
	scanCode = 79 ifTrue: [^Character value: 4].
	scanCode = 73 ifTrue: [^Character value: 11].
	scanCode = 81 ifTrue: [^Character value: 12].
	^ Character value: 0
! !

!OldPCKeyboard methodsFor: 'irq handling' stamp: 'r++ 7/26/2008 10:39'!
handleIRQ
	self report: 'IRQ'.
	self handleKbdEvent.
! !

!OldPCKeyboard methodsFor: 'irq handling' stamp: 'GuidoChari 12/16/2010 17:32'!
handleKbdEvent
	| count |
	count := 1.
	self readStatus.
	[self outputBufferFull]
		whileTrue: 
			[self nextData.
			self checkError
				ifFalse: [self auxOutputBufferFull
					ifTrue: [self processMouseScanCode: lastScanCode]
					ifFalse: [self processScanCode: lastScanCode]].
			count := count + 1.
			count = 1000
				ifTrue: 
					[Transcript cr; show: 'Error de teclado'.
					^ self].
			self readStatus]! !

!OldPCKeyboard methodsFor: 'irq handling' stamp: 'gera 5/17/2006 11:39'!
hideCursor
	"underCursorForm ifNotNil: [underCursorForm displayOn: Display at: mousePoint]"
	self showCursor! !

!OldPCKeyboard methodsFor: 'initialization' stamp: 'gera 5/17/2006 11:39'!
initializationHandleIRQOn: aComputer! !

!OldPCKeyboard methodsFor: 'initialization' stamp: 'r++ 7/26/2008 10:56'!
initialize
	| auxPortPresent |
	super initialize.
	pressedKeys := SharedQueue new.
	event := Array new: 8.
	mousePoint := 320 @ 320.
	buttonsState := 0.
	mouseCount := 2.
	prevScanCode := 0.
	underCursorForm := nil.
	lastScanCode := 0.
	self clearInput.

	self setMode: 0.
	self initializeHardware.

	(auxPortPresent := true "self isAuxPortPresent") ifTrue: [
		self report: 'Detected PS/2 Mouse port'.
		self initializeAux].
	self setInitialMode: auxPortPresent
! !

!OldPCKeyboard methodsFor: 'initialization' stamp: 'gera 5/17/2006 11:39'!
initializeAux
	self
		auxEnable;
		mouseSetStandard;
		auxEnableDevice! !

!OldPCKeyboard methodsFor: 'initialization' stamp: 'r++ 7/26/2008 10:55'!
initializeHardware
	self report: 'Performing keyboard initialization'.
	self controllerSelfTest
		ifFalse: 
			[self report: 'controller self test: failed.'.
			^ false].
	self report: 'controller self test: Ok'.
	self keyboardSelfTest
		ifFalse: 
			[self report: 'keyboard self test: failed.'.
			^ false].
	self report: 'keyboard self test: Ok'.
	self enableKeyboard.
	self report: 'keyboard enabled'.
	self resetKeyboard. 
	self report: 'keyboard reset'.
! !

!OldPCKeyboard methodsFor: 'testing' stamp: 'gera 5/17/2006 11:39'!
inputBufferFull
	^ status anyMask: 2! !

!OldPCKeyboard methodsFor: 'testing' stamp: 'gera 5/21/2006 19:31'!
isAuxPortPresent
	self auxWriteToOutBuffer: 16r5A.
	10
		timesRepeat: 
			[self readStatus.
			self nextData.
			self auxOutputBufferFull ifTrue: [^ true].
			(Delay forMilliseconds: 1) wait].
	^false! !

!OldPCKeyboard methodsFor: 'ports' stamp: 'r++ 7/26/2008 10:18'!
keyboardCommand: cmd 
	
	[self dataPort: cmd.
	self waitData.
	self ackReceived ifTrue: [^ true].
	self resendReceived] whileTrue.
	^ false! !

!OldPCKeyboard methodsFor: 'testing' stamp: 'gera 5/17/2006 11:39'!
keyboardLocked
	^ (status anyMask: 16r10) not! !

!OldPCKeyboard methodsFor: 'controller commands' stamp: 'gera 5/17/2006 11:39'!
keyboardSelfTest
	self controllerCommand: 16rAB.
	^ self waitData = 0! !

!OldPCKeyboard methodsFor: 'testing' stamp: 'gera 5/17/2006 11:39'!
lastWriteCommand
	^ status anyMask: 8! !

!OldPCKeyboard methodsFor: 'accessing' stamp: 'gera 5/17/2006 11:39'!
leftShiftDown
	^ self leftShiftPressed! !

!OldPCKeyboard methodsFor: 'accessing' stamp: 'gera 5/17/2006 11:39'!
leftShiftPressed
	^ buttonsState anyMask: 8! !

!OldPCKeyboard methodsFor: 'accessing' stamp: 'gera 5/17/2006 11:39'!
macOptionKeyPressed
	^ false! !

!OldPCKeyboard methodsFor: 'mouse access' stamp: 'GuidoChari 12/16/2010 17:33'!
mousePoint: aPoint
	mousePoint := aPoint adhereTo: Display boundingBox! !

!OldPCKeyboard methodsFor: 'mouse commands' stamp: 'gera 5/17/2006 11:39'!
mouseSetStandard
	self auxWrite: 16rF6.! !

!OldPCKeyboard methodsFor: 'irq handling' stamp: 'gera 5/17/2006 11:39'!
newKeyboardDownEvent: aCharacter
	self newKeyboardEvent: aCharacter type: EventKeyDown.
	self newKeyboardEvent: aCharacter type: EventKeyChar.
! !

!OldPCKeyboard methodsFor: 'irq handling' stamp: 'r++ 7/26/2008 11:01'!
newKeyboardEvent: aCharacter type: byteType
	" taken from EventSensor >> #nextEventSynthesized "
	event
		at: 1 put: EventTypeKeyboard; "evt type"
		at: 2 put: Time millisecondClockValue; "time stamp"
		at: 3 put: aCharacter asciiValue; "char code"
		at: 4 put: byteType; "key press/release"
		at: 5 put: buttonsState >> 3. "modifier keys"

	Sensor processEvent: event.
	self report: event.! !

!OldPCKeyboard methodsFor: 'irq handling' stamp: 'gera 5/17/2006 11:39'!
newKeyboardUpEvent: aCharacter
	self newKeyboardEvent: aCharacter type: EventKeyUp! !

!OldPCKeyboard methodsFor: 'irq handling' stamp: 'r++ 7/26/2008 11:01'!
newMouseEvent
	| modifiers buttons mapped |
	modifiers := buttonsState bitShift: -3.
	buttons := buttonsState bitAnd: 7.
	mapped := Sensor mapButtons: buttons modifiers: modifiers.
	event
		at: 1 put: EventTypeMouse;
		at: 2 put: Time millisecondClockValue;
		at: 3 put: mousePoint x;
		at: 4 put: mousePoint y;
		at: 5 put: mapped;
		at: 6 put: modifiers.
	Sensor processEvent: event.
	self report: event.! !

!OldPCKeyboard methodsFor: 'commands support' stamp: 'gera 5/21/2006 19:16'!
nextData
	^ lastScanCode := self dataPort.
! !

!OldPCKeyboard methodsFor: 'accessing' stamp: 'gera 5/17/2006 11:39'!
nextKey
	^ pressedKeys next! !

!OldPCKeyboard methodsFor: 'testing' stamp: 'gera 5/17/2006 11:39'!
outputBufferFull
	^ status anyMask: 1! !

!OldPCKeyboard methodsFor: 'testing' stamp: 'gera 5/17/2006 11:39'!
parityError
	^ status anyMask: 16r80! !

!OldPCKeyboard methodsFor: 'accessing' stamp: 'gera 5/17/2006 11:39'!
peekKey
	^ pressedKeys peek! !

!OldPCKeyboard methodsFor: 'irq handling' stamp: 'r++ 7/26/2008 10:59'!
processMouseScanCode: aByte
	| scanCode |
	scanCode := aByte.
	mouseCount := mouseCount + 1.
	mouseCount = 1 ifTrue: [ "button state"
		buttonsState := (((buttonsState bitClear: 7)
			bitOr: (scanCode bitAnd: 2))
			bitOr: (scanCode bitAnd: 1) << 2)
			bitOr: (scanCode bitAnd: 4) >> 2.].
	mouseCount = 2 ifTrue: [ "x delta"	
		scanCode > 127 ifTrue: [scanCode := scanCode - 256].
		self hideCursor.
		self mousePoint: scanCode @ 0 + mousePoint].
	mouseCount = 3 ifTrue: [ "y delta"
		scanCode > 127 ifTrue: [scanCode := scanCode - 256].
		self mousePoint: mousePoint - (0 @ scanCode).
		mouseCount := 0.
		self showCursor].
	self newMouseEvent! !

!OldPCKeyboard methodsFor: 'irq handling' stamp: 'r++ 7/26/2008 10:59'!
processScanCode: scanCode
	| key code |
	scanCode = 0 | (scanCode = 16rFF)	" extended keys "
		ifTrue: 
			[prevScanCode := 0.
			^ self].
	(scanCode anyMask: 16r80)
		ifTrue: "key up"
			[scanCode = 16rE0 | (scanCode = 16rE1)	" special keys (SysReq) "
				ifTrue: 
					[prevScanCode := scanCode.
					^ self].
			code := scanCode bitClear: 16r80.
			(key := self simpleTranslation: code) asciiValue = 0
				ifTrue: [buttonsState := buttonsState bitClear: (self shiftTranslation: code)]
				ifFalse: [self newKeyboardUpEvent: key].
			prevScanCode := scanCode.
			^ self]
		ifFalse: "key down"
			[prevScanCode = 16rE0
				ifTrue: [key := self extendedTranslation: scanCode]
				ifFalse: 
					[key := self shiftPressed
								ifTrue: [self shiftedTranslation: scanCode]
								ifFalse: [self simpleTranslation: scanCode].
					key asciiValue = 0
					 ifTrue: [buttonsState := buttonsState bitOr: (self shiftTranslation: scanCode)]].
				key asciiValue = 0 ifFalse: [self newKeyboardDownEvent: key]. 
				prevScanCode := 0].

! !

!OldPCKeyboard methodsFor: 'accessing' stamp: 'gera 5/17/2006 11:39'!
rawMacOptionKeyPressed
	^ false! !

!OldPCKeyboard methodsFor: 'commands support' stamp: 'r++ 7/21/2008 22:29'!
readData
	| answer |
	self readStatus.
	self outputBufferFull ifFalse: [^ nil].
	answer := self nextData.
	^ self checkError
		ifTrue: 
			[Transcript cr; show: 'Error in #readData: ', (status printStringBase: 2).
			nil]
		ifFalse: [answer]! !

!OldPCKeyboard methodsFor: 'commands support' stamp: 'gera 5/21/2006 18:46'!
readStatus
	^ status := self controllerStatus! !

!OldPCKeyboard methodsFor: 'mouse access' stamp: 'gera 5/17/2006 11:39'!
redButtonPressed
	"Answer true if the red mouse button is being pressed. This is the first mouse button."

	^self buttons = 4! !

!OldPCKeyboard methodsFor: 'testing' stamp: 'gera 5/17/2006 11:39'!
resendReceived
	^ lastScanCode = 16rFE! !

!OldPCKeyboard methodsFor: 'keyboard commands' stamp: 'gera 5/17/2006 11:39'!
resetKeyboard
	^ self keyboardCommand: 16rFF.
! !

!OldPCKeyboard methodsFor: 'accessing' stamp: 'gera 5/17/2006 11:39'!
rightShiftPressed
	^ buttonsState anyMask: 8! !

!OldPCKeyboard methodsFor: 'commands support' stamp: 'gera 5/17/2006 11:39'!
safeDelay
	250
		timesRepeat: 
			[self handleKbdEvent.
			self inputBufferFull ifFalse: [^ self].
			(Delay forMilliseconds: 1) wait]! !

!OldPCKeyboard methodsFor: 'mouse commands' stamp: 'gera 5/17/2006 11:39'!
setAuxResolution: value
	self auxWriteAndWaitAck: 16rE8.
	self auxWriteAndWaitAck: value. ! !

!OldPCKeyboard methodsFor: 'mouse commands' stamp: 'gera 5/17/2006 11:39'!
setAuxSample: value
	self auxWriteAndWaitAck: 16rF3.
	self auxWriteAndWaitAck: value. ! !

!OldPCKeyboard methodsFor: 'mouse commands' stamp: 'gera 5/17/2006 11:39'!
setAuxScale11
	self auxWriteAndWaitAck: 16rE6. ! !

!OldPCKeyboard methodsFor: 'mouse commands' stamp: 'gera 5/17/2006 11:39'!
setAuxScale21
	self auxWriteAndWaitAck: 16rE7. ! !

!OldPCKeyboard methodsFor: 'controller commands' stamp: 'gera 5/17/2006 11:39'!
setInitialMode: auxPortPresent
	#(keyboardGenerateIRQ1 auxGenerateIRQ12 systemFlag disableKeboardInterface disableMouseInterface  scanCodeConversionToPCFormat ).
	#(1 2 4 16 32 64 ).
	self disableScanning.
	self setMode: (auxPortPresent ifTrue: [16r47] ifFalse: [16r65]).
	self enableScanning

! !

!OldPCKeyboard methodsFor: 'commands support' stamp: 'r++ 7/26/2008 10:29'!
setMode: aByte
	self controllerCommand: 16r60 data: aByte! !

!OldPCKeyboard methodsFor: 'accessing' stamp: 'gera 5/17/2006 11:39'!
shiftPressed
	^ self leftShiftPressed or: [self rightShiftPressed]! !

!OldPCKeyboard methodsFor: 'translation' stamp: 'gera 5/17/2006 11:39'!
shiftTranslation: scanCode
	scanCode = 16r2A & (prevScanCode ~= 16rE0) ifTrue: ["left shift"	^ 8].
	scanCode = 16r36 & (prevScanCode ~= 16rE0) ifTrue: ["right shift"	^ 8].
	scanCode = 16r38 ifTrue: ["left ALT (command key)"	^ 16r40].
	scanCode = 16r1D ifTrue: ["left CTRL"	^ 16r10].

"	Transcript show: scanCode hex; space."
	^ 0! !

!OldPCKeyboard methodsFor: 'translation' stamp: 'gera 6/16/2006 02:35'!
shiftedTranslation: scanCode
	^ ShiftedTranslationTable at: scanCode + 1 ifAbsent: [Character value: 0]
! !

!OldPCKeyboard methodsFor: 'irq handling' stamp: 'gera 9/1/2006 01:21'!
showCursor
"	underCursorForm _ Form fromDisplay: (mousePoint extent: Cursor currentCursor extent).
	Cursor currentCursor asCursorForm displayOn: Display at: mousePoint rule: Form reverse.
"! !

!OldPCKeyboard methodsFor: 'translation' stamp: 'gera 6/16/2006 02:35'!
simpleTranslation: scanCode
	^ TranslationTable at: scanCode + 1 ifAbsent: [Character value: 0]

! !

!OldPCKeyboard methodsFor: 'testing' stamp: 'gera 5/17/2006 11:39'!
testSuccessful
	^ status anyMask: 4! !

!OldPCKeyboard methodsFor: 'testing' stamp: 'gera 5/17/2006 11:39'!
timeout
	^ status anyMask: 16r40! !

!OldPCKeyboard methodsFor: 'accessing' stamp: 'r++ 7/21/2008 21:40'!
waitData
	| answer |
	2
		timesRepeat: 
			[(answer := self readData) ifNotNil: [^ answer].
			" (Delay forMilliseconds: 1) wait "].
	Transcript cr; show: ' wait data timedout.'.
	^ nil! !

!OldPCKeyboard methodsFor: 'mouse access' stamp: 'gera 5/17/2006 11:39'!
yellowButtonPressed
	"Answer whether only the yellow mouse button is being pressed. This is the second mouse button or option+click on the Mac."

	^self buttons = 2! !

HardwareDevice subclass: #PCIBusEntry
	instanceVariableNames: 'bus device function'
	classVariableNames: 'VendorsAndDevices'
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Base'!

!PCIBusEntry commentStamp: 'gera 7/2/2006 14:06' prior: 0!
I represent an entry (a specific device) in the PCI bus. Some examples:

"To scan the bus"		PCIBusEntry allValid
"To get memory ranges"	PCIBusEntry allValid collect: [:e | e allMemoryRanges]
"To get IO ranges"		PCIBusEntry allValid collect: [:e | e allIORanges]

Information on PCIBus

GRUB Legacy source (GRUB 0.97) netboot/pci.c

Info from pages:
http://www.mega-tokyo.com/osfaq/Where%20can%20I%20find%20programming%20info%20on%20PCI%3F
http://www.cs.nmsu.edu/~pfeiffer/classes/473/notes/pci.html

Specs from:
http://perso.orange.fr/pierrelib/buses/index.htm
Specially chapter  6 from PCI Local Bus Specification (v2.2 for example)

Vendors and device list:
http://www.pcidatabase.com/

Class codes and Class sub codes:
http://www.acm.uiuc.edu/sigops/roll_your_own/7.c.1.html
http://cvs.opensolaris.org/source/raw/on/usr/src/common/pci/pci_strings.c

Still missing in this implementation (may be more things are missing):
- Memory and I/O map support (moving PCI devices around in memory and I/O space)
- Class and subClass code strings (just for readability).
- Capabilities List (chapter 6.7 and Appendix H of PCI Local Bus Spec)
- PCI Exansion ROMs (chapter 6.3 of PCI Local Bus Spec)
- Vital Product Data (Appendix I of PCI Local Bus Spec)
- Message Signaled Interrupts (chapter 6.8 of PCI Local Bus Spec)
!

!PCIBusEntry class methodsFor: 'instance creation' stamp: 'gera 6/28/2006 19:57'!
allValid
	" PCIDevice allValid "
	| answer scanner |
	answer := OrderedCollection new.
	scanner := self bus: 0 device: 0 function: 0.
	0 to: 255 do: [:bus |
		0 to: 31 do: [:device |
			scanner
				bus: bus;
				device: device;
				function: 0.
			scanner isValid ifTrue: [
				answer add: scanner copy.
				scanner isMultiFunction ifTrue: [
					1 to: 7 do: [:function | 
						scanner function: function.
						scanner isValid ifTrue: [answer add: scanner copy]
						]
					]
			]
		]
	].
	^ answer! !

!PCIBusEntry class methodsFor: 'instance creation' stamp: 'gera 1/1/1901 00:35'!
bus: bus device: device function: function
	^ (self onPort: 16rCF8)
		bus: bus;
		device: device;
		function: function.! !

!PCIBusEntry class methodsFor: 'initialization' stamp: 'LC 8/23/2008 12:06'!
initialize
	"
	PCIBusEntry initialize
	"
	self initializeVendorsAndDevicesList! !

!PCIBusEntry class methodsFor: 'initialization' stamp: 'LC 8/23/2008 12:05'!
initializeVendorsAndDevicesList
	" self initializeVendorsAndDevicesList "
	^VendorsAndDevices := self parseVendorsAndDevicesFromPCIIDsDatabase: (ReadStream on: self vendorsAndDevicesData).! !

!PCIBusEntry class methodsFor: 'initialization' stamp: 'r++ 7/27/2008 11:45'!
initializeVendorsAndDevicesMethod
	" self initializeVendorsAndDevicesMethod "
	" The old csv file was downloaded from http://www.pcidatabase.com/reports.php?type=csv "
	" We are currently using a more complete database from http://pci-ids.ucw.cz/ "
	| file data |
	file := StandardFileStream readOnlyFileNamed: 'info/Buses/pci/pci.ids'.

	data := ZLibWriteStream on: String new.
	data nextPutAll: file contents.
	data close.
	self class compile: 'vendorsAndDevicesZLibData',String cr,'   ^ ', data encodedStream contents storeString.
	! !

!PCIBusEntry class methodsFor: 'initialization' stamp: 'gera 6/26/2006 19:48'!
numberFromString: str
	| strm head base |
	strm := ReadStream on: str asUppercase.
	strm peekFor: $".
	head := strm next: 2.
	head size > 1
		ifTrue: [
			base := 10.
			head = '0X'
				ifTrue: [base := 16]
				ifFalse: [
					head = '&#' ifFalse: [strm skip: -2]]]
		ifFalse: [strm skip: -1].
	^ [Number readFrom: strm base: base] ifError: [0]! !

!PCIBusEntry class methodsFor: 'initialization' stamp: 'r++ 7/20/2008 12:02'!
parseVendorsAndDevicesFromPCIDatabase: strm
	" The csv file was downloaded from http://www.pcidatabase.com/reports.php?type=csv "
	| line fields vendors vendor device |
	vendors := Dictionary new.
	[line := strm upTo: Character lf.
	line notNil and: [line size > 0]] whileTrue: [
		fields := (line findBetweenSubStrs: #('","')) asArray.
		fields size >= 2
			ifTrue: [
				vendor := self numberFromString: (fields at: 1).
				device := self numberFromString: (fields at: 2).
				vendors at: (vendor << 32 + device) put: fields.
				vendors at: vendor put: (fields at: 3)]
			ifFalse: [Transcript show: line; cr].
	].

	^ vendors! !

!PCIBusEntry class methodsFor: 'initialization' stamp: 'r++ 7/27/2008 12:40'!
parseVendorsAndDevicesFromPCIIDsDatabase: strm
	" The csv file was downloaded from http://pci-ids.ucw.cz/  "
	"# Syntax:
	# vendor  vendor_name
	#	device  device_name				<-- single tab
	#		subvendor subdevice  subsystem_name	<-- two tabs
	"

	| vendors tok vendorId subId deviceId description |
	vendors := Dictionary new.
	[strm atEnd] whileFalse: [
		tok := strm peek.
		tok == Character tab
			ifTrue: [	" starts with tab "
				strm next.
				tok := strm peek.
				tok == Character tab
					ifTrue: [	"#		subvendor subdevice  subsystem_name"
						strm next.
						subId := strm upTo: Character space.
						strm skipSeparators.
						subId := subId, (strm upTo: Character space).
						strm upTo: Character lf.
					] ifFalse: [	"#	device  device_name"
						deviceId := (strm upTo: Character space) asUppercase.
						deviceId := Number readFrom: deviceId base: 16.
						strm skipSeparators.
						description := strm upTo: Character lf.
						vendors at: vendorId << 32 + deviceId put: description.
					]
			] ifFalse: [	" doesn't start with tab "
				tok == $C
					ifTrue: [	" device classes, not supported yet. Assume end "
						strm setToEnd.
					] ifFalse: [
						(tok == $# or: [tok == Character lf])
							ifTrue: [strm upTo: Character lf]
							ifFalse: [ "# vendorId vendor name "
								vendorId := (strm upTo: Character space) asUppercase.
								vendorId := Number readFrom: vendorId base: 16.
								strm skipSeparators.
								description := strm upTo: Character lf.
								vendors at: vendorId put: description.
							]
					]
			]
	].

	^ vendors! !

!PCIBusEntry class methodsFor: 'initialization' stamp: 'LC 8/23/2008 12:27'!
pciidsLocation
	^'http://pci-ids.ucw.cz/pci.ids'! !

!PCIBusEntry class methodsFor: 'initialization' stamp: 'r++ 7/27/2008 12:57'!
stringForVendor: vendorId device: deviceId
	| vendor device |
	vendor := VendorsAndDevices
		at: vendorId
		ifAbsent: ['unknown ', vendorId hex].
	device := VendorsAndDevices
		at: vendorId << 32 + deviceId
		ifAbsent: ['unknown ', deviceId hex].
	^ 'Vendor: ', vendor, ' Device: ', device
! !

!PCIBusEntry class methodsFor: 'initialization' stamp: 'LC 8/23/2008 12:26'!
vendorsAndDevicesData
	"
	PCIBusEntry vendorsAndDevicesData
	"
	^self pciidsLocation asUrl retrieveContents contents! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/1/2006 17:40'!
DEVSELtiming
	" bits 9,10 - These bits encode the timing of DEVSEL#. Section 3.6.1. of
	PCI Local Bus Spec specifies three allowable timings for assertion of DEVSEL#.
	These are encoded as 00b for fast, 01b for medium, and 10b for slow (11b is
	reserved). These bits are read-only and must indicate the slowest time
	that a device asserts DEVSEL# for any bus command except
	Configuration Read and Configuration Write."

	^ self status >> 9 bitAnd: 3! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 6/29/2006 19:32'!
MaxLat
	^ self configByte: 16r3F! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 6/29/2006 19:32'!
MinGnt
	^ self configByte: 16r3E! !

!PCIBusEntry methodsFor: 'accessing - addresses map' stamp: 'gera 7/2/2006 13:34'!
allIORanges
	| answer addr |

	answer := OrderedCollection new: 6.
	0 to: 5 do: [:i |
		addr := self baseAddressRegister: i.
		addr even
			ifTrue: ["is memory"]
			ifFalse: [
				answer add: 
					(addr bitAnd: 3 bitInvert) -> (self baseIOAddressRegisterSize: i original: addr).
			]].

	^ answer! !

!PCIBusEntry methodsFor: 'accessing - addresses map' stamp: 'gera 7/2/2006 13:34'!
allMemoryRanges
	| answer addr |

	answer := OrderedCollection new: 6.
	0 to: 5 do: [:i |
		addr := self baseAddressRegister: i.
		(addr ~= 0 and: [addr even])
			ifTrue: ["is memory"
				answer add: 
					(addr bitAnd: 3 bitInvert) -> (self baseMemoryAddressRegisterSize: i original: addr).
			]].

	^ answer! !

!PCIBusEntry methodsFor: 'accessing - addresses map' stamp: 'gera 7/18/2006 12:39'!
baseAddressRegister: index
	index > 5 ifTrue: [self errorSubscriptBounds: index].
	^ self configLong: index * 4 + 16! !

!PCIBusEntry methodsFor: 'accessing - addresses map' stamp: 'gera 7/18/2006 12:39'!
baseAddressRegister: index put: address
	index > 5 ifTrue: [self errorSubscriptBounds: index].
	^ self configLong: index * 4 + 16 put: address! !

!PCIBusEntry methodsFor: 'accessing - addresses map' stamp: 'gera 7/2/2006 12:27'!
baseAddressRegisterSize: index
	| original |
	
	original := self baseAddressRegister: index.
	original even
		ifTrue: [^ self baseMemoryAddressRegisterSize: index original: original]
		ifFalse: [^ self baseIOAddressRegisterSize: index original: original]
! !

!PCIBusEntry methodsFor: 'accessing - addresses map' stamp: 'gera 7/2/2006 12:43'!
baseIOAddressRegisterSize: index original: original
	| enabled answer |

	enabled := self hasIOEnabled.

	self baseAddressRegister: index put: 16rFFFFFFFF.
	answer := self baseAddressRegister: index.
	self baseAddressRegister: index put: original.

	enabled ifTrue: [self enableIO].

	(answer noMask: 16rFFFF0000)
		ifTrue: [answer := answer + 16rFFFF0000].

	^ ((answer bitAnd: 3 bitInvert) bitInvert + 1) bitAnd: 16rFFFFFFFF
! !

!PCIBusEntry methodsFor: 'accessing - addresses map' stamp: 'gera 7/2/2006 12:43'!
baseMemory32AddressRegisterSize: index original: original
	| enabled answer |

	enabled := self hasMemoryEnabled.

	self baseAddressRegister: index put: 16rFFFFFFFF.
	answer := self baseAddressRegister: index.
	self baseAddressRegister: index put: original.

	enabled ifTrue: [self enableMemory].

	^ ((answer bitAnd: 15 bitInvert) bitInvert + 1) bitAnd: 16rFFFFFFFF
! !

!PCIBusEntry methodsFor: 'accessing - addresses map' stamp: 'gera 7/2/2006 13:08'!
baseMemory64AddressRegisterSize: index original: originalLo
	| enabled answer originalHi |

	enabled := self hasMemoryEnabled.

	originalHi := self baseAddressRegister: index+1.

	self baseAddressRegister: index put: 16rFFFFFFFF.
	self baseAddressRegister: index+1 put: 16rFFFFFFFF.

	"from spec it's not clear if reg at index+1 has lower bits correct or not. From testing, apparently it has"
	answer := (self baseAddressRegister: index + 1) << 32 + (self baseAddressRegister: index).

	self baseAddressRegister: index put: originalLo.
	self baseAddressRegister: index+1 put: originalHi.

	enabled ifTrue: [self enableMemory].

	^ ((answer bitAnd: 15 bitInvert) bitInvert + 1) bitAnd: 16rFFFFFFFFFFFFFFFF
! !

!PCIBusEntry methodsFor: 'accessing - addresses map' stamp: 'gera 7/2/2006 13:26'!
baseMemoryAddressRegisterSize: index original: original
	| size |
	original isZero ifTrue: [^ 0].

	size := original bitAnd: 2r110.
	
	size = 2r100 ifTrue: [^ self baseMemory64AddressRegisterSize: index original: original].
	size = 2r110 ifTrue: ["reserved mode" ^ self error: 'Unknown memory model'].

	" can be 2r000 (32 bits) or 2r010 (32 bits < 1Meg) "
	^ self baseMemory32AddressRegisterSize: index original: original.! !

!PCIBusEntry methodsFor: 'accessing - bist' stamp: 'gera 7/1/2006 17:59'!
bistCompletionCode
	" bits 0-3 - A value of 0 means the device has passed its test. Non-zero values
	mean the device failed. Device-specific failure codes can be encoded
	in the non-zero value."
	^ self builtInSelfTest bitAnd: 15! !

!PCIBusEntry methodsFor: 'accessing - bist' stamp: 'gera 7/1/2006 17:58'!
bistHasFinished
	" bit 6 - Write a 1 to invoke BIST. Device resets the bit when BIST is complete.
	Software should fail the device if BIST is not complete after 2 seconds."

	^ (self builtInSelfTest anyMask: 64) not! !

!PCIBusEntry methodsFor: 'accessing - bist' stamp: 'gera 7/1/2006 17:54'!
builtInSelfTest
	^ self configByte: 15! !

!PCIBusEntry methodsFor: 'accessing - bist' stamp: 'gera 7/1/2006 17:55'!
builtInSelfTest: byte
	^ self configByte: 15 put: byte! !

!PCIBusEntry methodsFor: 'private' stamp: 'gera 1/1/1901 00:34'!
bus: aNumber
	bus := aNumber! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 6/26/2006 09:30'!
cacheLineSize
	^ self configByte: 12! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 6/29/2006 19:31'!
capabilitiesPointer
	^ self configByte: 16r34! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 7/18/2006 12:39'!
cardbusCISPointer
	^ self configLong: 16r28! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 6/26/2006 12:30'!
classCode
	^ self configByte: 11! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 6/26/2006 12:30'!
classSubCode
	^ self configByte: 10! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/18/2006 12:40'!
command
	^ self configShort: 4! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/18/2006 12:40'!
command: aNumber
	^ self configShort: 4 put: aNumber! !

!PCIBusEntry methodsFor: 'private' stamp: 'gera 7/18/2006 12:10'!
configByte: index
	self longAt: 0 put: (self translate: index).
	^ self byteAt: 4 + (index bitAnd: 3) ! !

!PCIBusEntry methodsFor: 'private' stamp: 'gera 7/18/2006 12:10'!
configByte: index put: aNumber
	self longAt: 0 put: (self translate: index).
	^ self byteAt: 4 + (index bitAnd: 3) put: aNumber! !

!PCIBusEntry methodsFor: 'private' stamp: 'gera 7/18/2006 12:39'!
configLong: index
	self longAt: 0 put: (self translate: index).
	^ self longAt: 4 ! !

!PCIBusEntry methodsFor: 'private' stamp: 'gera 7/18/2006 12:39'!
configLong: index put: aNumber
	self longAt: 0 put: (self translate: index).
	^ self longAt: 4 put: aNumber! !

!PCIBusEntry methodsFor: 'private' stamp: 'gera 7/18/2006 12:40'!
configShort: index
	self longAt: 0 put: (self translate: index).
	^ self shortAt: 4 + (index bitAnd: 2) ! !

!PCIBusEntry methodsFor: 'private' stamp: 'gera 7/18/2006 12:40'!
configShort: index put: aNumber
	self longAt: 0 put: (self translate: index).
	^ self shortAt: 4 + (index bitAnd: 2) put: aNumber! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/1/2006 17:47'!
detectedParityError
	" bit 15 - This bit must be set by the device whenever it detects a parity error,
	even if parity error handling is disabled (as controlled by bit 6 in the
	Command register)."

	^ self statusBit: 15! !

!PCIBusEntry methodsFor: 'private' stamp: 'gera 1/1/1901 00:34'!
device: aNumber
	device := aNumber! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 7/18/2006 12:40'!
deviceId
	^ self configShort: 2! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:58'!
disableBusMastering
	^ self disableCommandBit: 2! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:58'!
disableCommandBit: bit
	^ self command: (self command bitAnd: 16rFFFF - (1 << bit))! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 14:13'!
disableFastBackToBack
	^ self disableCommandBit: 9! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:58'!
disableIO
	^ self disableCommandBit: 0! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:57'!
disableMemory
	^ self disableCommandBit: 1! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:53'!
disableMemoryWriteAndInvalidateEnabled
	^ self disableCommandBit: 4! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:58'!
disableParityErrorGeneration
	^ self disableCommandBit: 6! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:58'!
disableSpecialCycle
	^ self disableCommandBit: 3! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 14:03'!
disableStepping
	^ self disableCommandBit: 7! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 14:11'!
disableSystemErrorGeneration
	^ self disableCommandBit: 8! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:58'!
disableVGAPaletteSnooping
	^ self disableCommandBit: 5! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:58'!
disconnect
	^ self command: 0! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:59'!
enableBusMastering
	^ self enableCommandBit: 2! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:59'!
enableCommandBit: bit
	^ self command: (self command bitOr: 1 << bit)! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 14:13'!
enableFastBackToBack
	^ self enableCommandBit: 9! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:59'!
enableIO
	^ self enableCommandBit: 0! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:59'!
enableMemory
	^ self enableCommandBit: 1! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:53'!
enableMemoryWriteAndInvalidateEnabled
	^ self enableCommandBit: 4! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:59'!
enableParityErrorGeneration
	^ self enableCommandBit: 6! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:59'!
enableSpecialCycle
	^ self enableCommandBit: 3! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 14:03'!
enableStepping
	^ self enableCommandBit: 7! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 14:11'!
enableSystemErrorGeneration
	^ self enableCommandBit: 8! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:59'!
enableVGAPaletteSnooping
	^ self enableCommandBit: 5! !

!PCIBusEntry methodsFor: 'private' stamp: 'gera 1/1/1901 00:34'!
function: aNumber
	function := aNumber! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/2/2006 15:33'!
hasBusMasteringEnabled
	"bit 2 - Controls a device's ability to act as a master on the PCI bus. A value
	of 0 disables the device from generating PCI accesses. A value of 1
	allows the device to behave as a bus master. State after RST# is 0."

	^ self testCommandBit: 2! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/2/2006 12:08'!
hasCapabilitiesList
	" bit 4 - This optional read-only bit indicates whether or not this device
	implements the pointer for a New Capabilities linked list at offset 34h.
	A value of zero indicates that no New Capabilities linked list is
	available. A value of one indicates that the value read at offset 34h is a
	pointer in Configuration Space to a linked list of new capabilities. Refer
	to Section 6.7. of PCI Local Bus Spec for details on New Capabilities."

	^ self statusBit: 4! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 14:13'!
hasFastBackToBackEnabled
	"bit 9 - This optional read/write bit controls whether or not a master can do
	fast back-to-back transactions to different devices. Initialization
	software will set the bit if all targets are fast back-to-back capable. A
	value of 1 means the master is allowed to generate fast back-to-back
	transactions to different agents as described in Section 3.4.2. A value
	of 0 means fast back-to-back transactions are only allowed to the
	same agent. This bit\u2019s state after RST# is 0."

	^ self testCommandBit: 9! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 12:03'!
hasIOEnabled
	"bit 0 - Controls a device\u2019s response to I/O Space accesses. A value of 0
	disables the device response. A value of 1 allows the device to
	respond to I/O Space accesses. State after RST# is 0."

	^ self testCommandBit: 0! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/1/2006 17:38'!
hasMasterDataParityError
	" bit 8 - This bit is only implemented by bus masters. It is set when three
	conditions are met: 1) the bus agent asserted PERR# itself (on a read)
	or observed PERR# asserted (on a write); 2) the agent setting the bit
	acted as the bus master for the operation in which the error occurred;
	and 3) the Parity Error Response bit (Command register) is set."

	^ self statusBit: 8! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 12:03'!
hasMemoryEnabled
	"bit 1 - Controls a device's response to Memory Space accesses. A value of
	0 disables the device response. A value of 1 allows the device to
	respond to Memory Space accesses. State after RST# is 0."

	^ self testCommandBit: 1! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:52'!
hasMemoryWriteAndInvalidateEnabled
	"bit 4 - This is an enable bit for using the Memory Write and Invalidate
	command. When this bit is 1, masters may generate the command.
	When it is 0, Memory Write must be used instead. State after RST# is
	0. This bit must be implemented by master devices that can generate
	the Memory Write and Invalidate command."

	^ self testCommandBit: 4! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:56'!
hasParityErrorGenerationEnabled
	"bit 6 - This bit controls the device\u2019s response to parity errors. When the bit is
	set, the device must take its normal action when a parity error is
	detected. When the bit is 0, the device sets its Detected Parity Error
	status bit (bit 15 in the Status register) when an error is detected, but
	does not assert PERR# and continues normal operation. This bit\u2019s
	state after RST# is 0. Devices that check parity must implement this
	bit. Devices are still required to generate parity even if parity checking
	is disabled."

	^ self testCommandBit: 6! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 12:03'!
hasSpecialCycleEnabled
	"bit 3 - Controls a device's action on Special Cycle operations. A value of 0
	causes the device to ignore all Special Cycle operations. A value of 1
	allows the device to monitor Special Cycle operations. State after
	RST# is 0."

	^ self testCommandBit: 3! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 14:03'!
hasSteppingEnabled
	"bit 7 - This bit is used to control whether or not a device does address/data
	stepping. Devices that never do stepping must hardwire this bit to 0.
	Devices that always do stepping must hardwire this bit to 1. Devices
	that can do either, must make this bit read/write and have it initialize to
	1 after RST#."

	^ self testCommandBit: 7! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 14:11'!
hasSystemErrorGenerationEnabled
	"bit 8 - This bit is used to control whether or not a device does address/data
	stepping. Devices that never do stepping must hardwire this bit to 0.
	Devices that always do stepping must hardwire this bit to 1. Devices
	that can do either, must make this bit read/write and have it initialize to
	1 after RST#. SERR is signaled by hardware for Unrecoverable errors."

	^ self testCommandBit: 8! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 7/1/2006 13:54'!
hasVGAPaletteSnoopingEnabled
	"bit 5 - This bit controls how VGA compatible and graphics devices handle
	accesses to VGA palette registers. When this bit is 1, palette
	snooping is enabled (i.e., the device does not respond to palette
	register writes and snoops the data). When the bit is 0, the device
	should treat palette write accesses like all other accesses. VGA
	compatible devices should implement this bit. Refer to Section 3.10.
	of PCI Local Bus Spec for more details on VGA palette snooping."

	^ self testCommandBit: 5! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 6/26/2006 09:31'!
headerType
	^ self configByte: 14! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 6/29/2006 19:31'!
interruptLine
	^ self configByte: 16r3C! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 7/2/2006 11:53'!
interruptPin
	^ self configByte: 16r3D! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/1/2006 17:46'!
is66MHzCapable
	" bit 5 - This optional read-only bit indicates whether or not this device is
	capable of running at 66 MHz as defined in Chapter 7 of PCI Local Bus Spec.
	A value of zero indicates 33 MHz. A value of 1 indicates that the device is 66 MHz
	capable."

	^ self statusBit: 5! !

!PCIBusEntry methodsFor: 'accessing - bist' stamp: 'gera 7/1/2006 17:57'!
isBistCapable
	" bit 7 - Return 1 if device supports BIST. Return 0 if the device is not BIST
	capable."

	^ self builtInSelfTest anyMask: 128! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/1/2006 17:35'!
isFastBackToBackCapable
	" bit 7 - This optional read-only bit indicates whether or not the target is
	capable of accepting fast back-to-back transactions when the
	transactions are not to the same agent. This bit can be set to 1 if the
	device can accept these transactions and must be set to 0 otherwise.
	Refer to Section 3.4.2. of PCI Local Bus Spec for a complete description
	of requirements for setting this bit."

	^ self statusBit: 7! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 6/26/2006 10:23'!
isMultiFunction
	^ self headerType anyMask: 16r80! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 6/26/2006 09:37'!
isValid
	| vendor |
	vendor := self vendorId.
	^ vendor ~= 0 and: [vendor ~= 16rFFFF].! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 6/26/2006 09:31'!
latencyTimer
	^ self configByte: 13! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 7/2/2006 15:58'!
latencyTimer: aByte
	^ self configByte: 13 put: aByte! !

!PCIBusEntry methodsFor: 'printing' stamp: 'gera 7/18/2006 18:29'!
printOn: strm
	strm
		nextPutAll: self class name;
		nextPut: $:;
		space;
		nextPutAll: bus printStringHex;
		nextPut: $:;
		nextPutAll: device printStringHex;
		nextPut: $.;
		nextPutAll: function printString;
		space;
		nextPutAll: self stringForVendorAndDevice.! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 6/26/2006 12:31'!
programmingInterface
	^ self configByte: 9! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/1/2006 17:46'!
receivedMasterAbort
	" bit 13 - This bit must be set by a master device whenever its transaction is
	terminated with Target-Abort. All master devices must implement this
	bit."

	^ self statusBit: 13! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/1/2006 17:43'!
receivedTargetAbort
	" bit 12 - This bit must be set by a master device whenever its transaction is
	terminated with Target-Abort. All master devices must implement this
	bit."

	^ self statusBit: 12! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/1/2006 17:48'!
resetDetectedParityError
	^ self resetStatusBit: 15! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/1/2006 17:38'!
resetMasterDataParityError
	^ self resetStatusBit: 8! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/1/2006 17:49'!
resetReceivedMasterAbort
	^ self resetStatusBit: 13! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/1/2006 17:44'!
resetReceivedTargetAbort
	^ self resetStatusBit: 12! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/1/2006 17:45'!
resetSignaledSystemError
	^ self resetStatusBit: 14! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/1/2006 17:42'!
resetSignaledTargetAbort
	^ self resetStatusBit: 11! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/1/2006 17:30'!
resetStatusBit: bit
	^ self status: 1 << bit! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 6/26/2006 12:16'!
revisionId
	^ self configByte: 8! !

!PCIBusEntry methodsFor: 'accessing - addresses map' stamp: 'gera 7/18/2006 12:39'!
romAddressRegister
	^ self configLong: 16r30! !

!PCIBusEntry methodsFor: 'accessing - addresses map' stamp: 'gera 7/18/2006 12:40'!
romAddressRegister: addr
	^ self configLong: 16r30 put: addr! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/1/2006 17:46'!
signaledSystemError
	" bit 14 - This bit must be set whenever the device asserts SERR#. Devices
	who will never assert SERR# do not need to implement this bit."

	^ self statusBit: 14! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/1/2006 17:42'!
signaledTargetAbort
	" bit 11 - This bit must be set by a target device whenever it terminates a
	transaction with Target-Abort. Devices that will never signal Target-
	Abort do not need to implement this bit."

	^ self statusBit: 11! !

!PCIBusEntry methodsFor: 'accessing - bist' stamp: 'gera 7/1/2006 17:57'!
startBist
	" bit 6 - Write a 1 to invoke BIST. Device resets the bit when BIST is complete.
	Software should fail the device if BIST is not complete after 2 seconds."

	^ self builtInSelfTest: (self builtInSelfTest bitOr: 64)! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/18/2006 12:40'!
status
	^ self configShort: 6! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/18/2006 12:41'!
status: word
	^ self configShort: 6 put: word! !

!PCIBusEntry methodsFor: 'accessing - status' stamp: 'gera 7/1/2006 17:29'!
statusBit: bit
	^ self status anyMask: 1 << bit! !

!PCIBusEntry methodsFor: 'printing' stamp: 'gera 6/28/2006 14:21'!
stringForVendorAndDevice
	^ self class stringForVendor: self vendorId device: self deviceId! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 7/18/2006 12:40'!
subsystemId
	^ self configShort: 16r2E! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 7/18/2006 12:40'!
subsystemVendorId
	^ self configShort: 16r2C! !

!PCIBusEntry methodsFor: 'accessing - command register' stamp: 'gera 6/30/2006 22:20'!
testCommandBit: bit
	^ self command anyMask: 1 << bit
! !

!PCIBusEntry methodsFor: 'private' stamp: 'gera 6/26/2006 09:15'!
translate: index
	^ 16r80000000 + (bus << 16) + (device << 11) + (function << 8) + (index bitAnd: 16rFC)
! !

!PCIBusEntry methodsFor: 'accessing - general config' stamp: 'gera 7/18/2006 12:40'!
vendorId
	^ self configShort: 0! !

HardwareDevice subclass: #PCIDevice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Base'!

PCIDevice subclass: #ATAController
	instanceVariableNames: ''
	classVariableNames: 'primary secondary'
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Storage'!

!ATAController commentStamp: '<historical>' prior: 0!
First reference is this:

http://www.repairfaq.org/filipg/LINK/F_IDE-tech.html

But it contains some errors/simplifications, particularly about LBA addressing, so I recomend
reading this too:

http://www.t13.org/Documents/UploadedDocuments/project/d0791r4c-ATA-1.pdf

ATA Specification defines a set of registers that are used to communicate with a hard disk controller. Each controller controls at most two hard disks: a master and a slave. Most
commands issued in these registers apply to the controller's selected disk (master or slave).

+----+------+------+---+---+---+----------------+---------------+
|Addr|-CS1FX|-CS3FX|SA2|SA1|SA0| Read (-IOR)    | Write (-IOW)  |
+----+------+------+---+---+---+----------------+---------------+-----------+
|    |  0   |  0   | X | X | X | ILLEGAL        | ILLEGAL       | <--+      |
|    |  1   |  1   | X | X | X | High Impedance | Not Used      | Control   |
|3FX |  1   |  0   | 0 | X | X | High Impedance | Not Used      | Block     |
|3FX |  1   |  0   | 1 | 0 | X | High Impedance | Not Used      | Registers |
|3F6 |  1   |  0   | 1 | 1 | 0 | Altern Status  | Device Control|    |      |
|3F7 |  1   |  0   | 1 | 1 | 1 | Drive Address  | Not Used      | <--+      |
+----+------+------+---+---+---+----------------+---------------+-----------+
|1F0 |  0   |  1   | 0 | 0 | 0 | Data Port      | Data Port     | <--+      |
|1F1 |  0   |  1   | 0 | 0 | 1 | Error Register | Features       |    |      |
|1F2 |  0   |  1   | 0 | 1 | 0 | Sector Count   | Sector Count  | Command   |
|1F3 |  0   |  1   | 0 | 1 | 1 | Sector Number  | Sector Number | Block     |
|1F4 |  0   |  1   | 1 | 0 | 0 | Cylinder Low   | Cylinder Low  | Registers |
|1F5 |  0   |  1   | 1 | 0 | 1 | Cylinder High  | Cylinder High |    |      |
|1F6 |  0   |  1   | 1 | 1 | 0 | Drive / Head   | Drive / Head  |    |      |
|1F7 |  0   |  1   | 1 | 1 | 1 | Status         | Command       | <--+      |
+----+------+------+---+---+---+----------------+---------------+-----------+

1F0: Read/Write: DATA PORT REGISTER
1F1: Read: ERROR REGISTER
1F1: Write: FEATURES
1F2: Read/Write: SECTOR COUNT REGISTER
1F3: Read/Write: SECTOR NUMBER REGISTER
1F4: Read/Write: CYLINDER LOW REGISTER
1F5: Read/Write: CYLINDER HIGH REGISTER
1F6: Read/Write: DRIVE/HEAD REGISTER (rrrDHHHH)
1F7: Read: STATUS REGISTER
1F7: Write: COMMAND REGISTER

	mov     dx,1f6h         ;Drive and head port
	mov     al,0a0h         ;Drive 0, head 0
	out     dx,al

	mov     dx,1f2h         ;Sector count port
	mov     al,1            ;Read one sector
	out     dx,al

	mov     dx,1f3h         ;Sector number port
	mov     al,1            ;Read sector one
	out     dx,al

	mov     dx,1f4h         ;Cylinder low port
	mov     al,0            ;Cylinder 0
	out     dx,al

	mov     dx,1f5h         ;Cylinder high port
	mov     al,0            ;The rest of the cylinder 0
	out     dx,al

	mov     dx,1f7h         ;Command port
	mov     al,20h          ;Read with retry.
	out     dx,al
still_going:
	in      al,dx
	test    al,8            ;This means the sector buffer requires!

!ATAController class methodsFor: 'as yet unclassified' stamp: 'JavierPimas 8/23/2010 09:52'!
findPCIBusEntry
	
	"IDE controller have a PCI classID = 1 (Mass storage device) and subclass 1 (IDE Mass storage device)."
	
	^PCIBusEntry allValid detect: [ :entry | entry classCode = 1 and: [entry classSubCode = 1]] ifNone: [^nil].! !

!ATAController class methodsFor: 'as yet unclassified' stamp: 'JavierPimas 8/23/2010 13:02'!
primary
	primary ifNil: [ primary := self onPort: 16r1F0 ].
	^primary.! !

!ATAController class methodsFor: 'as yet unclassified' stamp: 'Pocho 7/16/2010 15:28'!
secondary
	secondary ifNil: [ secondary := self onPort: 16r170 ].
	^secondary.! !

!ATAController methodsFor: 'services' stamp: 'JavierPimas 11/8/2010 01:25'!
at: firstSectorNumber count: aNumberOfSectors of: aDeviceNumber 
	| answer remaining alreadyRead nextBlockNumber |
	"The max we can read is 256 sectors (thats an ATA limit). If we want to read more, we do it by grabing chunks of 256 sectors until we finish."
	"Transcript show: 'Reading from: ', firstBlockNumber asString, ' to: ', lastBlockNumber asString, Character cr asString."
	"self halt."
	remaining := aNumberOfSectors .
	alreadyRead := 0.
	
	answer := ByteString new: remaining * self sectorSize.
	nextBlockNumber := firstSectorNumber - 1.

	[ remaining > 0 ] whileTrue: [ | chunkSize | 
		"Transcript show: 'Reading sector ', (nextBlockNumber - 1) asString, Character cr asString."
		chunkSize := remaining min: 256.
		answer 
			replaceFrom: (self byteOffsetOfBlock: alreadyRead + 1)
			to: (self byteOffsetOfBlock: alreadyRead + chunkSize + 1) - 1
			with: (self issueReadFrom: nextBlockNumber count: chunkSize device: aDeviceNumber timeout: self readMillisecondsTimeout)
			startingAt: 1.
		nextBlockNumber := nextBlockNumber + chunkSize.
		alreadyRead := alreadyRead + 256.
		remaining := remaining - 256. 
		].
	"Transcript show: '... done
	'."
	^ answer.! !

!ATAController methodsFor: 'services' stamp: 'JavierPimas 11/8/2010 01:02'!
at: firstSectorNumber of: aDeviceNumber putAll: aByteArray
	| nextSectorNumber |
	nextSectorNumber := firstSectorNumber - 1. "Decrement 1 because block num comes 1-based and LBA indexes are 0-based"
	self groupsOfMax: 256 * 512 atATimeIn: aByteArray do: [ :sectorContents |
		self
			issueWrite: sectorContents
			at: nextSectorNumber
			device: aDeviceNumber
			timeout: self writeMillisecondsTimeout.
			nextSectorNumber := nextSectorNumber + 256.
	].


	
! !

!ATAController methodsFor: 'registers' stamp: 'Pocho 3/25/2010 23:16'!
atCommandRegPut: aSmallInteger
	"When the host request a command it is transferred to the hard drive through an eight bit code written to the command register. As soon as the drive receives a command in its command register, it begins execution of the command. The following table lists the commands in alphabetical order and the parameters for each executable command:"

	^ self byteAt: 7 put: aSmallInteger
	
	"
	+--------+---------------------------------+-----------------+
	| Command| Command Description             | Parameters Used 
	| Code   |                                 | PC SC SN CY DH  
	+--------+---------------------------------+-----------------+
	| 98h  @ | Check Power Mode                |    V        D   
	| E5h  @ | Check Power Mode (same as 98h)  |    V        D   
	| 90h    | Execute Drive Diagnostic        |             D+  
	| 50h    | Format Track                    |          V  V   
	| ECh  @ | Identify Drive                  |             D   
	| 97h  @ | Idle                            |    V        D   
	| E3h  @ | Idle (same as 97h)              |    V        D   
	| 95h  @ | Idle Immediate                  |             D   
	| E1h  @ | Idle Immadiate (same as 95h)    |             D   
	| 91h    | Initialize Drive Parameters     |    V        V   
	| E4h  @ | Read Buffer                     |             D   
	| C8h  @ | Read DMA With Retry             |  >> Unknown <<  
	| C9h  @ | Read DMA                        |  >> Unknown <<  
	| C4h  @ | Read Multiple                   |    V  V  V  V   
	| 20h    | Read Sectors With Retry         |    V  V  V  V   
	| 21h    | Read Sectors                    |    V  V  V  V   
	| 22h    | Read Long With Retry            |    V  V  V  V   
	| 23h    | Read Long                       |    V  V  V  V   
	| 40h    | Read Verify Sectors With Retry  |    V  V  V  V   
	| 41h    | Read Verify Sectors             |    V  V  V  V   
	| 1Xh    | Recalibrate                     |             D   
	| 7Xh    | Seek                            |          V  V   
	| EFh  @ | Set Features                    |  V          D   
	| C6h  @ | Set Multiple Mode               |    V        D   
	| 99h  @ | Set Sleep Mode                  |             D   
	| E6h  @ | Set Sleep Mode (same as 99h)    |             D   
	| 96h  @ | Standby                         |    V        D   
	| E2h  @ | Standby (same as 96h)           |    V        D   
	| 94h  @ | Standby Immediate               |             D   
	| E0h  @ | Standby Immediate (same as 94h) |             D   
	| 8Xh    | Vendor Unique                   |  >> Unknown <<  
	| 9Ah    | Vendor Unique                   |  >> Unknown <<  
	| C0h    | Vendor Unique                   |  >> Unknown <<  
	| C1h    | Vendor Unique                   |  >> Unknown <<  
	| C2h    | Vendor Unique                   |  >> Unknown <<  
	| C3h    | Vendor Unique                   |  >> Unknown <<  
	| F5h    | Vendor Unique                   |  >> Unknown <<  
	| F6h    | Vendor Unique                   |  >> Unknown <<  
	| F7h    | Vendor Unique                   |  >> Unknown <<  
	| F8h    | Vendor Unique                   |  >> Unknown <<  
	| F9h    | Vendor Unique                   |  >> Unknown <<  
	| FAh    | Vendor Unique                   |  >> Unknown <<  
	| FBh    | Vendor Unique                   |  >> Unknown <<  
	| FCh    | Vendor Unique                   |  >> Unknown <<  
	| FDh    | Vendor Unique                   |  >> Unknown <<  
	| FEh    | Vendor Unique                   |  >> Unknown <<  
	| FFh    | Vendor Unique                   |  >> Unknown <<  
	| E8h  @ | Write Buffer                    |             D   
	| CAh  @ | Write DMA With Retry            |  >> Unknown <<  
	| CBh  @ | Write DMA                       |  >> Unknown <<  
	| C5h  @ | Write Multiple                  |    V  V  V  V   
	| E9h  @ | Write Same                      |  >> Unknown <<  
	| 30h    | Write Sectors With Retry        |    V  V  V  V   
	| 31h    | Write Sectors                   |    V  V  V  V   
	| 32h    | Write Long With Retry           |    V  V  V  V   
	| 33h    | Write Long                      |    V  V  V  V   
	| 3Ch  @ | Write Verify                    |    V  V  V  V   
	+--------+---------------------------------+-----------------+
	"! !

!ATAController methodsFor: 'registers' stamp: 'Pocho 3/29/2010 20:45'!
atCylinderHighReg
	^ self byteAt: 5! !

!ATAController methodsFor: 'registers' stamp: 'Pocho 3/29/2010 20:46'!
atCylinderHighRegPut: aSmallInteger
	^ self byteAt: 5 put: aSmallInteger! !

!ATAController methodsFor: 'registers' stamp: 'Pocho 3/29/2010 20:46'!
atCylinderLowReg
	^ self byteAt: 4! !

!ATAController methodsFor: 'registers' stamp: 'Pocho 3/29/2010 20:46'!
atCylinderLowRegPut: aSmallInteger
	^ self byteAt: 4 put: aSmallInteger! !

!ATAController methodsFor: 'registers' stamp: 'Pocho 3/25/2010 22:43'!
atDataPortRegRead: anAmount
	"Read amount of shorts from data register."
	^ self shortStringAt: 0 size: anAmount.! !

!ATAController methodsFor: 'registers' stamp: 'Pocho 3/25/2010 23:22'!
atDataPortRegWrite: aString
	^ self shortStringAt: 0 put: aString! !

!ATAController methodsFor: 'registers' stamp: 'Pocho 4/2/2010 00:43'!
atDriveHeadReg
	"Drive/Head head register, Offset 6, 8 bits.
	 This register contains the drive and head numbers. The contents of this
	 register define the number of heads minus 1, when executing an Initialize
	 Drive Parameters command.
	
	 Upon command completion this register is updated to refplect the head number currently
	 selected.
	"

	^ self byteAt: 6.
	
	"
	+-----------------------------------------+
	| 7 | 6  | 5 |  4   |   3  |   2  |  1  |  0  |
	|---+---+---+-----+-----+-----+-----+-----|
	| 1 | L | 1 | DRV | HS3 | HS2 | HS1 | HS0 |
	+-----------------------------------------+

	- L is the binary encoded address mode select. When L=0, addressing is
	by CHS mode. When L=1, addressing is by LBA mode.
	- DRV is the binary encoded drive select number. When DRV-0, Drive 0 is
	selected. When DRV=1, Drive 1 is selected.
	- If L=0, HS3 through HS0 contain the binary coded address of the head to
	be selected e.g., if HS3 through HS0 are 0011b, respectively, head 3
	will be selected. HS3 is the most significant bit. At command
	completion, these bits are updated to reflect the currently selected
	head.
	- If L=1, HS3 through HS0 contain bits 24-27 of the LBA. At command
	completion, these bits are updated to reflect the current LBA bits
	24-27.
	"! !

!ATAController methodsFor: 'registers' stamp: 'Pocho 4/2/2010 00:44'!
atDriveHeadRegPut: aValue
	"Drive/Head head register, Offset 6, 8 bits.
	 This register contains the drive and head numbers. The contents of this
	 register define the number of heads minus 1, when executing an Initialize
	 Drive Parameters command.
	
	 Upon command completion this register is updated to refplect the head number currently
	 selected.
	"
	^ self byteAt: 6 put: aValue.
	
	"
	+-----------------------------------------+
	| 7 | 6  | 5 |  4   |   3  |   2  |  1  |  0  |
	|---+---+---+-----+-----+-----+-----+-----|
	| 1 | L | 1 | DRV | HS3 | HS2 | HS1 | HS0 |
	+-----------------------------------------+

	- L is the binary encoded address mode select. When L=0, addressing is
	by CHS mode. When L=1, addressing is by LBA mode.
	- DRV is the binary encoded drive select number. When DRV-0, Drive 0 is
	selected. When DRV=1, Drive 1 is selected.
	- If L=0, HS3 through HS0 contain the binary coded address of the head to
	be selected e.g., if HS3 through HS0 are 0011b, respectively, head 3
	will be selected. HS3 is the most significant bit. At command
	completion, these bits are updated to reflect the currently selected
	head.
	- If L=1, HS3 through HS0 contain bits 24-27 of the LBA. At command
	completion, these bits are updated to reflect the current LBA bits
	24-27.
	"
	! !

!ATAController methodsFor: 'registers' stamp: 'Pocho 3/29/2010 20:46'!
atSectorNumberReg
	^ self byteAt: 3! !

!ATAController methodsFor: 'registers' stamp: 'Pocho 3/29/2010 20:46'!
atSectorNumberRegPut: aSmallInteger
	^ self byteAt: 3 put: aSmallInteger! !

!ATAController methodsFor: 'registers' stamp: 'Pocho 3/25/2010 23:12'!
atStatusReg
	"Contains information about the status of the drive and controller. The contents of
	 this register are updated at the completion of each command. When the busy bit
	 is set, no other bits in the Command Block Registers are valid. When the busy bit
	 is not set, the information in the Status Register and Command Block Registers is valid."
	
	^ self byteAt: 7
	
	"
	+-----+----------+----------------------------------------------------------+
	| BIT | Mnemonic | Description                                              
	+-----+----------+----------------------------------------------------------+
	|  7  |  BUSY    | Busy bit. Set by the controller logic of the drive when  
	|     |          | ever the drive has access to and the host is locked out 
	|     |          | of the Command Block Registers. Set under the following  
	|     |          | conditions:                                              
	|     |          |  o Within 400 nsec after the negation of RESET or after  
	|     |          |    SRST is set in the Device Control Register. After a   
	|     |          |    reset it is recomended that BUSY be set no more than  
	|     |          |    30 seconds.                                           
	|     |          |  o Within 400 nsec of a host write to the Command        
	|     |          |    Register with a Recalibrate, Read Long, Read Buffer,  
	|     |          |    Read, Read Verify, Initialize Drive Parameters, Seek  
	|     |          |    Identify Drive, or Execute Drive Diagnostic command.  
	|     |          |  o Within 5 microseconds following the transfer of 512   
	|     |          |    bytes of data during the execution of a Write, Write  
	|     |          |    Buffer or Format Track command; or 512 bytes of data  
	|     |          |    and the appropriate number of ECC bytes during the    
	|     |          |    execution of a Write Long command.                    
	|     |          |    When BUSY is set no Command Block Register can be     
	|     |          |    written too and a read of any Command Block Register  
	|     |          |    returns the contents of the Status Register.          
	|     |          |                                                          
	|  6  |  DRDY    | Drive Ready bit. Indicates that the drive is ready to    
	|     |          | accept commands. When and error occurs, this bit stays   
	|     |          | unchanged until the host reads the Status Register then  
	|     |          | again indicates that hte drive is ready. On power up,    
	|     |          | this bit should be cleared and should remain cleared     
	|     |          | until the drive is up to speed and ready to accept a     
	|     |          | command.                                                 
	|     |          |                                                          
	|  5  |  DWF     | Drive Write Fault bit. When an error occurs, this bit    
	|     |          | remains unchanged until the host reads the Status        
	|     |          | Register, then again indicates the current write fault   
	|     |          | status.                                                  
	|     |          |                                                          
	|  4  |  DSC     | Drive Seek Complete bit. This bit is set when a seek     
	|     |          | operation is complete and the heads are settled over a   
	|     |          | track. When an error occurs, this bit remains unchanged  
	|     |          | until the host reads the Status Register, then again it  
	|     |          | indicates the current seek complete status.              
	|     |          |                                                          
	|  3  |  DRQ     | Data Request bit. When set it indicates that the drive   
	|     |          | is ready to transfer a word or byte of data between the  
	|     |          | host and the data port.                                  
	|     |          |                                                          
	|  2  |  CORR    | Corrected Data bit. When a correctable data error has    
	|     |          | been encountered and the data has been corrected, this   
	|     |          | bit is set. This condition does not terminate a multi    
	|     |          | sector read operation.                                   
	|     |          |                                                          
	|  1  |  INDEX   | Index bit. Set when the index mark is detected once per  
	|     |          | disk revolution.                                         
	|     |          |                                                          
	|  0  |  ERROR   | Error bit. When set indicates that the previous command  
	|     |          | ended in an error. The other bits in the Error Register  
	|     |          | and Status Register contain additional information about 
	|     |          | the cause of the error.                                  
	+-----+----------+----------------------------------------------------------+
	"! !

!ATAController methodsFor: 'accessing' stamp: 'JavierPimas 10/28/2010 13:00'!
blockSize
	^512! !

!ATAController methodsFor: 'status/testing' stamp: 'Pocho 4/2/2010 04:16'!
busy: aStatus
	^ aStatus anyMask: 128.! !

!ATAController methodsFor: 'private' stamp: 'JavierPimas 11/8/2010 01:26'!
byteOffsetOfBlock: aBlockNumber
	"Returns the position of the first byte of the block"
	^ aBlockNumber - 1 * self blockSize + 1.! !

!ATAController methodsFor: 'commands' stamp: 'Pocho 3/25/2010 23:19'!
cmdDeviceReset
	^ self atCommandRegPut: 16r08! !

!ATAController methodsFor: 'commands' stamp: 'Pocho 3/25/2010 23:19'!
cmdIdentifyDevice
	^ self atCommandRegPut: 16rEC! !

!ATAController methodsFor: 'commands' stamp: 'Pocho 3/25/2010 23:19'!
cmdReadSectorsWithRetry
	^ self atCommandRegPut: 16r20! !

!ATAController methodsFor: 'commands' stamp: 'Pocho 3/25/2010 23:18'!
cmdWriteSectorsWithRetry
	^ self atCommandRegPut: 16r30! !

!ATAController methodsFor: 'status/testing' stamp: 'Pocho 3/25/2010 23:01'!
dataReady: aStatus
	^ aStatus anyMask: 8.! !

!ATAController methodsFor: 'status/testing' stamp: 'Pocho 7/9/2010 22:48'!
driveReady: aStatus
	^ aStatus anyMask: 64.! !

!ATAController methodsFor: 'registers' stamp: 'Pocho 3/29/2010 20:47'!
error
	^ self byteAt: 1! !

!ATAController methodsFor: 'status/testing' stamp: 'Pocho 3/25/2010 23:01'!
errorOccurred: aStatus
	^ aStatus anyMask: 1.! !

!ATAController methodsFor: 'status/testing' stamp: 'Pocho 3/25/2010 23:01'!
errorsDidntOccur: aStatus
	^ aStatus noMask: 1.! !

!ATAController methodsFor: 'services' stamp: 'JavierPimas 11/8/2010 01:17'!
from: firstSectorNumber to: lastSectorNumber device: aDeviceNumber
	^ self at: firstSectorNumber count: lastSectorNumber - firstSectorNumber + 1 of: aDeviceNumber.! !

!ATAController methodsFor: 'private' stamp: 'JavierPimas 11/2/2010 00:39'!
groupsOf: n atATimeIn: aByteArray do: aBlock 
	"Evaluate aBlock with my elements taken n at a time. Ignore any leftovers at the end. Taken from SequenceableCollection but highly optimized."
	| args |
	args := ByteArray new: n.
	n to: aByteArray size by: n do: [:index |
		args replaceFrom: 1
			 to: n
			 with: aByteArray
			 startingAt: index - n + 1.
		aBlock value: args.
	]
! !

!ATAController methodsFor: 'private' stamp: 'JavierPimas 11/8/2010 01:02'!
groupsOfMax: n atATimeIn: aByteArray do: aBlock
	"Evaluate aBlock with my elements taken n at a time. Also evaluate with leftover elements at end"
	| leftover |
	leftover := aByteArray size \\ n.
	n
		to: aByteArray size
		by: n
		do: [:index | 
			| args |
			args := (aByteArray copyFrom: index - n + 1 to: index).
			aBlock value: args
		].
	
	(leftover > 0) ifTrue: [
		aBlock value: (aByteArray copyFrom: aByteArray size - leftover + 1 to: aByteArray size)
	].

! !

!ATAController methodsFor: 'services' stamp: 'JavierPimas 10/28/2010 12:45'!
issueReadFrom: firstSector count: sectorsCount device: deviceNumber timeout: timeout
	^self waitUntilNotBusyOr: timeout;
		 sectorCount: sectorsCount;
		 selectSector: firstSector ofDrive: deviceNumber;
		 waitUntilReadyOr: timeout;
		 cmdReadSectorsWithRetry;
		 readAllAvailable: sectorsCount.
	
! !

!ATAController methodsFor: 'services' stamp: 'Pocho 7/13/2010 19:14'!
issueWrite: aByteArray at: firstSector device: deviceNumber timeout: aTimeout
	"Transcript show: 'going to write ', aByteArray size printString, ' bytes: ', aByteArray asString printString, ' at: ', firstSector printString, '
	'."
	self waitUntilNotBusyOr: aTimeout;
		selectSector: firstSector ofDrive: deviceNumber;
		sectorCount: aByteArray size // 512;
		waitUntilReadyOr: aTimeout;
		cmdWriteSectorsWithRetry;
		writeAllAvailable: aByteArray.

	
! !

!ATAController methodsFor: 'device creation' stamp: 'Pocho 3/27/2010 16:27'!
master
	^ATADevice controlledBy: self device: 0.! !

!ATAController methodsFor: 'status/testing' stamp: 'Pocho 7/22/2010 01:38'!
moreDataIsAvailable
	"We should remove this method, it does the same than waitUntilDataTransferIsReady"
	| status time |
	time := 0.
	[status := self atStatusReg. (self busy: status) & (self errorsDidntOccur: status) and: [ time < 10 ]] whileTrue:
		[time := time + 1. (Delay forMilliseconds: 1) wait ]..
	(self errorOccurred: status) ifTrue: [self error: 'An error occurred while reading'].
	time >= 10 ifTrue: [Transcript show: 'Read timeout. Status: ', status, Character cr ].
	"tells wheter data port contains more data available. This happens if:"
	 ^ (self dataReady: status)" & (self errorsDidntOccur: status)".! !

!ATAController methodsFor: 'private' stamp: 'Pocho 4/2/2010 04:14'!
readAllAvailable
	| answer |
	answer := ''.
	[ self moreDataIsAvailable ] whileTrue: [answer := answer, self readSector].
	(answer = '') ifTrue: [
		 Transcript show: 'Status: ', self atStatusReg asString, Character cr asString.
		 self error: 'No grabe nada' ].
	^answer.
! !

!ATAController methodsFor: 'private' stamp: 'JavierPimas 10/28/2010 13:50'!
readAllAvailable: sectorCount
	| answer nextPosition |
	answer := ByteString new: sectorCount * self sectorSize.
	nextPosition := 1.
	[ self moreDataIsAvailable ] whileTrue: [
		answer replaceFrom: nextPosition to: nextPosition + self sectorSize - 1 with: self readSector startingAt:1.
		nextPosition := nextPosition + self sectorSize.
	].
	(answer = '') ifTrue: [
		 Transcript show: 'Status: ', self atStatusReg asString, Character cr asString.
		 self error: 'No grabe nada' ].
	^answer.
! !

!ATAController methodsFor: 'private' stamp: 'JavierPimas 11/8/2010 01:06'!
readMillisecondsTimeout
	"Max amount of milliseconds to wait for ready status when trying to read a sector"
	^5000! !

!ATAController methodsFor: 'accessing' stamp: 'Pocho 3/25/2010 22:44'!
readSector
	^ self atDataPortRegRead: 512! !

!ATAController methodsFor: 'accessing' stamp: 'Pocho 3/25/2010 20:59'!
resetDevice: aDriveNumber
	^self
		selectDrive: aDriveNumber;
		cmdDeviceReset! !

!ATAController methodsFor: 'registers' stamp: 'Pocho 3/29/2010 20:47'!
sectorCount
	^ self byteAt: 2! !

!ATAController methodsFor: 'registers' stamp: 'Pocho 3/29/2010 21:15'!
sectorCount: aSmallInteger
	"We handle special case when we want to read 256 sectors, which is done by puting a 0 in
	 sector count register"
	aSmallInteger = 256 ifTrue: [^ self byteAt: 2 put: 0].
	^ self byteAt: 2 put: aSmallInteger! !

!ATAController methodsFor: 'registers' stamp: 'Pocho 3/29/2010 20:47'!
sectorNumber
	^ self byteAt: 3! !

!ATAController methodsFor: 'registers' stamp: 'Pocho 3/29/2010 20:47'!
sectorNumber: aSmallInteger
	^ self byteAt: 3 put: aSmallInteger! !

!ATAController methodsFor: 'registers' stamp: 'JavierPimas 10/28/2010 13:51'!
sectorSize
	^512! !

!ATAController methodsFor: 'accessing' stamp: 'Pocho 3/25/2010 20:59'!
selectDrive: aDriveNumber
	"Select master or slave (aDriveNumber is 0 or 1 respectively). See 
	 atDriveHeadRegPut for more details"
	^ self atDriveHeadRegPut: aDriveNumber << 4.! !

!ATAController methodsFor: 'accessing' stamp: 'Pocho 3/25/2010 20:53'!
selectHead: aHeadNumber ofDevice: aDeviceNumber
	"select head of drive. See atDriveHeadRegPut: for more details."
	^ self atDriveHeadRegPut: aDeviceNumber << 4 + aHeadNumber.! !

!ATAController methodsFor: 'accessing' stamp: 'Pocho 3/28/2010 15:27'!
selectSector: lbaAddress ofDrive: aDriveNumber

	"LBA Addressing: 28 bits. 
	<4 bits: head> < 8 bits: cyl high> <8 bits: cyl low> <8 bits: sector>
	We add 4 to drive number so that the bit of LBA addressing mode is asserted inside selectHead.
	"

	self
		atSectorNumberRegPut: (lbaAddress bitAnd: 16rFF);
		atCylinderLowRegPut: ((lbaAddress bitShift: -8) bitAnd: 16rFF);
		atCylinderHighRegPut: ((lbaAddress bitShift: -16) bitAnd: 16rFF);
		selectHead: ((lbaAddress bitShift: -24) bitAnd: 16rF) ofDevice: aDriveNumber + 4.! !

!ATAController methodsFor: 'status/testing' stamp: 'Pocho 3/25/2010 17:01'!
selectedDevice
	^ self atDriveHeadReg >> 4 bitAnd: 1.! !

!ATAController methodsFor: 'status/testing' stamp: 'Pocho 3/27/2010 14:49'!
selectedHead
	^ (self shortAt: 6) bitAnd: 2r1111! !

!ATAController methodsFor: 'device creation' stamp: 'Pocho 3/27/2010 16:27'!
slave
	^ATADevice controlledBy: self device: 1.! !

!ATAController methodsFor: 'status/testing' stamp: 'Pocho 7/13/2010 12:21'!
waitUntilDataTransferIsReady
	| status |
	[
		status := self atStatusReg.
		(self busy: status) &
		(self errorsDidntOccur: status)
	] whileTrue.
	(self errorOccurred: status) ifTrue: [self error: 'An error occurred while reading'].
	 ^self dataReady: status.! !

!ATAController methodsFor: 'services' stamp: 'Pocho 7/22/2010 12:26'!
waitUntilNotBusyOr: maxMilliseconds
	| time status |
	time := Time millisecondClockValue.
	
	[ status := self atStatusReg. (self busy: status) and: [ Time millisecondClockValue - time < maxMilliseconds ] ] whileTrue.
	"Time millisecondClockValue - time >= maxMilliseconds ifTrue: [Transcript show: 'Not busy timeout. Status: ', status, Character cr ]."! !

!ATAController methodsFor: 'services' stamp: 'Pocho 7/22/2010 12:26'!
waitUntilReadyOr: maxMilliseconds
	| time status |
	time := Time millisecondClockValue.
	
	[ status := self atStatusReg. (self driveReady: status) not and: [ Time millisecondClockValue - time < maxMilliseconds ] ] whileTrue.
	
	"Time millisecondClockValue - time >= maxMilliseconds ifTrue: [Transcript show: 'Ready timeout. Status: ', status, Character cr ]."! !

!ATAController methodsFor: 'private' stamp: 'JavierPimas 11/2/2010 00:34'!
writeAllAvailable: aByteArray
	self groupsOf: 512 atATimeIn: aByteArray do: [ :sectorContents |
		self waitUntilDataTransferIsReady.
		self atDataPortRegWrite: sectorContents.
	].
! !

!ATAController methodsFor: 'accessing' stamp: 'Pocho 3/26/2010 00:35'!
writeDataOld: source fromByte: sourceOffset atByteOffset: destOffset bytesCount: count on: aDriveNumber
	"Write count bytes from source starting at startIndex bytes. We handle half sector
	 overwriting. Should be optimized so it doesn't write intermediate sectors (which will
	 be completely overwritten)."
	| data sector sectorCount startOffset |
	sector := self offsetToSector: destOffset.
	sectorCount := (self offsetToSector: count) + 1.
	data := self
		sectorCount: sectorCount;
		selectSector: sector ofDrive: aDriveNumber;
		cmdReadSectorsWithRetry;
		readAllAvailable.
	startOffset := destOffset \\ 512 + 1.
	data
		replaceFrom: startOffset
		to: startOffset + count - 1
		with: source
		startingAt: sourceOffset.
		
	self
		sectorCount: sectorCount;
		selectSector: sector ofDrive: aDriveNumber;
		cmdWriteSectorsWithRetry;
		atDataPortRegWrite: data.
		
	^count.! !

!ATAController methodsFor: 'private' stamp: 'JavierPimas 11/8/2010 01:06'!
writeMillisecondsTimeout
	"Max amount of milliseconds to wait for ready status when trying to read a sector"
	^5000! !

!ATAController methodsFor: 'registers' stamp: 'gera 11/14/2008 21:17'!
writePrecompensation: aSmallInteger
	^ self shortAt: 1 put: aSmallInteger! !

PCIDevice subclass: #NetworkingDevice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Network'!

NetworkingDevice subclass: #LancePCIDevice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Network'!

!LancePCIDevice commentStamp: 'gera 7/6/2006 10:06' prior: 0!
Only "working" for PCI, however, we use 16 bits mode so it's more compatible with older ISA cards, try with:

LancePCIDevice installOn: Computer current.
Computer current defaultNetworkInterface macAddress hex.

Information from:

GRUB Legacy's source in netboot/lance.c netboot/pci.c and netboot/config.c
(from this sources, we are assuming PCI, and with that ENABLE_AUTOSELECT and no MUST_UNREST)

Am79C972
http://www.amd.com/us-en/assets/content_type/white_papers_and_tech_docs/21485_pt1.pdf
http://www.amd.com/us-en/assets/content_type/white_papers_and_tech_docs/21485_pt2.pdf
Specially pages starting at: 91 of part 1

Am79C970
http://www.amd.com/files/connectivitysolutions/networking/archivednetworking/19436.pdf

More Tech Info from AMD:
http://www.amd.com/us-en/ConnectivitySolutions/DesignWithAMD (Networking Tech Docs, Archived Tech Docs)!

!LancePCIDevice class methodsFor: 'as yet unclassified' stamp: 'LC 8/23/2008 16:27'!
deviceId
	^ 16r2000! !

!LancePCIDevice class methodsFor: 'as yet unclassified' stamp: 'gera 7/2/2006 15:53'!
vendorId
	^ 16r1022! !

!LancePCIDevice methodsFor: 'accessing - basic' stamp: 'gera 7/18/2006 12:11'!
address
	^ self shortAt: 16r12! !

!LancePCIDevice methodsFor: 'accessing - basic' stamp: 'gera 7/18/2006 12:12'!
address: word
	^ self shortAt: 16r12 put: word ! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 08:49'!
anyError
	"bit 15 - ERR
	Error is set by the ORing of BABL, CERR, MISS, and MERR.
	ERR remains set as long as any of the error flags are true.
	Read accessible always. ERR is read only. Write operations are
	ignored."

	^ self statusBit: 15! !

!LancePCIDevice methodsFor: 'accessing - bus control' stamp: 'gera 7/9/2006 19:12'!
automaticMediaSelection
	^ self miscConfiguration: (self miscConfiguration bitOr: 2r10)! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 08:50'!
bablError
	"bit 14 - BABL
	Babble is a transmitter time-out error. BABL is set by the
	PCnet-PCI II controller when the    (CSR112) also increments each
	transmitter has been on the channel longer than the time required
	to send the maximum length frame. BABL will be set if 1519 bytes or
	greater are transmitted.

	When BABL is set, INTA is asserted if IENA is ONE and the
	mask bit BABLM (CSR3, bit 14) is ZERO. BABL assertion will set
	the ERR bit, regardless of the settings of IENA and BABLM.

	Read/Write accessible always. BABL is cleared by the host by
	writing a ONE. Writing a ZERO has no effect. BABL is cleared by
	H_RESET, S_RESET or by setting the STOP bit."

	^ self statusBit: 14! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 23:57'!
bablErrorReset
	^ self statusBitSet: 14! !

!LancePCIDevice methodsFor: 'accessing - bus control' stamp: 'gera 7/18/2006 12:11'!
busControlData
	^ self shortAt: 16r16! !

!LancePCIDevice methodsFor: 'accessing - bus control' stamp: 'gera 7/18/2006 12:12'!
busControlData: word
	^ self shortAt: 16r16 put: word! !

!LancePCIDevice methodsFor: 'accessing - bus control' stamp: 'gera 7/6/2006 10:36'!
busControlWord: index
	self address: index.
	^ self busControlData! !

!LancePCIDevice methodsFor: 'accessing - bus control' stamp: 'gera 7/6/2006 10:37'!
busControlWord: index put: word
	^ self
		address: index;
		busControlData: word.! !

!LancePCIDevice methodsFor: 'as yet unclassified' stamp: 'gera 7/6/2006 10:43'!
chipVersion
	self controlStatusAddress: 88.
	self controlStatusAddress ~= 88 ifTrue: [^ 0].	" version 0 does not reflect addresses "

	^ (self controlStatusWord: 89) << 16 + (self controlStatusWord: 88)! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 08:50'!
collisionError
	"bit 13 - CERR
	Collision Error is set by the PC=net-PCI II controller when the
	device operates in half-duplex mode and the collision inputs to
	the AUI port failed to activate within 20 network bit times after
	the chip terminated transmission (SQE Test). This feature is a
	transceiver test feature. CERR reporting is disabled when the
	AUI interface is active and the PCnet-PCI II controller operates in
	full-duplex mode.
	In 10BASE-T mode, for both half-duplex and full-duplex operation,
	CERR will be set after a transmission if the T-MAU is in Link Fail state.
	CERR assertion will not result in an interrupt being generated.
	CERR assertion will set the ERR bit.
	Read/Write accessible always. CERR is cleared by the host by
	writing a ONE. Writing a ZERO has no effect. CERR is cleared by
	H_RESET, S_RESET or by setting the STOP bit."

	^ self statusBit: 13! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 23:57'!
collisionErrorReset
	^ self statusBitSet: 13! !

!LancePCIDevice methodsFor: 'accessing - control status' stamp: 'gera 7/18/2006 12:11'!
controlStatusData
	^ self shortAt: 16r10! !

!LancePCIDevice methodsFor: 'accessing - control status' stamp: 'gera 7/18/2006 12:12'!
controlStatusData: word
	^ self shortAt: 16r10 put: word! !

!LancePCIDevice methodsFor: 'accessing - control status' stamp: 'gera 1/1/1901 01:25'!
controlStatusWord: index
	self address: index.
	^ self controlStatusData! !

!LancePCIDevice methodsFor: 'accessing - control status' stamp: 'gera 1/1/1901 01:26'!
controlStatusWord: index put: word
	^ self
		address: index;
		controlStatusData: word.! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 09:10'!
demandTransmition
	"bit 3 - TDMD
	Transmit Demand, when set, causes the buffer management
	unit to access the transmit descriptor ring without waiting for
	the poll-time counter to elapse. If TXON is not enabled, TDMD bit
	will be cleared and no transmit descriptor ring access will occur.
	If the DPOLL bit in CSR4 is set, automatic polling is disabled and
	TDMD can be used to start a transmission.
	Read/Write accessible always. TDMD is set by writing a ONE.
	Writing a ZERO has no effect. TDMD will be cleared by the buffer
	management unit when it polls a transmit descriptor. TDMD is
	cleared by H_RESET, S_RESET or by setting the STOP bit."
	^ self statusBitSet: 3! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 09:03'!
disableInterrupts
	^ self statusBitClear: 6! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 09:03'!
enableInterrupts
	"bit 6 - IENA
	Interrupt Enable allows INTA to be active if the Interrupt Flag is
	set. If IENA is cleared to ZERO, INTA will be disabled regardless
	of the state of INTR.
	Read/Write accessible always. IENA is set by writing a ONE and
	cleared by writing a ZERO. IENA is cleared by H_RESET,
	S_RESET or by setting the STOP bit."
	^ self statusBitSet: 6! !

!LancePCIDevice methodsFor: 'irq handling' stamp: 'gera 7/26/2006 17:26'!
handleIRQ
	| statusOnEntry |
	statusOnEntry := self status.
	[
	self receiveInterruptPending
		ifTrue: [self handleReceiveInterrupt].
	self transmitInterruptPending
		ifTrue: [].
	] on: Error do: [:ex | Transcript show: ex; cr].
	self status: statusOnEntry! !

!LancePCIDevice methodsFor: 'irq handling' stamp: 'gera 7/26/2006 10:39'!
handleReceiveInterrupt
	| ring pkt |
	ring := self initializationBlock receiveRing.
	ring isOwnedByHost ifTrue: [
		pkt := EthernetPacket bytes: ring message.
		ring beOwnedByCard.
		self input: pkt.
	].! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/10/2006 18:56'!
init
	" bit 0 - INIT
	INIT assertion enables the PCnet-PCI II controller to begin the
	initialization procedure which reads the initialization block from
	memory. Setting INIT clears the STOP bit. If STRT and INIT are
	set together, the PCnet-PCI II controller initialization will be
	performed first. INIT is not cleared. If when the initialization
	sequence has completed.
	Read/Write accessible always. INIT is set by writing a ONE.
	Writing a ZERO has no effect. INIT is cleared by H_RESET, S_RESET
	or by setting the STOP bit."

	^ self status: 1! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/10/2006 18:56'!
initAndStart
	"by spec. INIT+START clear STOP. INIT is done before START"
	^ self status: 3! !

!LancePCIDevice methodsFor: 'accessing - control status' stamp: 'gera 7/9/2006 18:55'!
initializationBlock
	^ self is16
		ifTrue: [LanceNICInitializationBlock16 fromHandle: (
			ExternalAddress new fromInteger: (self initializationBlockAddress))]
		ifFalse: [self notYetImplemented]
! !

!LancePCIDevice methodsFor: 'accessing - control status' stamp: 'gera 7/10/2006 03:54'!
initializationBlock: aLanceNICInitBlock
	aLanceNICInitBlock is16
		ifTrue: [
			self
				softwareStyleRegister: 0;
				initializationBlockAddress: aLanceNICInitBlock address]
		ifFalse: [self notYetImplemented]
! !

!LancePCIDevice methodsFor: 'accessing - control status' stamp: 'gera 7/10/2006 03:57'!
initializationBlockAddress
	^ (self controlStatusWord: 2) << 16 + (self controlStatusWord: 1)! !

!LancePCIDevice methodsFor: 'accessing - control status' stamp: 'gera 7/10/2006 03:57'!
initializationBlockAddress: addr
	^ self
		controlStatusWord: 1 put: (addr bitAnd: 16rFFFF);
		controlStatusWord: 2 put: (addr >> 16).! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 08:56'!
initializationDone
	"bit 8 - IDON
	Initialization Done is set by the PCnet-PCI II controller after the
	initialization sequence has completed. When IDON is set, the
	PCnet-PCI II controller has read the initialization block from mem-
	ory.
	When IDON is set, INTA is asserted if IENA is ONE and the
	mask bit IDONM (CSR3, bit 8) is ZERO.
	Read/Write accessible always. IDON is cleared by the host by
	writing a ONE. Writing a ZERO has no effect. IDON is cleared by
	H_RESET, S_RESET or by setting the STOP bit."
	^ self statusBit: 8! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 23:57'!
initializationDoneReset
	^ self statusBitSet: 8! !

!LancePCIDevice methodsFor: 'as yet unclassified' stamp: 'gera 7/27/2006 18:59'!
initialize
	| initBlock tring rring rbuf tbuf |

	rbuf := ExternalAddress allocate: 1536.
	rring := (LanceNICReceiveRingDescriptor16 externalNewAligned: 8)
		reset;
		buffer: rbuf;
		bufferSize: 1536;
		messageSize: 0;
		beOwnedByCard.

	tbuf := ExternalAddress allocate: 1536.
	tring := (LanceNICTransmitRingDescriptor16 externalNewAligned: 8)
		reset;
		buffer: tbuf;
		beOwnedByHost.
		
	initBlock := (LanceNICInitializationBlock16 externalNewAligned: 8)   
		mode: 0;		"auto media"
		macAddress: self macAddress;
		logicalAddressFilter: 0;
		transmitRing: tring;
		transmitRingLen: 0;
		receiveRing: rring;
		receiveRingLen: 0.

	self
		stop;
		initializationBlock: initBlock;
		testAndFeaturesControl: 2r0100111101111111;
		automaticMediaSelection;
		initAndStart.

	" 2r0100.1111.0111.1111 = (page 112 of Am79C790A pdf)
		0,1	No Jabber IRQ + reset Jabber flag.
		2,3	No Transmit Start IRQ + reset Transmit status.
		4,5	No Receive Collition Counter overflow IRQ + reset RCVCCO.
		6	Clear user interrupt flag.
		7	No User Interrupt Command.
		8,9	No Clear Missed Frame Counter overflow IRQ + clear MFCO.
		10	Auto Strip Receive Padding (may we want to see it?)
		11	Auto Pad Outgoing.
		12	No Disable Auto Transmit Polling
		13	No Enable Bus Timer
		14	Disable DMA Plus transfer counter.
		15	Disable EN124 (No Runt Packet Accept)
	"

	self enableInterrupts.! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 09:00'!
interruptPending
	"bit 7 - INTR
	Interrupt Flag indicates that one or more following interrupt
	causing conditions has occurred: BABL, EXDINT, IDON, JAB,
	MERR, MISS, MFCO, MPINT, RVCC, RINT, SINT, SLPINT, TINT,
	TXSTRT or UINT and the associated mask or enable bit is
	programmed to allow the event to cause an interrupt. If IENA is set
	to ONE and INTR is set, INTA will be active. When INTR is set by
	SINT or SLPINT, INTA will be active independent of the state of
	INEA.
	Read accessible always. INTR is read only. INTR is cleared by
	clearing all of the active individual interrupt bits that have not been
	masked out."
	^ self statusBit: 7! !

!LancePCIDevice methodsFor: 'accessing - bus control' stamp: 'gera 7/9/2006 18:57'!
is16
	^ (self softwareStyleRegister bitAnd: 16rF) isZero! !

!LancePCIDevice methodsFor: 'accessing - bus control' stamp: 'gera 7/9/2006 18:57'!
is32
	^ self is16 not! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 09:05'!
isReceiveEnabled
	"bit 5 - RXON
	Receive On indicates that the receive function is enabled. RXON
	is set to ONE if DRX (CSR15, bit 0) is cleared to ZERO after the
	START bit is set. If INIT and START are set together, RXON
	will not be set until after the initialization block has been read in.
	Read accessible always. RXON is read only. RXON is cleared by
	H_RESET, S_RESET or by setting the STOP bit."
	^ self statusBit: 5! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 09:06'!
isTransmitEnabled
	"bit 4 - TXON
	Transmit On indicates that the transmit function is enabled. TXON
	is set to ONE if DTX (CSR15, bit 1) is cleared to ZERO after the
	START bit is set. If INIT and START are set together, TXON
	will not be set until after the initialization block has been read in.
	Read accessible always. TXON is read only. TXON is cleared by
	H_RESET, S_RESET or by setting the STOP bit."
	^ self statusBit: 4! !

!LancePCIDevice methodsFor: 'as yet unclassified' stamp: 'gera 1/1/1901 01:25'!
isValid
	| ver |
	self reset: self reset.
	(self controlStatusWord: 0) ~= 4 ifTrue: [^ false].
	ver := self chipVersion.
	(ver isZero or: [(ver bitAnd: 16rFFF) == 3])
		ifFalse: [^ false].
	^ true! !

!LancePCIDevice methodsFor: 'accessing - basic' stamp: 'gera 7/16/2006 17:46'!
macAddress
	| answer |
	answer := self controlStatusWord: 14.
	answer := answer << 16 + (self controlStatusWord: 13).
	answer := answer << 16 + (self controlStatusWord: 12).
	^ EthernetAddress fromInteger: answer! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 08:51'!
memoryError
	"bit 11 - MERR
	Memory Error is set by the PCnet-PCI II controller when it re-
	quests the use of the system interface bus by asserting REQ
	and GNT has not been asserted after a programmable length of
	time. The length of time in microseconds before MERR is asserted
	will depend upon the setting of the Bus Timeout register
	(CSR100). The default setting of CSR100 will set MERR after
	153.6 s of bus latency.
	When MERR is set, INTA is asserted if IENA is ONE and the
	mask bit MERRM (CSR3, bit 11) is ZERO. MERR assertion will set
	the ERR bit, regardless of the settings of IENA and MERRM.
	Read/Write accessible always. MERR is cleared by the host by
	writing a ONE. Writing a ZERO has no effect. MERR is cleared
	by H_RESET, S_RESET or by setting the STOP bit."

	^ self statusBit: 11! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 23:57'!
memoryErrorReset
	^ self statusBitSet: 11! !

!LancePCIDevice methodsFor: 'accessing - bus control' stamp: 'gera 7/10/2006 03:34'!
miscConfiguration
	^ self busControlWord: 2! !

!LancePCIDevice methodsFor: 'accessing - bus control' stamp: 'gera 7/10/2006 03:35'!
miscConfiguration: config
	^ self busControlWord: 2 put: config! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 08:50'!
missedFrameError
	"bit 12 - MISS
	Missed Frame is set by the PCnet-PCI II controller when it
	looses an incoming receive frame because a receive descriptor was
	not available. This bit is the only immediate indication that receive
	data has been lost since there is no current receive descriptor.
	The Missed Frame Counter (CSR112) also increments each
	time a receive frame is missed.
	When MISS is set, INTA is asserted if IENA is ONE and the mask
	bit MISSM (CSR3, bit 12) is ZERO. MISS assertion will set the
	ERR bit, regardless of the settings of IENA and MISSM.
	Read/Write accessible always. MISS is cleared by the host by
	writing a ONE. Writing a ZERO has no effect. MISS is cleared by
	H_RESET, S_RESET or by setting the STOP bit."

	^ self statusBit: 12! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 23:58'!
missedFrameErrorReset
	^ self statusBitSet: 12! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 08:51'!
receiveInterruptPending
	"bit 10 - RINT
	Receive Interrupt is set by the PCnet-PCI II controller after the
	last descriptor of a receive frame has been updated by writing a
	ZERO to the OWN bit. RINT may also be set when the first descriptor
	of a receive frame has been updated by writing a ZERO to the
	OWN bit if the LAPPEN bit of CSR3 has been set to ONE.
	When RINT is set, INTA is asserted if IENA is ONE and the mask
	bit RINTM (CSR3, bit 10) is ZERO.
	Read/Write accessible always. RINT is cleared by the host by
	writing a ONE. Writing a ZERO has no effect. RINT is cleared by
	H_RESET, S_RESET or by setting the STOP bit."
	^ self statusBit: 10! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 23:58'!
receiveInterruptPendingReset
	^ self statusBitSet: 10! !

!LancePCIDevice methodsFor: 'accessing - basic' stamp: 'gera 1/1/1901 00:05'!
reset
	^ self byteAt: 16r14! !

!LancePCIDevice methodsFor: 'accessing - basic' stamp: 'gera 1/1/1901 00:06'!
reset: byte
	^ self byteAt: 16r14 put: byte! !

!LancePCIDevice methodsFor: 'as yet unclassified' stamp: 'gera 7/26/2006 10:38'!
sendNow: anEthernetPacket
	self initializationBlock transmitRing message: anEthernetPacket asString! !

!LancePCIDevice methodsFor: 'accessing - bus control' stamp: 'gera 7/10/2006 03:44'!
softwareStyleRegister
	^ self busControlWord: 20! !

!LancePCIDevice methodsFor: 'accessing - bus control' stamp: 'gera 7/10/2006 03:44'!
softwareStyleRegister: newStyle
	^ self busControlWord: 20 put: newStyle! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/10/2006 18:56'!
start
	" bit 1 - STRT
	STRT assertion enables the PCnet-PCI II controller to send and
	receive frames and perform buffer management operations. Set-
	ting STRT clears the STOP bit. If STRT and INIT are set together,
	the PCnet-PCI II controller initialization will be performed first.
	Read/Write accessible always. STRT is set by writing a ONE.
	Writing a ZERO has no effect. STRT is cleared by H_RESET,
	S_RESET or by setting the STOP bit."

	^ self statusBitSet: 2! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/10/2006 18:55'!
status
	^ self controlStatusWord: 0! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/10/2006 18:56'!
status: status
	^ self controlStatusWord: 0 put: status! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/10/2006 18:57'!
statusBit: index
	^ self status anyMask: 1 << index! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/10/2006 18:56'!
statusBitClear: index
	^ self status: (self status bitAnd: (1 << index) bitInvert)! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/10/2006 18:56'!
statusBitSet: index
	^ self status: (self status bitOr: 1 << index)! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/10/2006 18:57'!
stop
	" bit 2 - STOP
	STOP assertion disables the chip from all DMA and network activi	ty.
	The chip remains inactive until 	either STRT or INIT are set. If STOP,
	STRT and INIT are all set together, STOP will override STRT and INIT.
	Read/Write accessible always. STOP is set by writing a ONE, by
	H_RESET or S_RESET. Writing a ZERO has no effect. STOP is
	cleared by setting either STRT or INIT."

	^ self status: 4! !

!LancePCIDevice methodsFor: 'accessing - control status' stamp: 'gera 7/9/2006 19:06'!
testAndFeaturesControl
	^ self controlStatusWord: 4! !

!LancePCIDevice methodsFor: 'accessing - control status' stamp: 'gera 7/9/2006 19:06'!
testAndFeaturesControl: word
	^ self controlStatusWord: 4 put: word! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 08:52'!
transmitInterruptPending
	"bit 9 - TINT
	Transmit Interrupt is set by the PCnet-PCI II controller after the
	OWN bit in the last descriptor of a transmit frame has been cleared
	to indicate the frame has been sent or an error occurred in the
	transmission. When TINT is set, INTA is asserted if IENA is ONE
	and the mask bit TINTM (CSR3,bit 9) is ZERO."
	^ self statusBit: 9! !

!LancePCIDevice methodsFor: 'accessing - status' stamp: 'gera 7/13/2006 23:58'!
transmitInterruptPendingReset
	^ self statusBitSet: 9! !

!NetworkingDevice class methodsFor: 'as yet unclassified' stamp: 'LC 8/23/2008 16:14'!
onPCIEntry: aPCIBusEntry computer: aComputer
	| answer |
	answer := super onPCIEntry: aPCIBusEntry computer: aComputer.
	aComputer defaultNetworkInterface: answer.
	^answer! !

!NetworkingDevice methodsFor: 'as yet unclassified' stamp: 'gera 7/26/2006 17:26'!
down! !

!NetworkingDevice methodsFor: 'as yet unclassified' stamp: 'gera 7/27/2006 18:50'!
input: pkt
	"a packet coming from media"
	self triggerEvent: #input: with: pkt.
! !

!NetworkingDevice methodsFor: 'as yet unclassified' stamp: 'gera 7/26/2006 17:27'!
mtu
	" 1536 - 4 (for Ethernet CRC)"
	^ 1532! !

!NetworkingDevice methodsFor: 'as yet unclassified' stamp: 'gera 7/26/2006 10:42'!
output: aPacket
	^ self sendNow: aPacket! !

!NetworkingDevice methodsFor: 'as yet unclassified' stamp: 'gera 7/26/2006 17:26'!
up! !

NetworkingDevice subclass: #Realtek8139PCIDevice
	instanceVariableNames: 'nextTxIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Network'!

!Realtek8139PCIDevice commentStamp: 'gera 7/20/2006 18:48' prior: 0!
Realtek offers somehow good information

http://www.realtek.com.tw/downloads/downloads1-1.aspx?lineid=1

self installOn: Computer current!

!Realtek8139PCIDevice class methodsFor: 'as yet unclassified' stamp: 'gera 7/18/2006 11:23'!
deviceId
	^ 16r8139! !

!Realtek8139PCIDevice class methodsFor: 'as yet unclassified' stamp: 'LC 8/23/2008 16:25'!
onPCIEntry: aPCIBusEntry
	^self atMemoryAddress: aPCIBusEntry allMemoryRanges first key.
! !

!Realtek8139PCIDevice class methodsFor: 'as yet unclassified' stamp: 'gera 7/18/2006 11:23'!
vendorId
	^ 16r10EC! !

!Realtek8139PCIDevice methodsFor: 'commands' stamp: 'gera 7/23/2006 02:38'!
command
	"This register is used for issuing commands to the RTL8139C(L).
	These commands are issued by setting the corresponding bits for
	the function. A global software reset along with individual reset
	and enable/disable for transmitter and receiver are provided here."
	^ self byteAt: 16r37! !

!Realtek8139PCIDevice methodsFor: 'commands' stamp: 'gera 7/19/2006 19:45'!
command: aByte
	^ self byteAt: 16r37 put: aByte! !

!Realtek8139PCIDevice methodsFor: 'receiving' stamp: 'gera 7/19/2006 19:44'!
earlyReceiveByteCount
	^ self shortAt: 16r34! !

!Realtek8139PCIDevice methodsFor: 'receiving' stamp: 'gera 7/19/2006 19:45'!
earlyReceiveStatus
	^ self byteAt: 16r36! !

!Realtek8139PCIDevice methodsFor: 'irq handling' stamp: 'gera 7/26/2006 10:44'!
handleIRQ
	| statusOnEntry |
	statusOnEntry := self interruptStatus.
	"Status contents: self statusString."	"Status := TextMorph new openInWorld"
	[	self receiveInterruptPending ifTrue: [self handleReceiveInterrupt].
		self receiveBufferOverflowInterruptPending ifTrue: [self handleReceiveBufferFull].
	] ifError: [:ex | Transcript show: ex; cr; flush].

	"reset every interrupt, as they where on entry to avoid race conditions"
	self interruptStatus: statusOnEntry.! !

!Realtek8139PCIDevice methodsFor: 'irq handling' stamp: 'gera 7/26/2006 10:43'!
handleReceiveInterrupt
	| rbuf status len |
	[self hasReceiveBufferEmpty] whileFalse: [
		rbuf := self receiveReadAddress.
		status := rbuf unsignedShortAt: 1.
		len := rbuf unsignedShortAt: 3.
		(status anyMask: 1) ifTrue: [	"received OK"
			self input: 
				(EthernetPacket bytes: (rbuf stringAt: 5 size: len - 4))].	"The length includes Ethernet CRC"

		"+4 for PacketHeader, wrap around and align to 4"
		len := self receiveReadOffset + len + 4 + 3 bitAnd: 16rFFFC.
		self receiveReadOffset: len.]
! !

!Realtek8139PCIDevice methodsFor: 'receiving' stamp: 'gera 7/21/2006 09:45'!
hasReceiveBufferEmpty
	^ self command anyMask: 1! !

!Realtek8139PCIDevice methodsFor: 'initialization' stamp: 'gera 7/26/2006 10:35'!
initialize
	| rbuf |
	0 to: 3 do: [:i |
		self transmitStartAddress: i put: (ExternalAddress allocate: 1536 aligned: 4).
		self transmitStatus: i put: 2r10000000000000	"belogning to host, don't send"].
	
	rbuf := ExternalAddress allocate: 64*1024+16 aligned: 4.
	nextTxIndex := 0.
	self
		reset;
		receiveBufferAddress: rbuf;
		receiveReadOffset: 16rFFF0;
		interruptMask: 2r1110000001111111;		"enable all IRQs. needed because the status must be cleared"
		command: 12;							"enable receive, enable transmit"
		receiveConfiguration: 2r1111111001011110;	"receive everything except non-matching MAC"
		transmitConfiguration: 2r00000011000000000000011011110000.! !

!Realtek8139PCIDevice methodsFor: 'accessing' stamp: 'gera 7/19/2006 19:50'!
interruptMask
	"IMR - Interrupt Mask Register"
	^ self shortAt: 16r3C! !

!Realtek8139PCIDevice methodsFor: 'accessing' stamp: 'gera 7/19/2006 19:50'!
interruptMask: aShort
	^ self shortAt: 16r3C put: aShort! !

!Realtek8139PCIDevice methodsFor: 'accessing' stamp: 'gera 7/19/2006 19:50'!
interruptStatus
	"ISR - Interrupt Status Register"
	^ self shortAt: 16r3E! !

!Realtek8139PCIDevice methodsFor: 'accessing' stamp: 'gera 7/19/2006 19:50'!
interruptStatus: aShort
	^ self shortAt: 16r3E put: aShort! !

!Realtek8139PCIDevice methodsFor: 'accessing' stamp: 'gera 7/20/2006 21:00'!
interruptStatusBit: index
	^ self interruptStatus anyMask: 1 << index! !

!Realtek8139PCIDevice methodsFor: 'accessing' stamp: 'gera 7/19/2006 19:35'!
logicalAddressFilter
	^ (self longAt: 16rC) << 32 + (self longAt: 8)! !

!Realtek8139PCIDevice methodsFor: 'accessing' stamp: 'gera 7/19/2006 19:36'!
logicalAddressFilter: anInteger
	self longAt: 16rC put: anInteger // 16r100000000.
	^ self longAt: 8 put: anInteger \\ 16r100000000! !

!Realtek8139PCIDevice methodsFor: 'accessing' stamp: 'gera 7/19/2006 19:31'!
macAddress
	| answer |
	answer := self shortAt: 4.
	answer := answer << 32 + (self longAt: 0).
	^ EthernetAddress fromInteger: answer
! !

!Realtek8139PCIDevice methodsFor: 'accessing' stamp: 'gera 7/19/2006 19:54'!
missedPacketCounter
	"MPC - Missed Packet Counter: Indicates the number of packets discarded
	due to rx FIFO overflow. It is a 24-bit counter. After s/w reset, MPC is
	cleared. Only the lower 3 bytes are valid. When any value is written,
	MPC will be reset."
	^ self longAt: 16r4C
! !

!Realtek8139PCIDevice methodsFor: 'accessing' stamp: 'gera 7/19/2006 19:54'!
missedPacketCounterReset
	^ self longAt: 16r4C put: 0
! !

!Realtek8139PCIDevice methodsFor: 'receiving' stamp: 'gera 7/19/2006 20:04'!
receiveBuffer
	^ ExternalAddress new fromInteger: self receiveBufferAddress! !

!Realtek8139PCIDevice methodsFor: 'receiving' stamp: 'gera 7/19/2006 19:43'!
receiveBufferAddress
	"RBSTART"
	^ self longAt: 16r30! !

!Realtek8139PCIDevice methodsFor: 'receiving' stamp: 'gera 7/19/2006 19:43'!
receiveBufferAddress: anExternalAddressOrInteger
	^ self longAt: 16r30 put: anExternalAddressOrInteger asInteger! !

!Realtek8139PCIDevice methodsFor: 'irq handling' stamp: 'gera 7/20/2006 21:03'!
receiveBufferOverflowInterruptPending
	^ self interruptStatusBit: 4! !

!Realtek8139PCIDevice methodsFor: 'receiving' stamp: 'gera 7/19/2006 19:52'!
receiveConfiguration
	"RCR - Receive Configuration Register"
	^ self longAt: 16r44! !

!Realtek8139PCIDevice methodsFor: 'receiving' stamp: 'gera 7/19/2006 19:51'!
receiveConfiguration: aLong
	^ self longAt: 16r44 put: aLong! !

!Realtek8139PCIDevice methodsFor: 'irq handling' stamp: 'gera 7/20/2006 21:00'!
receiveInterruptPending
	^ self interruptStatusBit: 0! !

!Realtek8139PCIDevice methodsFor: 'receiving' stamp: 'gera 7/21/2006 12:11'!
receiveReadAddress
	^ ExternalAddress new fromInteger: self receiveReadOffset + 16r10 \\ 16r10000 + self receiveBufferAddress! !

!Realtek8139PCIDevice methodsFor: 'receiving' stamp: 'gera 7/20/2006 20:58'!
receiveReadOffset
	"CAPR - Current Address of Packet Read.
	The initial value is 0FFF0h"
	^ self shortAt: 16r38! !

!Realtek8139PCIDevice methodsFor: 'receiving' stamp: 'gera 7/20/2006 20:56'!
receiveReadOffset: aShort
	^ self shortAt: 16r38 put: aShort! !

!Realtek8139PCIDevice methodsFor: 'receiving' stamp: 'gera 7/20/2006 20:58'!
receiveWriteOffset
	"CBA - Current Buffer Address
	The initial value is 0000h. It reflect total received byte-count in the rx buffer."
	^ self shortAt: 16r3A! !

!Realtek8139PCIDevice methodsFor: 'commands' stamp: 'gera 7/23/2006 02:39'!
reset
	"Reset: Setting to 1 forces the RTL8139C(L) to a software reset state
	which disables the transmitter and receiver, reinitializes the FIFOs,
	resets the system buffer pointer to the initial value (Tx buffer is at
	TSAD0, Rx buffer is empty). The values of IDR0-5 and MAR0-7 and
	PCI configuration space will have no changes. This bit is 1 during the
	reset operation, and is cleared to 0 by the RTL8139C(L) when the reset
	operation is complete."

	self command: 128.
	[self command anyMask: 128] whileTrue.! !

!Realtek8139PCIDevice methodsFor: 'transmiting' stamp: 'gera 7/26/2006 10:40'!
sendNow: anEthernetPacket
	| oldTxIndex |
	nextTxIndex := (oldTxIndex := nextTxIndex) + 1 \\ 4.	"race condition here if two threads want to do this"
	^ self sendNow: anEthernetPacket on: oldTxIndex.! !

!Realtek8139PCIDevice methodsFor: 'transmiting' stamp: 'gera 7/31/2006 12:12'!
sendNow: anEthernetPacket on: descriptorIndex
	| str |
	str := anEthernetPacket asString padded: #right to: 60 with: $ .
	(self transmitStartAddress: descriptorIndex) stringAt: 1 put: str.
	self transmitStatus: descriptorIndex put: str size.! !

!Realtek8139PCIDevice methodsFor: 'transmiting' stamp: 'gera 7/24/2006 17:02'!
statusString
	^ String streamContents: [:strm |
		Time now printOn: strm.
		strm nextPutAll: ' IRQ:'.
		self interruptStatus printOn: strm base: 16.
		strm nextPutAll: ' Tx0:'.
		(self transmitStatus: 0) printOn: strm base: 16.
		strm nextPutAll: ' Tx1:'.
		(self transmitStatus: 1) printOn: strm base: 16.
		strm nextPutAll: ' Tx2:'.
		(self transmitStatus: 2) printOn: strm base: 16.
		strm nextPutAll: ' Tx3:'.
		(self transmitStatus: 3) printOn: strm base: 16]
! !

!Realtek8139PCIDevice methodsFor: 'accessing' stamp: 'gera 7/19/2006 19:53'!
timerCount
	"TCTR - Timer Count Register: This register contains a 32-bit
	general-purpose timer. Writing any value to this 32-bit register will
	reset the original timer and begin to count from zero."
	^ self longAt: 16r48
! !

!Realtek8139PCIDevice methodsFor: 'accessing' stamp: 'gera 7/19/2006 19:53'!
timerCountReset
	^ self longAt: 16r48 put: 0
! !

!Realtek8139PCIDevice methodsFor: 'transmiting' stamp: 'gera 7/19/2006 19:51'!
transmitConfiguration
	"TCR - Transmit Configuration Register"
	^ self longAt: 16r40! !

!Realtek8139PCIDevice methodsFor: 'transmiting' stamp: 'gera 7/19/2006 19:51'!
transmitConfiguration: aLong
	^ self longAt: 16r40 put: aLong! !

!Realtek8139PCIDevice methodsFor: 'transmiting' stamp: 'gera 7/23/2006 19:20'!
transmitStartAddress: index
	^ ExternalAddress fromInteger: (self longAt: index*4+16r20)! !

!Realtek8139PCIDevice methodsFor: 'transmiting' stamp: 'gera 7/23/2006 02:41'!
transmitStartAddress: index put: address
	^ self longAt: index*4+16r20 put: address asInteger! !

!Realtek8139PCIDevice methodsFor: 'transmiting' stamp: 'gera 7/25/2006 11:59'!
transmitStatus: index
	"The read-only bits (CRS, TABT, OWC, CDH, NCC3-0, TOK, TUN) will be cleared
	by the RTL8139C(L) when the Transmit Byte Count (bit12-0) in the corresponding
	Tx descriptor is written. It is not affected when software writes to these bits.
	These registers are only permitted to write by double-word access. After a software
	reset, all bits except the OWN bit are reset to 0"
	^ self longAt: index*4+16r10! !

!Realtek8139PCIDevice methodsFor: 'transmiting' stamp: 'gera 7/19/2006 19:44'!
transmitStatus: index put: value
	^ self longAt: index*4+16r10 put: value! !

!PCIDevice class methodsFor: 'instance creation' stamp: 'gera 8/25/2008 21:06'!
installOn: aComputer
	| pciEntry |
	pciEntry := PCIBusEntry allValid
		detect: [:e | e vendorId = self vendorId and: [e deviceId = self deviceId]]
		ifNone: [^ nil].
	^ self onPCIEntry: pciEntry computer: aComputer.
! !

!PCIDevice class methodsFor: 'instance creation' stamp: 'LC 8/23/2008 16:24'!
onPCIEntry: aPCIBusEntry
	^self onPort: aPCIBusEntry allIORanges first key
! !

!PCIDevice class methodsFor: 'instance creation' stamp: 'LC 8/23/2008 16:24'!
onPCIEntry: aPCIBusEntry computer: aComputer
	| answer |
	answer := self onPCIEntry: aPCIBusEntry.

	aPCIBusEntry
		enableBusMastering;
		enableIO.

	" copyed from GRUB, not sure if needed or not:"
	aPCIBusEntry latencyTimer < 32 ifTrue: [aPCIBusEntry latencyTimer: 32].

	aComputer interruptController
		addHandler: answer
		forIRQ: aPCIBusEntry interruptLine.

	^ answer! !

PCIDevice subclass: #SDDevice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-USB'!

!SDDevice class methodsFor: 'accessing' stamp: 'LC 8/23/2008 17:11'!
deviceId
	^2082! !

!SDDevice class methodsFor: 'class initialization' stamp: 'LC 8/24/2008 15:41'!
initialize
	super initialize.
	self initializeSDCommands! !

!SDDevice class methodsFor: 'class initialization' stamp: 'LC 8/24/2008 20:03'!
initializeSDCommands
	SDCommands := Dictionary new
		at: 'SendCSD' put: 8;
		at: 'SendCID' put: 10;
		at: 'SendRelativeAddress' put: 3;
		yourself! !

!SDDevice class methodsFor: 'instance creation' stamp: 'gera 8/25/2008 08:23'!
installOn: aComputer
	| card |
	card := super installOn: aComputer.
	card ifNil: [^ nil].
	card enableInterrupts.
	aComputer sdCard: card.
	^card! !

!SDDevice class methodsFor: 'instance creation' stamp: 'LC 8/24/2008 12:49'!
onPCIEntry: aPCIBusEntry
	^self atMemoryAddress: aPCIBusEntry allMemoryRanges first key.
! !

!SDDevice class methodsFor: 'accessing' stamp: 'LC 8/23/2008 17:11'!
vendorId
	^4480! !

!SDDevice methodsFor: 'registers' stamp: 'gera 8/30/2008 15:49'!
blockSizeRegister
	^self shortAt: 16r04! !

!SDDevice methodsFor: 'testing' stamp: 'LC 8/24/2008 15:54'!
canIssueCommand
	^(self testPresentStateBit: 0) not! !

!SDDevice methodsFor: 'testing' stamp: 'LC 8/23/2008 17:43'!
canIssueDATCommand
	^(self testPresentStateBit: 1) not! !

!SDDevice methodsFor: 'testing' stamp: 'LC 8/23/2008 17:36'!
canWriteData
	^self testPresentStateBit: 10! !

!SDDevice methodsFor: 'registers' stamp: 'LC 8/24/2008 14:40'!
capabilitiesRegister
	^self longAt: 16r40! !

!SDDevice methodsFor: 'low level' stamp: 'LC 8/23/2008 17:31'!
cardDetectPinLevel
	^(self testPresentStateBit: 18) ifTrue: [1] ifFalse: [0]! !

!SDDevice methodsFor: 'private' stamp: 'LC 8/24/2008 14:57'!
checkCardPresent
	self isCardInserted
		ifTrue: [self report: 'card inserted']
		ifFalse: [self report: 'card removed'].! !

!SDDevice methodsFor: 'clearing interrupts' stamp: 'LC 8/24/2008 13:54'!
clearCardInsertionInterrupt
	self setInterruptStatusBit:6! !

!SDDevice methodsFor: 'clearing interrupts' stamp: 'LC 8/24/2008 13:55'!
clearCardRemovalInterrupt
	self setInterruptStatusBit: 7! !

!SDDevice methodsFor: 'clearing interrupts' stamp: 'LC 8/24/2008 16:04'!
clearCommandCompleteInterrupt
	self setInterruptStatusBit: 0! !

!SDDevice methodsFor: 'registers' stamp: 'gera 8/30/2008 16:12'!
clockControlRegister
	^ self shortAt: 16r2C! !

!SDDevice methodsFor: 'enabling interrupts' stamp: 'LC 8/24/2008 13:43'!
enableBlockGapInterrupt
	self setInterruptEnableBit: 2! !

!SDDevice methodsFor: 'enabling interrupts' stamp: 'LC 8/24/2008 13:43'!
enableBufferReadyInterrupt
	self setInterruptEnableBit: 5! !

!SDDevice methodsFor: 'enabling interrupts' stamp: 'LC 8/24/2008 13:43'!
enableBufferWriteReadyInterrupt
	self setInterruptEnableBit: 4! !

!SDDevice methodsFor: 'enabling interrupts' stamp: 'LC 8/24/2008 14:01'!
enableCardInsertionInterrupt
	self setInterruptEnableBit: 6; enableCardInsertionInterruptStatus! !

!SDDevice methodsFor: 'enabling interrupts' stamp: 'LC 8/24/2008 13:57'!
enableCardInsertionInterruptStatus
	self setInterruptStatusEnableBit: 6! !

!SDDevice methodsFor: 'enabling interrupts' stamp: 'LC 8/24/2008 14:14'!
enableCardInterrupt
	self setInterruptEnableBit: 8; enableCardInterruptStatus! !

!SDDevice methodsFor: 'enabling interrupts' stamp: 'LC 8/24/2008 14:14'!
enableCardInterruptStatus
	self setInterruptStatusEnableBit: 8! !

!SDDevice methodsFor: 'enabling interrupts' stamp: 'LC 8/24/2008 14:02'!
enableCardRemovalInterrupt
	self setInterruptEnableBit: 7; enableCardRemovalInterruptStatus! !

!SDDevice methodsFor: 'enabling interrupts' stamp: 'LC 8/24/2008 14:01'!
enableCardRemovalInterruptStatus
	self setInterruptStatusEnableBit: 7! !

!SDDevice methodsFor: 'enabling interrupts' stamp: 'LC 8/24/2008 16:01'!
enableCommandCompleteInterrupt
	self setInterruptEnableBit: 0; enableCommandCompleteInterruptStatus! !

!SDDevice methodsFor: 'enabling interrupts' stamp: 'LC 8/24/2008 16:02'!
enableCommandCompleteInterruptStatus
	self setInterruptStatusEnableBit: 0! !

!SDDevice methodsFor: 'enabling interrupts' stamp: 'LC 8/24/2008 13:44'!
enableDMAInterrupt
	self setInterruptEnableBit: 3! !

!SDDevice methodsFor: 'enabling interrupts' stamp: 'LC 8/24/2008 17:37'!
enableErrorInterrupt
	self setErrorInterruptEnableBit: 0;
		setErrorInterruptEnableBit: 1;
		setErrorInterruptEnableBit: 2;
		setErrorInterruptEnableBit: 3;
		setErrorInterruptEnableBit: 4;
		setErrorInterruptEnableBit: 5;
		setErrorInterruptStatusEnableBit: 1;
		setErrorInterruptStatusEnableBit: 2;
		setErrorInterruptStatusEnableBit: 3;
		setErrorInterruptStatusEnableBit: 4;
		setErrorInterruptStatusEnableBit: 5! !

!SDDevice methodsFor: 'enabling interrupts' stamp: 'LC 8/24/2008 17:33'!
enableInterrupts
	self enableCardRemovalInterrupt; 
		enableCardInsertionInterrupt; 
		enableCommandCompleteInterrupt;
		enableErrorInterrupt! !

!SDDevice methodsFor: 'enabling interrupts' stamp: 'LC 8/24/2008 13:44'!
enableTransferCompleteInterrupt
	self setInterruptEnableBit: 1! !

!SDDevice methodsFor: 'registers' stamp: 'gera 8/30/2008 15:49'!
errorInterruptEnableRegister
	^self shortAt: 16r3A! !

!SDDevice methodsFor: 'registers' stamp: 'gera 8/30/2008 15:49'!
errorInterruptStatus
	^self shortAt: 16r32! !

!SDDevice methodsFor: 'registers' stamp: 'gera 8/30/2008 15:46'!
errorInterruptStatusEnableRegister
	^self shortAt: 16r36! !

!SDDevice methodsFor: 'commands' stamp: 'gera 11/21/2009 11:40'!
getCardID
	| answer address arg |
	address := self getRelativeAddress.
	arg := address bitShift: 16.
	answer := self sendCommand: 10 with: arg.
	^answer bitAnd: 16rFFFF
	
SDCommands! !

!SDDevice methodsFor: 'commands' stamp: 'gera 11/21/2009 11:41'!
getRelativeAddress
	| answer |
	answer := self sendCommand: 3.
	answer bitShift: -16.
	^answer bitAnd: 16rFFFF! !

!SDDevice methodsFor: 'irq handling' stamp: 'LC 8/24/2008 16:04'!
handleIRQ
	self hasCardRemovalInterrupt ifTrue: [
		self clearCardRemovalInterrupt.
		self checkCardPresent].
	self hasCardInsertionInterrupt ifTrue: [
		self clearCardInsertionInterrupt.
		self checkCardPresent].
	self hasCommandCompleteInterrupt ifTrue: [
		self clearCommandCompleteInterrupt].! !

!SDDevice methodsFor: 'testing interrupts' stamp: 'LC 8/24/2008 12:28'!
hasBlockGapInterrupt
	^self testInterruptStatusBit: 2! !

!SDDevice methodsFor: 'testing interrupts' stamp: 'LC 8/24/2008 12:27'!
hasBufferReadReadyInterrupt
	^self testInterruptStatusBit: 5! !

!SDDevice methodsFor: 'testing interrupts' stamp: 'LC 8/24/2008 12:27'!
hasBufferWriteReadyInterrupt
	^self testInterruptStatusBit: 4! !

!SDDevice methodsFor: 'testing interrupts' stamp: 'LC 8/24/2008 12:26'!
hasCardInsertionInterrupt
	^self testInterruptStatusBit: 6! !

!SDDevice methodsFor: 'testing interrupts' stamp: 'LC 8/24/2008 12:25'!
hasCardRemovalInterrupt
	^self testInterruptStatusBit: 7! !

!SDDevice methodsFor: 'testing interrupts' stamp: 'LC 8/24/2008 12:28'!
hasCommandCompleteInterrupt
	^self testInterruptStatusBit: 0! !

!SDDevice methodsFor: 'testing interrupts' stamp: 'LC 8/24/2008 12:27'!
hasDMAInterrupt
	^self testInterruptStatusBit: 3! !

!SDDevice methodsFor: 'testing interrupts' stamp: 'LC 8/24/2008 17:25'!
hasErrorInterrupt
	^self testInterruptStatusBit: 15! !

!SDDevice methodsFor: 'testing' stamp: 'LC 8/23/2008 17:34'!
hasReadableData
	^self testPresentStateBit: 11! !

!SDDevice methodsFor: 'testing interrupts' stamp: 'LC 8/24/2008 12:28'!
hasTransferCompleteInterrupt
	^self testInterruptStatusBit: 1! !

!SDDevice methodsFor: 'registers' stamp: 'gera 8/30/2008 15:50'!
interruptEnableRegister
	^self shortAt: 16r38! !

!SDDevice methodsFor: 'registers' stamp: 'gera 8/30/2008 15:46'!
interruptStatus
	^self shortAt: 16r30! !

!SDDevice methodsFor: 'registers' stamp: 'gera 8/30/2008 15:50'!
interruptStatusEnableRegister
	^self shortAt: 16r34! !

!SDDevice methodsFor: 'testing' stamp: 'LC 8/23/2008 17:26'!
isCardInserted
	^self testPresentStateBit: 16! !

!SDDevice methodsFor: 'testing' stamp: 'LC 8/23/2008 17:21'!
isCardPresent
	^self testPresentStateBit: 18! !

!SDDevice methodsFor: 'testing' stamp: 'LC 8/23/2008 17:39'!
isDATLineActive
	^self testPresentStateBit: 2! !

!SDDevice methodsFor: 'testing' stamp: 'LC 8/23/2008 17:38'!
isReadingData
	^self testPresentStateBit: 9! !

!SDDevice methodsFor: 'testing' stamp: 'LC 8/23/2008 17:24'!
isStateStable
	^self testPresentStateBit: 17! !

!SDDevice methodsFor: 'testing' stamp: 'LC 8/23/2008 17:19'!
isWriteProtected
	^(self testPresentStateBit: 19) not! !

!SDDevice methodsFor: 'testing' stamp: 'LC 8/23/2008 17:38'!
isWritingData
	^self testPresentStateBit: 8! !

!SDDevice methodsFor: 'accessing' stamp: 'LC 8/23/2008 17:18'!
lineSignalLevel
	^self testPresentStateBit: 24! !

!SDDevice methodsFor: 'registers' stamp: 'LC 8/23/2008 18:05'!
presentState
	^self longAt: 16r24! !

!SDDevice methodsFor: 'commands' stamp: 'LC 8/24/2008 16:31'!
readResponse
	| answer |
	answer := self responseRegister! !

!SDDevice methodsFor: 'private' stamp: 'LC 8/24/2008 14:36'!
reportStatus! !

!SDDevice methodsFor: 'registers' stamp: 'LC 8/24/2008 16:06'!
responseRegister
	^self longAt: 16r10! !

!SDDevice methodsFor: 'commands' stamp: 'LC 8/24/2008 21:20'!
sendCommand: c
	self sendCommand: c with: 0! !

!SDDevice methodsFor: 'commands' stamp: 'gera 8/30/2008 15:52'!
sendCommand: c with: arg
	self
		waitForCommandSendAllowed;
		waitForDATCommandAllowed;
		longAt: 16r08 put: arg;
		shortAt: 16r0E put: (c bitShift: 8);
		waitForCommandComplete;
		readResponse! !

!SDDevice methodsFor: 'private' stamp: 'gera 8/30/2008 16:13'!
setClockControlRegisterBit: bit
	| register |
	register := self clockControlRegister.
	register := register bitOr: (1 bitShift: bit).
	self shortAt: 16r2C put: register! !

!SDDevice methodsFor: 'private' stamp: 'LC 8/24/2008 17:31'!
setErrorInterruptEnableBit: bit
	| register |
	register := self errorInterruptEnableRegister.
	register := register bitOr: (1 bitShift: bit).
	self longAt: 16r3A put: register! !

!SDDevice methodsFor: 'private' stamp: 'LC 8/24/2008 17:29'!
setErrorInterruptStatusEnableBit: bit
	| register |
	register := self errorInterruptStatusEnableRegister.
	register := register bitOr: (1 bitShift: bit).
	self longAt: 16r36 put: register! !

!SDDevice methodsFor: 'private' stamp: 'LC 8/24/2008 13:42'!
setInterruptEnableBit: bit
	| register |
	register := self interruptEnableRegister.
	register := register bitOr: (1 bitShift: bit).
	self longAt: 16r38 put: register! !

!SDDevice methodsFor: 'private' stamp: 'LC 8/24/2008 13:52'!
setInterruptStatusBit: bit
	| register |
	register := self interruptStatus.
	register := register bitOr: (1 bitShift: bit).
	self longAt: 16r30 put: register! !

!SDDevice methodsFor: 'private' stamp: 'LC 8/24/2008 12:42'!
setInterruptStatusEnableBit: bit
	| register |
	register := self interruptStatusEnableRegister.
	register := register bitOr: (1 bitShift: bit).
	self longAt: 16r34 put: register! !

!SDDevice methodsFor: 'testing' stamp: 'LC 8/24/2008 14:41'!
supportsHighSpeed
	^self testCapabilitiesBit: 21! !

!SDDevice methodsFor: 'private' stamp: 'LC 8/24/2008 14:41'!
testCapabilitiesBit: bit
	^self capacilitiesRegister anyMask: (1 bitShift: bit)! !

!SDDevice methodsFor: 'private' stamp: 'LC 8/24/2008 17:40'!
testErrorInterruptStatusBit: bit
	^self errorInterruptStatus anyMask: (1 bitShift: bit)! !

!SDDevice methodsFor: 'private' stamp: 'LC 8/24/2008 14:28'!
testInterruptStatusBit: bit
	^self interruptStatus anyMask: (1 bitShift: bit)! !

!SDDevice methodsFor: 'private' stamp: 'LC 8/23/2008 17:17'!
testPresentStateBit: bit
	^self presentState anyMask: (1 bitShift: bit)! !

!SDDevice methodsFor: 'serivices' stamp: 'LC 8/24/2008 16:00'!
waitFor: aBlock
	aBlock whileFalse! !

!SDDevice methodsFor: 'commands' stamp: 'LC 8/24/2008 15:59'!
waitForCommandComplete
	self waitFor: [self hasCommandCompleteInterrupt]! !

!SDDevice methodsFor: 'commands' stamp: 'LC 8/24/2008 15:59'!
waitForCommandSendAllowed
	self waitFor: [self canIssueCommand]! !

!SDDevice methodsFor: 'commands' stamp: 'LC 8/24/2008 15:59'!
waitForDATCommandAllowed
	self waitFor: [self canIssueDATCommand]! !

HardwareDevice subclass: #PIC8259
	instanceVariableNames: 'computer slave dispatchers savedMask'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Base'!

!PIC8259 class methodsFor: 'instance creation' stamp: 'gera 7/20/2006 18:49'!
installOn: aComputer 
	^ (aComputer has: #interruptController)
		ifFalse: [aComputer
				interruptController: (self master computer: aComputer)]! !

!PIC8259 class methodsFor: 'instance creation' stamp: 'gera 5/20/2006 16:16'!
master
	^ ((self onPort: 16r20)
		slave: self slave) enableIRQ: 0! !

!PIC8259 class methodsFor: 'instance creation' stamp: 'gera 5/20/2006 01:43'!
slave
	^ self onPort: 16rA0! !

!PIC8259 methodsFor: 'dispatching' stamp: 'gera 7/23/2006 19:21'!
addHandler: anObject forIRQ: aNumber
	" the master mantains the array of dispatchers"
	| dispatcher |

	dispatcher := self dispatcherForIRQ: aNumber.
	dispatcher ifNil: [
		dispatcher := InterruptRequestDispatcher onIRQ: aNumber.
		self dispatcher: dispatcher forIRQ: aNumber.
		dispatcher
			addHandler: anObject;
			installOn: computer.
	] ifNotNil: [
		dispatcher addHandler: anObject].

	Transcript cr; show:
		'handler for IRQ #',
		aNumber printString,
		' installed: ',
		anObject printString.! !

!PIC8259 methodsFor: 'accessing' stamp: 'gera 5/20/2006 01:04'!
computer
	^ computer! !

!PIC8259 methodsFor: 'accessing' stamp: 'gera 5/20/2006 01:04'!
computer: aComputer
	computer := aComputer.
	slave ifNotNil: [slave computer: aComputer]! !

!PIC8259 methodsFor: 'commands' stamp: 'gera 5/20/2006 01:05'!
disableAll
	0 to: 7 do: [:i | self disableIRQ: i].
	slave ifNotNil: [slave disableAll]! !

!PIC8259 methodsFor: 'commands' stamp: 'r++ 7/19/2008 19:59'!
disableIRQ: aNumber
	aNumber > 7
		ifTrue: [
			slave disableIRQ: aNumber - 8.
			slave isAnyEnabled ifFalse: [self disableIRQ: 2]]
		ifFalse: [
			savedMask := savedMask bitOr: 1 << aNumber.
			self byteAt: 1 put: savedMask].

"	Transcript cr; show: 'IRQ #', aNumber printString, ' disabled. Mask: ',savedMask hex.
"! !

!PIC8259 methodsFor: 'dispatching' stamp: 'gera 6/9/2006 02:49'!
dispatcher: anIRQDispatcher forIRQ: aNumber
	^ aNumber > 7
		ifTrue: [slave dispatcher: anIRQDispatcher forIRQ: aNumber - 8]
		ifFalse: [dispatchers at: aNumber + 1 put: anIRQDispatcher]! !

!PIC8259 methodsFor: 'dispatching' stamp: 'gera 5/20/2006 16:29'!
dispatcherForIRQ: aNumber
	^ aNumber > 7
		ifTrue: [slave dispatcherForIRQ: aNumber - 8]
		ifFalse: [dispatchers at: aNumber + 1].! !

!PIC8259 methodsFor: 'commands' stamp: 'r++ 7/19/2008 19:59'!
enableIRQ: aNumber
	aNumber > 7
		ifTrue: [
			slave enableIRQ: aNumber - 8.
			self enableIRQ: 2]
		ifFalse: [
			savedMask := savedMask bitClear: 1 << aNumber.
			self byteAt: 1 put: savedMask].

"	Transcript cr; show: 'IRQ #', aNumber printString, ' enabled. Mask: ',savedMask printStringHex
"! !

!PIC8259 methodsFor: 'initialization' stamp: 'gera 6/9/2006 02:43'!
initialize
	dispatchers := Array new: 8.
	savedMask := 0.

	self disableAll.! !

!PIC8259 methodsFor: 'accessing' stamp: 'gera 5/20/2006 16:35'!
isAnyEnabled
	^ savedMask ~= 16rFF! !

!PIC8259 methodsFor: 'dispatching' stamp: 'gera 6/9/2006 02:50'!
removeDispatcher: anIRQDispatcher
	^ self dispatcher: nil forIRQ: anIRQDispatcher interruptNumber! !

!PIC8259 methodsFor: 'dispatching' stamp: 'gera 6/7/2006 09:40'!
removeHandler: anObject forIRQ: aNumber
	" the master mantains the array of dispatchers"
	| dispatcher |

	dispatcher := self dispatcherForIRQ: aNumber.
	dispatcher ifNotNil: [dispatcher removeHandler: anObject].

	Transcript cr; show:
		'handler for IRQ #',
		aNumber printString,
		' removed: ',
		anObject printString.! !

!PIC8259 methodsFor: 'commands' stamp: 'r++ 7/20/2008 13:17'!
signalEndOfInterrupt: interruptNumber
	interruptNumber > 7 ifTrue: [slave signalEndOfInterrupt: interruptNumber - 8].
	self byteAt: 0 put: 16r20.
"	Transcript cr; show: 'end of IRQ #', interruptNumber printString.
"! !

!PIC8259 methodsFor: 'accessing' stamp: 'gera 5/20/2006 01:05'!
slave
	^ slave! !

!PIC8259 methodsFor: 'accessing' stamp: 'gera 5/20/2006 01:09'!
slave: aPIC8259
	slave := aPIC8259.! !

HardwareDevice subclass: #PS2Keyboard
	instanceVariableNames: 'modifiersAndButtons mouseCoord mouseDataCount events previousScanCode configBits decoder keysMapping'
	classVariableNames: ''
	poolDictionaries: 'EventSensorConstants'
	category: 'SqueakNOS-Devices-Base'!

!PS2Keyboard class methodsFor: 'class initialization' stamp: 'r++ 7/26/2008 13:37'!
cCharsToArray: aString
	| strm table |
	strm := ReadStream on: aString.
	strm reset.
	table := OrderedCollection new: 128.
	[strm atEnd]
		whileFalse: [strm peek = $\
				ifTrue: 
					[strm next.
					strm peek isDigit
						ifTrue: [table add: (Character value: ('8r' , (strm next: 3)) asNumber)]
						ifFalse: [table add: (self unescapeCharacter: strm next)]]
				ifFalse: [table add: strm next]].
	^ table asArray! !

!PS2Keyboard class methodsFor: 'class initialization' stamp: 'JavierPimas 8/12/2010 17:59'!
fixPasteUpMorphIfPharo
	SmalltalkImage current isPharo ifFalse: [^self].
	PasteUpMorph compile:
	'morphsInFrontOf: someMorph overlapping: aRectangle do: aBlock
	"Include hands if the receiver is the World"
	self handsDo:[:m|
		m == someMorph ifTrue:[ "Try getting out quickly"
			owner ifNil:[^self].
			^owner morphsInFrontOf: self overlapping: aRectangle do: aBlock
		]
	].
		
	^super morphsInFrontOf: someMorph overlapping: aRectangle do: aBlock'
		classified: 'submorphs-accessing'.
		! !

!PS2Keyboard class methodsFor: 'class initialization' stamp: 'Pocho 12/2/2009 16:18'!
generatedEnglishKeysMapping

	| mapping temp |
	
	mapping := Dictionary new.
	
	mapping at: #(none) put: (self cCharsToArray: '\0331234567890-=\010\t' ,
		'qwertyuiop[]\r\000as' ,
		'dfghjkl;''`\000\\zxcv' ,
		'bnm,./\000*\000 \000\201\202\203\204\205' ,
		'\206\207\210\211\212\000\000789-456+1' ,
		'230\177\000\000\213\214\000\000\000\000\000\000\000\000\000\000' ,
		'\r\000/').
		
	mapping at: #(shift) put: (self cCharsToArray: 
		'\033!!@#$%^&*()_+\010\t' ,
		'QWERTYUIOP{}\r\000AS' ,
		'DFGHJKL:"~\000|ZXCV' ,
		'BNM<>?\000*\000 \000\201\202\203\204\205' ,
		'\206\207\210\211\212\000\000789-456+1' ,
		'230\177\000\000\213\214\000\000\000\000\000\000\000\000\000\000' ,
		'\r\000/').
		
	mapping at: #(alt) put: (Array new: 128 withAll: (Character value: 0)).
	mapping at: #(shift alt) put: (Array new: 128 withAll: (Character value: 0)).
	
	temp := Array new: 128 withAll: (Character value: 0).
	temp at: 16r48 put: Character arrowUp.
	temp at: 16r50 put: Character arrowDown.
	temp at: 16r4D put: Character arrowRight.
	temp at: 16r4B put: Character arrowLeft.
	temp at: 16r47 put: Character home.
	temp at: 16r4F put: Character end.
	temp at: 16r49 put: Character pageUp.
	temp at: 16r51 put: Character pageDown.
	temp at: 16r52 put: Character insert.	
	temp at: 16r53 put: Character delete.

	mapping at: #(extended) put: temp.
	
	 ^mapping.! !

!PS2Keyboard class methodsFor: 'class initialization' stamp: 'Pocho 12/26/2009 18:41'!
generatedSpanishKeysMapping

	| mapping |
	
	mapping := self generatedEnglishKeysMapping.
	
	"TODO: fill this"
	"mapping at: #(none) put: Dictionary new.
	mapping at: #(shift) put: Dictionary new.
	mapping at: #(alt) put: Dictionary new.
	mapping at: #(alt shift) put: Dictionary new.
	mapping at: #(extended) put: Dictionary new.
	"
	
	 ^mapping.! !

!PS2Keyboard class methodsFor: 'class initialization' stamp: 'Pocho 12/26/2009 18:31'!
initialize
	! !

!PS2Keyboard class methodsFor: 'system startup' stamp: 'JavierPimas 8/12/2010 17:42'!
installOn: aComputer
	| keyboard p |
	keyboard := self onPort: 16r60.
	aComputer interruptController addHandler: keyboard forIRQ: 1.
	aComputer keyboard: keyboard.
	aComputer interruptController addHandler: keyboard forIRQ: 12.
	HandMorph allInstances do: [:each |
		each hasUserInformation ifFalse: [
			each userInitials: ' ' andPicture: each userPicture.
		]
	].
	self fixPasteUpMorphIfPharo.
	"Cursor normal show."
	SmalltalkImage current isPharo ifFalse: [
		p := Sensor eventTicklerProcess.
		p notNil ifTrue: [p terminate].
	].
	

	^ aComputer mouse: keyboard.
! !

!PS2Keyboard class methodsFor: 'class initialization' stamp: 'r++ 7/26/2008 13:37'!
unescapeCharacter: char 
	char = $t ifTrue: [^ Character tab].
	char = $r ifTrue: [^ Character cr].
	char = $n ifTrue: [^ Character lf].
	^ char! !

!PS2Keyboard methodsFor: 'controller commands' stamp: 'r++ 7/24/2008 22:19'!
checkPassword
	self controllerCommand: 16rA6.
"	^ self readData"! !

!PS2Keyboard methodsFor: 'command byte' stamp: 'gera 9/4/2008 19:26'!
clearCommandBit: bit
	^ self commandByte: (self commandByte bitClear: 1 << bit)
! !

!PS2Keyboard methodsFor: 'controller commands' stamp: 'r++ 7/26/2008 12:41'!
commandByte
	self controllerCommand: 16r20.
	^ self readKeyboardData.! !

!PS2Keyboard methodsFor: 'controller commands' stamp: 'r++ 7/24/2008 21:44'!
commandByte: value
	self controllerCommand: 16r60.
	self keyboardCommand: value.! !

!PS2Keyboard methodsFor: 'low level protocol' stamp: 'r++ 7/24/2008 21:30'!
controllerCommand: cmd
	self waitToWrite ifFalse: [^false].
	self controllerPort: cmd.
	^true! !

!PS2Keyboard methodsFor: 'I/O' stamp: 'r++ 7/24/2008 21:30'!
controllerPort: cmd
	^ self byteAt: 4 put: cmd! !

!PS2Keyboard methodsFor: 'I/O' stamp: 'r++ 7/24/2008 20:31'!
dataPort
	^ self byteAt: 0! !

!PS2Keyboard methodsFor: 'I/O' stamp: 'r++ 7/24/2008 20:31'!
dataPort: value
	^ self byteAt: 0 put: value! !

!PS2Keyboard methodsFor: 'low level protocol' stamp: 'r++ 7/30/2008 08:11'!
disableIRQsWhile: aBlock
	| answer |
	self controllerCommand: 16r60; dataPort: 0.
	answer := aBlock value.
	self controllerCommand: 16r60; dataPort: 16r47.
	^ answer
! !

!PS2Keyboard methodsFor: 'command byte' stamp: 'gera 9/4/2008 19:26'!
disableInputBufferFullInterrupt
	^ self clearCommandBit: 0! !

!PS2Keyboard methodsFor: 'command byte' stamp: 'r++ 7/25/2008 19:33'!
disableInterrupts
	^self disableInputBufferFullInterrupt; disableMouseInputBufferFullInterrupt
! !

!PS2Keyboard methodsFor: 'keyboard commands' stamp: 'r++ 7/25/2008 19:35'!
disableKeyboard
	self keyboardCommand: 16rF5.
	^ self waitKeyboardAck! !

!PS2Keyboard methodsFor: 'keyboard commands' stamp: 'r++ 7/24/2008 22:21'!
disableKeyboardInterface
	self controllerCommand: 16rAD.
! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:45'!
disableMouse
	^ self mouseCommand: 16rF5.! !

!PS2Keyboard methodsFor: 'command byte' stamp: 'gera 9/4/2008 19:26'!
disableMouseInputBufferFullInterrupt
	^ self clearCommandBit: 1! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/24/2008 22:21'!
disableMouseInterface
	self controllerCommand: 16rA7.
! !

!PS2Keyboard methodsFor: 'accessing' stamp: 'gera 9/4/2008 08:54'!
disableMouseScrollingParsing
	configBits := configBits bitClear: 1! !

!PS2Keyboard methodsFor: 'command byte' stamp: 'gera 9/4/2008 19:26'!
disableScancodeTranslation
	^ self clearCommandBit: 6! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:49'!
disableWrapMode
	^ self mouseCommand: 16rEC.! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:56'!
enable1in1Scaling
	^self mouseCommand: 16rE6.! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:56'!
enable2in1Scaling
	^self mouseCommand: 16rE7.! !

!PS2Keyboard methodsFor: 'keyboard commands' stamp: 'r++ 7/25/2008 19:37'!
enableKeyboard
	self keyboardCommand: 16rF4.
	^ self waitKeyboardAck! !

!PS2Keyboard methodsFor: 'command byte' stamp: 'gera 9/4/2008 19:27'!
enableKeyboardInputBufferFullInterrupt
	^ self setCommandBit: 0! !

!PS2Keyboard methodsFor: 'keyboard commands' stamp: 'r++ 7/24/2008 22:21'!
enableKeyboardInterface
	self controllerCommand: 16rAE.
! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:28'!
enableMouse
	^ self mouseCommand: 16rF4.! !

!PS2Keyboard methodsFor: 'command byte' stamp: 'gera 9/4/2008 19:27'!
enableMouseInputBufferFullInterrupt
	^ self setCommandBit: 1! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/24/2008 22:21'!
enableMouseInterface
	self controllerCommand: 16rA8.
! !

!PS2Keyboard methodsFor: 'accessing' stamp: 'gera 9/4/2008 08:53'!
enableMouseScrollingParsing
	configBits := configBits bitOr: 1! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:48'!
enableRemoteMode
	^ self mouseCommand: 16rF0.! !

!PS2Keyboard methodsFor: 'command byte' stamp: 'gera 9/4/2008 19:27'!
enableScancodeTranslation
	^ self setCommandBit: 6! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:52'!
enableStreamMode
	^ self mouseCommand: 16rEA.! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:49'!
enableWrapMode
	^ self mouseCommand: 16rEE.! !

!PS2Keyboard methodsFor: 'irq handling' stamp: 'r++ 7/26/2008 20:02'!
handleIRQ
	[self keyboardOutputBufferFull] whileTrue: [
		self mouseOutputBufferFull
			ifTrue: [self handleMouseIRQ]
			ifFalse: [self handleKeyboardIRQ]]

! !

!PS2Keyboard methodsFor: 'irq handling' stamp: 'Pocho 12/26/2009 18:21'!
handleKeyboardIRQ
	| scanCode key |
	scanCode := self readKeyboardData.

	decoder nextScanCode: scanCode.
	
	decoder nextKeyReady ifFalse: [^self].
	
	decoder isModifier
		ifFalse: [ "it's an ascii caracter"
			key := decoder keyUsing: keysMapping modifiers: modifiersAndButtons.
			key asciiValue = 0 ifTrue: [^self].
			decoder isKeyUp 
				ifTrue: [ self newKeyboardUpEvent: key ]
				ifFalse: [ self newKeyboardDownEvent: key].
		]
		ifTrue: [ " it's a modifier "
			"modifiersAndButtons := modifiersAndButtons bitXor: decoder translateModifierScanCode."
			
			decoder isKeyUp
				ifTrue: [ modifiersAndButtons := modifiersAndButtons bitClear: decoder translateModifierScanCode ]
				ifFalse: [ modifiersAndButtons := modifiersAndButtons bitOr: decoder translateModifierScanCode ].
		].
		
	

! !

!PS2Keyboard methodsFor: 'irq handling' stamp: 'Pocho 12/26/2009 18:21'!
handleMouseIRQ
	| data |
	data := self readMouseData.

	"self mouseScrollingEnabled
			ifTrue:  [Keys1 add: 'Number ', mouseDataCount asString, ' data ', data asString, '
'. ]."
			
	mouseDataCount == 0 ifTrue: [ "button state"
		mouseDataCount := mouseDataCount + 1.
		^ modifiersAndButtons := (((modifiersAndButtons bitClear: 16r7)
			bitOr: (data bitAnd: 2))
			bitOr: (data bitAnd: 1) << 2)
			bitOr: (data bitAnd: 4) >> 2].

	data >= 16r80 ifTrue: [data := data - 16r100].

	mouseDataCount == 1 ifTrue: [ "x delta "
		mouseDataCount := mouseDataCount + 1.
		^ mouseCoord := data @ 0 + mouseCoord].

	
	mouseDataCount = 2 ifTrue: [ " y delta "
		mouseCoord := mouseCoord  - (0 @ data) adhereTo: Display boundingBox.
		].

	self mouseScrollingEnabled
			ifTrue:  [
				mouseDataCount = 2 ifTrue: [^mouseDataCount := mouseDataCount + 1.] ]
			ifFalse:[
				mouseDataCount := 0.
				^self newMouseEvent].
	
	" mouseDataCount == 3: z delta "
	mouseDataCount := 0.
	data < 0 ifTrue:["Scrolling up"
		^self newKeyboardControlCharEvent: Character arrowUp].
	data > 0 ifTrue:["Scrolling down"
		^self newKeyboardControlCharEvent: Character arrowDown].
	self newMouseEvent.! !

!PS2Keyboard methodsFor: 'controller commands' stamp: 'r++ 7/26/2008 12:41'!
hasPassword
	self controllerCommand: 16rA4.
	^ self readKeyboardData == 16rFA! !

!PS2Keyboard methodsFor: 'initialization' stamp: 'Pocho 11/21/2009 18:44'!
initialize
	super initialize.

	mouseDataCount := modifiersAndButtons := 0.
	mouseCoord := DisplayScreen actualScreenSize // 2.
	configBits := 0.
	
	keysMapping := self class generatedEnglishKeysMapping.
	decoder :=  ScancodeDecoder new.

	self initializeHardware.
	self initializeEventsQueue.! !

!PS2Keyboard methodsFor: 'initialization' stamp: 'JavierPimas 8/12/2010 18:15'!
initializeEventsQueue
	| p block |
	events := SharedQueue new.
	SmalltalkImage current isPharo
			   ifTrue: [ block := [ Sensor handleEvent: events next ] ]
			   ifFalse: [ block := [ Sensor processEvent: events next] ].
	p := [ block repeat] forkAt: Processor highIOPriority.
	
	p name: 'PS2Keboard shared queue poll'! !

!PS2Keyboard methodsFor: 'initialization' stamp: 'gera 9/4/2008 09:01'!
initializeHardware
	self
		initializeKeyboardHardware;
		initializeMouseHardware.

"	self enableKeyboardInputBufferFullInterrupt;	not needed, commandByte: 16r47 enables all
		enableKeyboardInterface.
"
	self commandByte: 16r47.	" enable mouse and keyboard, and set scan code 1 "
! !

!PS2Keyboard methodsFor: 'initialization' stamp: 'gera 9/4/2008 08:57'!
initializeKeyboardHardware

	self report: 'Performing keyboard initialization';
		commandByte: 0.
	self report: 'reseting keyboard'.
	self
		resetKeyboard;
		commandByte: 0;
		report: 'keyboard reset.'.

	self testController
		ifFalse: 
			[self report: 'controller self test: failed.'.
			^ false].

	self report: 'controller self test: Ok'.
	self testKeyboardInterface
		ifFalse: 
			[self report: 'keyboard self test: failed.'.
			^ false].
	self report: 'keyboard self test: Ok'.

	self testKeyboardEcho
		ifFalse: 
			[self report: 'keyboard echo: failed.'.
			^ false].
	self report: 'keyboard echo: Ok'";
		keyboardLeds: 0;
		keyboardScanCodeSet: 1".		" this two commented out because they take too long to complete :( "
! !

!PS2Keyboard methodsFor: 'initialization' stamp: 'Pocho 12/26/2009 15:31'!
initializeMouseHardware

	self report: 'Performing mouse initialization'.

	self testMouseInterface ifTrue: [
		self report: 'Mouse present'.
		self mouseSampleRate: 16rC8. 
		self mouseSampleRate: 16r64. 
		self mouseSampleRate: 16r50.
		self mouseId = 16r03
			ifTrue: [
				self report: 'Enabling mouse scrolling.'.
				self enableMouseScrollingParsing]
			ifFalse: [self disableMouseScrollingParsing].
"		self disableMouseScrollingParsing."
		self "disableMouse;
			resetMouse;"
			enableMouse";
			enableMouseInputBufferFullInterrupt;	 not needed, commandByte: 16r47 enables all 
			enableMouseInterface"].
! !

!PS2Keyboard methodsFor: 'hardware status' stamp: 'r++ 7/24/2008 20:33'!
inputBufferFull
	^ self statusPort anyMask: 2! !

!PS2Keyboard methodsFor: 'controller commands' stamp: 'r++ 7/26/2008 12:42'!
inputPort
	self controllerCommand: 16rCO.
	^ self readKeyboardData.! !

!PS2Keyboard methodsFor: 'keyboard commands' stamp: 'r++ 7/24/2008 22:26'!
keyboardBuffer: value
	self controllerCommand: 16rD2.
	self keyboardCommand: value.
	! !

!PS2Keyboard methodsFor: 'low level protocol' stamp: 'r++ 7/24/2008 20:45'!
keyboardCommand: cmd
	self waitToWrite ifFalse: [^false].
	self dataPort: cmd.
	^true! !

!PS2Keyboard methodsFor: 'keyboard commands' stamp: 'r++ 7/26/2008 12:42'!
keyboardId
	self keyboardCommand: 16rF2.
	self waitKeyboardAck.
	^(self readKeyboardData bitShift: 8) bitOr: self keyboardData.! !

!PS2Keyboard methodsFor: 'hardware status' stamp: 'r++ 7/24/2008 20:34'!
keyboardInhibited
	^ (self statusPort anyMask: 16) not! !

!PS2Keyboard methodsFor: 'keyboard commands' stamp: 'r++ 7/26/2008 15:25'!
keyboardLeds: value
	self keyboardCommand: 16rED.
	self waitKeyboardAck.
	self keyboardCommand: value.
	^self waitKeyboardAck.
! !

!PS2Keyboard methodsFor: 'hardware status' stamp: 'r++ 7/26/2008 13:39'!
keyboardOutputBufferFull
	^ self statusPort anyMask: 1! !

!PS2Keyboard methodsFor: 'keyboard commands' stamp: 'gera 9/4/2008 19:27'!
keyboardScanCodeSet: value
	value == 1
		ifTrue: [self setCommandBit: 6]
		ifFalse: [self clearCommandBit: 6].
"	self keyboardCommand: 16rF0.
	self waitKeyboardAck.
	self keyboardCommand: value.
	^self waitKeyboardAck.
"! !

!PS2Keyboard methodsFor: 'keyboard commands' stamp: 'r++ 7/26/2008 13:35'!
keyboardTypematicRateDelay: value
	self keyboardCommand: 16rF3.
	self waitKeyboardAck.
	self keyboardCommand: value.
	^self waitKeyboardAck! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/24/2008 22:27'!
mouseBuffer: value
	self controllerCommand: 16rD3.
	self keyboardCommand: value.
	! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 17:30'!
mouseCommand: value
	self controllerCommand: 16rD4.
	self keyboardCommand: value.
	^ self waitMouseAck.! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:33'!
mouseCommandNoAck: value
	self controllerCommand: 16rD4.
	self keyboardCommand: value.! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:47'!
mouseId
	self mouseCommand: 16rF2.
	^self readMouseData! !

!PS2Keyboard methodsFor: 'command byte' stamp: 'r++ 7/25/2008 19:29'!
mouseInputBufferInterruptEnabled
	^ self testCommandBit: 2! !

!PS2Keyboard methodsFor: 'hardware status' stamp: 'r++ 7/24/2008 20:36'!
mouseOutputBufferFull
	^ self statusPort anyMask: 32! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:55'!
mouseResolution: value
	^ (self mouseCommand: 16rE8) and: [self mouseCommand: value]! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:54'!
mouseSampleRate: value
	^ (self mouseCommand: 16rF3) and: [self mouseCommand: value]! !

!PS2Keyboard methodsFor: 'accessing' stamp: 'gera 9/4/2008 08:53'!
mouseScrollingEnabled
	^ configBits anyMask: 1! !

!PS2Keyboard methodsFor: 'irq handling' stamp: 'gera 9/4/2008 09:22'!
newKeyboardControlCharEvent: char
	modifiersAndButtons  := (modifiersAndButtons  bitOr: 16r10).
	self newKeyboardEvent: char type: EventKeyChar.
	modifiersAndButtons := modifiersAndButtons bitClear: 16r10.
! !

!PS2Keyboard methodsFor: 'irq handling' stamp: 'r++ 7/26/2008 14:57'!
newKeyboardDownEvent: aCharacter
	self newKeyboardEvent: aCharacter type: EventKeyDown.
	self newKeyboardEvent: aCharacter type: EventKeyChar.
! !

!PS2Keyboard methodsFor: 'irq handling' stamp: 'JEP 5/4/2010 18:16'!
newKeyboardEvent: aCharacter type: byteType
	" taken from EventSensor >> #nextEventSynthesized "
	| event |
	(event := Array new: 8)
		at: 1 put: EventTypeKeyboard; "evt type"
		at: 2 put: Time millisecondClockValue; "time stamp"
		at: 3 put: aCharacter asciiValue; "char code"
		at: 4 put: byteType; "key press/release"
		at: 5 put: modifiersAndButtons >> 3; "modifier keys"
		at: 6 put: 0. "reserved, but nil breaks something called UTF32InputInterpreter"

	"Transcript show: modifiersAndButtons."
	events nextPut: event.! !

!PS2Keyboard methodsFor: 'irq handling' stamp: 'r++ 7/26/2008 14:57'!
newKeyboardUpEvent: aCharacter
	self newKeyboardEvent: aCharacter type: EventKeyUp! !

!PS2Keyboard methodsFor: 'irq handling' stamp: 'JavierPimas 8/11/2010 15:18'!
newMouseEvent
	| modifiers buttons mapped event |
	modifiers := modifiersAndButtons bitShift: -3.
	buttons := modifiersAndButtons bitAnd: 7.
	mapped := Sensor mapButtons: buttons modifiers: modifiers.
	(event := Array new: 8)
		at: 1 put: EventTypeMouse;
		at: 2 put: Time millisecondClockValue;
		at: 3 put: mouseCoord x;
		at: 4 put: mouseCoord y;
		at: 5 put: mapped;
		at: 6 put: modifiers;
		at: 7 put: 0;
		at: 8 put: 1.
	events nextPut: event.
"	self report: event.
"! !

!PS2Keyboard methodsFor: 'controller commands' stamp: 'r++ 7/26/2008 12:42'!
outputPort
	self controllerCommand: 16rDO.
	^ self readKeyboardData.! !

!PS2Keyboard methodsFor: 'controller commands' stamp: 'r++ 7/24/2008 22:26'!
outputPort: value
	self controllerCommand: 16rD1.
	self keyboardCommand: value.
	! !

!PS2Keyboard methodsFor: 'controller commands' stamp: 'r++ 7/24/2008 22:25'!
outputPortLow: value
	self controllerCommand: 16r90 + (value bitAnd: 15).
	! !

!PS2Keyboard methodsFor: 'hardware status' stamp: 'r++ 7/24/2008 20:36'!
paryityError
	^ self statusPort anyMask: 128! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:51'!
pollMouseDataPacket
	self mouseCommand: 16rEB.
	^self readMouseDataPacket! !

!PS2Keyboard methodsFor: 'controller commands' stamp: 'r++ 7/24/2008 22:29'!
pulseOutputPortLow: value
	self controllerCommand: 16rF0 + (value bitAnd: 15).! !

!PS2Keyboard methodsFor: 'low level protocol' stamp: 'r++ 7/26/2008 12:40'!
readKeyboardData
	self waitToReadKeyboard ifFalse: [^nil].
	^self dataPort! !

!PS2Keyboard methodsFor: 'low level protocol' stamp: 'r++ 7/26/2008 20:01'!
readMouseData
	self waitToReadMouse ifFalse: [^nil].
	^self dataPort.! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:51'!
readMouseDataPacket
	^ Array with: self readMouseData with: self readMouseData with: self readMouseData! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:52'!
readMouseStatus
	self mouseCommand: 16rE9.
	^self readMouseData! !

!PS2Keyboard methodsFor: 'keyboard commands' stamp: 'r++ 7/26/2008 12:42'!
resendKeyboardCommand
	self keyboardCommand: 16rFE.
	^ self readKeyboardData! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:32'!
resendMouseCommand
	^ self mouseCommand: 16rFE.! !

!PS2Keyboard methodsFor: 'keyboard commands' stamp: 'gera 8/27/2008 05:45'!
resetKeyboard
	| answer |
	self keyboardCommand: 16rFF.
	self waitKeyboardAck ifFalse: [^false].
	(answer := self readKeyboardData) ifNil: [^ false].
	answer == 16rAA ifTrue: [^true].
	answer ~~ 16rFC ifTrue: [self report: 'Unexpected answer to reset command: ', answer hex].
	^ false! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 13:04'!
resetMouse
	| answer |
	(self mouseCommand: 16rFF) ifFalse: [^false].
	answer := self readMouseData.
	answer == 16rAA ifTrue: [^self readMouseData == 0 " mouse sends device ID after reset "].
	answer ~~ 16rFC ifTrue: [self report: 'Unexpected answer to reset command: ', answer hex].
	^ false! !

!PS2Keyboard methodsFor: 'command byte' stamp: 'r++ 7/25/2008 19:30'!
scancodeTranslationEnabled
	^ self testCommandBit: 16r40! !

!PS2Keyboard methodsFor: 'command byte' stamp: 'gera 9/4/2008 19:27'!
setCommandBit: bit
	^ self commandByte: (self commandByte bitOr: 1 << bit)! !

!PS2Keyboard methodsFor: 'keyboard commands' stamp: 'r++ 7/25/2008 19:38'!
setKeyboardDefaults
	self keyboardCommand: 16rF6.
	^ self waitKeyboardAck! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:45'!
setMouseDefaults
	^ self mouseCommand: 16rF6.! !

!PS2Keyboard methodsFor: 'keyboard access' stamp: 'r++ 7/26/2008 15:05'!
shiftPressed
	^ modifiersAndButtons anyMask: 8! !

!PS2Keyboard methodsFor: 'I/O' stamp: 'r++ 7/24/2008 20:29'!
statusPort
	^ self byteAt: 4! !

!PS2Keyboard methodsFor: 'hardware status' stamp: 'r++ 7/24/2008 20:33'!
systemInitialized
	^ self statusPort anyMask: 4! !

!PS2Keyboard methodsFor: 'command byte' stamp: 'r++ 7/25/2008 19:29'!
testCommandBit: mask
	^ self commandByte anyMask: mask! !

!PS2Keyboard methodsFor: 'controller commands' stamp: 'r++ 7/26/2008 12:42'!
testController
	self controllerCommand: 16rAA.
	^ self readKeyboardData == 16r55
! !

!PS2Keyboard methodsFor: 'keyboard commands' stamp: 'r++ 7/26/2008 12:42'!
testKeyboardEcho
	self keyboardCommand: 16rEE.
	^ self readKeyboardData == 16rEE! !

!PS2Keyboard methodsFor: 'keyboard commands' stamp: 'r++ 7/26/2008 12:42'!
testKeyboardInterface
	self controllerCommand: 16rAB.
	^ self readKeyboardData isZero
! !

!PS2Keyboard methodsFor: 'mouse commands' stamp: 'r++ 7/26/2008 12:43'!
testMouseInterface
	self controllerCommand: 16rA9.
	^ self readKeyboardData isZero
! !

!PS2Keyboard methodsFor: 'controller commands' stamp: 'r++ 7/26/2008 12:43'!
testPort
	self controllerCommand: 16rE0.
	^ self readKeyboardData! !

!PS2Keyboard methodsFor: 'hardware status' stamp: 'r++ 7/24/2008 20:35'!
timeoutError
	^ self statusPort anyMask: 64! !

!PS2Keyboard methodsFor: 'controller commands' stamp: 'r++ 7/24/2008 22:22'!
version
	self controllerCommand: 16rAD.
"	^ self readData."! !

!PS2Keyboard methodsFor: 'controller commands' stamp: 'r++ 7/24/2008 22:22'!
versionNumber
	self controllerCommand: 16rA1.
"	^ self readData."! !

!PS2Keyboard methodsFor: 'low level protocol' stamp: 'r++ 7/26/2008 12:40'!
waitKeyboardAck
	^ self readKeyboardData == 16rFA! !

!PS2Keyboard methodsFor: 'low level protocol' stamp: 'r++ 7/26/2008 17:30'!
waitMouseAck
	^ self readMouseData == 16rFA! !

!PS2Keyboard methodsFor: 'low level protocol' stamp: 'gera 8/27/2008 05:46'!
waitToReadKeyboard
	| delay |
	self keyboardOutputBufferFull ifTrue: [^true].
	delay := Delay forMilliseconds: 1.
	1000 timesRepeat: [
		delay wait.
		self keyboardOutputBufferFull ifTrue: [^true]
	].
	self report: 'timedout out witing for keyboard input.'.
	^false
	! !

!PS2Keyboard methodsFor: 'low level protocol' stamp: 'r++ 7/26/2008 17:00'!
waitToReadMouse
	| delay |
	self mouseOutputBufferFull ifTrue: [^true].
	delay := Delay forMilliseconds: 1.
	250 timesRepeat: [
		delay wait.
		self mouseOutputBufferFull ifTrue: [^true]
	].
	self report: 'timedout out witing for mouse input.'.
	^false
	! !

!PS2Keyboard methodsFor: 'low level protocol' stamp: 'r++ 7/26/2008 17:00'!
waitToWrite
	| delay |
	self inputBufferFull ifFalse: [^true].
	delay := Delay forMilliseconds: 1.
	250 timesRepeat: [
		delay wait.
		self inputBufferFull ifFalse: [^true]
	].
	self report: 'timedout out witing to write.'.
	^false
	! !

HardwareDevice subclass: #UART8250
	instanceVariableNames: 'receivedChars baudRate stopBits parity dataBits interruptId lineStatus modemStatus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Base'!

!UART8250 commentStamp: '<historical>' prior: 0!
This is the Serial port driver. It's useful for debugging.

Usage example: 

This code will loop until it receives 100 bytes and will write them in transcript. Caution, will block everything until it finishes reading.
| s |
s := Computer current defaultSerialPort.
s open.
100 timesRepeat: [Transcript show: (s nextPut: s next)]. !

UART8250 subclass: #UART16550
	instanceVariableNames: 'fifoStatus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Base'!

!UART16550 class methodsFor: 'system startup' stamp: 'gera 7/20/2006 18:49'!
installOn: aComputer 
	| first |
	first := nil.
	self detectedUARTS with: #(4 3 4 3) do: [:uart :irq |
		uart notNil ifTrue: [
			first isNil ifTrue: [first := uart].
			aComputer interruptController
				addHandler: uart
				forIRQ: irq]].
	^ aComputer defaultSerialPort: first.! !

!UART16550 methodsFor: 'device protocol' stamp: 'gera 5/21/2006 20:08'!
close
	super close.
	self fifoControlRegister: 0
	! !

!UART16550 methodsFor: 'FIFO control' stamp: 'gera 5/21/2006 20:08'!
disableFIFO
	fifoStatus := fifoStatus bitClear: 1.
	self fifoControlRegister: fifoStatus.! !

!UART16550 methodsFor: 'FIFO control' stamp: 'gera 5/21/2006 20:08'!
enableFIFO
	fifoStatus := fifoStatus bitOr: 1.
	self fifoControlRegister: fifoStatus.! !

!UART16550 methodsFor: 'registers' stamp: 'gera 5/21/2006 19:58'!
fifoControlRegister
	^ self byteAt: 2! !

!UART16550 methodsFor: 'registers' stamp: 'gera 5/21/2006 19:58'!
fifoControlRegister: aByte
	^ self byteAt: 2 put: aByte! !

!UART16550 methodsFor: 'device protocol' stamp: 'gera 5/17/2006 11:39'!
open
	" tiene comentarios!! "
	fifoStatus _ 0.
	super open.
	self enableFIFO;
		triggerLevel: 4;
		resetInputQueue;
		resetOutputQueue.

		
		
	
! !

!UART16550 methodsFor: 'FIFO control' stamp: 'gera 5/21/2006 20:08'!
resetInputQueue
	self fifoControlRegister: (fifoStatus bitOr: 2).! !

!UART16550 methodsFor: 'FIFO control' stamp: 'gera 5/21/2006 20:08'!
resetOutputQueue
	self fifoControlRegister: (fifoStatus bitOr: 4).! !

!UART16550 methodsFor: 'FIFO control' stamp: 'gera 5/21/2006 20:08'!
triggerLevel: integer
	| idx |
	idx := #(1 4 8 14) indexOf: integer.
	idx = 0 ifTrue: [idx := 3]. "default value"
	fifoStatus := fifoStatus bitOr: ((idx - 1) bitShift: 6).
	self fifoControlRegister:	fifoStatus! !

!UART8250 class methodsFor: 'system startup' stamp: 'gera 5/21/2006 19:51'!
detectedUARTS
	| uart |
	^#(16r3F8 16r2F8 16r3E8 16r2E8)
		collect: [:portNumber |
			uart := self onPort: portNumber.
			uart exists ifTrue: [uart] ifFalse: [nil]].
! !

!UART8250 methodsFor: 'testing' stamp: 'gera 5/17/2006 11:39'!
anyInterrupt
	^(interruptId bitAnd: 2r1110) ~= 0

! !

!UART8250 methodsFor: 'accessing' stamp: 'gera 5/17/2006 11:39'!
baudRateDivisorFor: baud
	^ 115200 // baud
! !

!UART8250 methodsFor: 'accessing' stamp: 'gera 7/18/2006 18:29'!
checkError
	(lineStatus bitAnd: 16r1E) = 0
		ifFalse: [Transcript cr; show: 'Error LSR/UART ', lineStatus printStringHex]! !

!UART8250 methodsFor: 'device protocol' stamp: 'gera 5/21/2006 19:59'!
close
	Preferences disableLogging.
	self interruptEnableRegister: 0.
	self modemControlRegister: 3.

! !

!UART8250 methodsFor: 'testing' stamp: 'gera 5/17/2006 11:39'!
dataAvailabelInRDR
	^ (lineStatus bitAnd: 1) = 1! !

!UART8250 methodsFor: 'device protocol' stamp: 'gera 5/17/2006 11:39'!
dataAvailable
	^ receivedChars isEmpty not! !

!UART8250 methodsFor: 'accessing' stamp: 'gera 5/21/2006 20:06'!
disableLoopbackTesting
	self modemControlRegister: 16r0! !

!UART8250 methodsFor: 'accessing' stamp: 'gera 5/21/2006 20:06'!
enableLoopbackTesting
	self modemControlRegister: 16r10! !

!UART8250 methodsFor: 'testing' stamp: 'gera 5/21/2006 20:06'!
exists
	self enableLoopbackTesting.
	self readModemStatus.
	(modemStatus anyMask: 16rF0) ifTrue: [^ false].
	self modemControlRegister: 16r1F.
	self readModemStatus.
	(modemStatus bitAnd: 16rF0) = 16rF0 ifFalse: [^ false].
	self disableLoopbackTesting.
	^true
		! !

!UART8250 methodsFor: 'device protocol' stamp: 'gera 5/17/2006 11:39'!
flush
	^ self! !

!UART8250 methodsFor: 'irq handling' stamp: 'gera 7/22/2006 14:07'!
handleIRQ
	self turnOffRTS.
	
	[self readInterruptId.
	self receivedDataPending
		ifTrue: 
			[
			[receivedChars nextPut: (self byteAt: 0).
			self readLineStatus.
			self checkError.
			self dataAvailabelInRDR] whileTrue].
	self interruptPending] whileTrue.
	self turnOnRTS! !

!UART8250 methodsFor: 'initialization' stamp: 'gera 5/28/2006 14:46'!
initialize
	super initialize.
	baudRate := 57600. "tried 115200 but doesn't work on my vmware at least"
	stopBits := 1.
	parity := 0.
	dataBits := 8! !

!UART8250 methodsFor: 'accessing' stamp: 'gera 5/21/2006 20:05'!
initializeLineControlRegisterStopBitsType: stopBitsInteger parityType: parityInteger dataBits: numDataBits 
	| lcr |
	numDataBits = 7
		ifTrue: [lcr := 2]
		ifFalse: [lcr := 3].
	stopBits = 2 ifTrue: [lcr := lcr bitOr: 4].
	parity = 0
		ifFalse: 
			[lcr := lcr bitOr: 8.
			parity = 2 ifTrue: [lcr := lcr bitOr: 16]].
	self lineControlRegister: lcr! !

!UART8250 methodsFor: 'registers' stamp: 'gera 5/21/2006 19:56'!
interruptEnableRegister
	^ self byteAt: 1! !

!UART8250 methodsFor: 'registers' stamp: 'gera 5/21/2006 19:57'!
interruptEnableRegister: aByte
	^ self byteAt: 1 put: aByte! !

!UART8250 methodsFor: 'registers' stamp: 'gera 5/21/2006 19:56'!
interruptIDRegister
	^ self byteAt: 2! !

!UART8250 methodsFor: 'registers' stamp: 'gera 5/21/2006 19:57'!
interruptIDRegister: aByte
	^ self byteAt: 2 put: aByte! !

!UART8250 methodsFor: 'testing' stamp: 'gera 5/17/2006 11:39'!
interruptPending
	^(interruptId bitAnd: 1) = 0

! !

!UART8250 methodsFor: 'device protocol' stamp: 'gera 5/17/2006 11:39'!
isOpen
	^ true! !

!UART8250 methodsFor: 'registers' stamp: 'gera 5/21/2006 19:56'!
lineControlRegister
	^ self byteAt: 3! !

!UART8250 methodsFor: 'registers' stamp: 'gera 5/21/2006 19:57'!
lineControlRegister: aByte
	^ self byteAt: 3 put: aByte! !

!UART8250 methodsFor: 'registers' stamp: 'gera 5/21/2006 19:56'!
lineStatusRegister
	^ self byteAt: 5! !

!UART8250 methodsFor: 'registers' stamp: 'gera 5/21/2006 19:57'!
lineStatusRegister: aByte
	^ self byteAt: 5 put: aByte! !

!UART8250 methodsFor: 'registers' stamp: 'gera 5/21/2006 19:56'!
modemControlRegister
	^ self byteAt: 4! !

!UART8250 methodsFor: 'registers' stamp: 'gera 5/21/2006 19:57'!
modemControlRegister: aByte
	^ self byteAt: 4 put: aByte! !

!UART8250 methodsFor: 'registers' stamp: 'gera 5/21/2006 19:56'!
modemStatusRegister
	^ self byteAt: 6! !

!UART8250 methodsFor: 'registers' stamp: 'gera 5/21/2006 19:57'!
modemStatusRegister: aByte
	^ self byteAt: 6 put: aByte! !

!UART8250 methodsFor: 'device protocol' stamp: 'gera 5/25/2006 22:39'!
next
	^ self nextByte! !

!UART8250 methodsFor: 'device protocol' stamp: 'gera 5/25/2006 22:43'!
next: anInteger
	| answer |
	answer := ByteArray new: anInteger.
	1 to: anInteger do: [:index | answer at: index put: self next].
	^answer! !

!UART8250 methodsFor: 'device protocol' stamp: 'gera 5/17/2006 11:39'!
nextAvailable
	| size answer |
	size _ receivedChars size.
	answer _ String new: size.
	1 to: size do: [:index | answer at: index put: self next].
	^answer! !

!UART8250 methodsFor: 'accessing' stamp: 'gera 5/17/2006 11:39'!
nextByte
	^ receivedChars next! !

!UART8250 methodsFor: 'device protocol' stamp: 'gera 5/17/2006 11:39'!
nextPut: aCharacter
	self xmitByte: aCharacter asInteger.
	^ aCharacter! !

!UART8250 methodsFor: 'device protocol' stamp: 'gera 5/17/2006 11:39'!
nextPutAll: aString
	aString do: [:char | self nextPut: char].! !

!UART8250 methodsFor: 'device protocol' stamp: 'JavierPimas 12/29/2010 13:44'!
open
	receivedChars := SharedQueue new.
	self setBaudRate: baudRate.
	self
		initializeLineControlRegisterStopBitsType: stopBits
		parityType: parity
		dataBits: dataBits.
	self byteAt: 0.
	self readLineStatus.
	self readModemStatus.
	self modemControlRegister: 16r0B.
	self interruptEnableRegister: 16r09.
	self interruptIDRegister! !

!UART8250 methodsFor: 'squeakNOS primitives' stamp: 'gera 5/17/2006 11:39'!
primClosePort: portNumber
	self close! !

!UART8250 methodsFor: 'squeakNOS primitives' stamp: 'gera 5/17/2006 11:39'!
primOpenPort: portNumber baudRate: baud stopBitsType: stop
	parityType: parityType dataBits: numDataBits
	inFlowControlType: inFlowCtrl outFlowControlType: outFlowCtrl
	xOnByte: xOn xOffByte: xOff
	self openPort: portNumber! !

!UART8250 methodsFor: 'squeakNOS primitives' stamp: 'gera 5/17/2006 11:39'!
primReadPort: portNumber into: byteArray startingAt: startIndex count: count
	| index |
	index _ startIndex.
	count timesRepeat: [
		byteArray at: index put: self nextByte.
		index _ index + 1].! !

!UART8250 methodsFor: 'squeakNOS primitives' stamp: 'gera 5/17/2006 11:39'!
primWritePort: portNumber from: byteArray startingAt: startIndex count: count
	| index |
	index _ startIndex.
	count timesRepeat: [self nextPut: (byteArray at: index)]! !

!UART8250 methodsFor: 'accessing' stamp: 'gera 5/21/2006 20:05'!
readInterruptId
	interruptId := self interruptIDRegister

! !

!UART8250 methodsFor: 'accessing' stamp: 'gera 5/21/2006 20:06'!
readLineStatus
	lineStatus := self lineStatusRegister

! !

!UART8250 methodsFor: 'accessing' stamp: 'gera 5/21/2006 20:07'!
readModemStatus
	modemStatus := self modemStatusRegister

! !

!UART8250 methodsFor: 'testing' stamp: 'gera 5/17/2006 11:39'!
receivedDataPending
	^(interruptId bitAnd: 2r110) = 2r100

! !

!UART8250 methodsFor: 'device protocol' stamp: 'gera 5/17/2006 11:39'!
reopen
	self close.
	self open! !

!UART8250 methodsFor: 'accessing' stamp: 'gera 7/18/2006 12:05'!
setBaudRate: baud
	| brd |
	baudRate := baud.
	brd := self baudRateDivisorFor: baud.
	self lineControlRegister: 16r80.
 	self interruptEnableRegister: (brd bitShift: -8).
	self byteAt: 0 put: (brd bitAnd: 255).! !

!UART8250 methodsFor: 'testing' stamp: 'gera 5/17/2006 11:39'!
testTHR
	^(lineStatus bitAnd: 2r00100000) ~= 0! !

!UART8250 methodsFor: 'accessing' stamp: 'gera 5/21/2006 20:07'!
turnOffRTS
	| mcr |
	mcr := self modemControlRegister.
	self modemControlRegister: (mcr bitAnd: 2r11111101)
! !

!UART8250 methodsFor: 'accessing' stamp: 'gera 5/21/2006 20:10'!
turnOnRTS
	self modemControlRegister: 
		(self modemControlRegister bitOr: 2r10).! !

!UART8250 methodsFor: 'accessing' stamp: 'gera 7/18/2006 12:05'!
xmitByte: value
	| process delay timeout |
	timeout := false.
	delay := Delay forSeconds: 5.
	process := 
			[delay wait.
			timeout := true]
				forkAt: Processor lowIOPriority.
	[self readLineStatus.
	timeout | self testTHR] whileFalse.
	timeout ifTrue: [Transcript cr; show: 'TimeOut'. ^self].
	"delay unschedule."
	process terminate.
	self byteAt: 0 put: value! !

HardwareDevice subclass: #USBUHCIController
	instanceVariableNames: 'frameList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-USB'!

!USBUHCIController class methodsFor: 'as yet unclassified' stamp: 'gera 1/1/1901 00:14'!
classCode
	^12! !

!USBUHCIController class methodsFor: 'as yet unclassified' stamp: 'gera 1/1/1901 00:14'!
classSubCode
	^3! !

!USBUHCIController class methodsFor: 'as yet unclassified' stamp: 'gera 1/1/1901 00:14'!
installOn: aComputer
	| pciEntry |
	pciEntry := PCIBusEntry allValid
		detect: [:e |
			e classCode == self classCode and: [
			e classSubCode == self classSubCode and: [
			e programmingInterface == self programmingInterface]]]
		ifNone: [^ self].

	^ self onPCIEntry: pciEntry computer: aComputer.
! !

!USBUHCIController class methodsFor: 'as yet unclassified' stamp: 'gera 9/14/2008 14:15'!
onPCIEntry: aPCIBusEntry computer: aComputer
	| answer |
	answer := self onPort: aPCIBusEntry allIORanges first key.

	aPCIBusEntry
		enableBusMastering;
		enableIO;
		" enable IRQ routing (legacy support)"
		configShort: 16rC0 put: ((aPCIBusEntry configShort: 16rC0) bitOr: 1 << 13).

	" copyed from GRUB, not sure if needed or not:"
	aPCIBusEntry latencyTimer < 32 ifTrue: [aPCIBusEntry latencyTimer: 32].

	aComputer interruptController
		addHandler: answer
		forIRQ: aPCIBusEntry interruptLine.

	aComputer usbUHCIController: answer.
	^ answer

! !

!USBUHCIController class methodsFor: 'as yet unclassified' stamp: 'gera 1/1/1901 00:14'!
programmingInterface
	^0! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'r++ 8/15/2008 19:35'!
acknowledgeForceGlobalResume
	^self clearCommandBit: 4! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'gera 9/4/2008 19:24'!
clearCommandBit: bit
	^ self command: (self command bitClear: 1 << bit)! !

!USBUHCIController methodsFor: 'accessing - frame list' stamp: 'gera 8/24/2008 09:41'!
clearFrameListAt: index
	self frameListValueAt: index put: 1	" 1 = termiator "! !

!USBUHCIController methodsFor: 'accessing - interrupt register' stamp: 'gera 9/4/2008 19:24'!
clearInterruptBit: bit
	^ self interruptEnable: (self interruptEnable bitClear: 1 << bit)
! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'gera 8/24/2008 12:07'!
clearPort1ConnectStatusChange
	^self setPort1ControlBit: 1! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'gera 9/4/2008 19:25'!
clearPort1ControlBit: bit
	^ self port1StatusControl: (self port1StatusControl bitClear: 1 << bit)! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:45'!
clearPort1EnableStatusChange
	^self setPort1ControlBit: 3! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'gera 8/24/2008 12:07'!
clearPort2ConnectStatusChange
	^self setPort2ControlBit: 1! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'gera 9/4/2008 19:25'!
clearPort2ControlBit: bit
	^ self port2StatusControl: (self port2StatusControl bitClear: 1 << bit)! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:45'!
clearPort2EnableStatusChange
	^self setPort2ControlBit: 3! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:21'!
command
	^self shortAt: 0! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:22'!
command: anInteger
	^self shortAt: 0 put: anInteger! !

!USBUHCIController methodsFor: 'accessing - interrupt register' stamp: 'gera 8/24/2008 08:48'!
disableAllInterrupts
	self interruptEnable: 0! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'r++ 8/15/2008 19:35'!
disableConfigureFlag
	^self clearCommandBit: 6! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'r++ 8/15/2008 19:38'!
disableGlobalReset
	^self clearCommandBit: 2! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'r++ 8/15/2008 19:40'!
disableGlobalSuspendMode
	^self setCommandBit: 3
! !

!USBUHCIController methodsFor: 'accessing - interrupt register' stamp: 'gera 8/24/2008 08:46'!
disableInterruptOnComplete
	self clearInterruptBit: 2! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:47'!
disablePort1
	^self clearPort1ControlBit: 2! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:31'!
disablePort1Reset
	self clearPort1ControlBit: 9! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:42'!
disablePort1ResumeSignaling
	self clearPort1ControlBit: 6! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:31'!
disablePort1Suspend
	self clearPort1ControlBit: 12! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:47'!
disablePort2
	^self clearPort2ControlBit: 2! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:31'!
disablePort2Reset
	self clearPort2ControlBit: 9! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:42'!
disablePort2ResumeSignaling
	self clearPort2ControlBit: 6! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:31'!
disablePort2Suspend
	self clearPort2ControlBit: 12! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'r++ 8/15/2008 19:35'!
disableScheduling
	^self clearCommandBit: 0! !

!USBUHCIController methodsFor: 'accessing - interrupt register' stamp: 'gera 8/24/2008 08:46'!
disableShortPacketInterrupt
	self clearInterruptBit: 3! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'r++ 8/15/2008 19:36'!
disableSoftwareDebug
	^self clearCommandBit: 5! !

!USBUHCIController methodsFor: 'accessing - interrupt register' stamp: 'gera 8/24/2008 08:47'!
disableTimeoutCRCInterrupt
	self clearInterruptBit: 0! !

!USBUHCIController methodsFor: 'accessing - interrupt register' stamp: 'gera 8/24/2008 08:48'!
enableAllInterrupts
	self interruptEnable: 2r1111! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'r++ 8/15/2008 19:37'!
enableConfigureFlag
	^self setCommandBit: 6! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'r++ 8/15/2008 19:38'!
enableGlobalReset
	^self setCommandBit: 2! !

!USBUHCIController methodsFor: 'accessing - interrupt register' stamp: 'gera 8/24/2008 08:46'!
enableInterruptOnComplete
	self setInterruptBit: 2! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:46'!
enablePort1
	^self setPort1ControlBit: 2! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:31'!
enablePort1Reset
	self setPort1ControlBit: 9! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:42'!
enablePort1ResumeSignaling
	self setPort1ControlBit: 6! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:30'!
enablePort1Suspend
	self setPort1ControlBit: 12! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:46'!
enablePort2
	^self setPort2ControlBit: 2! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:31'!
enablePort2Reset
	self setPort2ControlBit: 9! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:42'!
enablePort2ResumeSignaling
	self setPort2ControlBit: 6! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:30'!
enablePort2Suspend
	self setPort2ControlBit: 12! !

!USBUHCIController methodsFor: 'accessing - interrupt register' stamp: 'gera 8/24/2008 08:45'!
enableResumeInterrupt
	self setInterruptBit: 1! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'r++ 8/15/2008 19:37'!
enableScheduling
	^self setCommandBit: 0! !

!USBUHCIController methodsFor: 'accessing - interrupt register' stamp: 'gera 8/24/2008 08:46'!
enableShortPacketInterrupt
	self setInterruptBit: 3! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'r++ 8/15/2008 19:37'!
enableSoftwareDebug
	^self setCommandBit: 5! !

!USBUHCIController methodsFor: 'accessing - interrupt register' stamp: 'gera 8/24/2008 08:45'!
enableTimeoutCRCInterrupt
	self setInterruptBit: 0! !

!USBUHCIController methodsFor: 'accessing - status' stamp: 'gera 1/1/1901 00:44'!
errorInterruptPending
	^self testStatusBit: 1! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'gera 1/1/1901 00:35'!
forceGlobalResumeRequested
	^self testCommandBit: 4! !

!USBUHCIController methodsFor: 'accessing - frame list' stamp: 'gera 8/24/2008 08:10'!
frameList
	^ frameList! !

!USBUHCIController methodsFor: 'accessing - frame list' stamp: 'gera 9/8/2008 20:10'!
frameListAddressAt: index
	^ ExternalAddress fromInteger: ((self frameListValueAt: index) bitClear: 2r1111)! !

!USBUHCIController methodsFor: 'accessing - frame list' stamp: 'gera 8/24/2008 10:01'!
frameListAt: index
	(self isTerminatorAt: index) ifTrue: [^nil].
	^ (self isPointingToQueueHeadAt: index) 
		ifTrue: [USBQueueHead fromHandle: (self frameListAddressAt: index)]
		ifFalse: [USBTransferDescriptor fromHandle: (self frameListAddressAt: index)]! !

!USBUHCIController methodsFor: 'accessing - frame list' stamp: 'gera 8/24/2008 09:57'!
frameListAt: index put: aListElement
	aListElement ifNil: [^ self clearFrameListAt: index].
	self frameListValueAt: index put: aListElement address.	" this clears the [next] terminator flag "
	aListElement isQueueHead
		ifTrue: [self pointToQueueHeadAt: index]
		ifFalse: [self pointToTransferDescriptorAt: index]
! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:23'!
frameListBaseAddress
	^self longAt: 8! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:23'!
frameListBaseAddress: anInteger
	^self longAt: 8 put: anInteger! !

!USBUHCIController methodsFor: 'accessing - frame list' stamp: 'gera 8/24/2008 11:03'!
frameListValueAt: index
	^frameList unsignedLongAt: index * 4 - 3! !

!USBUHCIController methodsFor: 'accessing - frame list' stamp: 'gera 8/24/2008 09:41'!
frameListValueAt: index put: anInteger
	frameList unsignedLongAt: index * 4 - 3 put: anInteger! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:23'!
frameNumber
	^self shortAt: 6! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:23'!
frameNumber: anInteger
	^self shortAt: 6 put: anInteger! !

!USBUHCIController methodsFor: 'irq handling' stamp: 'gera 9/9/2008 08:56'!
handleIRQ
	self report: 'Command: ', self command hex, ' Status: ', self status hex.
	self resetStatus.
! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'gera 1/1/1901 00:30'!
hasBeenConfigured
	^self testCommandBit: 6! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'gera 1/1/1901 00:40'!
hasSchedulingEnabled
	^self testCommandBit: 0! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'gera 1/1/1901 00:35'!
hasSoftwareDebugEnabled
	^self testCommandBit: 5! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'gera 8/24/2008 08:35'!
hostControllerResetHasFinished
	^(self testCommandBit: 1) not! !

!USBUHCIController methodsFor: 'initialization' stamp: 'gera 9/8/2008 20:36'!
initialize
	| delay10ms |
	delay10ms := Delay forMilliseconds: 10.
	self enableGlobalReset.
	delay10ms wait.
	self
		disableGlobalReset;
		startHostControllerReset.
	[self hostControllerResetHasFinished] whileFalse: [delay10ms wait].
	self
		disableScheduling;
		disableAllInterrupts;
		disableConfigureFlag;
		initializeFrameList;
		maxPacketSize: 64;
		enableAllInterrupts;
		enableScheduling;
		enableConfigureFlag.
	self initializeRootHubs.! !

!USBUHCIController methodsFor: 'initialization' stamp: 'gera 8/24/2008 08:56'!
initializeFrameList
	frameList := ExternalAddress allocate: 4*1024 aligned: 4*1024.
	1 to: 1024 do: [:i | self clearFrameListAt: i].
	self frameListBaseAddress: frameList asInteger.
	self frameNumber: 0.! !

!USBUHCIController methodsFor: 'initialization' stamp: 'gera 9/3/2008 15:27'!
initializeRootHubs
	"
\ We mustn't wait more than 3 ms between releasing the reset and enabling
\ the port to begin the SOF stream, otherwise some devices (e.g. pl2303)
\ will go into suspend state and then not respond to set-address.
: reset-root-hub-port  ( port -- )
   dup >r  portsc@ h# 20e invert and    ( value r: port )  \ Clear reset, enable, status
   dup h# 200 or  r@ portsc!!	        ( value r: port )  \ Reset port
   d# 30 ms                             ( value r: port )  \ > 10 ms - reset time
   dup r@ portsc!!                       ( value r: port )  \ Release reset
   1 ms                                 ( value r: port )  \ > 5.3 uS - reconnect time
   h# e or  r> portsc!!	                ( )  \ Enable port and clear status
;

: probe-root-hub-port  ( port -- )
   dup reset-root-hub-port
   dup portsc@ 1 and 0=  if  drop exit  then		\ No device-connected
   ok-to-add-device? 0=  if  drop exit  then		\ Can't add another device

   new-address				( port dev )
   over portsc@ 100 and  if  speed-low  else  speed-full  then
   over di-speed!!			( port dev )

   0 set-target				( port dev )    \ Address it as device 0
   dup set-address  if  2drop exit  then ( port dev )	\ Assign it usb addr dev
   dup set-target			( port dev )    \ Address it as device dev
   make-device-node			( )
;

external
: power-ports  ( -- )  ;

: probe-root-hub  ( -- )
   \ Set active-package so device nodes can be added and removed
   my-self ihandle>phandle push-package

   alloc-pkt-buf
   2 0  do
      i portsc@ h# a and  if
         i rm-obsolete-children			\ Remove obsolete device nodes
         i ['] probe-root-hub-port catch  if
            drop .' Failed to probe root port ' i .d cr
         then
         i portsc@ i portsc!!			\ Clear change bits
      then
   loop
   free-pkt-buf

   pop-package
;
	"! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:22'!
interruptEnable
	^self shortAt: 4! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:23'!
interruptEnable: anInteger
	^self shortAt: 4 put: anInteger! !

!USBUHCIController methodsFor: 'accessing - status' stamp: 'gera 1/1/1901 00:45'!
interruptPending
	^self testStatusBit: 0! !

!USBUHCIController methodsFor: 'accessing - status' stamp: 'gera 1/1/1901 00:42'!
isHalted
	^self testStatusBit: 5! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'gera 1/1/1901 00:38'!
isInGlobalSuspendMode
	^self testCommandBit: 3! !

!USBUHCIController methodsFor: 'accessing - frame list' stamp: 'gera 8/24/2008 09:52'!
isPointingToQueueHeadAt: index
	^ (self frameListValueAt: index) anyMask: 2! !

!USBUHCIController methodsFor: 'accessing - frame list' stamp: 'gera 8/24/2008 09:44'!
isPointingToTransferDescriptorAt: index
	^ ((self frameListValueAt: index) anyMask: 2) not! !

!USBUHCIController methodsFor: 'accessing - frame list' stamp: 'gera 8/24/2008 10:01'!
isTerminatorAt: index
	^ (self frameListValueAt: index) anyMask: 1! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'gera 1/1/1901 00:28'!
maxPacketSize
	^(self testCommandBit: 7)
		ifTrue: [64]
		ifFalse: [32]! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'gera 9/8/2008 20:36'!
maxPacketSize: anInteger
	anInteger == 32 ifTrue: [^self clearCommandBit: 7].
	anInteger == 64 ifTrue: [^self setCommandBit: 7].
	self error: 'Invalid maxPacketSize. Only 32 or 64 bytes allowed'! !

!USBUHCIController methodsFor: 'accessing - frame list' stamp: 'gera 8/24/2008 09:52'!
pointToQueueHeadAt: index
	^ self
		frameListValueAt: index
		put: ((self frameListValueAt: index) bitOr: 2) ! !

!USBUHCIController methodsFor: 'accessing - frame list' stamp: 'gera 8/24/2008 09:45'!
pointToQueueHeaderAt: index
	^ self
		frameListValueAt: index
		put: ((self frameListValueAt: index) bitOr: 2) ! !

!USBUHCIController methodsFor: 'accessing - frame list' stamp: 'gera 8/24/2008 11:06'!
pointToTransferDescriptorAt: index
	^ self
		frameListValueAt: index
		put: ((self frameListValueAt: index) bitAnd: 2 bitInvert) ! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:48'!
port1ConnectStatusHasChanged
	^self testPort1StatusBit: 1! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:45'!
port1EnableStatusHasChanged
	^self testPort1StatusBit: 3! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:51'!
port1HasDeviceConnected
	^self testPort1StatusBit: 0! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:32'!
port1HasLowSpeedDeviceAttached
	^self testPort1StatusBit: 8! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:28'!
port1IsReset
	^self testPort1StatusBit: 9! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'gera 1/1/1901 00:04'!
port1IsSuspended
	^self testPort1StatusBit: 12! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:43'!
port1LineStatus
	^(self testPort1StatusBit: 5) * 2 + (self testPort1StatusBit: 4)! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:02'!
port1StatusControl
	^self shortAt: 16! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:02'!
port1StatusControl: anInteger
	^self shortAt: 16 put: anInteger! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:47'!
port2ConnectStatusHasChanged
	^self testPort2StatusBit: 1! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:45'!
port2EnableStatusHasChanged
	^self testPort2StatusBit: 3! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:51'!
port2HasDeviceConnected
	^self testPort2StatusBit: 0! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:47'!
port2HasLowSpeedDeviceAttached
	^self testPort2StatusBit: 8! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:29'!
port2IsReset
	^self testPort2StatusBit: 9! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'gera 1/1/1901 00:04'!
port2IsSuspended
	^self testPort2StatusBit: 12! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'r++ 8/15/2008 19:43'!
port2LineStatus
	^(self testPort2StatusBit: 5) * 2 + (self testPort2StatusBit: 4)! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:03'!
port2StatusControl
	^self shortAt: 18! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:03'!
port2StatusControl: anInteger
	^self shortAt: 18 put: anInteger! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:25'!
power1StatusControl
	^self shortAt: 16! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:25'!
power1StatusControl: anInteger
	^self shortAt: 16 put: anInteger! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:25'!
power2StatusControl
	^self shortAt: 18! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:25'!
power2StatusControl: anInteger
	^self shortAt: 18 put: anInteger! !

!USBUHCIController methodsFor: 'accessing - status' stamp: 'gera 1/1/1901 00:44'!
processError
	^self testStatusBit: 4! !

!USBUHCIController methodsFor: 'accessing - status' stamp: 'gera 1/1/1901 00:43'!
resetStatus
	" Writing a 1 clears that bit status "
	^self status: self status! !

!USBUHCIController methodsFor: 'accessing - status' stamp: 'gera 1/1/1901 00:44'!
resumeRequestedByDevice
	^self testStatusBit: 2! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'gera 8/24/2008 08:27'!
setCommandBit: bit
	^ self command: (self command bitOr: 1 << bit)
! !

!USBUHCIController methodsFor: 'accessing - interrupt register' stamp: 'gera 8/24/2008 08:40'!
setInterruptBit: bit
	^ self interruptEnable: (self interruptEnable bitOr: 1 << bit)
! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'gera 9/3/2008 15:47'!
setPort1ControlBit: bit
	^ self port1StatusControl: (self port1StatusControl bitOr: 1 << bit)
! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'gera 9/3/2008 15:47'!
setPort2ControlBit: bit
	^ self port2StatusControl: (self port2StatusControl bitOr: 1 << bit)
! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'r++ 8/15/2008 19:40'!
startHostControllerReset
	^self setCommandBit: 1! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:25'!
startOfFrameModify
	^self byteAt: 12! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:26'!
startOfFrameModify: anInteger
	^self byteAt: 12 put: anInteger! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:22'!
status
	^self shortAt: 2! !

!USBUHCIController methodsFor: 'accessing - registers' stamp: 'gera 1/1/1901 00:22'!
status: anInteger
	^self shortAt: 2 put: anInteger! !

!USBUHCIController methodsFor: 'accessing - status' stamp: 'gera 1/1/1901 00:44'!
systemError
	^self testStatusBit: 3! !

!USBUHCIController methodsFor: 'accessing - command register' stamp: 'gera 8/24/2008 08:26'!
testCommandBit: bit
	^ self command anyMask: 1 << bit! !

!USBUHCIController methodsFor: 'initialization' stamp: 'gera 9/14/2008 14:25'!
testGetDeviceDescriptor
	| qh tdSetup tdData tdStatus buf |
	self enablePort1Reset.
	(Delay forMilliseconds: 10) wait.
	self disablePort1Reset.
	self enablePort1.
	self clearPort1ConnectStatusChange; clearPort1EnableStatusChange.

	qh := USBQueueHead externalNew.
	tdSetup := USBTransferDescriptor externalNew.
	tdData := USBTransferDescriptor externalNew.
	tdStatus := USBTransferDescriptor externalNew.
	buf := ExternalAddress allocate: 2000.

	qh beTerminator; beEmpty; next: qh.

	1 to: 1024 do: [:i | self frameListAt: i put: qh].

	tdSetup next: tdData.
	tdData next: tdStatus.

	tdSetup beData0; beSetup; activate; errorCount: 3; bufferPointer: buf asInteger; enableInterruptOnComplete.
	tdData beData1; beInput; activate; errorCount: 3; bufferPointer: buf asInteger; enableInterruptOnComplete.
	tdStatus beData1; beOutput; activate; errorCount: 3; beTerminator; enableInterruptOnComplete.

	tdSetup maxLength: 8.
	tdData maxLength: 1000.

	buf
		byteAt: 1 put: 16r80;		" Input. Standard. Device "
		byteAt: 2 put: 6;			" GET_DESCRIPTOR "
		unsignedByteAt: 3 put: 0;	" wValue: idx"
		unsignedByteAt: 4 put: 1;	" wValue: DEVICE"
		unsignedShortAt: 5 put: 0;
		unsignedShortAt: 7 put: 18.

	qh first: tdSetup.

	^ Array with: qh with: buf.! !

!USBUHCIController methodsFor: 'initialization' stamp: 'gera 9/4/2008 17:38'!
testGetStringDescriptor: idx
	| td buf |
	td := USBTransferDescriptor externalNew.
	buf := ExternalAddress allocate: 1280.
	td bufferPointer: buf asInteger.
	td packetIdentification: 16r2D.
	td maxLength: 1280.
	td errorCount: 3.
	td activate.
	buf
		byteAt: 1 put: 16r80;			" bmRequestType: Direction=Device to Host | Type=Standard | Recipient=Device "
		byteAt: 2 put: 6;				" bRequest: GET_DESCRIPTOR "
		unsignedByteAt: 3 put: idx;	" wValue: idx"
		unsignedByteAt: 4 put: 3;	" wValue: STRING"
		unsignedShortAt: 5 put: 0;	" wIndex: LANGUAGE"
		unsignedShortAt: 7 put: 1000." wLength: 1000 "
	self frameListAt: 90 put: td.
	^ Array with: td with: buf.
! !

!USBUHCIController methodsFor: 'initialization' stamp: 'gera 9/8/2008 20:19'!
testInput
	| td buf |
	td := USBTransferDescriptor externalNew.
	buf := ExternalAddress allocate: 1500.
	td bufferPointer: buf asInteger.
	td beInput.
	td maxLength: 1280.
	td errorCount: 3.
	td enableInterruptOnComplete.
	td beTerminator.
	td activate.
	self frameListAt: 100 put: td.
	^ Array with: td with: buf.
! !

!USBUHCIController methodsFor: 'accessing - interrupt register' stamp: 'gera 8/24/2008 08:38'!
testInterruptBit: bit
	^ self interruptEnable anyMask: 1 << bit! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'gera 1/1/1901 00:03'!
testPort1StatusBit: bit
	^ self port1StatusControl anyMask: 1 << bit
! !

!USBUHCIController methodsFor: 'accessing - port status/controll' stamp: 'gera 1/1/1901 00:03'!
testPort2StatusBit: bit
	^ self port2StatusControl anyMask: 1 << bit
! !

!USBUHCIController methodsFor: 'accessing - status' stamp: 'gera 8/24/2008 08:26'!
testStatusBit: bit
	^ self status anyMask: 1 << bit! !

Object subclass: #InterruptRequestDispatcher
	instanceVariableNames: 'semaphore process interruptNumber clients'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Kernel'!

!InterruptRequestDispatcher class methodsFor: 'instace creation' stamp: 'gera 5/20/2006 01:54'!
new
	^ super new initialize! !

!InterruptRequestDispatcher class methodsFor: 'instace creation' stamp: 'gera 5/20/2006 01:54'!
onIRQ: aNumber
	^ self new privInterruptNumber: aNumber! !

!InterruptRequestDispatcher methodsFor: 'accessing' stamp: 'gera 5/20/2006 00:41'!
addHandler: anObject
	clients add: anObject! !

!InterruptRequestDispatcher methodsFor: 'handling' stamp: 'r++ 7/24/2008 23:09'!
handleOn: aComputer 
"	Transcript cr; show: 'handling IRQ #', interruptNumber asString.
"	clients
		do: [:each |
			[each handleIRQfor: self on: aComputer]
				ifError: [:err :rcvr | 
					Transcript
						nextPutAll: err;
					 	nextPutAll: ' when handling IRQ #';
						print: interruptNumber;
						nextPutAll: ' on ';
						print: each;
						cr;
						flush.
				]
	].
"	Transcript cr; show: ' handled'.
"! !

!InterruptRequestDispatcher methodsFor: 'initialization' stamp: 'gera 5/20/2006 00:34'!
initialize
	semaphore _ Semaphore new.
	clients _ OrderedCollection new! !

!InterruptRequestDispatcher methodsFor: 'initialization' stamp: 'gera 8/24/2008 18:47'!
installOn: aComputer
	self registerSemaphore.
	process := [
		[
			semaphore wait.
			self handleOn: aComputer.
			aComputer interruptController signalEndOfInterrupt: interruptNumber
		] repeat.
	] forkAt: Processor highIOPriority.
	process name: 'Iterrupt Dispatcher for IRQ#:', interruptNumber printString.
	aComputer interruptController enableIRQ: interruptNumber
! !

!InterruptRequestDispatcher methodsFor: 'accessing' stamp: 'gera 6/1/2006 21:24'!
interruptNumber
	^ interruptNumber! !

!InterruptRequestDispatcher methodsFor: 'private' stamp: 'gera 5/20/2006 00:33'!
primRegisterSemaphoreIndex: externalObjectForSemaphore forIRQ: IRQNumber 
	<primitive: 'primitiveRegisterSemaphoreIndexForIRQ' module:'SqueakNOSPlugin'> 
	^ self primitiveFailed! !

!InterruptRequestDispatcher methodsFor: 'private' stamp: 'gera 5/20/2006 00:30'!
privInterruptNumber: irqNumber
	interruptNumber
		ifNil: [
			interruptNumber := irqNumber.
			self registerSemaphore]
		ifNotNil: [self error: 'Can''t change the IRQ number for a handler']! !

!InterruptRequestDispatcher methodsFor: 'private' stamp: 'gera 5/20/2006 00:32'!
registerSemaphore
	self
		primRegisterSemaphoreIndex: (Smalltalk registerExternalObject: semaphore)
		forIRQ: interruptNumber! !

!InterruptRequestDispatcher methodsFor: 'accessing' stamp: 'gera 6/5/2006 19:35'!
removeHandler: anObject
	" should not be called from a handler routine,
	as it may terminate the process if it's the last handler,
	in which case the interrupt will not be finished signaling the interruptController.
	XXX: This must be solved, there must be a clean wat of doing one time IRQs"
	clients remove: anObject.
	clients ifEmpty: [self uninstall].! !

!InterruptRequestDispatcher methodsFor: 'initialization' stamp: 'gera 6/9/2006 23:57'!
uninstall
	Computer current interruptController disableIRQ: interruptNumber.
	self primRegisterSemaphoreIndex: 0 forIRQ: interruptNumber.
	Computer current interruptController removeDispatcher: self.

	" the next is forked so it doesn't kill the process calling.
	  Of utter importance if called from within handleIRQ:
	  as otherwise the interrupt end will not be signaled.
	  The current process is running at hiIOPriority, so the
	  new one won't be executed until the current is idle"
	[process terminate] forkAt: Processor lowIOPriority.
! !

Object subclass: #MasterBootRecord
	instanceVariableNames: 'bytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Filesystems'!

!MasterBootRecord commentStamp: 'Pocho 4/5/2010 18:27' prior: 0!
The Master Boot Record is the same for pretty much all Operating Systems.  It is located on the first Sector of the Hard Drive, at Cylinder 0, Head 0, Sector 1.  It is the first piece of code that your computer runs after it has checked all of your hardware (POST) and turned control of loading software over the hard drive.

  It also contains the partition table, which defines the different sections of your hard drive.  Basically if anything happens to this little 512 byte section, your hard drive is brain dead. 

Offset				Description								   Size		
000h				Executable Code (Boots Computer)			446 Bytes
1BEh				1st Partition Entry (See Next Table)		16  Bytes
1CEh				2nd Partition Entry						16  Bytes
1DEh				3rd Partition Entry						16  Bytes
1EEh				4th Partition Entry						16  Bytes
1FEh				Boot Record Signature (55h AAh)			2   Bytes

!

!MasterBootRecord class methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 22:44'!
of: aDiskStream
	^self new bytes: (aDiskStream position: 0; next: 512).! !

!MasterBootRecord class methodsFor: 'as yet unclassified' stamp: 'Pocho 4/5/2010 18:39'!
with: anArray
	anArray size ~= 512 ifTrue: [self error: 'Not a Master Boot Record'].
	^self new bytes: anArray.! !

!MasterBootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/5/2010 18:39'!
bytes: aBytesArray
	bytes := aBytesArray.! !

!MasterBootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/5/2010 18:42'!
firstPartition
	^PartitionRecord with: (bytes copyFrom: 447 to: 447+16).! !

!MasterBootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 14:58'!
firstPartitionRecord
	^PartitionRecord with: (bytes copyFrom: 447 to: 447+16).! !

!MasterBootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 23:18'!
offsetToPartition: aNumber sectorSize: aSectorSize
	"Gets the partition record number aNumber. There are 4 of them, each occupies 16 bytes and
	 are placed in a table. aNumber can be 1, 2, 3 or 4.
	Result is 0-indexed"

	^(self partitionRecord: aNumber) offsetFromMBR * aSectorSize.! !

!MasterBootRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 17:12'!
partitionRecord: aNumber
	"Gets the partition record number aNumber. There are 4 of them, each occupies 16 bytes and
	 are placed in a table. aNumber can be 1, 2, 3 or 4"

	| offset |
	offset := 447 + (16 * (aNumber - 1)).
	^PartitionRecord with: (bytes copyFrom: offset to: offset+15).! !

Object subclass: #MemoryBlock
	instanceVariableNames: 'interval description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Memory'!

!MemoryBlock class methodsFor: 'instance creation' stamp: 'gc 6/16/2010 15:24'!
from: start to: end description: aString
	^self new interval: (Interval from: start to: end); description: aString! !

!MemoryBlock methodsFor: 'accessing' stamp: 'gc 6/16/2010 15:25'!
description
	^description! !

!MemoryBlock methodsFor: 'accessing' stamp: 'gc 6/16/2010 15:25'!
description: aString
	description := aString! !

!MemoryBlock methodsFor: 'accessing' stamp: 'gc 6/19/2010 16:19'!
end
	^interval last! !

!MemoryBlock methodsFor: 'accessing' stamp: 'gc 6/16/2010 15:25'!
interval
	^interval! !

!MemoryBlock methodsFor: 'accessing' stamp: 'gc 6/16/2010 15:25'!
interval: anInterval
	interval := anInterval! !

!MemoryBlock methodsFor: 'printing' stamp: 'gc 6/17/2010 14:55'!
printOn: aStream
	^aStream nextPutAll: self interval first printString; nextPut: $-; nextPutAll: self interval last printString; nextPut: $(;nextPutAll: self description; nextPut: $)! !

!MemoryBlock methodsFor: 'accessing' stamp: 'gc 6/19/2010 16:18'!
start
	^interval first! !

Object subclass: #MemoryManagerStrategy
	instanceVariableNames: 'memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Memory-Manager'!

!MemoryManagerStrategy class methodsFor: 'instance creation' stamp: 'GuidoChari 8/6/2010 17:35'!
forMemory: aMemory
	^self new memory: aMemory; identityMapping ! !

!MemoryManagerStrategy methodsFor: 'accesing' stamp: 'GuidoChari 8/6/2010 14:49'!
memory
	^memory! !

!MemoryManagerStrategy methodsFor: 'accesing' stamp: 'GuidoChari 8/6/2010 14:49'!
memory: aMemory
	memory  := aMemory! !

MemoryManagerStrategy subclass: #Paging
	instanceVariableNames: 'directory handlers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Memory-Manager'!

!Paging methodsFor: 'accesing' stamp: 'GuidoChari 8/30/2010 16:26'!
directory
	^directory! !

!Paging methodsFor: 'private' stamp: 'GuidoChari 9/18/2010 17:24'!
directory: aPageDirectory
	directory := aPageDirectory! !

!Paging methodsFor: 'services' stamp: 'GuidoChari 10/28/2010 16:16'!
from: startAddress to: stopAddress useHandler: aPageFaultHandler
	handlers at: (startAddress to: stopAddress) put: aPageFaultHandler! !

!Paging methodsFor: 'private' stamp: 'GuidoChari 10/26/2010 15:50'!
handlerFor: anAddress
	| interval |
	interval := (handlers keys select: [:int | int includes: anAddress]) min.
	^handlers at: interval! !

!Paging methodsFor: 'initialize-release' stamp: 'GuidoChari 10/18/2010 17:29'!
identityMapping 
	| tables space count |
	space := self pageTableMappedSpace.
	count := self pageTablesCount.
	tables := OrderedCollection new: count.
	1 to: count do: [:i | 
		| table | table := PageTable entriesCount: self pageTableEntriesCount entrySize: self pageTableEntrySize. 
						 table identityMappingStartingAt: (i - 1) * space pageSize: self pageSize.
						 tables add: table.
	].
	directory := PageDirectory entriesCount: count entrySize: 4 pageTables: tables.
! !

!Paging methodsFor: 'initialize-release' stamp: 'GuidoChari 10/28/2010 16:23'!
initialize 
	super initialize.
	handlers := Dictionary new.! !

!Paging methodsFor: 'testing' stamp: 'GuidoChari 9/1/2010 15:09'!
isPresentAndAllowed: anAddress
	|  table tableIndex |
	table := self pageTableFor: anAddress.
	tableIndex := self pageTableIndexFor: anAddress.
	^table isPresentAndAllowed: tableIndex! !

!Paging methodsFor: 'translation-private' stamp: 'JavierPimas 8/11/2010 16:09'!
offsetFor: anAddress
	^anAddress bitAnd: 16r00000FFF.
	! !

!Paging methodsFor: 'accesing' stamp: 'GuidoChari 9/1/2010 15:28'!
pageDirectoryEntryFor: anAddress
	| index |
	index := self pageDirectoryIndexFor: anAddress.
	^directory entryFor: index ! !

!Paging methodsFor: 'translation-private' stamp: 'GuidoChari 8/13/2010 16:13'!
pageDirectoryIndexFor: anAddress
	| shifted trunced |
	shifted := anAddress bitShift: -22.
	trunced := shifted bitAnd: 16r000003FF.
	^trunced! !

!Paging methodsFor: 'page faults' stamp: 'gc 11/2/2010 14:02'!
pageFaultHandler 
	^[:args :result | self halt resolvePageFaultOn: args virtualFaultAddress]! !

!Paging methodsFor: 'accesing' stamp: 'GuidoChari 8/6/2010 16:37'!
pageSize
	^4096! !

!Paging methodsFor: 'services' stamp: 'GuidoChari 10/26/2010 15:42'!
pageStartAddressOf: anAddress. 
	^( anAddress / self pageSize ) * self pageSize + 1! !

!Paging methodsFor: 'accesing' stamp: 'JavierPimas 8/11/2010 16:36'!
pageTableEntriesCount
	^1024! !

!Paging methodsFor: 'accesing' stamp: 'JavierPimas 12/20/2010 16:36'!
pageTableEntriesFor: anInterval
	|  startDirectoryIndex stopDirectoryIndex start end firstIndex lastIndex entries |
	start := anInterval first.
	end := anInterval last.
	startDirectoryIndex := self pageDirectoryIndexFor: start.
	stopDirectoryIndex := self pageDirectoryIndexFor: end.
	entries := OrderedCollection new.
	firstIndex := self pageTableIndexFor: start.
	lastIndex := self pageTableIndexFor: end.
	startDirectoryIndex = stopDirectoryIndex ifTrue: [
		entries addAll: ((directory pageTableAtIndex: startDirectoryIndex) entriesFromIndex: firstIndex to: lastIndex).
	] ifFalse: [
		entries addAll: ((directory pageTableAtIndex: startDirectoryIndex) entriesFromIndex: firstIndex);
				addAll: ((directory pageTableAtIndex: stopDirectoryIndex) entriesUptoIndex: lastIndex).		
		startDirectoryIndex + 1 to: stopDirectoryIndex - 1 do: [:index |
			entries addAll: (directory pageTableAtIndex: index) entries
		]
	].
	^entries
	
	! !

!Paging methodsFor: 'accesing' stamp: 'GuidoChari 9/1/2010 15:27'!
pageTableEntryFor: anAddress
	| table index |
	table := self pageTableFor: anAddress.
	index := self pageTableIndexFor: anAddress.
	^table entryFor: index ! !

!Paging methodsFor: 'accesing' stamp: 'JavierPimas 8/11/2010 16:36'!
pageTableEntrySize
	^4! !

!Paging methodsFor: 'accesing' stamp: 'GuidoChari 9/1/2010 15:09'!
pageTableFor: anAddress
	| directoryIndex tableIndex |
	directoryIndex := self pageDirectoryIndexFor: anAddress.
	^directory pageTableAtIndex: directoryIndex.
	! !

!Paging methodsFor: 'translation-private' stamp: 'GuidoChari 8/13/2010 16:11'!
pageTableIndexFor: anAddress
	| shifted trunced |
	shifted := anAddress bitShift: -12.
	trunced := shifted bitAnd: 16r000003FF.
	^trunced! !

!Paging methodsFor: 'accesing' stamp: 'JavierPimas 8/11/2010 16:37'!
pageTableMappedSpace 
	^self pageSize * self pageTableEntriesCount! !

!Paging methodsFor: 'accesing' stamp: 'GuidoChari 8/20/2010 17:22'!
pageTablesCount 
	| size space |
	"size := self memory size."
	size := 1024 * 1024 * 1024 * 4.
	space := self pageTableMappedSpace.
	^(size / space) ceiling.
	! !

!Paging methodsFor: 'services' stamp: 'GuidoChari 9/18/2010 15:51'!
readOnly
	directory readOnly! !

!Paging methodsFor: 'services' stamp: 'gc 11/4/2010 18:46'!
readOnlyFrom: start to: end
	(self pageTableEntriesFor: (start to: end)) do: [:entry | entry readOnly]! !

!Paging methodsFor: 'services' stamp: 'GuidoChari 12/28/2010 15:51'!
readWriteFrom: start to: end
	(self pageTableEntriesFor: (start to: end)) do: [:entry | entry readWrite]! !

!Paging methodsFor: 'page faults' stamp: 'GuidoChari 10/28/2010 16:16'!
resolvePageFaultOn: anAddress
	| handler |
	handler := self handlerFor: anAddress.
	handler resolvePageFaultOn: anAddress
	! !

!Paging methodsFor: 'translation' stamp: 'GuidoChari 8/10/2010 18:36'!
translate: anAddress
	| directoryIndex tableIndex offset table address |
	directoryIndex := self pageDirectoryIndexFor: anAddress.
	tableIndex := self pageTableIndexFor: anAddress.
	offset := self offsetFor: anAddress.
	table := directory pageTableAtIndex: directoryIndex.
	address := table phisicalAddressFor: tableIndex.
	^address + offset! !

Object subclass: #MicroProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Processor'!

MicroProcessor subclass: #X86Processor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Processor'!

!X86Processor methodsFor: 'registers' stamp: 'gc 7/25/2010 18:34'!
cr0
	<primitive: 'primitiveRead32bitRegisterCr0' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^self primitiveFailed! !

!X86Processor methodsFor: 'registers' stamp: 'GuidoChari 8/9/2010 15:51'!
cr0: statusWord
	<primitive: 'primitivePutIn32bitRegisterCr0' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^self primitiveFailed! !

!X86Processor methodsFor: 'registers' stamp: 'gc 7/25/2010 18:34'!
cr3
	<primitive: 'primitiveRead32bitRegisterCr3' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^self primitiveFailed! !

!X86Processor methodsFor: 'registers' stamp: 'GuidoChari 8/9/2010 15:46'!
cr3: memoryAddress
	<primitive: 'primitivePutIn32bitRegisterCr3' module:'SqueakNOSPlugin'> "primitiveExternalCall" 
	^self primitiveFailed! !

!X86Processor methodsFor: 'paging' stamp: 'gc 11/4/2010 14:39'!
enablePaging
	| pagingEnabled |
	pagingEnabled := self cr0 bitAt: 32 put: 1. "Enable paging"
	pagingEnabled := pagingEnabled bitAt: 17 put: 1. "Enable write protect"
	self cr0: pagingEnabled! !

!X86Processor methodsFor: 'paging' stamp: 'GuidoChari 8/9/2010 15:59'!
enablePagingWithDirectory: memoryAddress
	self pageDirectory: memoryAddress.
	self enablePaging.! !

!X86Processor methodsFor: 'paging' stamp: 'GuidoChari 8/9/2010 15:46'!
pageDirectory: memoryAddress
	self cr3: memoryAddress! !

Object subclass: #NullBlockCache
	instanceVariableNames: 'device'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Storage'!

!NullBlockCache class methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 18:36'!
on: aDevice
	^self new on: aDevice! !

!NullBlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 18:55'!
flushWrites! !

!NullBlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 18:41'!
from: firstBlock to: lastBlock
	^device from: firstBlock to: lastBlock.
	
! !

!NullBlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 18:36'!
on: aDevice
	device := aDevice.! !

!NullBlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 16:35'!
readInto: byteArray startWritingAtByte: destOffset startReadingAtByte: sourceOffset bytesCount: bytesCount
	
	| data firstBlock lastBlock firstBlockBytesOffset |
	firstBlock := device blockNumberFromByteOffset: sourceOffset.
	lastBlock := device blockNumberFromByteOffset: sourceOffset + bytesCount - 1.
	
	data := device from: firstBlock to: lastBlock.
	
	firstBlockBytesOffset := device positionInBlockOf: sourceOffset.
	byteArray replaceFrom: destOffset to: destOffset + bytesCount - 1 with: data startingAt: firstBlockBytesOffset.
	^bytesCount.
	
! !

!NullBlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 19:16'!
replaceFromByte: destOffset bytesCount: bytesCount with: source startingAtByte: sourceOffset
	"Write count bytes from source starting at startIndex bytes. We handle half sector
	 overwriting."
	| data firstBlock lastBlock blocksCount firstBlockBytesOffset lastBlockBytesCount blockData firstSectorRead |
	
	firstBlock := device blockNumberFromByteOffset: destOffset.
	lastBlock := device blockNumberFromByteOffset: destOffset + bytesCount - 1.
	blocksCount := lastBlock - firstBlock + 1.
	
	firstSectorRead := false.
	
	data := ByteArray new: blocksCount * device blockSize.
	
	"If it starts at block boundaries, we don't need to read the block. We'll probably overwrite it entirely"
	firstBlockBytesOffset := device positionInBlockOf: destOffset.
	firstBlockBytesOffset ~= 1 ifTrue: [
		firstSectorRead := true.
		blockData := device at: firstBlock.
		data replaceFrom: 1	to: device blockSize with: blockData startingAt: 1.
	].
	
	"If it ends at block boundaries, we don't need to read the last block. We'll probably overwrite it entirely"
	lastBlockBytesCount := device positionInBlockOf: destOffset + bytesCount - 1.
	lastBlockBytesCount ~= device blockSize ifTrue: [
		(blocksCount = 1 & firstSectorRead) ifFalse: [
			blockData := device at: lastBlock.
			data replaceFrom: 1	to: device blockSize with: blockData startingAt: 1.
		].
	].

	data
		replaceFrom: firstBlockBytesOffset to: (firstBlockBytesOffset + bytesCount - 1)
		with: source startingAt: sourceOffset.
	
	Transcript show: 'Writing ', blocksCount asString, ' sectors starting at ', firstBlock asString, '
	'.
	device at: firstBlock writeArray: data.
	
! !

Object subclass: #OpenFirmwareCalloutClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-OFW-OLPC'!

!OpenFirmwareCalloutClient commentStamp: '<historical>' prior: 0!
args := OpenFirmwareCalloutClient newArgsFor: 'interpreter' inputs: 1 outputs: 0.
args at: 4 put: '." hola manola"'.
OpenFirmwareCalloutClient callout: args.
(ExternalAddress new fromInteger: args fourth / 2) stringAt: 0 size: 100
!

OpenFirmwareCalloutClient subclass: #OFWDeviceNode
	instanceVariableNames: 'phandle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-OFW-OLPC'!

!OFWDeviceNode commentStamp: '<historical>' prior: 0!
chosen := OFWDeviceNode findDevice: '/chosen'
chosen nextProp: ''
!

!OFWDeviceNode class methodsFor: 'as yet unclassified' stamp: 'gera 9/23/2008 23:18'!
findDevice: nodeName
	| args |
	args := self newArgsFor: 'finddevice' inputs: 1 outputs: 1.
	args at: 4 put: nodeName.
	self callout: args.
	^ self new handle: args last
! !

!OFWDeviceNode methodsFor: 'as yet unclassified' stamp: 'gera 9/24/2008 00:16'!
getProp: propertyName 
	| args len buf |
	len := self getPropLen: propertyName.
	buf := String new: len.
	args := self newArgsFor: 'getprop' inputs: 4 outputs: 1.
	args at: 4 put: phandle.
	args at: 5 put: propertyName, (Character value: 0) asString.
	args at: 6 put: buf.
	args at: 7 put: len.
	self callout: args.
	^ buf
! !

!OFWDeviceNode methodsFor: 'as yet unclassified' stamp: 'gera 9/24/2008 00:16'!
getPropLen: propertyName 
	| args |
	args := self newArgsFor: 'getproplen' inputs: 2 outputs: 1.
	args at: 4 put: phandle.
	args at: 5 put: propertyName, (Character value: 0) asString.
	self callout: args.
	^ args last
! !

!OFWDeviceNode methodsFor: 'as yet unclassified' stamp: 'gera 9/23/2008 23:30'!
handle
	^ phandle! !

!OFWDeviceNode methodsFor: 'as yet unclassified' stamp: 'gera 9/23/2008 23:18'!
handle: anInteger
	phandle := anInteger! !

!OFWDeviceNode methodsFor: 'as yet unclassified' stamp: 'gera 9/24/2008 00:16'!
nextProp: previous 
	| args buf |
	buf := String new: 32.
	args := self newArgsFor: 'getprop' inputs: 3 outputs: 1.
	args at: 4 put: phandle.
	args at: 5 put: previous, (Character value: 0) asString.
	args at: 6 put: buf.

	self callout: args.
	^ buf
! !

!OpenFirmwareCalloutClient class methodsFor: 'as yet unclassified' stamp: 'gera 9/23/2008 22:48'!
callout: anArray
	| answer |
	answer := self primOFWCallout: anArray.
	answer = 0 ifFalse: [^ self error: 'OpenFirmware calout returned error: ', answer printString]! !

!OpenFirmwareCalloutClient class methodsFor: 'as yet unclassified' stamp: 'gera 9/24/2008 00:16'!
newArgsFor: serviceName inputs: aInteger outputs: bInteger
	| answer |
	answer := Array new: 3 + aInteger + bInteger.
	answer
		at: 1 put: serviceName, (Character value: 0) asString;
		at: 2 put: aInteger;
		at: 3 put: bInteger.
	^ answer
! !

!OpenFirmwareCalloutClient class methodsFor: 'as yet unclassified' stamp: 'gera 11/21/2009 11:12'!
primOFWCallout: anArray 
	<primitive: 'primitiveOFWCallout' module:'SqueakNOSPlugin'> 
	^ self primitiveFailed! !

!OpenFirmwareCalloutClient methodsFor: 'as yet unclassified' stamp: 'gera 9/23/2008 22:48'!
callout: anArray
	self class callout: anArray! !

!OpenFirmwareCalloutClient methodsFor: 'as yet unclassified' stamp: 'gera 9/23/2008 22:49'!
newArgsFor: serviceName inputs: aInteger outputs: bInteger
	^ self class newArgsFor: serviceName inputs: aInteger outputs: bInteger! !

Object subclass: #PageFaultHandler
	instanceVariableNames: 'manager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Memory-Manager'!

PageFaultHandler subclass: #CopyOnWriteSaveReadOnlyPageFaultHandler
	instanceVariableNames: 'readOnly'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Memory-Manager'!

!CopyOnWriteSaveReadOnlyPageFaultHandler class methodsFor: 'instance creation' stamp: 'GuidoChari 10/26/2010 15:56'!
manager: aMemoryManager readOnlyOn: aDictionary
	(super manager: aMemoryManager) readOnly: aDictionary! !

!CopyOnWriteSaveReadOnlyPageFaultHandler methodsFor: 'accessing' stamp: 'GuidoChari 10/28/2010 16:24'!
readOnly: anOrderedCollection
	readOnly := anOrderedCollection! !

!CopyOnWriteSaveReadOnlyPageFaultHandler methodsFor: 'handling strategies' stamp: 'GuidoChari 10/26/2010 15:57'!
resolvePageFaultOn: anAddress
	| pde pte table newTable contents start |
	pde := manager pageDirectoryEntryFor: anAddress.
	pde isPresentAndAllowed ifFalse: [self error: 'Que fachemo si viene el fault en el directory?'].
	pte := manager pageTableEntryFor: anAddress.
	pte isPresentAndForbidden ifFalse: [self defaultPageFaultHandlingOf: anAddress].
	contents := self pageContentsOf: anAddress.
	start := manager pageStartAddressOf: anAddress.
	readOnly at: start put: contents. 
	pte setPresentAndWritable
	"table := manager pageTableFor: anAddress.
	newTable := table deepCopy.
	pde pageFrame: newTable externalAddress.
	pte := manager pageTableEntryFor: anAddress.
	pte setPresentAndWritable"! !

!PageFaultHandler class methodsFor: 'instance creation' stamp: 'GuidoChari 10/22/2010 15:40'!
manager: aMemoryManagerStrategy
	^self new manager: aMemoryManagerStrategy! !

!PageFaultHandler methodsFor: 'handling strategies' stamp: 'GuidoChari 10/26/2010 15:32'!
copyOnWritePageFaultHandlingOf: anAddress
	| pde pte table newTable contents start |
	pde := manager pageDirectoryEntryFor: anAddress.
	pde isPresentAndAllowed ifFalse: [self error: 'Que fachemo si viene el fault en el directory?'].
	pte := manager pageTableEntryFor: anAddress.
	pte isPresentAndForbidden ifFalse: [self defaultPageFaultHandlingOf: anAddress].
	contents := manager pageContentsOf: anAddress.
	start := ( anAddress / manager pageSize ) *  manager pageSize + 1.
	manager addReadOnlyCopy: contents forAddress: start. 
	pte setPresentAndWritable
	"table := manager pageTableFor: anAddress.
	newTable := table deepCopy.
	pde pageFrame: newTable externalAddress.
	pte := manager pageTableEntryFor: anAddress.
	pte setPresentAndWritable"! !

!PageFaultHandler methodsFor: 'accessing' stamp: 'GuidoChari 10/22/2010 15:40'!
manager: aMemoryManagerStrategy
	manager := aMemoryManagerStrategy! !

!PageFaultHandler methodsFor: 'services' stamp: 'GuidoChari 10/26/2010 15:45'!
pageContentsOf: anAddress
	| start |
	start := self pageStartAddressOf: anAddress.
	^Computer current readStringLength: manager pageSize fromMemory: start! !

!PageFaultHandler methodsFor: 'services' stamp: 'GuidoChari 10/26/2010 15:57'!
resolvePageFaultOn: anAddress
	| pde pte |
	self halt.
	pde := manager pageDirectoryEntryFor: anAddress.
	pde isPresentAndAllowed ifFalse: [^pde setPresentAndWritable].
	pte := manager pageTableEntryFor: anAddress.
	pte isPresentAndAllowed ifFalse: [^pte setPresentAndWritable].
	self error: 'Porque fallo la pagina?'! !

Object subclass: #PageIndex
	instanceVariableNames: 'handle entriesCount entrySize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-MemoryManager-Paging'!

PageIndex subclass: #PageDirectory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-MemoryManager-Paging'!

!PageDirectory class methodsFor: 'instance creation' stamp: 'GuidoChari 10/18/2010 17:08'!
entriesCount: aNumber entrySize: anotherNumber pageTables: anOrderedCollection
	^(super entriesCount: aNumber entrySize: anotherNumber) pageTables: anOrderedCollection! !

!PageDirectory methodsFor: 'copying' stamp: 'GuidoChari 10/19/2010 18:05'!
deepCopy
	| pageTables readOnlyTables |
	pageTables := self pageTables.
	readOnlyTables := OrderedCollection new: pageTables size.
	pageTables do: [:table | readOnlyTables add: (PageTable fromTable: table)].
	^self class entriesCount: self entriesCount entrySize: self entrySize pageTables: readOnlyTables! !

!PageDirectory methodsFor: 'memory management' stamp: 'GuidoChari 10/18/2010 16:54'!
free
	self halt.
	self entries do: [:entry | entry free].
	super free.! !

!PageDirectory methodsFor: 'initialize-release' stamp: 'GuidoChari 10/18/2010 17:47'!
initialize 
	super initialize.
	"self entries withIndexDo: [:entry :index | entry clean. entry setPresentAndSupervisor]"! !

!PageDirectory methodsFor: 'accessing' stamp: 'GuidoChari 10/19/2010 17:57'!
pageTableAtIndex: aNumber
	| entry |
	entry := self entryFor: aNumber.
	^entry isPresentAndAllowed ifTrue: [ | alien |
		alien := Alien forPointer: entry pointedAddress. 
		PageTable handledBy: alien entriesCount: self entriesCount entrySize: self entrySize. 
	] ifFalse: [(self error: 'PageFault')]! !

!PageDirectory methodsFor: 'private' stamp: 'GuidoChari 10/18/2010 16:58'!
pageTables
	| records tables size entries |
	tables := OrderedCollection new: self entriesCount.
	1 to: self entriesCount do: [:index | tables add: (self pageTableAtIndex: index - 1)].
	^tables! !

!PageDirectory methodsFor: 'private' stamp: 'GuidoChari 10/19/2010 16:38'!
pageTables: anOrderedCollection
	(self entries first: anOrderedCollection size) withIndexDo: [:entry : index | entry pageFrame: (anOrderedCollection at: index) externalAddress; setPresentAndWritable]! !

!PageDirectory methodsFor: 'printing' stamp: 'GuidoChari 10/18/2010 17:03'!
printOn: aStream
	self entries withIndexDo: [ :entry :index | 
		aStream nextPutAll: 'Table ', index printString, ': ', entry printString; cr.
	]! !

!PageDirectory methodsFor: 'services' stamp: 'gc 11/3/2010 12:08'!
readOnly
	self pageTables do: [:pageTable | pageTable readOnly]! !

!PageDirectory methodsFor: 'services' stamp: 'gc 11/4/2010 18:24'!
readOnlyFrom: start to: end
	| interval |
	interval := start to: end.
	self pageTables select: [:pageTable | interval rangeIncludes: pageTable ] thenDo: [:pageTable | pageTable readOnly]! !

!PageIndex class methodsFor: 'instance creation' stamp: 'GuidoChari 10/16/2010 18:50'!
entriesCount: aNumber entrySize: anotherNumber
	| alien |
	alien := (Alien newCPageAligned: aNumber * anotherNumber).
	^self handledBy: alien entriesCount: aNumber entrySize: anotherNumber! !

!PageIndex class methodsFor: 'private' stamp: 'GuidoChari 10/16/2010 18:43'!
handledBy:  externalHandle entriesCount: aNumber entrySize: anotherNumber
	^self new handle: externalHandle; entriesCount: aNumber; entrySize: anotherNumber! !

!PageIndex methodsFor: 'accessing' stamp: 'GuidoChari 10/25/2010 15:53'!
contents
	| result |
	result := ByteArray new: self entriesCount * self entrySize.
	self handle copyInto: result from: 1 to: result size in: self handle startingAt: 1.
	^result! !

!PageIndex methodsFor: 'accessing' stamp: 'GuidoChari 10/25/2010 16:00'!
contentsFrom: start to: stop
	| result |
	result := ByteArray new: stop - start + 1.
	self handle copyInto: result from: 1 to: result size in: self handle startingAt: start.
	^result! !

!PageIndex methodsFor: 'accessing' stamp: 'GuidoChari 10/14/2010 16:11'!
entries
	| count entries |
	count := self entriesCount.
	entries := OrderedCollection new: count.
	0 to: count - 1 do: [:index | | record | 
			entries add: (self entryFor: index)].
	^entries! !

!PageIndex methodsFor: 'accessing' stamp: 'GuidoChari 10/14/2010 16:12'!
entriesCount 
	^entriesCount! !

!PageIndex methodsFor: 'accessing' stamp: 'GuidoChari 10/14/2010 16:12'!
entriesCount: aNumber
	entriesCount := aNumber! !

!PageIndex methodsFor: 'accessing' stamp: 'gc 11/4/2010 19:08'!
entriesFromIndex: start 
	| entries stop |
	stop := self entriesCount.
	entries := OrderedCollection new: stop - start + 1.
	(start to: stop) do: [:index | entries add: (self entryFor: index)].
	^entries! !

!PageIndex methodsFor: 'accessing' stamp: 'gc 11/4/2010 19:08'!
entriesFromIndex: start to: stop
	| entries |
	entries := OrderedCollection new: stop - start + 1.
	(start to: stop) do: [:index | entries add: (self entryFor: index)].
	^entries! !

!PageIndex methodsFor: 'accessing' stamp: 'gc 11/4/2010 19:08'!
entriesUptoIndex: stop 
	| entries |
	entries := OrderedCollection new: stop.
	(1 to: stop) do: [:index | entries add: (self entryFor: index)].
	^entries! !

!PageIndex methodsFor: 'accessing' stamp: 'GuidoChari 10/16/2010 19:25'!
entryFor: anIndex
	| address handler |
	address := self externalAddressFor: anIndex.
	handler := Alien forPointer: address. 
	^PageTableEntry handledBy: handler! !

!PageIndex methodsFor: 'accessing' stamp: 'GuidoChari 10/14/2010 16:08'!
entrySize
	^entrySize! !

!PageIndex methodsFor: 'accessing' stamp: 'GuidoChari 10/14/2010 16:13'!
entrySize: aNumber
	entrySize := aNumber! !

!PageIndex methodsFor: 'private' stamp: 'GuidoChari 10/16/2010 19:27'!
externalAddress
	^handle address! !

!PageIndex methodsFor: 'private' stamp: 'GuidoChari 10/14/2010 16:23'!
externalAddressFor: anIndex
	^self externalAddress + (self entrySize * anIndex)! !

!PageIndex methodsFor: 'private' stamp: 'GuidoChari 10/19/2010 18:04'!
handle
	^handle
! !

!PageIndex methodsFor: 'private' stamp: 'GuidoChari 10/16/2010 19:17'!
handle: anExternalHandler
	handle := anExternalHandler! !

PageIndex subclass: #PageTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-MemoryManager-Paging'!

!PageTable class methodsFor: 'instance creation' stamp: 'GuidoChari 10/19/2010 18:03'!
fromTable: aPageTable
	| count alien |
	count := aPageTable entriesCount * aPageTable entrySize.
	alien := Alien newCPageAligned: count.
	alien copyInto: alien from: 1 to: count in: aPageTable handle startingAt: 1.
	^self handledBy: alien entriesCount: aPageTable entriesCount entrySize: aPageTable entrySize ! !

!PageTable class methodsFor: 'instance creation' stamp: 'GuidoChari 10/18/2010 11:17'!
fromTable: aPageTable size: aNumber
	^(self newCPageAligned: aNumber) copyInto: self from: 0 to: aNumber - 1 in: aPageTable startingAt: 0! !

!PageTable methodsFor: 'copying' stamp: 'GuidoChari 10/25/2010 14:55'!
deepCopy
	| entries size count alien |
	entries := self entriesCount.
	size := self entrySize.
	count :=  entries * size.
	alien := Alien newCPageAligned: count.
	alien copyInto: alien from: 1 to: count in: self handle startingAt: 1.
	^self class handledBy: alien entriesCount: entries entrySize: size! !

!PageTable methodsFor: 'initialize-release' stamp: 'GuidoChari 10/19/2010 16:37'!
identityMappingStartingAt: address pageSize: aNumber
	self entries withIndexDo: [:entry :index | entry clean; setPresentAndWritable; pageFrame: (index - 1) * aNumber + address]
	! !

!PageTable methodsFor: 'testing' stamp: 'GuidoChari 10/19/2010 18:12'!
isPresentAndAllowed:  aNumber
	| entry |
	entry := self entryFor: aNumber.
	^entry isPresentAndAllowed! !

!PageTable methodsFor: 'translation' stamp: 'GuidoChari 10/19/2010 18:11'!
phisicalAddressFor: aNumber
	| entry |
	entry := self entryFor: aNumber.
	^entry pointedAddress! !

!PageTable methodsFor: 'printing' stamp: 'GuidoChari 10/18/2010 12:18'!
printOn: aStream
	self entries withIndexDo: [ :entry :index | 
		aStream nextPutAll: 'Page ', index printString, ': ', entry printString; cr.
	]! !

!PageTable methodsFor: 'services' stamp: 'gc 11/3/2010 12:09'!
readOnly
	self entries do: [:entry | entry readOnly]! !

Object subclass: #PageTableEntry
	instanceVariableNames: 'handle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-MemoryManager-Paging'!

!PageTableEntry class methodsFor: 'instance creation' stamp: 'GuidoChari 10/14/2010 16:25'!
handledBy: externalHandle
	^self new handle: externalHandle! !

!PageTableEntry methodsFor: 'accessing' stamp: 'GuidoChari 10/14/2010 16:25'!
clean 
	handle unsignedLongAt: 1 put: 0! !

!PageTableEntry methodsFor: 'private' stamp: 'GuidoChari 10/18/2010 12:13'!
handle: anExternalHandler
	handle := anExternalHandler! !

!PageTableEntry methodsFor: 'testing' stamp: 'GuidoChari 10/22/2010 15:52'!
isPresent
	| value |
	value := handle unsignedLongAt: 1.
	value := value bitAnd: 16r00000001.
	^value = 16r1 ! !

!PageTableEntry methodsFor: 'testing' stamp: 'GuidoChari 10/14/2010 16:26'!
isPresentAndAllowed 
	| value |
	value := handle unsignedLongAt: 1.
	value := value bitAnd: 16r00000003.
	^value = 16r3 ! !

!PageTableEntry methodsFor: 'testing' stamp: 'GuidoChari 10/25/2010 15:33'!
isPresentAndForbidden 
	| value |
	value := handle unsignedLongAt: 1.
	value := value bitAnd: 16r00000003.
	^value = 16r1 ! !

!PageTableEntry methodsFor: 'testing' stamp: 'GuidoChari 10/22/2010 15:53'!
isReadOnly 
	| value |
	value := handle unsignedLongAt: 1.
	value := value bitAnd: 16r00000010.
	^value = 16r2 ! !

!PageTableEntry methodsFor: 'accessing' stamp: 'GuidoChari 10/18/2010 12:14'!
pageFrame: aNumber
	| value frame |
	"aNumber must be page aligned"
	value := handle unsignedLongAt: 1.
	value := value bitAnd: 16r00000FFF.
	value := value bitOr: aNumber.
	handle unsignedLongAt: 1 put: value! !

!PageTableEntry methodsFor: 'accessing' stamp: 'GuidoChari 10/19/2010 17:05'!
pageTable
	| address |
	address := self pointedAddress.
	^PageTable forPointer: address! !

!PageTableEntry methodsFor: 'private' stamp: 'GuidoChari 10/19/2010 17:07'!
pointedAddress
	| address |
	address := handle unsignedLongAt: 1.
	^address bitAnd: 16rFFFFF000! !

!PageTableEntry methodsFor: 'private' stamp: 'GuidoChari 10/19/2010 16:36'!
presentAndWritableWord
	^16r00000003
	! !

!PageTableEntry methodsFor: 'printing' stamp: 'GuidoChari 10/19/2010 17:06'!
printOn: aStream
	aStream nextPutAll: 'Translates to: ', self pointedAddress printString, ', Status bits: ', self status printString.! !

!PageTableEntry methodsFor: 'accessing' stamp: 'gc 11/4/2010 14:51'!
readOnly 
	| value |
	"User mode needs to be set"
	value := handle unsignedLongAt: 1.
	value := value bitAt: 2 put: 0.
	handle unsignedLongAt: 1 put: value	
	


! !

!PageTableEntry methodsFor: 'accessing' stamp: 'GuidoChari 12/28/2010 15:52'!
readWrite
	| value |
	"User mode needs to be set"
	value := handle unsignedLongAt: 1.
	value := value bitAt: 2 put: 1.
	handle unsignedLongAt: 1 put: value	
	


! !

!PageTableEntry methodsFor: 'accessing' stamp: 'GuidoChari 10/19/2010 16:36'!
setPresentAndWritable 
	| value |
	value := handle unsignedLongAt: 1.
	value := value bitOr: self presentAndWritableWord.
	handle unsignedLongAt: 1 put: value 	! !

!PageTableEntry methodsFor: 'private' stamp: 'GuidoChari 10/25/2010 14:58'!
status
	| value |
	value := handle unsignedLongAt: 1.
	^value := value bitAnd: 16r00000FFF! !

Object subclass: #PartitionRecord
	instanceVariableNames: 'bytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Filesystems-FAT32'!

!PartitionRecord commentStamp: 'Pocho 4/5/2010 18:24' prior: 0!
It is a 16 bytes table contained inside the MBR, it's contents are:

Offset  Description                                                          				  Size
00h		Current State of Partition (00h=Inactive, 80h=Active)         				1 Byte
01h		Beginning of Partition - Head                                   				1 Byte
02h		Beginning of Partition - Cylinder/Sector (See Below)         				1 Word
04h		Type of Partition (See List Below)                            					1 Byte
05h		End of Partition - Head                                       					1 Byte
06h		End of Partition - Cylinder/Sector                                         		1 Word
08h		Number of Sectors Between the MBR and the First Sector in the Partition	1 Double Word
0Ch		Number of Sectors in the Partition                                           	1 Double Word


!

!PartitionRecord class methodsFor: 'as yet unclassified' stamp: 'Pocho 4/5/2010 20:35'!
partitionTypes
	"source:
	http://home.teleport.com/~brainy/fat32.htm and
	http://www.win.tue.nl/~aeb/partitions/partition_types-1.html"
	
	| types |
	types := Dictionary new.
	types at: 16r00 put: #Unknown;
		at: 16r01 put: #FAT12;
		at: 16r04 put: #FAT16; "16-bit FAT (Partition Smaller than 32MB)"
		at: 16r05 put: #ExtendedMSDOS;
		at: 16r06 put: #FAT16Large; "16-bit FAT (Partition Larger than 32MB)"
		at: 16r0B put: #FAT32; "32-bit FAT (Partition Up to 2048GB)"
		at: 16r0C put: #FAT32LBA; "Same as 0BH, but uses LBA1 13h Extensions"
		at: 16r0E put: #FAT16LargeLBA; "Same as 06H, but uses LBA1 13h Extensions"
		at: 16r0F put: #ExtendedMSDOSLBA; "Same as 05H, but uses LBA1 13h Extensions"
		at: 16r83 put: #Linux. "Various filesystem types like xiafs, ext2, ext3, reiserfs, etc. all use ID 83".
		
	^types.! !

!PartitionRecord class methodsFor: 'as yet unclassified' stamp: 'Pocho 4/5/2010 18:43'!
with: anArray
	anArray size ~= 16 ifTrue: [self error: 'Not a Partition Record'].
	^self new bytes: anArray.! !

!PartitionRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/5/2010 22:07'!
active
	"00h	Current State of Partition (00h=Inactive, 80h=Active) 		1 Byte"
	^(bytes byteAt: 1) = 16r80.! !

!PartitionRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/5/2010 18:44'!
bytes: aByteArray
	bytes := aByteArray.! !

!PartitionRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/5/2010 22:07'!
decodedCylinderLow: encodedCylSecLow high: encodedCylSecHigh
	"
	+ 15 14 13 12 11 10 9 8	|    7    6  	| 5 4 3 2 1 0	+
	|  Cylinder Bits 7 to 0	|  Cylinder	|   Sector 	|
	+ 						|   Bits 9+8	| Bits 5 to 0	+
	"
	^encodedCylSecHigh bitOr: ((encodedCylSecLow bitAnd: 16rC0) bitShift: 2).! !

!PartitionRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/5/2010 22:07'!
decodedSector: encodedCylSec
	"
	+ 15 14 13 12 11 10 9 8	|    7    6  	| 5 4 3 2 1 0	+
	|  Cylinder Bits 7 to 0	|  Cylinder	|   Sector 	|
	+ 						|   Bits 9+8	| Bits 5 to 0	+
	"
	^encodedCylSec bitAnd: 16r3F.! !

!PartitionRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/5/2010 22:06'!
firstCylinder
	"01h - Beginning of Partition - Cylinder/Sector - 2 Byte
	"
	^self decodedCylinderLow: (bytes byteAt: 3) high: (bytes byteAt: 4).! !

!PartitionRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/5/2010 22:06'!
firstHead
	"01h		Beginning of Partition - Head		1 Byte"
	^bytes byteAt: 2.! !

!PartitionRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/5/2010 20:38'!
firstSector
	"01h - Beginning of Partition - Cylinder/Sector - 2 Byte"
	^self decodedSector: (bytes byteAt: 3).! !

!PartitionRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/5/2010 22:06'!
inactive
	"00h	Current State of Partition (00h=Inactive, 80h=Active) 		1 Byte"
	^(bytes byteAt: 1) = 16r00.! !

!PartitionRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 00:55'!
numberOfSectors
	"08h	Number of Sectors in the Partition.	1 Double Word"
	^bytes unsignedLongAt: 13.! !

!PartitionRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/6/2010 00:56'!
offsetFromMBR
	"08h	Number of Sectors Between the MBR and the First Sector in the Partition.	1 Double Word"
	^bytes unsignedLongAt: 9.! !

!PartitionRecord methodsFor: 'as yet unclassified' stamp: 'Pocho 4/5/2010 22:07'!
partitionType
	"04h - Type of Partition - 1 Byte	"
		
	^self class partitionTypes at: (bytes byteAt: 5) ifAbsent: [ ^#unknown].! !

Object subclass: #ReadBlockCache
	instanceVariableNames: 'device cache count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Storage'!

!ReadBlockCache class methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 18:46'!
on: aDevice
	^self new on: aDevice! !

!ReadBlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 18:55'!
flushWrites! !

!ReadBlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 18:50'!
from: firstBlock to: lastBlock
	 | data |
	"Very primitive caching mechanism"
	(firstBlock = (cache at: 1)) & (lastBlock = (cache at: 2)) ifFalse: [
		data := device from: firstBlock to: lastBlock.
		cache := Array with: firstBlock with: lastBlock with: data.
	] ifTrue: [ data := cache at: 3].

	^data.
	
! !

!ReadBlockCache methodsFor: 'as yet unclassified' stamp: 'Pocho 7/21/2010 19:54'!
on: aDevice
	device := aDevice.
	cache := Array with: nil with: nil with: nil.
	count := 0.! !

!ReadBlockCache methodsFor: 'as yet unclassified' stamp: 'GuidoChari 1/3/2011 17:39'!
replaceFromByte: destOffset bytesCount: bytesCount with: source startingAtByte: sourceOffset
	"Write count bytes from source starting at startIndex bytes. We handle half sector
	 overwriting."
	| data firstBlock lastBlock blocksCount firstBlockBytesOffset lastBlockBytesCount blockData firstSectorRead |
	
	firstBlock := device blockNumberFromByteOffset: destOffset.
	lastBlock := device blockNumberFromByteOffset: destOffset + bytesCount - 1.
	blocksCount := lastBlock - firstBlock + 1.
	
	firstSectorRead := false.
	
	data := ByteArray new: blocksCount * device blockSize.
	cache := Array with: nil with: nil with: nil.
	"If it starts at block boundaries, we don't need to read the block. We'll probably overwrite it entirely"
	firstBlockBytesOffset := device positionInBlockOf: destOffset.
	firstBlockBytesOffset ~= 1 ifTrue: [
		firstSectorRead := true.
		blockData := device at: firstBlock.
		data replaceFrom: 1	to: device blockSize with: blockData startingAt: 1.
	].
	
	"If it ends at block boundaries, we don't need to read the last block. We'll probably overwrite it entirely"
	lastBlockBytesCount := device positionInBlockOf: destOffset + bytesCount - 1.
	lastBlockBytesCount ~= device blockSize ifTrue: [
		(blocksCount = 1 & firstSectorRead) ifFalse: [
			blockData := device at: lastBlock.
			data replaceFrom: 1	to: device blockSize with: blockData startingAt: 1.
		].
	].

	data
		replaceFrom: firstBlockBytesOffset to: (firstBlockBytesOffset + bytesCount - 1)
		with: source startingAt: sourceOffset.
	
	count > 10000 ifTrue: [ count := 0.
		"Transcript show: 'Writing ', blocksCount asString, ' sectors starting at ', firstBlock asString, '
'."
	].
	count := count + bytesCount.
	
	device at: firstBlock writeArray: data.
	
! !

Object subclass: #RemoteObjectChannel
	instanceVariableNames: 'handle stream object'
	classVariableNames: 'Channels MainChannelStream'
	poolDictionaries: ''
	category: 'SqueakNOS-FileSupport'!

!RemoteObjectChannel commentStamp: 'gera 5/26/2006 20:35' prior: 0!
I'm a channel used on the client side of an RPC communication. I know how to perform: something on a remote object and return the answer. Classes must be mirrored on both images

" To start a remoting server, do the next in a standard squeak."
RemoteObjectChannel stream socket closeAndDestroy.
RemoteObjectChannel waitConnectionsOnPort: 1234.
[RemoteObjectChannel performNext] repeat..

" To connect to a remoting server from a standard Squeak (testing) do:"
RemoteObjectChannel conRemoteObjectChannel stream socket closeAndDestroy.
nectSocketTo: NetNameResolver localHostAddress onPort: 1234

" To setup the remoting client inside SqueakNOS, do the next"
Computer current defaultSerialPort open.
RemoteObjectChannel stream: (DeviceStream on: Computer current defaultSerialPort)

" To test do:"
(RemoteMultiByteStream oldFileNamed: 'TestFile.st') fileIn

" If you want to change default File and Directory classes, edit the next methods:"
activeDirectoryClass
	^ RemoteFileDirectory

concreteStream
	^ RemoteMultiByteFileStream
!

!RemoteObjectChannel class methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 03:12'!
channels
	"only used in server's side.
	In client side there is no need to mantain the Dictionary, as every Channel knows its handle"
	^ Channels ifNil: [
		Channels := Dictionary new
			at: 0 put: (self new
				handle: 0;
				object: self;
				stream: self stream);
			yourself.
		]! !

!RemoteObjectChannel class methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 14:05'!
connectSocketTo: ipAddress onPort: port
	self stream: (SocketStream openConnectionToHost: ipAddress port: port) binary.
! !

!RemoteObjectChannel class methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 14:04'!
for: anObject using: contructorString
	| handle |
	handle := (self channels at: 0)
		remotePerform: #newOnServerFor:
		withString: '{',contructorString,'}'.

	^ self new
		handle: handle;
		stream: self stream;
		object: anObject
! !

!RemoteObjectChannel class methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 11:25'!
forget: aHandle
	self channels 
		removeKey: aHandle! !

!RemoteObjectChannel class methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 11:23'!
forgetOnServer: aHandle
	" called of client side "
	(self channels at: 0)
		remotePerform: #forget:
		withString: '#(',aHandle printString,')'.! !

!RemoteObjectChannel class methodsFor: 'as yet unclassified' stamp: 'r++ 7/26/2008 15:20'!
installOn: aComputer
	| serial |
	serial := Computer current defaultSerialPort.
	serial ifNil: [^self].
	serial open.
	self stream: (DeviceStream on: serial).
	[[RemoteObjectChannel performNext] repeat] fork.
! !

!RemoteObjectChannel class methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 02:09'!
newHandle
	| answer |
	[answer := SmallInteger maxVal atRandom.
	self channels includesKey: answer] whileTrue.
	^ answer! !

!RemoteObjectChannel class methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 03:44'!
newOnServerFor: anObject
	| handle |
	handle := self newHandle.
	self channels at: handle put: (
		self new
			handle: handle;
			object: anObject).	" no need to set the stream on the server side "
	^ handle! !

!RemoteObjectChannel class methodsFor: 'as yet unclassified' stamp: 'gera 5/28/2006 13:51'!
objectForHandle: handle
	^ (self channels at: handle ifAbsent: [^ nil]) object! !

!RemoteObjectChannel class methodsFor: 'as yet unclassified' stamp: 'gera 5/28/2006 13:52'!
performNext
	"server side"
	| strm object selector arguments answer |
	strm := self stream.

	[strm next = $> asciiValue] whileFalse.

	object := strm int32.
	selector := strm string asSymbol.
	arguments := strm string.

	object := self objectForHandle: object.
	arguments := Compiler evaluate: arguments.

	[	answer :=object perform: selector withArguments: arguments.
		answer := answer == object
			ifTrue: [#self]
			ifFalse: [answer storeString].
	]	ifError: [:msg :receiver | answer := 'Error signal: ', msg storeString].

	strm
		nextPut: $<;
		int32: answer size;
		nextPutAll: answer;
		flush.
! !

!RemoteObjectChannel class methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 01:29'!
stream
	^ MainChannelStream! !

!RemoteObjectChannel class methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 14:06'!
stream: aStream
	MainChannelStream := aStream.
	Channels := nil.! !

!RemoteObjectChannel class methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 14:06'!
waitConnectionsOnPort: port
	| s |
	s := Socket new listenOn: port backlogSize: 10.
	self stream: (SocketStream on: (s waitForAcceptFor: 1000)) binary.! !

!RemoteObjectChannel methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 11:21'!
forget
	^ self class forgetOnServer: self handle! !

!RemoteObjectChannel methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 02:14'!
handle
	^ handle! !

!RemoteObjectChannel methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 02:14'!
handle: anInteger
	handle := anInteger! !

!RemoteObjectChannel methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 02:14'!
object
	^ object! !

!RemoteObjectChannel methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 02:14'!
object: anObject
	object := anObject! !

!RemoteObjectChannel methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 03:57'!
remotePerform: aSelector
	^ self remotePerform: aSelector withString: '#()'! !

!RemoteObjectChannel methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 11:56'!
remotePerform: aSelector with: arg1
	^ self remotePerform: aSelector withArguments: (Array with: arg1)! !

!RemoteObjectChannel methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 11:56'!
remotePerform: aSelector with: arg1 with: arg2
	^ self remotePerform: aSelector withArguments: (Array with: arg1 with: arg2)! !

!RemoteObjectChannel methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 11:56'!
remotePerform: aSelector with: arg1 with: arg2 with: arg3
	^ self remotePerform: aSelector withArguments: (Array with: arg1 with: arg2 with: arg3)! !

!RemoteObjectChannel methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 13:33'!
remotePerform: aSelector with: arg1 with: arg2 with: arg3 with: arg4
	^ self remotePerform: aSelector withArguments: (Array with: arg1 with: arg2 with: arg3 with: arg4)! !

!RemoteObjectChannel methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 13:36'!
remotePerform: aSelector withArguments: arguments
	| strm |
	strm := WriteStream on: ''.
	strm nextPut: ${.
	arguments do: [:each |
		strm
			store: each;
			nextPut: $ ;
			nextPut: $.].

	^ self remotePerform: aSelector withString: strm contents allButLast, '}'

! !

!RemoteObjectChannel methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 21:47'!
remotePerform: aSelector withString: argumentsString
	| answer |
	self stream
		nextPut: $>;	" query "
		int32: self handle;
		string: aSelector;
		string: argumentsString;
		flush.

	[self stream next = $< asciiValue] whileFalse.

	answer := (self stream next: self stream int32) asString.
	^ answer = 'self' ifTrue: [self object] ifFalse: [Compiler evaluate: answer].
! !

!RemoteObjectChannel methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 02:14'!
stream
	^ stream! !

!RemoteObjectChannel methodsFor: 'as yet unclassified' stamp: 'gera 5/25/2006 02:14'!
stream: aStream
	stream := aStream! !

Object subclass: #ScancodeDecoder
	instanceVariableNames: 'previousScanCode actualScanCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Devices-Base'!

!ScancodeDecoder methodsFor: 'as yet unclassified' stamp: 'Pocho 11/21/2009 16:48'!
altGrPressedIn: aModifiersRegister
	^(aModifiersRegister bitAnd: 16r40) > 0 and: [(aModifiersRegister bitAnd: 16r10 ) > 0 ].! !

!ScancodeDecoder methodsFor: 'as yet unclassified' stamp: 'Pocho 11/21/2009 18:40'!
correspondingMapWith: aModifiersRegister

	"rule 1 - extended keys aren't affected by modifiers like control and alt gr.
	 rule 2 - caps lock isn't handled here, because <fill when you know the answer>"
	
	| modifiers |
	modifiers := OrderedCollection new.
	
	previousScanCode == 16rE0 ifTrue: [ modifiers add: #extended. ^modifiers asArray. ].
	
	(self shiftPressedIn: aModifiersRegister) ifTrue: [ modifiers add: #shift ].
	(self altGrPressedIn: aModifiersRegister) ifTrue: [ modifiers add: #alt ].

	modifiers ifEmpty: [modifiers add: #none].
	
	 ^modifiers asArray.! !

!ScancodeDecoder methodsFor: 'as yet unclassified' stamp: 'Pocho 11/11/2009 12:37'!
isKeyUp
	^actualScanCode anyMask: 16r80.! !

!ScancodeDecoder methodsFor: 'as yet unclassified' stamp: 'Pocho 11/21/2009 18:02'!
isModifier
	^self translateModifierScanCode > 0.! !

!ScancodeDecoder methodsFor: 'as yet unclassified' stamp: 'Pocho 12/2/2009 16:19'!
keyUsing: aKeysMapping modifiers: modifiers
	| normalizedCode |
	normalizedCode := actualScanCode bitClear: 16r80.
	
	^(aKeysMapping at: (self correspondingMapWith: modifiers)) at: (normalizedCode ).
	! !

!ScancodeDecoder methodsFor: 'as yet unclassified' stamp: 'Pocho 11/21/2009 17:58'!
nextKeyReady
	 ^(actualScanCode == 16rE0 | (actualScanCode == 16rE1)) not. "If extended scancode we have to wait next to complete"
	
! !

!ScancodeDecoder methodsFor: 'as yet unclassified' stamp: 'Pocho 11/11/2009 12:26'!
nextScanCode: aScanCode
	previousScanCode := actualScanCode.
	actualScanCode := aScanCode.
	! !

!ScancodeDecoder methodsFor: 'as yet unclassified' stamp: 'Pocho 11/21/2009 16:48'!
shiftPressedIn: aModifiersRegister
	^(aModifiersRegister bitAnd: 8 ) > 0.
! !

!ScancodeDecoder methodsFor: 'as yet unclassified' stamp: 'Pocho 12/26/2009 03:18'!
translateModifierScanCode

	| normalizedCode |
	
	previousScanCode = 16rE0 ifTrue: [^ 0]. "Is an extended scancode, can't be a modifier"
	
	normalizedCode := actualScanCode bitClear: 16r80.
	
	normalizedCode == 16r2A ifTrue: [^ 8].		" left shift "	
	normalizedCode == 16r36 ifTrue: [^ 8].		" right shift "
	normalizedCode == 16r38 ifTrue: [^ 16r40].	" left ALT (command key) "
	normalizedCode == 16r1D ifTrue: [^ 16r10].	" left CTRL "

	^ 0.! !

Object subclass: #WriteList
	instanceVariableNames: 'writeQueue blocksList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNOS-Storage'!

!WriteList methodsFor: 'as yet unclassified' stamp: 'Pocho 7/20/2010 00:25'!
areIntersected: firstA to: lastA and: firstB to: lastB
	firstA > lastB ifTrue: [^false].
	lastA < firstB ifTrue: [^false].
	^true.! !

!WriteList methodsFor: 'as yet unclassified' stamp: 'Pocho 7/17/2010 16:23'!
at: aPosition wrote: someData
	self reserve: someData size at: aPosition.
	writeQueue add: { aPosition. someData }! !

!WriteList methodsFor: 'as yet unclassified' stamp: ''!
blocks
	^ blocksList! !

!WriteList methodsFor: 'as yet unclassified' stamp: 'Pocho 7/18/2010 22:53'!
clear
	
	writeQueue := OrderedCollection new.
	blocksList := OrderedCollection new.! !

!WriteList methodsFor: 'as yet unclassified' stamp: 'Pocho 7/19/2010 19:13'!
do: aBlock
	blocksList do: [ :block | aBlock value: (block at: 1) value: (block at: 2) - 1 value:
		 (writeQueue select: [ :write | (block at: 1) <= (write at: 1) and: [(block at: 2) > (write at: 1)]  ]) ].! !

!WriteList methodsFor: 'as yet unclassified' stamp: 'Pocho 7/18/2010 23:27'!
findLeftStart: startPosition end: endPosition
	
	blocksList withIndexDo: [ :elem :index |
		((elem at: 2) >= startPosition) ifTrue: [
			((elem at: 1) <= endPosition) ifTrue: [^{index. true}] ifFalse: [^{index. false}].
		].
	].
	^{blocksList size + 1. false}.

! !

!WriteList methodsFor: 'as yet unclassified' stamp: 'Pocho 7/18/2010 23:20'!
findRightStart: startPosition end: endPosition
	| last |	
	blocksList withIndexDo: [ :elem :index |
		((elem at: 1) <= endPosition)
		  ifTrue: [
			last := index.
		] ifFalse: [
			^last.
		].
	].
	^last.

! !

!WriteList methodsFor: 'as yet unclassified' stamp: 'Pocho 7/18/2010 22:53'!
initialize
	self clear.! !

!WriteList methodsFor: 'as yet unclassified' stamp: 'Pocho 7/20/2010 14:27'!
removeAllNecesaryFrom: startPosition to: endPosition ifAdd: aBlock
	| left right newStartPosition newEndPosition |
	left := self findLeftStart: startPosition end: endPosition.
	
	(left at: 2) ifFalse: [
			aBlock value: (left at: 1) value: startPosition value: endPosition.
	] ifTrue: [
		newStartPosition := startPosition min: ((blocksList at: (left at: 1)) at: 1).
	
		right := self findRightStart: startPosition end: endPosition.
		newEndPosition := endPosition max: ((blocksList at: right) at: 2).

		"(((left at: 1) == right) and: [(newStartPosition <= startPosition and: [ newEndPosition >= endPosition ])]) ifFalse: ["
			right to: (left at: 1) by: -1 do: [ :index | blocksList removeAt: index ].
			aBlock value: (left at: 1) value: newStartPosition value: newEndPosition.
		"]"
	] 


	! !

!WriteList methodsFor: 'as yet unclassified' stamp: 'Pocho 7/18/2010 22:41'!
reserve: size at: startPosition

	| endPosition |
	endPosition := startPosition + size.

	self removeAllNecesaryFrom: startPosition to: endPosition ifAdd: [ :index :newStartPosition :newEndPosition |
		blocksList add: {newStartPosition. newEndPosition} beforeIndex: index.
	].
	! !

!WriteList methodsFor: 'as yet unclassified' stamp: 'Pocho 7/20/2010 14:08'!
writeFrom: firstByte to: lastByte into: aByteArray
	| helper | 
	helper := BlockArithmetic new blockSize: aByteArray size.
	
	"self halt."
	writeQueue do: [ :write | | sourceStart sourceEnd |
		sourceStart := write at: 1.
		sourceEnd := sourceStart + (write at: 2) size - 1.
		(self areIntersected: firstByte to: lastByte and: sourceStart to: sourceEnd) ifTrue: [ | destStart destEnd |
			destStart := helper positionInBlockOf: (firstByte max: sourceStart).
			destEnd := helper positionInBlockOf: (lastByte min: sourceEnd).
			aByteArray replaceFrom: destStart to: destEnd with: (write at: 2) startingAt: (firstByte - sourceStart + 1 max: 1)
		]
	]! !
Computer initialize!
OldPCKeyboard initialize!
PCIBusEntry initialize!
SDDevice initialize!
PS2Keyboard initialize!
